<?php

/**
 * Represents device interface xml description.
 *
 * @author Wojciech Wichrowski
 */

class DeviceInterface
{
    private $name;
    private $properties;
    private $actions;
    
    public function __construct($name)
    {
        $this->name = $name;
        $this->properties = array();
        $this->actions = array();
    }
    
    public function addProperty($property)
    {
        if (get_class($property) == 'Property' && $property->valid)
        {
            $this->properties[] = $property;
        }
    }
    
    public function addAction($action)
    {
        if (get_class($action) == 'Action' && $action->valid)
        {
            $this->actions[] = $action;
        }
    }
    
    public function getName()
    {
        return $this->name;
    }
    
    public function getProperties()
    {
        return $this->properties;
    }
    
    public function getActions()
    {
        return $this->actions;
    }
    
    public function getInterfaces()
    {
        return $this->interfaces;
    }
    
}
