<?php

/**
 * Represents device type xml description.
 *
 * @author Wojciech Wichrowski
 */

require_once dirname(__FILE__) . '/Property.php';
require_once dirname(__FILE__) . '/Action.php';

class DeviceType
{
    private $type;
    private $baseType;
    private $properties;
    private $actions;
    private $interfaces;
    
    function __construct($type, $baseType)
    {
        $this->type = $type;
        $this->baseType = $baseType;
        $this->properties = array();
        $this->actions = array();
        $this->interfaces = array();
    }
    
    public function addProperty($property)
    {
        if (get_class($property) == 'Property' && $property->valid)
        {
            $this->properties[] = $property;
        }
    }
    
    public function addAction($action)
    {
        if (get_class($action) == 'Action' && $action->valid)
        {
            $this->actions[] = $action;
        }
    }
    
    public function addInterface($interface)
    {
        if (is_string($interface) && $interface != '')
        {
            $this->interfaces[] = $interface;
        }
    }
    
    public function getType()
    {
        return $this->type;
    }
    
    public function getBaseType()
    {
        return $this->baseType;
    }
    
    public function getProperties()
    {
        return $this->properties;
    }
    
    public function getActions()
    {
        return $this->actions;
    }
    
    public function getInterfaces()
    {
        return $this->interfaces;
    }
}
