<?php

require_once dirname(__FILE__) . '/Device.php';
require_once dirname(__FILE__) . '/../OldDevIdGroup/DeviceOld.php';
require_once dirname(__FILE__) . '/../LoadXmlTemplate/LoadXmlTemplate.php';
require_once dirname(__FILE__) . '/../includes/config.php';
require_once dirname(__FILE__) . '/DeviceHierarchy.php';

class Devices
{

    public $oldDevice;
    public $listNewDevice;

    function __construct($oldDev)
    {
        $this->oldDevice = $oldDev;
        $this->listNewDevice = array();

        $this->makeNewDeviceFromOld();

        
    }

    public function makeNewDeviceFromOld()
    {
        foreach ($this->oldDevice as $nodeId => $devices)
        {
            $this->addNewDevice($devices, $nodeId);
        }
    }

    public function updateDataInNewDevice($oldDev, $newDev)
    {
        global $convert, $propertiesToCopyFromFirstDevice, $logger;

        //NODE
        $firstDevice = $oldDev[0];
        $nodeId = $firstDevice->getPropertyName('nodeID');
        
        foreach ($newDev as $device)
        {
            $device->setPropertyValue('nodeId', $nodeId);




            $oldDead = $firstDevice->getPropertyName('dead');

            if ($oldDead == "0")
            {
                $device->setPropertyValue('dead', false);
                $device->setPropertyValue('markAsDead', true);
            } elseif ($oldDead == "1")
            {
                $device->setPropertyValue('dead', true);
                $device->setPropertyValue('markAsDead', true);
            } elseif ($oldDead == "2")
            {
                $device->setPropertyValue('dead', false);
                $device->setPropertyValue('markAsDead', false);
            }

            // FOR CONTROLLER
            if ($firstDevice->getPropertyName('nodeID') == 1)
            {
                $pollingDeadDevice = $firstDevice->getPropertyName('pollingDeadDevice');

                $device->setPropertyValue('dead', false);
                if ($pollingDeadDevice)
                {
                    $device->setPropertyValue('pollingDeadDevice', true);
                } else
                {
                    $device->setPropertyValue('pollingDeadDevice', false);
                }

                $autoConfig = $firstDevice->getPropertyName('autoConfig');

                if ($autoConfig)
                {
                    $device->setPropertyValue('autoConfig', true);
                } else
                {
                    $device->setPropertyValue('autoConfig', false);
                }
            }


            //ENDPOINT
            $endPointId = $device->getPropertyValue('endPointId');
            $endPointFound = false;
            $endPointCheck[0] = 0;
            $virtualTmp = 0;

            foreach ($oldDev as $oldDevice)
            {
//                $oldDevice = new DeviceOld($device, $property, $action);//remove

                $oldData = $oldDevice->getDevice();
                if (intval($oldDevice->getPropertyName('endPoint')) == $endPointId)
                {
                    $endPointFound = true;

                    $nodeID = $oldDevice->getPropertyName('nodeID');
                    $endPoint = $oldDevice->getPropertyName('endPoint');

//                    echo "Update Name: " . $oldData['Name'] . " N: " . $nodeId . " EndPoint: " . $endPoint . PHP_EOL;


                    $endPointCheck[$endPoint] = $endPoint;
                    $virtual = $virtualTmp;

                    echo "Vritual: " . $virtual . PHP_EOL;


                    if (intval($oldData['Device_Type']) == intval($convert->getTypeId($device->type)))
                    {
                        $device->roomID = $oldData['Room_Id'];
                        $device->sectionID = $oldData['Section_Id'];

                        foreach ($oldDevice->property as $property)
                        {
                            $device->setPropertyValue($property['Name'], $property['Value']);
                        }

                        //hardcoded changes
                        $changes = array(
                            'valueSensor' => 'power',
                            'valueMeter' => 'energy'
                        );
                        foreach ($changes as $oldPropertyName => $newPropertyName)
                        {
                            $propertyValue = $oldDevice->getPropertyName($oldPropertyName);
                            if (!is_null($propertyValue))
                            {
                                $device->setPropertyValue($newPropertyName, $propertyValue);
                            }
                        }

                        //mega hardcode
                        $needConfigure = $oldDevice->getPropertyName('needConfigure');
                        if (!is_null($needConfigure))
                        {
                            if ($needConfigure == '5')
                            {
                                $device->setPropertyValue('configured', true);
                            } else
                            {
                                $device->setPropertyValue('configured', false);
                            }
                        }
                    }
                }
            }

            /*
             * associations, parameters, internal - cleaning up
             */
            foreach ($propertiesToCopyFromFirstDevice as $propertyName => $propertyType)
            {
                $oldVal = $firstDevice->getPropertyName($propertyName);
                if (!is_null($oldVal))
                {
                    if (!$device->hasProperty($propertyName))
                    {
                        $device->addProperty(new Property($propertyName, $propertyType));
                    }
                    $device->setPropertyValue($propertyName, $oldVal);
                }
            }

            if ($device->type == 'com.fibaro.zwaveDevice')
            {
                $device->internal->nodeID = $device->getPropertyValue('nodeId');
                foreach ($device->internal->endPoint as $endPoint)
                {
                    if (count($endPoint->getValue()) > 0)
                    {
                        foreach ($endPoint->getValue() as $value)
                        {
                            if ($value->getCmdID() == 85 && $value->data['nameValue'] == 'associationView')
                            {
                                $value->data['value'] = $firstDevice->associationInternalValue;
                            } elseif ($value->getCmdID() == 70 && $value->data['nameValue'] == 'parameters')
                            {
                                $value->data['value'] = $firstDevice->getPropertyName('parameters');
                            } elseif ($value->getCmdID() == 84 && $value->data['nameValue'] == 'wakeUpTime')
                            {
                                $value->data['value'] = intval($firstDevice->getPropertyName('wakeUpTime'));
                            }
                        }
                    }
                }
            }

            if (!$endPointFound)
            {
                echo 'EndPoint not found - device ' . $firstDevice->getID() . ' endPoint: ' . $endPointId . PHP_EOL;
            }
        }
        
        return $newDev;
    }

    public function addNewDevice($devices, $nodeId = 0)
    {
        global $logger, $_RECONFIGURATION;
        
        if (count($devices) > 0)
        {
            $firstDevice = $devices[0];
            echo "Add Device: " . $firstDevice->getID() . PHP_EOL;
            

            //array_push($this->listNewDevice, $this->updateDataInNewDevice($oldDev));

            $parametersTemplate = $firstDevice->getPropertyName('parametersTemplate');
            echo 'pt: ' . $parametersTemplate . PHP_EOL;
            $template = new LoadXmlTemplate();
            if ($parametersTemplate > 0 || $firstDevice->getID() == 1) //TODO: what should we do with Z-Wave controller? leaving old version for now...
            {
                echo 'with template' . PHP_EOL;
                $logger->logDebug('Adding devices with template ' . $parametersTemplate . ', nodeID: ' . $nodeId, $devices);
                $template->loadTemplateFromParametersTemplate($parametersTemplate);
                $template->createDevices(true, $nodeId, $devices);
                
                /**
                 * parameters template id > 0 but couldn't load Z-Wave template xml
                 */
                if (!$template->valid)
                {
                    $_RECONFIGURATION->addNode($nodeId);
                }
                
            } else
            {
                echo 'without template' . PHP_EOL;
                $logger->logDebug('Adding devices without template, nodeID: ' . $nodeId, $devices);
                $template->createDevices(false, $nodeId, $devices);
                
                /**
                 * no parameters template
                 */
                $_RECONFIGURATION->addNode($nodeId);
            }

            $newDevices = $template->devices;

            $this->updateDataInNewDevice($devices, $newDevices);

            $this->listNewDevice = mergeArrayValues($this->listNewDevice, $newDevices);
        }
    }

    public function viewOldDevice()
    {

        echo "############# START OLD DEVICE        ########################" . PHP_EOL;
        foreach ($this->oldDevice as $value)
        {
            echo "###############  OLD DEVICE    ######################" . PHP_EOL;
            print_r($value);
            echo "#####################################" . PHP_EOL;
        }
        echo "############# END OLD DEVICE        ########################" . PHP_EOL;
    }

    public function viewAllDeivce()
    {

        echo "############# START NEW DEVICE        ########################" . PHP_EOL;
//        foreach ($this->listNewDevice as $value)
//        {
//            echo "############# NEW DEVICE        ########################" . PHP_EOL;
//            print_r($value);
//            echo "#####################################" . PHP_EOL;
//        }
//        var_dump($this->listNewDevice);
        echo "############# END NEW DEVICE        ########################" . PHP_EOL;
    }

}
