<?php
/**
 * Description of CommandClass
 *
 * @author Wojciech Wichrowski
 */

require_once dirname(__FILE__) . '/../includes/config.php';
require_once dirname(__FILE__) . '/../includes/tools.php';
require_once dirname(__FILE__) . '/../includes/defineCmdClasses.php';

class CommandClass
{
    public $id;
    public $version;
    public $name;
    public $values;
    public $interfaces;
    
    public $controller;
    public $security;
    
    public function __construct($id, $version, $name)
    {
        $this->id = $id;
        $this->version = $version;
        $this->name = $name;
        $this->values = array();
        $this->interfaces = array();
        
        $this->controller = false;
        $this->security = false;
    }
    
    public function get()
    {
        $copy = new CommandClass($this->id, $this->version, $this->name);
        
        if (count($this->interfaces) > 0)
        {
            foreach ($this->interfaces as $interface)
            {
                $copy->interfaces[] = $interface;
            }
        }
        
        if (count($this->values) > 0)
        {
            foreach ($this->values as $value)
            {
                $copy->values[$value->index] = $value->get();
            }
        }
        
        return $copy;
    }
    
    public function getForInternal()
    {
        $obj = new stdClass();
        $obj->cmdID = $this->id;
        
        $data = new stdClass();
        $data->configure = true;
        $data->controller = $this->controller;
        $data->security = $this->security;
        $data->version = intval($this->version);
        
        $obj->data = $data;
        
        return $obj;
    }
    
    public function hasValue($index)
    {
        return array_key_exists($index, $this->values);
    }
}
