<?php

class DbConnect{
    
    public $db;
    
     
    function __construct($dbPath = '/opt/fibaro/db') {
        $this->db = new PDO('sqlite:' . $dbPath);
    }

    public function __destruct() {
        $this->db = NULL;
    }

    public function query($str){
        return $this->db->query($str);
    }
    
    public function exec($query, $values = array())
    {
        try
        {
            $sth = $this->db->prepare($query);
            $res = $sth->execute($values);
            return $res;
        } catch (PDOException $ex) {
            echo 'Exception in preparing statement: ' . $query . PHP_EOL;
            echo $ex->getMessage();
            return false;
        }
    }
    
    public function beginTransaction()
    {
        return $this->db->beginTransaction();
    }
    
    public function commit()
    {
        return $this->db->commit();
    }
    
    public function rollBack()
    {
        return $this->db->rollBack();
    }
    
    
}