<?php

class DbWorker {

    public $NEW_Device;
    public $NEW_Property;
    public $NEW_Action;
    public $associationsInternalValues;
    public $db;

    function __construct() {
        $this->NEW_Device = array();
        $this->NEW_Property = array();
        $this->NEW_Action = array();
        $this->associationsInternalValues = array();
        $this->db = new PDO('sqlite:/opt/fibaro/db');
        echo "\n\n LOAD ALL DEVICES BEGIN \n\n";
        $this->loadAllDevice();
        echo "\n\n LOAD ALL DEVICES END \n\n";
    }

    public function loadAllDevice() {
        $this->getAllAction();
        $this->getAllDevice();
        $this->getAllPropertis();
        $this->getAllAssociations();
        $this->getAllParameters();
    }

    public function __destruct() {
        $this->db = NULL;
    }

    public function query($str) {
        return $this->db->query($str);
    }

    public function test() {
        $testID = 1;
        $query = $this->query('select * from NEW_Device where Id=' . $testID);
        $rows = $query->fetchAll();
        if (count($rows) > 0)
        {
            echo $rows[0]['Name'] . PHP_EOL;
        }
        unset($query);
    }

    public function addNewDevice($Id, $Room_Id, $Section_Id, $Socket_Id, $Device_Type_Id, $Name, $Remote_Gateway_Id) {

        array_push($this->NEW_Device, array("Id" => $Id, "Room_Id" => $Room_Id, "Section_Id" => $Section_Id, "Socket_Id" => $Socket_Id, "Device_Type" => $Device_Type_Id, "Name" => $Name, "Remote_Gateway_Id" => $Remote_Gateway_Id));
    }

    public function viewNewDevice() {
        foreach ($this->NEW_Device as $key => $value) {
            echo "Id: " . $value["Id"] . " Name: " . $value["Name"] . " Key: " . $key . PHP_EOL;
        }
    }

    public function addNewProperty($Device_Id, $Name, $Value, $ModificationTime) {

        array_push($this->NEW_Property, array("Device_Id" => $Device_Id, "Name" => $Name, "Value" => $Value, "Modification_Time" => $ModificationTime));
    }

    public function viewNewProperty() {
        foreach ($this->NEW_Property as $key => $value) {
            echo "Device_Id: " . $value["Device_Id"] . " Name: " . $value["Name"] . " Value: " . $value["Value"] . " Key: " . $key . PHP_EOL;
        }
    }

    public function addNewAction($Device_Id, $Name, $ArgMask) {

        array_push($this->NEW_Action, array("Device_Id" => $Device_Id, "Name" => $Name, "Arg_Mask" => $ArgMask));
    }

    public function viewNewAction() {
        foreach ($this->NEW_Action as $key => $value) {
            echo "Device_Id: " . $value["Device_Id"] . " Name: " . $value["Name"] . " Arg_Mask: " . $value["Arg_Mask"] . " Key: " . $key . PHP_EOL;
        }
    }

    public function getAllDevice() {
        $query = $this->query('select * from NEW_Device where Socket_Id=1 and Device_Type_Id > 0');

        while ($row = $query->fetch()) {
        	/* 23.09.2014 - BEGIN - Pawe� Wo�ny */
        	//$row["Id"] = escapeString($row["Id"]);
        	//$row["Room_Id"] = escapeString($row["Room_Id"]);
        	//$row["Section_Id"] = escapeString($row["Section_Id"]);
        	//$row["Socket_Id"] = escapeString($row["Socket_Id"]);
        	//$row["Device_Type_Id"] = escapeString($row["Device_Type_Id"]);
        	$row["Name"] = escapeString($row["Name"]);
        	//$row["Remote_Gateway_Id"] = escapeString($row["Remote_Gateway_Id"]);
        	
        	/* 23.09.2014 - END - Pawe� Wo�ny */
        	
            $this->addNewDevice($row["Id"], $row["Room_Id"], $row["Section_Id"], $row["Socket_Id"], $row["Device_Type_Id"], $row["Name"], $row["Remote_Gateway_Id"]);
        }
        unset($query);
    }

    public function getAllPropertis() {
        $query = $this->query('select p.* from NEW_Property p '
                . 'inner join NEW_Device d on d.Id=p.Device_Id '
                . 'where d.Device_Type_Id > 0');

        while ($row = $query->fetch()) {
        	/* 23.09.2014 - BEGIN - Pawe� Wo�ny */
        	//$row["Device_Id"] = escapeString($row["Device_Id"]);
        	$row["Name"] = escapeString($row["Name"]);
        	$row["Value"] = escapeString($row["Value"]);
        	//$row["Modification_Time"] = escapeString($row["Modification_Time"]);
        	
        	/* 23.09.2014 - END - Pawe� Wo�ny */
            $this->addNewProperty($row["Device_Id"], $row["Name"], $row["Value"], $row["Modification_Time"]);
        }
        unset($query);
    }

    public function getAllAction() {
        $query = $this->query('select a.* from NEW_Action a '
                . 'inner join NEW_Device d on d.Id=a.Device_Id '
                . 'where d.Device_Type_Id > 0');

        while ($row = $query->fetch()) {
        	/* 23.09.2014 - BEGIN - Pawe� Wo�ny */
        	//$row["Device_Id"] = escapeString($row["Device_Id"]);
        	$row["Name"] = escapeString($row["Name"]);
        	$row["Arg_Mask"] = escapeString($row["Arg_Mask"]);
        	/* 23.09.2014 - END - Pawe� Wo�ny */
            $this->addNewAction($row["Device_Id"], $row["Name"], $row["Arg_Mask"]);
        }
        unset($query);
    }
    
    public function getAllAssociations()
    {
        $associations = array();
        $associationsInternalValues = array();
        
        $devQuery = $this->query('select * from NEW_Device where Id > 3 and Device_Type_Id > 0');
        while ($row = $devQuery->fetch())
        {
            $associations[$row['Id']]['view'] = array();
            $associations[$row['Id']]['setTo'] = array();
            $associationsInternalValues[$row['Id']] = array();
        }
        unset($devQuery);
        
        $query = $this->query('select a.* from Device_Association_Group a '
                . 'inner join NEW_Device d on d.Id=a.FK_Device '
                . 'where d.Device_Type_Id > 0 '
                . 'order by a.FK_Device, a.GroupID');
        while ($row = $query->fetch())
        {
            $view = explode(',', $row['View']);
            $setTo = explode(',', $row['SetTo']);
            $groupID = intval($row['GroupID']);
            
            $viewObj = new stdClass();
            $viewObj->groupID = $groupID;
            $viewObj->devices = array();
            
            $internalViewObj = new stdClass();
            $internalViewObj->id = $groupID;
            $internalViewObj->nodes = array();
            $internalViewObj->maxNode = intval($row['MaxDevices']);
            
            foreach ($view as $deviceID)
            {
                $viewObj->devices[] = intval($deviceID);
                $internalViewObj->nodes[] = intval($deviceID);
            }
            $associations[$row['FK_Device']]['view'][] = $viewObj;
            $associationsInternalValues[$row['FK_Device']][] = $internalViewObj;
            
            $setToObj = new stdClass();
            $setToObj->groupID = $groupID;
            $setToObj->devices = array();
            foreach ($setTo as $deviceID)
            {
                $setToObj->devices[] = intval($deviceID);
            }
            $associations[$row['FK_Device']]['setTo'][] = $setToObj;
            
        }
        unset($query);
        
        foreach ($associations as $deviceID => $data)
        {
            $this->addNewProperty($deviceID, 'associationView', $data['view'], time());
            $this->addNewProperty($deviceID, 'associationSet', $data['setTo'], time());
        }
        
        foreach ($associationsInternalValues as $deviceID => $data)
        {
            $this->associationsInternalValues[$deviceID] = $data;
        }
    }

    public function getAllParameters()
    {
        $parameters = array();
        $devQuery = $this->query('select * from NEW_Device where Id > 3 and Device_Type_Id > 0');
        while ($row = $devQuery->fetch())
        {
            $parameters[$row['Id']] = array();
            $associations[$row['Id']]['setTo'] = array();
            $associationsInternalValues[$row['Id']] = array();
        }
        unset($devQuery);
        
        $query = $this->query('select p.* from Device_Parameter p '
                . 'inner join NEW_Device d on d.Id=p.FK_Device '
                . 'where d.Device_Type_Id > 0 '
                . 'order by p.FK_Device, p.ParameterNumber');
        while ($row = $query->fetch())
        {
            $parameterNumber = intval($row['ParameterNumber']);
            $parameterSize = intval($row['ParameterSize']);
            $parameterValue = intval($row['ParameterValue']);
            if (trim($row['LastSentValue']) == '')
            {
                $lastSetValue = intval($row['ParameterValue']);
            }
            else
            {
                $lastSetValue = intval($row['LastSentValue']);
            }
            
            $obj = new stdClass();
            $obj->id = $parameterNumber;
            $obj->size = $parameterSize;
            $obj->value = $parameterValue;
            $obj->lastSetValue = $lastSetValue;
            
            $parameters[$row['FK_Device']][] = $obj;
        }
        unset($query);
        
        foreach ($parameters as $deviceID => $data)
        {
            $this->addNewProperty($deviceID, 'parameters', $data, time());
        }
        
    }

    public function getActionFromDevId($devID) {
        $tmp = array();

        foreach ($this->NEW_Action as $key => $value) {

            if ($value["Device_Id"] == $devID) {
                array_push($tmp, $value);
            }

        }

        return $tmp;
    }

    public function getPropertiesFromDevId($devID) {
        $tmp = array();
        foreach ($this->NEW_Property as $key => $value) {
            if ($value["Device_Id"] == $devID) {
                array_push($tmp, $value);
            }
        }
        return $tmp;
    }
    
    public function getAssociationsInternalFromDevId($devId)
    {
        if (isset($this->associationsInternalValues[$devId]))
        {
            return $this->associationsInternalValues[$devId];
        }
        
        return array();
    }
    

}

