<?php

require_once dirname(__FILE__) . '/../db/DbConnect.php';
require_once dirname(__FILE__) . '/../Device/DeviceHierarchy.php';

define('ZWAVE_TEMPLATES_PATH', '/opt/fibaro/template/zwave');
define('TYPES_PATH', '/opt/fibaro/types');
define('INTERFACES_PATH', '/opt/fibaro/interfaces');

define('TABLE_NEW_Device_Type', 'NEW_Device_Type'); //release - TODO: uncomment
//define('TABLE_NEW_Device_Type', 'NEW_Device_Type_Test'); //testing - TODO: comment

define('DEFAULT_DB_TMP_PATH', '/tmp/db_tmp'); //release - TODO: uncomment
//define('DB_TMP_PATH', '/opt/fibaro/db_new'); //testing - TODO: comment
//define('DB_TMP_PATH', '/opt/update/install/opt/fibaro/db_new'); //testing - TODO: comment

define('SCENES_PATH', '/opt/fibaro/scenes');

define('DEVICE_TYPE_VIRTUAL_DEVICE', 17);

define('ZWAVE_SUPPORTED_CMD_CLASSES_PATH', '/opt/fibaro/conf/Zwave.xml');

$propertiesToCopyFromFirstDevice = array(
    'associationView' => 'array',
    'associationSet' => 'array',
    'parameters' => 'array',
    'parametersTemplate' => 'int',
    'batteryLevel' => 'int',
    'pollingTimeSec' => 'int',
    'wakeUpTime' => 'int',
    'zwaveCompany' => 'string',
    'zwaveInfo' => 'string',
    'useTemplate' => 'bool',
    'dead'  => 'bool'
);

/**
 * array of device types, which should be rewritten from old db because we don't know user-specified type or real specific device type
 */
$deviceTypesToRewriteFromOldDB = array(
    'com.fibaro.binarySensor',
    'com.fibaro.multilevelSensor',
);

/**
 * Mega hardcode hack for devices, which endPoinds IDs have been changed in 4.x version.
 * Index - parametersTemplate.
 * Values - arrays describing which endPoint from 3.x version should be rewritten to which endPoint from 4.x version.
 */

$megaHardcodeArray = array(
    20      => array(
        0   =>  NULL,
        1   =>  0,
        2   =>  0
    ),
    45      => array(
        1   =>  0,
        2   =>  2,
        3   =>  3
    ),
    270      => array(
        0   =>  0,
        1   =>  0,
        2   =>  0
    ),
    271      => array(
        0   =>  0,
        1   =>  0,
        2   =>  0
    ),
    272      => array(
        0   =>  0,
        1   =>  0,
        2   =>  0
    ),
    273      => array(
        0   =>  0,
        1   =>  0,
        2   =>  0
    ),
    62      => array(
        0   =>  0,
        1   =>  0,
        2   =>  0,
        3   =>  0
    )
);
?>