<?php

function xmlStringToBool($str)
{
    if ($str == 'true')
        return true;

    return false;
}

function xmlHexToDec($hex)
{
    return hexdec($hex);
}

/**
 * Splits input string into 2-character strings and then converts them to dec numbers
 */
function xmlHexToDecArray($hex)
{
    $array = array();

    $len = strlen($hex);
    for ($i = 0; $i < $len; $i += 2)
    {
        $str = substr($hex, $i, 2);
        $array[] = xmlHexToDec($str);
    }

    return $array;
}

function mergeArrayValues($array1, $array2)
{
    $array = array();

    if (is_array($array1))
    {
        $array = $array1;
    }

    if (is_array($array2) && count($array2) > 0)
    {
        foreach ($array2 as $val)
        {
            $array[] = $val;
        }
    }

    return $array;
}

function removeExtraWhitespace($text)
{
    return preg_replace( '/\s+/', ' ', $text);
}

function startsWith($haystack, $needle)
{
    return $needle == '' || strpos($haystack, $needle) === 0;
}

function createDefineCmdClasses()
{
    $fh = fopen('/tmp/ZW_classcmd.h', 'r');
    $define = '';
    if ($fh)
    {
        while (($line = fgets($fh)) !== false)
        {
            $line = removeExtraWhitespace($line);
            $temp = explode(' ', $line);
            if ($temp[0] == '#define' && startsWith($temp[1], 'COMMAND_CLASS_'))
            {
                $define .= 'define(\'' . $temp[1] . '\', \'' . $temp[2] . '\');' . PHP_EOL;
            }
        }
        
        fclose($fh);
    }
    
    $fh = fopen('/tmp/define', 'w');
    if ($fh)
    {
        fwrite($fh, $define);
        fclose($fh);
    }
}

function replace_unicode_escape_sequence($match) {
    return mb_convert_encoding(pack('H*', $match[1]), 'UTF-8', 'UCS-2BE');
}

function escapeString($str)
{
    //escaping moved to PDO::prepare
    return $str;
}
?>

