<?php

require_once dirname(__FILE__) . '/../internal/InterfaceEndPoint.php';
require_once dirname(__FILE__) . '/../internal/SupportCmd.php';
require_once dirname(__FILE__) . '/../internal/SupportData.php';
require_once dirname(__FILE__) . '/../internal/Value.php';

class endPointID {

    public $configure;
    public $devIdEndPoint;
    public $enabled;
    public $endPointID;
    public $generic;
    public $interface;
    public $interfaceFibaro;
    public $specific;
    public $supportCmd;
    public $typeFibaro;
    public $value;
    public $visible;

    // Only tmp

    function __construct($endPointID) {
        $this->configure = false;
        $this->devIdEndPoint = 0;
        $this->enabled = false;
        $this->endPointID = $endPointID;
        $this->generic = "0";
        $this->interface = array();
        $this->interfaceFibaro = array();
        $this->specific = "";
        $this->supportCmd = array();
        $this->typeFibaro = "";
        $this->value = array();
        $this->visible = false;
    }

    public function addSupportCmd($cmdID, $configure, $controller, $security, $version) {
        //configure - always set to true
        $configure = true;
        
        array_push($this->supportCmd, new SupportCmd($cmdID, new SupportData($configure, $controller, $security, $version)));
    }

    public function addValue($cmdClass, $index, $valueType, $valueData) {
        
        array_push($this->value, new Value($cmdClass, $index, $valueType, $valueData));
    }

    public function addInterface($name, $enable) {
        array_push($this->interface, new InterfaceEndPoint($enable, $name));
    }

    public function getConfigure() {
        return $this->configure;
    }

    public function getDevIdEndPoint() {
        return $this->devIdEndPoint;
    }

    public function getEnabled() {
        return $this->enabled;
    }

    public function getEndPointID() {
        return $this->endPointID;
    }

    public function getGeneric() {
        return $this->generic;
    }

    public function getInterface() {
        return $this->interface;
    }

    public function getInterfaceFibaro() {
        return $this->interfaceFibaro;
    }

    public function getSpecific() {
        return $this->specific;
    }

    public function getSupportCmd() {
        return $this->supportCmd;
    }

    public function getTypeFibaro() {
        return $this->typeFibaro;
    }

    public function getValue() {
        return $this->value;
    }

    public function getVisible() {
        return $this->visible;
    }

    public function setConfigure($configure) {
        $this->configure = $configure;
    }

    public function setDevIdEndPoint($devIdEndPoint) {
        $this->devIdEndPoint = intval($devIdEndPoint);
    }

    public function setEnabled($enabled) {
        $this->enabled = $enabled;
    }

    public function setEndPointID($endPointID) {
        $this->endPointID = $endPointID;
    }

    public function setGeneric($generic) {
        $this->generic = $generic;
    }

    public function setInterface($interface) {
        $this->interface = $interface;
    }

    public function addInterfaceFibaro($interfaceFibaro) {
        array_push($this->interfaceFibaro , $interfaceFibaro);
    }

    public function setSpecific($specific) {
        $this->specific = $specific;
    }

    public function setSupportCmd($supportCmd) {
        $this->supportCmd = $supportCmd;
    }

    public function setTypeFibaro($typeFibaro) {
        $this->typeFibaro = $typeFibaro;
    }

    public function setValue($value) {
        $this->value = $value;
    }

    public function setVisible($visible) {
        $this->visible = $visible;
    }

}
