<?php

require_once(dirname(__FILE__) . "/../internal/ValueData.php");
require_once dirname(__FILE__) . '/../includes/defineCmdClasses.php';

class Value {

    
    public $cmdID;
        public $data;
        public $index;
        public $type;
        private $dataClass;
        
    
        function __construct($cmdID, $index, $type, $valueData) {
            $this->cmdID = $cmdID;
            $this->data = array();
            $this->index = $index;
            $this->type = $type;
            $this->dataClass = $valueData;
            
            //ugly hack for checkEventValue - new part of Zwave Value - we don't have it in templates
            if ($cmdID == substr(COMMAND_CLASS_SCENE_ACTIVATION, 2))
            {
                $this->dataClass->setCheckEventValue(false);
            }
            
            $this->convertData();
        }
        
        
        public function convertData(){
            
            //correct default value
            if ($this->dataClass->getValue() == 0)
            {
                if ($this->type == 'bool')
                {
                    $this->dataClass->setValue(false);
                }
                elseif ($this->type == 'string')
                {
                    $this->dataClass->setValue("0");
                }
                elseif ($this->type == 'array')
                {
                    $this->dataClass->setValue(array());
                }
                elseif ($this->type == 'object')
                {
                    $this->dataClass->setValue(new stdClass());
                }
            }
            
            $this->data = $this->dataClass->getSerialize();
        }
        
        public function getCmdID() {
            return $this->cmdID;
        }

        public function getData() {
            return $this->dataClass;
        }

        public function getIndex() {
            return $this->index;
        }

        public function getType() {
            return $this->type;
        }

        public function setCmdID($cmdID) {
            $this->cmdID = $cmdID;
        }

        public function setData($data) {
            $this->dataClass = $data;
            $this->convertData();
        }

        public function setIndex($index) {
            $this->index = $index;
        }

        public function setType($type) {
            $this->type = $type;
        }

        public function get()
        {
            $copy = new Value($this->cmdID, $this->index, $this->type, $this->dataClass->get());
            
            return $copy;
        }


}


