--
-- includes
--
require('Bu3025')
require('common.FIButtonUpDown')
--
-- create main class
--

bu3025 = Bu3025(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() bu3025:moveStop() end,
["Up_Button"] = function() bu3025:moveUp() end,
["Left_Button"] = function() bu3025:moveLeft() end,
["Right_Button"] = function() bu3025:moveRight() end,
["Down_Button"] = function() bu3025:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() bu3025:moveUp() end,
["Left_Button"] = function() bu3025:moveLeft() end,
["Right_Button"] = function() bu3025:moveRight() end,
["Down_Button"] = function() bu3025:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	bu3025:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
