require('common.device')
require('net.HTTPClient')
require('common.base64')
require('common.utils')


class 'Bu720' (Device)


function Bu720:__init(id)
	Device.__init(self, id)

	self.http = net.HTTPClient({ timeout = 10000 })

	self.url = {
	["left"] = self.properties.moveLeftPath,
	["right"] = self.properties.moveRightPath,
	["up"] = self.properties.moveUpPath,
	["down"] = self.properties.moveDownPath,
	["stop"] = self.properties.moveStopPath,
	["jpg"] = self.properties.jpgPath,
	["mjpg"] = self.properties.mjpgPath
	}

	if(self.properties.ip == "") then
		self:updateProperty('ui.imageStream.source', 'novideo.png')
	else
		self.base64 = false
		if(self.properties.userName == "" and self.properties.password == "") then
			self:updateProperty('ui.imageStream.source', 'http://' .. self.properties.ip .. "/" .. self.url.mjpg)

			self.headers = {}
		else
			self.base64 = true
			self:updateProperty('ui.imageStream.source', 'http://' .. self.properties.username .. ":" .. utils.urlencode(self.properties.password) .. "@" .. self.properties.ip .. "/" .. self.url.mjpg)

			self.headers = {
			['Authorization'] = 'Basic '.. to_base64(self.properties.username .. ':'.. self.properties.password),
			['Content-Type'] = 'application/x-www-form-urlencoded'
			}
		end
	end
end

function Bu720:moveLeft()
	self:httpRequest(self.url.left)
end

function Bu720:moveRight()
	self:httpRequest(self.url.right)
end

function Bu720:moveUp()
	self:httpRequest(self.url.up)
end

function Bu720:moveDown()
	self:httpRequest(self.url.down)
end

function Bu720:moveStop()
	self:httpRequest(self.url.stop)
end

function Bu720:httpRequest(url)
		self.http:request('http://' .. self.properties.ip .. '/' .. url, {
		options = {
			method = 'GET',
			headers = self.headers
		},
		success = function() end,
		error = function(err) print(err) end
	})
end
