--
-- includes
--
require('Cu720Pir')
require('common.FIButtonUpDown')
--
-- create main class
--

cu720pir = Cu720Pir(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() cu720pir:moveStop() end,
["Up_Button"] = function() cu720pir:moveUp() end,
["Left_Button"] = function() cu720pir:moveLeft() end,
["Right_Button"] = function() cu720pir:moveRight() end,
["Down_Button"] = function() cu720pir:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() cu720pir:moveUp() end,
["Left_Button"] = function() cu720pir:moveLeft() end,
["Right_Button"] = function() cu720pir:moveRight() end,
["Down_Button"] = function() cu720pir:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	cu720pir:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
