--
-- includes
--
require('Generic')
require('common.FIButtonUpDown')
--
-- create main class
--

generic = Generic(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() generic:moveStop() end,
["Up_Button"] = function() generic:moveUp() end,
["Left_Button"] = function() generic:moveLeft() end,
["Right_Button"] = function() generic:moveRight() end,
["Down_Button"] = function() generic:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() generic:moveUp() end,
["Left_Button"] = function() generic:moveLeft() end,
["Right_Button"] = function() generic:moveRight() end,
["Down_Button"] = function() generic:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	generic:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
