--
-- includes
--
require('Ica3350V')
require('common.FIButtonUpDown')
--
-- create main class
--

ica3350v = Ica3350V(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() ica3350v:moveStop() end,
["Up_Button"] = function() ica3350v:moveUp() end,
["Left_Button"] = function() ica3350v:moveLeft() end,
["Right_Button"] = function() ica3350v:moveRight() end,
["Down_Button"] = function() ica3350v:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() ica3350v:moveUp() end,
["Left_Button"] = function() ica3350v:moveLeft() end,
["Right_Button"] = function() ica3350v:moveRight() end,
["Down_Button"] = function() ica3350v:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	ica3350v:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
