--
-- includes
--
require('Ica5350V')
require('common.FIButtonUpDown')
--
-- create main class
--

ica5350v = Ica5350V(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() ica5350v:moveStop() end,
["Up_Button"] = function() ica5350v:moveUp() end,
["Left_Button"] = function() ica5350v:moveLeft() end,
["Right_Button"] = function() ica5350v:moveRight() end,
["Down_Button"] = function() ica5350v:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() ica5350v:moveUp() end,
["Left_Button"] = function() ica5350v:moveLeft() end,
["Right_Button"] = function() ica5350v:moveRight() end,
["Down_Button"] = function() ica5350v:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	ica5350v:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
