--
-- includes
--
require('Icahm312')
require('common.FIButtonUpDown')
--
-- create main class
--

icahm312 = Icahm312(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() icahm312:moveStop() end,
["Up_Button"] = function() icahm312:moveUp() end,
["Left_Button"] = function() icahm312:moveLeft() end,
["Right_Button"] = function() icahm312:moveRight() end,
["Down_Button"] = function() icahm312:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() icahm312:moveUp() end,
["Left_Button"] = function() icahm312:moveLeft() end,
["Right_Button"] = function() icahm312:moveRight() end,
["Down_Button"] = function() icahm312:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	icahm312:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
