--
-- includes
--
require('Icahm351')
require('common.FIButtonUpDown')
--
-- create main class
--

icahm351 = Icahm351(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() icahm351:moveStop() end,
["Up_Button"] = function() icahm351:moveUp() end,
["Left_Button"] = function() icahm351:moveLeft() end,
["Right_Button"] = function() icahm351:moveRight() end,
["Down_Button"] = function() icahm351:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() icahm351:moveUp() end,
["Left_Button"] = function() icahm351:moveLeft() end,
["Right_Button"] = function() icahm351:moveRight() end,
["Down_Button"] = function() icahm351:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	icahm351:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
