require('common.device')
require('net.HTTPClient')
require('common.base64')
require('common.utils')


class 'Ap007' (Device)


function Ap007:__init(id)
	Device.__init(self, id)

	self.http = net.HTTPClient({ timeout = 10000 })

	self.url = {
	["jpg"] = self.properties.jpgPath,
	["mjpg"] = self.properties.mjpgPath
	}

	if(self.properties.ip == "") then
		self:updateProperty('ui.imageStream.source', 'novideo.png')
	else
		self.base64 = false
		if(self.properties.userName == "" and self.properties.password == "") then
			self:updateProperty('ui.imageStream.source', 'http://' .. self.properties.ip .. "/" .. self.url.mjpg)

			self.headers = {}
		else
			self.base64 = true
			self:updateProperty('ui.imageStream.source', 'http://' .. self.properties.username .. ":" .. utils.urlencode(self.properties.password) .. "@" .. self.properties.ip .. "/" .. self.url.mjpg)

			self.headers = {
			['Authorization'] = 'Basic '.. to_base64(self.properties.username .. ':'.. self.properties.password),
			['Content-Type'] = 'application/x-www-form-urlencoded'
			}
		end
	end
end
