--
-- includes
--
require('Orange')
require('common.FIButtonUpDown')
--
-- create main class
--

orange = Orange(plugin.mainDeviceId)

uiBinding = {
["Stop_Button"] = function() orange:moveStop() end,
["Up_Button"] = function() orange:moveUp() end,
["Left_Button"] = function() orange:moveLeft() end,
["Right_Button"] = function() orange:moveRight() end,
["Down_Button"] = function() orange:moveDown() end
}

uiBindingForRepetition = {
["Up_Button"] = function() orange:moveUp() end,
["Left_Button"] = function() orange:moveLeft() end,
["Right_Button"] = function() orange:moveRight() end,
["Down_Button"] = function() orange:moveDown() end
}

fiButtonUpDown = FIButtonUpDown({
	repeatAfter=500,
	refreshRate=300,
	normalBinding=uiBinding,
	repeatBinding=uiBindingForRepetition
})

function onAction(deviceId, action)
	orange:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	fiButtonUpDown:onUIEvent(deviceId, event)
end

function configure(deviceId, config)
	plugin.restart()
end
