--
-- includes
--
require('AlphatechFarfisa')
--
-- create main class
--

alphatechFarfisa = AlphatechFarfisa(plugin.mainDeviceId)

uiBinding = {
	["Open_Door_Button1"] = function() alphatechFarfisa:openDoor1() end,
	["Open_Door_Button2"] = function() alphatechFarfisa:openDoor2() end
}

function onAction(deviceId, action)
	return alphatechFarfisa:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
    local callback = uiBinding[event.elementName]

	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip ~= '') then
		alphatechFarfisa:updateProperty('ui.imageStream.source', 'http://' .. config.ip .. '/video.jpg')
	else
		alphatechFarfisa:updateProperty('ui.imageStream.source', 'novideo.png')
	end
	
	if (config.selectedKeyCode ~= 0 and config.selectedVoipUser ~= 0) then
		alphatechFarfisa:updateProperty('selectedVoipUser', config.selectedVoipUser)
		alphatechFarfisa:updateProperty('selectedKeyCode', config.selectedKeyCode)
	end

	alphatechFarfisa:updateProperty('userName', config.userName)
	alphatechFarfisa:updateProperty('password', config.password)
	alphatechFarfisa:updateProperty('ip', config.ip)

	alphatechFarfisa:updateProperty('sipDisplayName', config.sipDisplayName)
	alphatechFarfisa:updateProperty('sipUserID', config.sipUserID)
	alphatechFarfisa:updateProperty('sipUserPassword', config.sipUserPassword)

	alphatechFarfisa:updatePluginSettings()
end
