
--! Include carrier class file.
require('carrier')

--! Create main class.
carrier = Carrier(plugin.mainDeviceId)

--! Array that contain functions assigned to user interface elements in view tab.
uiBinding = {  
--CarrierZone cless binding 
["Minus_Heat_Setpoint_Button"] = function() zone:setHeatSetpoint(-1) end,
["Plus_Heat_Setpoint_Button"] = function() zone:setHeatSetpoint(1) end,
["Minus_Cool_Setpoint_Button"] = function() zone:setCoolSetpoint(-1) end,
["Plus_Cool_Setpoint_Button"] = function() zone:setCoolSetpoint(1) end,
["Minus_O_T_H_Button"] = function() zone:setOverrideTimer(-1, 'hour') end,
["Plus_O_T_H_Button" ] = function() zone:setOverrideTimer(1, 'hour') end,
["Minus_O_T_M_Button"] = function() zone:setOverrideTimer(-1, 'minute') end,
["Plus_O_T_M_Button" ] = function() zone:setOverrideTimer(1, 'minute') end,
["Auto_Fann_Speed_Button" ] = function() zone:setFanSettings('AUTO') end,
["Low_Fann_Speed_Button"] = function() zone:setFanSettings('LOW') end,
["Medium_Fann_Speed_Button"] = function() zone:setFanSettings('MED') end,
["High_Fann_Speed_Button"] = function() zone:setFanSettings('HIGH') end,
["Hold_Status_Off_Button"] = function() zone:setHoldStatus('OFF') end,
["Hold_Status_On_Button"] = function() zone:setHoldStatus('ON') end,
["Unoccupied_Status_Off_Button"] = function() zone:setUnoccupiedStatus('OFF') end,
["Unoccupied_Status_On_Button"] = function() zone:setUnoccupiedStatus('ON') end,
["Programming_Z_Monday_Button"] = function() zone:setProgrammingInfo('MON', nil, nil, nil, nil, nil, nil, nil)  end,
["Programming_Z_Tuesday_Button"] = function() zone:setProgrammingInfo('TUES', nil, nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Wednesday_Button"] = function() zone:setProgrammingInfo('WED', nil, nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Thursday_Button"] = function() zone:setProgrammingInfo('THUR', nil, nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Friday_Button"] = function() zone:setProgrammingInfo('FRI', nil, nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Saturday_Button"] = function() zone:setProgrammingInfo('SAT', nil, nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Sunday_Button"] = function() zone:setProgrammingInfo('SUN', nil, nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Wake_Button"] = function() zone:setProgrammingInfo(nil, 'WAKE', nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Day_Button"] = function() zone:setProgrammingInfo(nil, 'DAY', nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Evening_Button"] = function() zone:setProgrammingInfo(nil, 'EVE', nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Sleep_Button"] = function() zone:setProgrammingInfo(nil, 'SLP', nil, nil, nil, nil, nil, nil) end,
["Programming_Z_Hour_Period_AM"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, 'A', nil, nil, nil) end,
["Programming_Z_Hour_Period_PM"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, 'P', nil, nil, nil) end,
["Programming_Z_Hour_Minus_B"] = function() zone:setProgrammingInfo(nil, nil, -1, nil, nil, nil, nil, nil) end,
["Programming_Z_Hour_Plus_B"] = function() zone:setProgrammingInfo(nil, nil, 1, nil, nil, nil, nil, nil) end,
["Programming_Z_Minuts_Minus_B"] = function() zone:setProgrammingInfo(nil, nil, nil, -1, nil, nil, nil, nil) end,
["Programming_Z_Minuts_Plus_B"] = function() zone:setProgrammingInfo(nil, nil, nil, 1, nil, nil, nil, nil) end,
["Programming_Z_Heat_Setpoint_Minus_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, -1, nil, nil) end,
["Programming_Z_Heat_Setpoint_Plus_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, 1, nil, nil) end,
["Programming_Z_Minus_Cool_Setpoint_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, nil, -1, nil) end,
["Programming_Z_Plus_Cool_Setpoint_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, nil, 1, nil) end,
["Programming_Z_Auto_Fann_Speed_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, nil, nil, 'AUTO') end,
["Programming_Z_Low_Fann_Speed_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, nil, nil, 'LOW') end,
["Programming_Z_Medium_Fann_Speed_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, nil, nil, 'MED') end,  
["Programming_Z_High_Fann_Speed_Button"] = function() zone:setProgrammingInfo(nil, nil, nil, nil, nil, nil, nil, 'HIGH') end,
["Programming_Z_Set_Button"] = function() zone:setProgrammingData() end,
               
--Carrier class binding
["Vacation_State_Minus_Button"] = function() carrier.carrierConfig:setVacationState(-1) end,
["Vacation_State_Plus_Button"] = function() carrier.carrierConfig:setVacationState(1) end,
["Vacation_Min_Temp_Minus_Button"] = function() carrier.carrierConfig:setVacationMinTemperature(-1) end,
["Vacation_Min_Temp_Plus_Button"] = function() carrier.carrierConfig:setVacationMinTemperature(1) end,
["Vacation_Max_Temp_Minus_Button"] = function() carrier.carrierConfig:setVacationMaxTemperature(-1) end,
["Vacation_Max_Temp_Plus_Button"] = function() carrier.carrierConfig:setVacationMaxTemperature(1) end,
["Vacation_Min_Hum_0_Button"] = function() carrier.carrierConfig:setVacationMinHumidity('000') end,
["Vacation_Min_Hum_10_Button"] = function() carrier.carrierConfig:setVacationMinHumidity('010') end,
["Vacation_Min_Hum_15_Button"] = function() carrier.carrierConfig:setVacationMinHumidity('015') end,
["Vacation_Min_Hum_20_Button"] = function() carrier.carrierConfig:setVacationMinHumidity('020') end,
["Vacation_Max_Hum_55_Button"] = function() carrier.carrierConfig:setVacationMaxHumidity('055') end,
["Vacation_Max_Hum_60_Button"] = function() carrier.carrierConfig:setVacationMaxHumidity('060') end,
["Vacation_Max_Hum_65_Button"] = function() carrier.carrierConfig:setVacationMaxHumidity('065') end,
["Vacation_Max_Hum_100_Button"] = function() carrier.carrierConfig:setVacationMaxHumidity('100') end,
["Vacation_Auto_Fann_Speed_Button"] = function() carrier.carrierConfig:setVacationFanSetting('AUTO') end,
["Vacation_Low_Fann_Speed_Button"] = function() carrier.carrierConfig:setVacationFanSetting('LOW') end,
["Vacation_Medium_Fann_Speed_Button"] = function() carrier.carrierConfig:setVacationFanSetting('MED') end,
["Vacation_High_Fann_Speed_Button"] = function() carrier.carrierConfig:setVacationFanSetting('HIGH') end,
["System1_Button"] = function () carrier:setSystemId(1) end, 
["System2_Button"] = function () carrier:setSystemId(2) end, 
["Zone1_Button"] = function () carrier:setZoneId(1) end, 
["Zone2_Button"] = function () carrier:setZoneId(2) end, 
["Zone3_Button"] = function () carrier:setZoneId(3) end, 
["Zone4_Button"] = function () carrier:setZoneId(4) end, 
["Zone5_Button"] = function () carrier:setZoneId(5) end, 
["Zone6_Button"] = function () carrier:setZoneId(6) end, 
["Zone7_Button"] = function () carrier:setZoneId(7) end, 
["Zone8_Button"] = function () carrier:setZoneId(8) end
}

function onAction(deviceId, action)
    print('onAction devID:')
    if (deviceId == carrier.id) then
        carrier:callAction(action.actionName, unpack(action.args))
    elseif (carrier.childDevices[deviceId]) then
        zone = carrier.childDevices[deviceId]
        zone:callAction(action.actionName, unpack(action.args))
    else
        print("[WARNING] wrong deviceId in action command")
    end
end

function onUIEvent(deviceId, event)
    local callback = uiBinding[event.elementName]
    if (deviceId == carrier.id) then
        -- if pressed button is systme or zone setter then first fire binded action (callback(event)) in carrier.lua
        if (string.sub(event.elementName, 1,6) == 'System' or string.sub(event.elementName, 1,4) == 'Zone' ) then
            if (callback) then
                callback(event)
            end

            zone = carrier:getActiveZone()

            if (zone ~= nil) then
                zone:getZoneName()
            end

            carrier:synchronizePropertiesFromActiveZone()

        -- if pressed button is setter for one of the zone options then fire binded action on selected zone
        -- and synchronize labels on main plugin    
        else
            if (callback) then

                -- search for selected zone 
                zone = carrier:getActiveZone()
                   
                if (zone ~= nil) then    
                    callback(event)
                    carrier:synchronizePropertiesFromActiveZone()
                end
            end
        end
    elseif (carrier.childDevices[deviceId]) then
        dev = carrier.childDevices[deviceId]

        if (dev.type == 'com.fibaro.carrierZone') then
            zone = dev
        end

        if (callback) then
            callback(event)
        end
    else
        print("[WARNING] wrong deviceId onUIEvent")
    end
end

function configure(deviceId, config)
    plugin.restart() 
end
