require('command')
require('weatherData')

--! Represents 'EEWR' Davis command
class 'eewrCommand'(command)

--! Initialises object, sets parent object (Davis)
--!@param parent Davis object
--!@param address offset in memory to be written to (string with hex value)
--!@param value value that would be written (1 byte) (string with hex value)
function eewrCommand:__init(parent, address, value)
	command.__init(self, parent)
	self.address = address
	self.value = value
end

--! Sends eewr command
function eewrCommand:send()
	
	self.responseNumber = 0
	command.send(self, "EEWR " .. self.address .. " " .. self.value .. '\n')
end

function eewrCommand:processResponse(data)
	if data == "OK" then
		self:finish()
	end
end

function eewrCommand:toString()
	return "EEWR " .. self.address .. " " .. self.value
end