--
-- includes
--
require('davis')

--
-- create main class
--
davis = davis(plugin.mainDeviceId)

uiBinding = {
    ["turnOn"] = function() davis:turnOn(); end,
    ["consoleHighlightButtonOn"] = function() davis:turnConsoleHighlightOn(); end,
    ["consoleHighlightButtonOff"] = function() davis:turnConsoleHighlightOff(); end
}

function onAction(deviceId, action)
    davis:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)


    local callback = uiBinding[event.elementName]
    
    if (callback) then
        callback(event)
    end
end

function configure(deviceId, config)
    local restart = false
    if (config.ip) then
        if (davis:updateProperty('ip', config.ip)) then
           restart = true
        end
    end

    if (config.port) then
        if (davis:updateProperty('port', config.port)) then
            restart = true
        end
    end

    if (config.units) then
        if (davis:updateProperty('units', config.units)) then
            restart = true
        end
    end

    if (config.pollingInterval) then
        if (davis:updateProperty('pollingInterval', config.pollingInterval)) then
            restart = true
        end
    end
            
    if restart then
         plugin.restart()
    end
            
end

