--
-- includes
--
require('denon')

--
-- create main class
--
denon = Denon(plugin.mainDeviceId)

uiBinding = {
	["mute_Switch"] = 	function(eventArgs)
							denon:setMute(eventArgs.values[1])
						end,

	["power_Switch"] =	function(eventArgs)
							if (eventArgs.values[1]) then
								denon:turnOn()
							else
								denon:turnOff()
							end
						end,

	["volume_Slider"] = function(eventArgs) denon:setVolume(eventArgs.values[1]) end,

	["DVD_Button"] = function() denon:setInput('DVD') end,
	["BD_Button"] = function() denon:setInput('BD') end,
	["GAME_Button"] = function() denon:setInput('GAME') end,
	["TV_Button"] = function() denon:setInput('TV') end,
	["TUNER_Button"] = function() denon:setInput('TUNER') end,
	["AUX_Button"] = function() denon:setInput('AUX1') end,
	["iPod_Button"] = function() denon:setInput('USB/IPOD') end,
	["CBL_SAT_Button"] = function() denon:setInput('SAT/CBL') end,
	["RADIO_Button"] = function() denon:setInput('IRADIO') end,
	["Media_Player_Button"] = function() denon:setInput('MPLAY') end,
	["NET_Button"] = function() denon:setInput('NET') end
}

denon.onPropertyChanged = {
	power = function(dev, value)
		if (value == false) then
			dev:updateProperty('ui.input_Label.caption', '---')
			dev:updateProperty('ui.volume_Label.caption', '---')
			dev:updateProperty('ui.volume_Slider.value', -80)
		else
			dev:updateProperty('ui.input_Label.caption', dev.properties.input)
			dev:updateProperty('ui.volume_Label.caption', tostring(dev.properties.volume))
			dev:updateProperty('ui.volume_Slider.value', dev.properties.volume)
		end

		dev:updateProperty('ui.power_Switch.value', value)
		dev:getState()
	end,

	volume = function(dev, value)
		dev:updateProperty('ui.volume_Label.caption', tostring(value))
		dev:updateProperty('ui.volume_Slider.value', value)
	end,

	mute = function(dev, value)
		if (value == true) then
			dev:updateProperty('ui.volume_Label.caption', '---')
			dev:updateProperty('ui.volume_Slider.value', -80)
		else
			dev:updateProperty('ui.volume_Label.caption', tostring(dev.properties.volume))
			dev:updateProperty('ui.volume_Slider.value', dev.properties.volume)
		end
		
		dev:updateProperty('ui.mute_Switch.value', value)
	end,

	input = function(dev, value)
		dev:updateProperty('ui.input_Label.caption', value)
	end
}

function onAction(deviceId, action)
	denon:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	local callback = uiBinding[event.elementName]
	
	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip) then
		if (denon:updateProperty('ip', config.ip)) then
			plugin.restart()
		end
	end
end