require('DenonHeos')


denonHeos = DenonHeos(plugin.mainDeviceId)
    
  
function onAction(deviceId, action)
    if deviceId == denonHeos.id then
        denonHeos:callAction(action.actionName, unpack(action.args))
    elseif denonHeos.zones[deviceId] then
        local zone = denonHeos.zones[deviceId]
        zone:callAction(action.actionName, unpack(action.args))
    elseif denonHeos.groups[deviceId] then
        local group = denonHeos.groups[deviceId]
        group:callAction(action.actionName, unpack(action.args))
    end
end

function onUIEvent(deviceId, event)
    if denonHeos.zones[deviceId] then
        local zone = denonHeos.zones[deviceId]
        local callback = zone.uiBinding[event.elementName]
        if (callback) then
            callback(event)
        end
    elseif denonHeos.groups[deviceId] then
        local group = denonHeos.groups[deviceId]
        local callback = group.uiBinding[event.elementName]
        if (callback) then
            callback(event)
        end
    end
end

function configure(deviceId, config)
    plugin.restart()
end