--
-- includes
--
require('dscAlarm')

--
-- create main class
--
dscAlarm = DSCAlarm(plugin.mainDeviceId)

function onAction(deviceId, action)
	if (deviceId == dscAlarm.id) then
		dscAlarm:callAction(action.actionName, unpack(action.args))
	elseif (dscAlarm.childDevices[deviceId]) then
		dscAlarm.childDevices[deviceId]:callAction(action.actionName, unpack(action.args))
	else
		print("[WARNING] wrong deviceId in action command")
	end
end

function onUIEvent(deviceId, event)
	-- not implemented
end

function configure(deviceId, config)
	if (deviceId == dscAlarm.id) then
		local needRestart = false

		needRestart = dscAlarm:updateProperty('ip', config.ip or dscAlarm.properties.ip) or needRestart
		needRestart = dscAlarm:updateProperty('port', config.port or dscAlarm.properties.port) or needRestart

		dscAlarm:updateProperty('userCode', config.userCode or dscAlarm.properties.userCode)
		
		if (needRestart) then
			plugin.restart()
		end
	end
end