require('common.device')

class 'EnvisaLinkPartition' (Device)

function EnvisaLinkPartition:__init(parent, dev)
	Device.__init(self, dev)
	self.parent = parent
end

function EnvisaLinkPartition:arm()
	self.parent:sendData('030', self.properties.partitionId)
end

function EnvisaLinkPartition:disarm()
	local userCode = tostring(self.parent.properties.userCode)
	local zero = '0'
	local paddingDigits = 6 - #userCode

	if (paddingDigits > 0) then
		userCode = userCode .. zero:rep(paddingDigits)
	end

	self.parent:sendData('040', self.properties.partitionId .. userCode)
end