--
-- includes
--
require('envisaLinkAlarm')

--
-- create main class
--
envisaLinkAlarm = EnvisaLinkAlarm(plugin.mainDeviceId)

function onAction(deviceId, action)
	if (deviceId == envisaLinkAlarm.id) then
		envisaLinkAlarm:callAction(action.actionName, unpack(action.args))
	elseif (envisaLinkAlarm.childDevices[deviceId]) then
		envisaLinkAlarm.childDevices[deviceId]:callAction(action.actionName, unpack(action.args))
	else
		print("[WARNING] wrong deviceId in action command")
	end
end

function onUIEvent(deviceId, event)
	-- not implemented
end

function configure(deviceId, config)
	if (deviceId == envisaLinkAlarm.id) then
		local needRestart = false

		needRestart = envisaLinkAlarm:updateProperty('ip', config.ip or envisaLinkAlarm.properties.ip) or needRestart
		needRestart = envisaLinkAlarm:updateProperty('port', config.port or envisaLinkAlarm.properties.port) or needRestart
		
		envisaLinkAlarm:updateProperty('envisalinkPassword', config.envisalinkPassword or envisaLinkAlarm.properties.envisalinkPassword)
		envisaLinkAlarm:updateProperty('userCode', config.userCode or envisaLinkAlarm.properties.userCode)
		
		if (needRestart) then
			plugin.restart()
		end
	end
end