require("FibaroIntercom")
require("FibaroIntercomHelper")

logger.setLevel(logger.INFO)
logger.info('****************************** Starting com.fibaro.fibaroIntercom ******************************')

fibaroIntercom = FibaroIntercom(plugin.mainDeviceId)

uiBinding = {
	['openDoor1Button'] 	= function() fibaroIntercom:openDoor1() end,
	['openDoor2Button'] 	= function() fibaroIntercom:openDoor2() end,
	['recordButton'] 		= function(event) fibaroIntercom:startStopRecord(event) end,
	['Open_Door1_Button']   = function() fibaroIntercom:openDoor1() end, -- for iOS
}

function onAction(deviceId, action)
	return fibaroIntercom:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
    local callback = uiBinding[event.elementName]

	if callback then
		callback(event)
	end
end

function configure(deviceId, config)
	if config.ip ~= nil and config.ip ~= "" then
		fibaroIntercom:updateProperty("ui.imageStream.source", "http://" .. config.ip .. ":8080/live/stream.jpg")
	else
		fibaroIntercom:updateProperty("ui.imageStream.source", "novideo.png")
	end

	if config.ip ~= fibaroIntercom.properties.ip then
		logger.info("[configure] Updating name")
		local helper = FibaroIntercomHelper(config, function (name)
			fibaroIntercom:setName(name)
			logger.info("[configure] restarting...")
			plugin.restart()
		end)
	else
		logger.info("[configure] restarting...")
		plugin.restart()
	end
end
