--
-- includes
--
require('Helios')
--
-- create main class
--

helios = Helios(plugin.mainDeviceId)

function onAction(deviceId, action)
	print("HeliosBasicMain-onAction", action.actionName)
	return helios:callAction(action.actionName, unpack(action.args)) 
end

function onUIEvent(deviceId, event)
	print("HeliosBasicMain-onUIEvent")

    local callback = uiBinding[event.elementName]

	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip ~= '') then
		helios:updateProperty('ui.imageStream.source', 'http://' .. config.ip..'/enu/camera640x480.jpg')
	else
		helios:updateProperty('ui.imageStream.source', 'novideo.png')
	end	

	helios:updateProperty('selectedVoipUser', config.selectedVoipUser)
	helios:updateProperty('selectedKeyCode', config.selectedKeyCode)

	helios:updateProperty('userName', config.userName)
	helios:updateProperty('password', config.password)
	helios:updateProperty('ip', config.ip)

	helios:updateProperty('sipDisplayName', config.sipDisplayName)
	helios:updateProperty('sipUserID', config.sipUserID)
	helios:updateProperty('sipUserPassword', config.sipUserPassword)

	helios:addVoipUserRowToJsonObjectForHeliosPhoneBook()
	helios:initialMethods()
end
