--
-- includes
--
require('lg')
--
-- create main class
--
lg = LG(plugin.mainDeviceId)

uiBinding = {
	["POWER_Button"] = function() lg:sendKey('KEY_POWEROFF') end,
	["NUM_1_Button"] = function() lg:sendKey('KEY_1') end,
	["NUM_2_Button"] = function() lg:sendKey('KEY_2') end,
	["NUM_3_Button"] = function() lg:sendKey('KEY_3') end,
	["NUM_4_Button"] = function() lg:sendKey('KEY_4') end,
	["NUM_5_Button"] = function() lg:sendKey('KEY_5') end,
	["NUM_6_Button"] = function() lg:sendKey('KEY_6') end,
	["NUM_7_Button"] = function() lg:sendKey('KEY_7') end,
	["NUM_8_Button"] = function() lg:sendKey('KEY_8') end,
	["NUM_9_Button"] = function() lg:sendKey('KEY_9') end,
	["NUM_0_Button"] = function() lg:sendKey('KEY_0') end,
	["MENU_Button"] = function() lg:sendKey('KEY_MENU') end,
	["UP_Button"] = function() lg:sendKey('KEY_UP') end,
	["LEFT_Button"] = function() lg:sendKey('KEY_LEFT') end,
	["OK_Button"] = function() lg:sendKey('KEY_ENTER') end,
	["RIGHT_Button"] = function() lg:sendKey('KEY_RIGHT') end,
	["DOWN_Button"] = function() lg:sendKey('KEY_DOWN') end,
	["RETURN_Button"] = function() lg:sendKey('KEY_RETURN') end,
	["RED_Button"] = function() lg:sendKey('KEY_RED') end,
	["GREEN_Button"] = function() lg:sendKey('KEY_GREEN') end,
	["YELLOW_Button"] = function() lg:sendKey('KEY_YELLOW') end,
	["BLUE_Button"] = function() lg:sendKey('KEY_BLUE') end,
	["REWIND_Button"] = function() lg:sendKey('KEY_REWIND') end,
	["PAUSE_Button"] = function() lg:sendKey('KEY_PAUSE') end,
	["FORWARD_Button"] = function() lg:sendKey('KEY_FF') end,
	["PLAY_Button"] = function() lg:sendKey('KEY_PLAY') end,
	["STOP_Button"] = function() lg:sendKey('KEY_STOP') end,
	["PAUSE_Button"] = function() lg:sendKey('KEY_PAUSE') end,
	["EJECT_Button"] = function() lg:sendKey("KEY_EJECT") end,
	["HOME_Button"] = function() lg:sendKey("KEY_HOME") end,
	["REPEAT_Button"] = function() lg:sendKey("KEY_REPEAT") end,
	["ZOOM_Button"] = function() lg:sendKey("KEY_ZOOM") end,
	["NEXT_Button"] = function() lg:sendKey("KEY_NEXT") end,
	["PREV_Button"] = function() lg:sendKey("KEY_PREV") end,
	["REWIND_Button"] = function() lg:sendKey("KEY_REWIND") end,
	["FORWARD_Button"] = function() lg:sendKey("KEY_FORWARD") end,
	["TITLE_POPUP_Button"] = function() lg:sendKey("KEY_TITLE_POPUP") end,
	["INFO_DISPLAY_Button"] = function() lg:sendKey("KEY_INFO_DISPLAY") end,
	["DISC_MENU_Button"] = function() lg:sendKey("KEY_DISC_MENU") end,
	["CLEAR_Button"] = function() lg:sendKey("KEY_CLEAR") end,
	["SEARCH_Button"] = function() lg:sendKey("KEY_SEARCH") end,
	["PAGE_Button"] = function() lg:sendKey("KEY_PAGE") end
}

function onAction(deviceId, action)
	lg:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	local callback = uiBinding[event.elementName]
	
	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip) then
		if (lg:updateProperty('ip', config.ip)) then
			plugin.restart()
		end
	end
end