require('HarmonyAccount')


harmonyAccount = HarmonyAccount(plugin.mainDeviceId)


uiBinding = {  
	["startStopActivitySwitch"] = function(eventArgs) activity:changeActivityState(eventArgs.values[1]) end,
}

function onAction(deviceId, action)
	local activityToAction = harmonyAccount:getActivityById(deviceId)

	if activityToAction then
		return activityToAction:callAction(action.actionName, unpack(action.args)) 
	else		
		return harmonyAccount:callAction(action.actionName, unpack(action.args)) 
	end
end

function onUIEvent(deviceId, event)
	activity = harmonyAccount:getActivityById(deviceId)
	local callback = uiBinding[event.elementName]

	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	plugin.restart() 
end
  