--
-- includes
--
require('Mobotix')
--
-- create main class
--

mobotix = Mobotix(plugin.mainDeviceId)

uiBinding = {
	["Open_Door_Button"] = function() mobotix:openDoor() end,
}

function onAction(deviceId, action)
	return mobotix:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
    local callback = uiBinding[event.elementName]

	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip ~= '') then
		mobotix:updateProperty('ui.imageStream.source', 'http://' .. config.ip .. '/cgi-bin/faststream.jpg')
	else
		mobotix:updateProperty('ui.imageStream.source', 'novideo.png')
	end
	
	mobotix:updateProperty('selectedVoipUser', config.selectedVoipUser)
	mobotix:updateProperty('selectedKeyCode', config.selectedKeyCode)

	mobotix:updateProperty('userName', config.userName)
	mobotix:updateProperty('password', config.password)
	mobotix:updateProperty('ip', config.ip)

	mobotix:updateProperty('sipDisplayName', config.sipDisplayName)
	mobotix:updateProperty('sipUserID', config.sipUserID)
	mobotix:updateProperty('sipUserPassword', config.sipUserPassword)

	mobotix:updatePluginSettings()
end
