--
-- includes
--
require('ncPlus')

--
-- create main class
--
ncPlus = ncPlus(plugin.mainDeviceId)

uiBinding = {
	['powerTv'] = function() ncPlus:sendKey('116') end,
	['home'] = function() ncPlus:sendKey('174') end,
	['volUp'] = function() ncPlus:sendKey('115') end,
	['mute'] = function() ncPlus:sendKey('113') end,
	['volDown'] = function() ncPlus:sendKey('114') end,
	['progUp'] = function() ncPlus:sendKey('402') end,
	['progDown'] = function() ncPlus:sendKey('403') end,
	['backward'] = function() ncPlus:sendKey('168') end,
	['play'] = function() ncPlus:sendKey('207') end,
	['foreward'] = function() ncPlus:sendKey('159') end,
	['rec'] = function() ncPlus:sendKey('167') end,
	['pause'] = function() ncPlus:sendKey('119') end,
	['stop'] = function() ncPlus:sendKey('128') end,
	['info'] = function() ncPlus:sendKey('358') end,
	['up'] = function() ncPlus:sendKey('103') end,
	['opt'] = function() ncPlus:sendKey('357') end,
	['left'] = function() ncPlus:sendKey('105') end,
	['ok'] = function() ncPlus:sendKey('352') end,
	['right'] = function() ncPlus:sendKey('106') end,
	['back'] = function() ncPlus:sendKey('158') end,
	['down'] = function() ncPlus:sendKey('108') end,
	['text'] = function() ncPlus:sendKey('388') end,
	['numeric_1'] = function() ncPlus:sendKey('002') end,
	['numeric_2'] = function() ncPlus:sendKey('003') end,
	['numeric_3'] = function() ncPlus:sendKey('004') end,
	['numeric_4'] = function() ncPlus:sendKey('005') end,
	['numeric_5'] = function() ncPlus:sendKey('006') end,
	['numeric_6'] = function() ncPlus:sendKey('007') end,
	['numeric_7'] = function() ncPlus:sendKey('008') end,
	['numeric_8'] = function() ncPlus:sendKey('009') end,
	['numeric_9'] = function() ncPlus:sendKey('010') end,
	['numeric_hash'] = function() ncPlus:sendKey('001') end,
	['numeric_star'] = function() ncPlus:sendKey('012') end,
	['numeric_0'] = function() ncPlus:sendKey('011') end,
	['epg'] = function() ncPlus:sendKey('365') end,
	['vod'] = function() ncPlus:sendKey('361') end,
	['app'] = function() ncPlus:sendKey('367') end,
	['list'] = function() ncPlus:sendKey('395') end,
	['setup'] = function() ncPlus:sendKey('139') end,
	['app'] = function() ncPlus:sendKey('357') end, 
	['red'] = function() ncPlus:sendKey('398') end, 
	['green'] = function() ncPlus:sendKey('399') end, 
	['yellow'] = function() ncPlus:sendKey('400') end, 
	['blue'] = function() ncPlus:sendKey('401') end, 
	['at'] = function() ncPlus:sendKey('385') end
}

function onAction(deviceId, action)
	return ncPlus:callAction(action.actionName, unpack(action.args)) 
end

function onUIEvent(deviceId, event)
    local callback = uiBinding[event.elementName]
    if (callback) then
        callback(event)
    end
end

function configure(deviceId, config)
	if config.ip then
		ncPlus:updateProperty('ip', config.ip)
	end
	if config.port then
		ncPlus:updateProperty('port', config.port)
	end
	if config.uuid then
		ncPlus:updateProperty('uuid', config.uuid)
	end

	ncPlus:getUuid()
end


