--
-- includes
--
require('netatmoController')

--
-- create main class
--
netatmo = NetatmoController(plugin.mainDeviceId)

uiBinding = {
        ["Away_Switch"] = function(eventArgs) if (eventArgs.values[1]) then
                                                    netatmo:changeMode(eventArgs.deviceId,2)
                                                else
                                                    netatmo:changeMode(eventArgs.deviceId,1)
                                                end
                            end,

        ["HG_Switch"] = function(eventArgs) if (eventArgs.values[1]) then
                                                netatmo:changeMode(eventArgs.deviceId,3)
                                            else
                                                netatmo:changeMode(eventArgs.deviceId,1)
                                            end
                        end,

        ["Setpoint_Endtime_Slider"] = function(eventArgs) netatmo:setEndpoint(eventArgs.deviceId, eventArgs.values[1]) end,
        ["Plus_Setpoint_Button"] = function(eventArgs) netatmo:setTemperature(true,eventArgs.deviceId) end,
        ["Minus__Setpoint_Button"] = function(eventArgs) netatmo:setTemperature(false,eventArgs.deviceId) end
}

function onAction(deviceId, action)
	netatmo:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
        local callback = uiBinding[event.elementName]

        if (callback) then
            callback(event)
        end
end

function configure(deviceId, config)
        if (config.username and config.password and config.client_id and config.client_secret and config.polling_time) then
            if (netatmo:updateProperty('polling_time', config.polling_time) or netatmo:updateProperty('username', config.username) or netatmo:updateProperty('password', config.password) or netatmo:updateProperty('client_id', config.client_id) or netatmo:updateProperty('client_secret', config.client_secret)) then
                plugin.restart()
            end
        end
end
