require('nuvo')

--
-- create main class
--

nuvo = Nuvo(plugin.mainDeviceId)
	
 

function onAction(deviceId, action)
    if deviceId == nuvo.id then
        nuvo:callAction(action.actionName, unpack(action.args))
    else
        local zone = nuvo.zones[deviceId]
        if zone then
            zone:callAction(action.actionName, unpack(action.args))
        end
    end
end

function onUIEvent(deviceId, event)
    if deviceId == nuvo.id then
        local callback = nuvo.uiBinding[event.elementName]
    
        if (callback) then
            callback(event)
        end
    else
        local zone = nuvo.zones[deviceId]
        if zone then
            if (zone.uiBinding) then
                local callback = zone.uiBinding[event.elementName]
    
                if (callback) then
                    callback(event)
                end
            end
        end
    end
end

function configure(deviceId, config)
	if (config.ip) then
		nuvo:updateProperty('ip', config.ip)
	end
	plugin.restart()
end