-- 
-- includes 
-- 
require('onkyo') 

-- 
-- create main class 
-- 
onkyo = Onkyo(plugin.mainDeviceId) 

uiBinding = {  
    ["BDDVD_Button"] = function() onkyo:setInput("BD/DVD") end, 
    ["VCRDVR_Button"] = function() onkyo:setInput("VCR/DVR") end, 
    ["CBLSAT_Button"] = function() onkyo:setInput("CBL/SAT") end, 
    ["GAME_Button"] = function() onkyo:setInput("GAME") end, 
    ["PC_Button"] = function() onkyo:setInput("PC") end, 
    ["AUX_Button"] = function() onkyo:setInput("AUX") end, 
    ["TUNER_Button"] = function() onkyo:setInput("TUNER") end, 
    ["TVCD_Button"] = function() onkyo:setInput("TV/CD") end, 
    ["PHONO_Button"] = function() onkyo:setInput("PHONO") end, 
    ["PORT_Button"] = function() onkyo:setInput("PORT") end, 
    ["NET_Button"] = function() onkyo:setInput("NET") end, 
    ["USB_Button"] = function() onkyo:setInput("USB") end, 
    ["MUTE_Switch"] = function(eventArgs) 
                            onkyo:setMute(eventArgs.values[1]) 
                        end, 
    ["volume_Slider"] = function(eventArgs) onkyo:setVolume(eventArgs.values[1]) end, 
    ["UP_Button"] = function() onkyo:sendKey("KEY_UP") end, 
    ["LEFT_Button"] = function() onkyo:sendKey("KEY_LEFT") end, 
    ["RIGHT_Button"] = function() onkyo:sendKey("KEY_RIGHT") end, 
    ["DOWN_Button"] = function() onkyo:sendKey("KEY_DOWN") end, 
    ["HOME_Button"] = function() onkyo:sendKey("KEY_HOME") end, 
    ["SETUP_Button"] = function() onkyo:sendKey("KEY_SETUP") end, 
    ["RETURN_Button"] = function() onkyo:sendKey("KEY_RETURN") end, 
    ["OK_Button"] = function() onkyo:sendKey("KEY_ENTER") end, 
    ["POWER_Switch"] =    function(eventArgs) 
                        if (eventArgs.values[1]) 
                            then 
                                onkyo:turnOn() 
                            else 
                                onkyo:turnOff() 
                            end 
                        end 
} 

onkyo.onPropertyChanged = { 
    power = function(dev, value) 
        if (value == 0) 
        then 
            dev:updateProperty('volume', 0) 
            dev:updateProperty('input', '---') 
            dev:updateProperty('mute', false) 
        else 
            dev:refreshState() 
        end 
        dev:updateProperty('ui.POWER_Switch.value', value) 
    end, 

    volume = function(dev, value) 

        if (dev.properties.power == true) 
        then 
        print('volume update') 
            dev:updateProperty('ui.volume_Slider.value', value) 
        else 

            local powerOffValue = 0 
            dev:updateProperty('ui.volume_Slider.value', powerOffValue) 
                            print('volume update powe off') 

            if dev.properties.volume ~= powerOffValue 
            then 
                dev:updateProperty('volume', powerOffValue) 
            end 
        end 
    end, 

    mute = function(dev, value) 
        if (dev.properties.power == true) 
        then 
            if (value > 0) 
            then 
                dev:updateProperty("ui.MUTE_Switch.value", true) 
            else 
                dev:updateProperty("ui.MUTE_Switch.value", false) 
            end 
        else 
            local powerOffValue = 0 
            dev:updateProperty("ui.MUTE_Switch.value", powerOffValue) 
            if dev.properties.mute ~= powerOffValue 
            then 
                dev:updateProperty('mute', powerOffValue) 
            end 
        end 

    end, 

    input = function(dev, value) 
        if (dev.properties.power == true) 
        then 
            dev:updateProperty('ui.input_Label.caption', value) 
        else 
            local powerOffValue = '---' 
            dev:updateProperty('ui.input_Label.caption', powerOffValue) 
            if dev.properties.input ~= powerOffValue 
            then 
                dev:updateProperty('input', powerOffValue) 
            end 
        end 
    end 
} 

function onAction(deviceId, action) 
    onkyo:callAction(action.actionName, unpack(action.args)) 
end 

function onUIEvent(deviceId, event) 
    local callback = uiBinding[event.elementName] 
    if (callback) then 
        callback(event) 
    end 
end 

function configure(deviceId, config) 
    print('config ip') 
    if (config.ip) then 
        if (onkyo:updateProperty('ip', config.ip)) then 
        end 
    end 
    print('config PORT') 

    if (config.port) then 
        if (onkyo:updateProperty('port', tonumber(config.port))) then 
        end 
    end 

    plugin.restart() 
end