require('philips')

--
-- create main class
--
philips = Philips(plugin.mainDeviceId)

uiBinding = {
	["POWER_Button"] = function() philips:sendKey("KEY_POWEROFF") end,
	["NUM_1_Button"] = function() philips:sendKey("KEY_1") end,
	["NUM_2_Button"] = function() philips:sendKey("KEY_2") end,
	["NUM_3_Button"] = function() philips:sendKey("KEY_3") end,
	["NUM_4_Button"] = function() philips:sendKey("KEY_4") end,
	["NUM_5_Button"] = function() philips:sendKey("KEY_5") end,
	["NUM_6_Button"] = function() philips:sendKey("KEY_6") end,
	["NUM_7_Button"] = function() philips:sendKey("KEY_7") end,
	["NUM_8_Button"] = function() philips:sendKey("KEY_8") end,
	["NUM_9_Button"] = function() philips:sendKey("KEY_9") end,
	["NUM_0_Button"] = function() philips:sendKey("KEY_0") end,
	["TOP_MENU_Button"] = function() philips:sendKey("KEY_TOP_MENU") end,
	["POP_UP_MENU_Button"] = function() philips:sendKey("KEY_POP_UP_MENU") end,
	["UP_Button"] = function() philips:sendKey("KEY_UP") end,
	["LEFT_Button"] = function() philips:sendKey("KEY_LEFT") end,
	["RIGHT_Button"] = function() philips:sendKey("KEY_RIGHT") end,
	["DOWN_Button"] = function() philips:sendKey("KEY_DOWN") end,
	["OK_Button"] = function() philips:sendKey("KEY_ENTER") end,
	["RETURN_Button"] = function() philips:sendKey("KEY_RETURN") end,
	["RED_Button"] = function() philips:sendKey("KEY_RED") end,
	["GREEN_Button"] = function() philips:sendKey("KEY_GREEN") end,
	["YELLOW_Button"] = function() philips:sendKey("KEY_YELLOW") end,
	["BLUE_Button"] = function() philips:sendKey("KEY_BLUE") end,
	["REWIND_Button"] = function()philips:sendKey("KEY_REWIND") end,
	["PAUSE_Button"] = function() philips:sendKey("KEY_PAUSE") end,
	["FORWARD_Button"] = function() philips:sendKey("KEY_FORWARD") end,
	["PLAY_Button"] = function() philips:sendKey("KEY_PLAY") end,
	["STOP_Button"] = function()philips:sendKey("KEY_STOP") end,
	["HOME_Button"] = function() philips:sendKey("KEY_HOME") end,
	["OPTIONS_Button"] = function() philips:sendKey("KEY_OPTIONS") end,
	["AUDIO_Button"] = function() philips:sendKey("KEY_AUDIO") end,
	["SUBTITLE_Button"] = function() philips:sendKey("KEY_SUBTITLE") end,
	["PREV_Button"] = function() philips:sendKey("KEY_PREV") end,
	["NEXT_Button"] = function() philips:sendKey("KEY_NEXT") end,
	["EJECT_Button"] = function() philips:sendKey("KEY_EJECT") end
}

function onAction(deviceId, action)
	philips:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	local callback = uiBinding[event.elementName]
	
	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip) then
		philips:updateProperty('ip', config.ip)
		philips:updateProperty('authCode', '')
		plugin.restart()
	end
end



