--
-- includes
--
require('philipsHue')

--
-- create main class
--
philipsHue = philipsHue(plugin.mainDeviceId)

function onAction(deviceId, action)
    if deviceId == philipsHue.id then
        philipsHue:callAction(action.actionName, unpack(action.args))
    else
        local light = philipsHue.lights[deviceId]
        if light then
            light:callAction(action.actionName, unpack(action.args))
        end
    end
end

function onUIEvent(deviceId, event)
    if deviceId == philipsHue.id then
        local callback = philipsHue.uiBinding[event.elementName]
    
        if (callback) then
            callback(event)
        end
    else
        local light = philipsHue.lights[deviceId]
        if light then
            if (light.uiBinding) then
                local callback = light.uiBinding[event.elementName]
    
                if (callback) then
                    callback(event)
                end
            end
        end
    end
end

function configure(deviceId, config)
    if deviceId == philipsHue.id then
        restart = false
        if (config.ip) then
            philipsHue:updateProperty('ip', config.ip)
            restart = true
        end
        if (config.pollingTimeout) then
            philipsHue:updateProperty('pollingTimeout', tonumber(config.pollingTimeout))
        end

        if (restart) then
            plugin.restart()
        end
    end
end
