require('PlanikaFla')

--
-- create main class
--

planikaFla = PlanikaFla(plugin.mainDeviceId)

uiBinding = {
	["START_BUTTON"] = function() planikaFla:start() end,
	["STOP_BUTTON"] = function() planikaFla:stop() end,
	["PLUS_BUTTON"] = function() planikaFla:plus() end,
	["MINUS_BUTTON"] = function() planikaFla:minus() end,
	["LOCK_ON_OFF_SWITCH"] = function(eventArgs) planikaFla:changeLockState(eventArgs.values[1]) end
}

function onAction(deviceId, action)
	return planikaFla:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	local callback = uiBinding[event.elementName]
	
	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	plugin.restart()
end