require('RussoundXZone4')


russoundXZone4 = RussoundXZone4(plugin.mainDeviceId)
     
  
function onAction(deviceId, action)
    if deviceId == russoundXZone4.id then
        russoundXZone4:callAction(action.actionName, unpack(action.args))
    else
        for _,controller in pairs(russoundXZone4.controllers or {}) do
            for _,zone in pairs(controller.zones or {}) do
                if zone.id == deviceId then
                    zone:callAction(action.actionName, unpack(action.args))
                end
            end
        end            
    end
end  

function onUIEvent(deviceId, event)
    for _,controller in pairs(russoundXZone4.controllers or {}) do
        for _,zone in pairs(controller.zones or {}) do
            if zone.id == deviceId then
                if event.eventType == 'playlistSort' then
                    local values = event.values
                    zone:queueSortOrder(values[1].from, values[1].to)
                elseif event.eventType == 'removeSong' then
                    local values = event.values
                    zone:removeFromPlaylist(values[1].id)       
                elseif event.eventType == 'currentIdUpdate' then
                    local values = event.values
                    zone:playFromQueue(values[1].id)
                end

                local callback = zone.uiBinding[event.elementName]
                if (callback) then
                    callback(event)
                end   
            end
        end
   end
end

function configure(deviceId, config)
    plugin.restart()
end