--
-- includes
--
require('samsung')

--
-- create main class
--
samsung = Samsung(plugin.mainDeviceId)

uiBinding = {
	["POWER_Button"] = function() samsung:sendKey('KEY_POWEROFF') end,
	["MUTE_Button"] = function() samsung:sendKey('KEY_MUTE') end,
	["NUM_1_Button"] = function() samsung:sendKey('KEY_1') end,
	["NUM_2_Button"] = function() samsung:sendKey('KEY_2') end,
	["NUM_3_Button"] = function() samsung:sendKey('KEY_3') end,
	["NUM_4_Button"] = function() samsung:sendKey('KEY_4') end,
	["NUM_5_Button"] = function() samsung:sendKey('KEY_5') end,
	["NUM_6_Button"] = function() samsung:sendKey('KEY_6') end,
	["NUM_7_Button"] = function() samsung:sendKey('KEY_7') end,
	["NUM_8_Button"] = function() samsung:sendKey('KEY_8') end,
	["NUM_9_Button"] = function() samsung:sendKey('KEY_9') end,
	["TTX_MIX_Button"] = function() samsung:sendKey('KEY_TTX_MIX') end,
	["NUM_0_Button"] = function() samsung:sendKey('KEY_0') end,
	["PRE_CH_Button"] = function() samsung:sendKey('KEY_PRECH') end,
	["VOLUME_UP_Button"] = function() samsung:sendKey('KEY_VOLUP') end,
	["VOLUME_DOWN_Button"] = function() samsung:sendKey('KEY_VOLDOWN') end,
	["CHANNEL_UP_Button"] = function() samsung:sendKey('KEY_CHUP') end,
	["CHANNEL_DOWN_Button"] = function() samsung:sendKey('KEY_CHDOWN') end,
	["MENU_Button"] = function() samsung:sendKey('KEY_MENU') end,
	["SMART_Button"] = function() samsung:sendKey('KEY_W_LINK') end,
	["GUIDE_Button"] = function() samsung:sendKey('KEY_GUIDE') end,
	["SOURCE_Button"] = function() samsung:sendKey('KEY_SOURCE') end,
	["HDMI_Button"] = function() samsung:sendKey('KEY_HDMI') end,
	["CH_LIST_Button"] = function() samsung:sendKey('KEY_CH_LIST') end,
	["TOOLS_Button"] = function() samsung:sendKey('KEY_TOOLS') end,
	["UP_Button"] = function() samsung:sendKey('KEY_UP') end,
	["INFO_Button"] = function() samsung:sendKey('KEY_INFO') end,
	["LEFT_Button"] = function() samsung:sendKey('KEY_LEFT') end,
	["OK_Button"] = function() samsung:sendKey('KEY_ENTER') end,
	["RIGHT_Button"] = function() samsung:sendKey('KEY_RIGHT') end,
	["RETURN_Button"] = function() samsung:sendKey('KEY_RETURN') end,
	["DOWN_Button"] = function() samsung:sendKey('KEY_DOWN') end,
	["EXIT_Button"] = function() samsung:sendKey('KEY_EXIT') end,
	["A_Button"] = function() samsung:sendKey('KEY_RED') end,
	["B_Button"] = function() samsung:sendKey('KEY_GREEN') end,
	["C_Button"] = function() samsung:sendKey('KEY_YELLOW') end,
	["D_Button"] = function() samsung:sendKey('KEY_CYAN') end,
	["FAST_REWIND_Button"] = function() samsung:sendKey('KEY_REWIND') end,
	["PAUSE_Button"] = function() samsung:sendKey('KEY_PAUSE') end,
	["FAST_FORWARD_Button"] = function() samsung:sendKey('KEY_FF') end,
	["RECORD_Button"] = function() samsung:sendKey('KEY_REC') end,
	["PLAY_Button"] = function() samsung:sendKey('KEY_PLAY') end,
	["STOP_Button"] = function() samsung:sendKey('KEY_STOP') end
}

function onAction(deviceId, action)
	samsung:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	local callback = uiBinding[event.elementName]
	
	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip) then
		if (samsung:updateProperty('ip', config.ip)) then
			plugin.restart()
		end
	end
end