--
-- includes
--
require('satelAlarm')

generalLog = io.open("/tmp/general.log" ,"a")
updatesLog = io.open("/tmp/updates.log" ,"a")

logType = 0 -- 0-none, 1-console, 2-file (paths set above)

function logGeneral(msg)
    if logType == 2 then
        generalLog:write(msg)
        generalLog:flush()
    elseif logType == 1 then
        print(msg)
    end
end

function logUpdates(msg)
    if logType == 2 then
        updatesLog:write(msg)
        updatesLog:flush()
    elseif logType == 1 then
        print(msg)
    end
end

--
-- create main class
--
alarm = SatelAlarm(plugin.mainDeviceId)

function onAction(deviceId, action)
    if (deviceId == alarm.id) then
        if action.actionName == "reloadConfiguration" then
            alarm.numberOfAllSteps = alarm.maxZones + alarm.maxPartitions + alarm.maxOutputs
            alarm.stepsToFinishAddingPlugin = alarm.maxZones + alarm.maxPartitions + alarm.maxOutputs
            alarm.lastJobPercent = 0

            alarm:createProgressNotification()
        end

        alarm:callAction(action.actionName, unpack(action.args))

    elseif (alarm.childDevices[deviceId]) then
        alarm.childDevices[deviceId]:callAction(action.actionName, unpack(action.args))
    else
        print("[WARNING] wrong deviceId in action command")
    end
end

function onUIEvent(deviceId, event)
    -- not implemented
end

function configure(deviceId, config)
    if (deviceId == alarm.id) then
        local needRestart = false

        needRestart = alarm:updateProperty('ip', config.ip or alarm.properties.ip) or needRestart
        needRestart = alarm:updateProperty('port', config.port or alarm.properties.port) or needRestart

        alarm:updateProperty('userCode', config.userCode or alarm.properties.userCode)

        if (needRestart) then
            plugin.restart()
        end
    else
        if config.disabled ~= nil then
            alarm.childDevices[deviceId].properties.disabled = config.disabled
        end
    end
end
