require('common.device')

class 'SatelOutput' (Device)

function SatelOutput:__init(parent, dev)
    self.parent = parent
    Device.__init(self, dev)
end

function SatelOutput:turnOn()
    self.parent:sendData(string.char(0x88) .. self.parent:getPinAsBytes() .. self.parent:to128bits(self.properties.outputId))
    setTimeout(function() self.parent:sendData(string.char(0x17)) end, 1000)
    self:updateProperty("value", true)
end

function SatelOutput:turnOff()
    self.parent:sendData(string.char(0x89) .. self.parent:getPinAsBytes() .. self.parent:to128bits(self.properties.outputId))
    setTimeout(function() self.parent:sendData(string.char(0x17)) end, 1000)
    self:updateProperty("value", false)
end

function SatelOutput:reload()
    self.parent:sendData(string.char(0xEE, 0x04, self.properties.outputId))
end