require('sonyTv')

--
-- create main class
--

sony = Sony(plugin.mainDeviceId)

uiBinding = {
	["POWER_Button"] = function() sony:power() end,
	["NUM_1_Button"] = function() sony:sendKey("KEY_1") end,
	["NUM_2_Button"] = function() sony:sendKey("KEY_2") end,
	["NUM_3_Button"] = function() sony:sendKey("KEY_3") end,
	["NUM_4_Button"] = function() sony:sendKey("KEY_4") end,
	["NUM_5_Button"] = function() sony:sendKey("KEY_5") end,
	["NUM_6_Button"] = function() sony:sendKey("KEY_6") end,
	["NUM_7_Button"] = function() sony:sendKey("KEY_7") end,
	["NUM_8_Button"] = function() sony:sendKey("KEY_8") end,
	["NUM_9_Button"] = function() sony:sendKey("KEY_9") end,
	["NUM_0_Button"] = function() sony:sendKey("KEY_0") end,
	["TOP_MENU_Button"] = function() sony:sendKey("KEY_TOP_MENU") end,
	["POP_UP_MENU_Button"] = function() sony:sendKey("KEY_POP_UP_MENU") end,
	["UP_Button"] = function() sony:sendKey("KEY_UP") end,
	["LEFT_Button"] = function() sony:sendKey("KEY_LEFT") end,
	["RIGHT_Button"] = function() sony:sendKey("KEY_RIGHT") end,
	["DOWN_Button"] = function() sony:sendKey("KEY_DOWN") end,
	["OK_Button"] = function() sony:sendKey("KEY_ENTER") end,
	["RETURN_Button"] = function() sony:sendKey("KEY_RETURN") end,
	["RED_Button"] = function() sony:sendKey("KEY_RED") end,
	["GREEN_Button"] = function() sony:sendKey("KEY_GREEN") end,
	["YELLOW_Button"] = function() sony:sendKey("KEY_YELLOW") end,
	["BLUE_Button"] = function() sony:sendKey("KEY_BLUE") end,
	["REWIND_Button"] = function()sony:sendKey("KEY_REWIND") end,
	["PAUSE_Button"] = function() sony:sendKey("KEY_PAUSE") end,
	["FORWARD_Button"] = function() sony:sendKey("KEY_FORWARD") end,
	["PLAY_Button"] = function() sony:sendKey("KEY_PLAY") end,
	["STOP_Button"] = function()sony:sendKey("KEY_STOP") end,
	["RECORD_Button"] = function()sony:sendKey("KEY_RECORD") end,
	["HOME_Button"] = function() sony:sendKey("KEY_HOME") end,
	["OPTIONS_Button"] = function() sony:sendKey("KEY_OPTIONS") end,
	["DISPLAY_Button"] = function() sony:sendKey("KEY_DISPLAY") end,
	["AUDIO_Button"] = function() sony:sendKey("KEY_AUDIO") end,
	["SUBTITLE_Button"] = function() sony:sendKey("KEY_SUBTITLE") end,
	["FAVORITES_Button"] = function() sony:sendKey("KEY_FAVORITES") end,
	["PREV_Button"] = function() sony:sendKey("KEY_PREV") end,
	["NEXT_Button"] = function() sony:sendKey("KEY_NEXT") end,
	["REPLY_Button"] = function() sony:sendKey("KEY_REPLY") end,
	["ADVANCE_Button"] = function() sony:sendKey("KEY_ADVANCE") end,
	["ANGLE_Button"] = function() sony:sendKey("KEY_ANGLE") end,
	["EJECT_Button"] = function() sony:sendKey("KEY_EJECT") end,
	["KARAOKE_Button"] = function() sony:sendKey("KEY_KARAOKE") end,
	["SEN_Button"] = function() sony:sendKey("KEY_SEN") end,
	["NETFLIX_Button"] = function() sony:sendKey("KEY_NETFLIX") end,
	["THREED_MODE_Button"] = function() sony:sendKey("KEY_3D_MODE") end,
	["INPUT_Button"] = function() sony:sendKey("KEY_INPUT") end,
	["VOLUME_UP_Button"] = function() sony:sendKey("KEY_VOLUP") end,
	["VOLUME_DOWN_Button"] = function() sony:sendKey("KEY_VOLDOWN") end,
	["CHANNEL_UP_Button"] = function() sony:sendKey("KEY_CHUP") end,
	["CHANNEL_DOWN_Button"] = function() sony:sendKey("KEY_CHDOWN") end,
	["MUTE_Button"] = function() sony:sendKey("KEY_MUTE") end,
	["RADIO_TV_Button"] = function() sony:sendKey("KEY_TV_RADIO") end,
	["WIDE_Button"] = function() sony:sendKey("KEY_Wide") end,
	["IMANUAL_Button"] = function() sony:sendKey("KEY_IMANUAL") end,
	["GUIDE_Button"] = 	function() sony:sendKey("KEY_GUIDE") end
}


	

function onAction(deviceId, action)
	sony:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	local callback = uiBinding[event.elementName]
	
	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	if (config.ip) then
		sony:updateProperty('ip', config.ip)
	end
	plugin.restart()
end