--
-- includes
--
require('wakeOnLan')

--
-- create main class
--
wakeOnLan = wakeOnLan(plugin.mainDeviceId)

uiBinding = {
    ["turnOn"] = function() wakeOnLan:turnOn(); end
}

function onAction(deviceId, action)
    wakeOnLan:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
    local callback = uiBinding[event.elementName]
    
    if (callback) then
        callback(event)
    end
end

function configure(deviceId, config)
    if (config.macAddress) then
        if (wakeOnLan:updateProperty('macAddress', config.macAddress)) then
            plugin.restart()
        end
    end
end
