--
-- includes
--
require('xbmc')

--
-- create main class
--
xbmc = Xbmc(plugin.mainDeviceId)

uiBinding = {
	["home"] = function() xbmc:eTgoHome() end,
	["rewind"] = function() xbmc:rewind() end,  
	["play"] = function() xbmc:play() end,
	["forward"] = function() xbmc:forward() end, 
	["back"] = function() xbmc:previous() end, 
	["stop"] = function() xbmc:stop() end, 
	["pause"] = function() xbmc:pause() end, 
	["next"] = function() xbmc:next() end,  
	["mute"] = function() xbmc:mute() end, 
	["up"] = function() xbmc:up() end, 
	["info"] = function() xbmc:info() end, 
	["left"] = function() xbmc:left() end, 
	["select"] = function() xbmc:select() end, 
	["right"] = function() xbmc:right() end, 
	["menu"] = function() xbmc:menu() end, 
	["down"] = function() xbmc:down() end, 
	["return"] = function() xbmc:back() end
}

xbmc.onPropertyChanged = {
}

function onAction(deviceId, action)
	xbmc:callAction(action.actionName, unpack(action.args))
end

function onUIEvent(deviceId, event)
	local callback = uiBinding[event.elementName]
	
	if (callback) then
		callback(event)
	end
end

function configure(deviceId, config)
	restart = false
	if (config.ip) then
		if (xbmc:updateProperty('ip', config.ip)) then
	restart=true
		end	
	end
	if (config.port) then
		if (xbmc:updateProperty('port', config.port)) then
	restart=true
		end
	end		
	if (config.usermane) then
		if (xbmc:updateProperty('usermane', config.usermane)) then
	restart=true
		end
	end	

	if (config.password) then
		if (xbmc:updateProperty('password', config.password)) then
	restart=true
		end
	end	
	if restart then
		plugin.restart()
	end
	    	
end