require('common.device')
require('common.base64') 
require('net.HTTPClient')



--local json = require('json')
print("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA",json)
class 'Xbmc' (Device)

function Xbmc:__init(id)
	Device.__init(self, id)
	self.http = net.HTTPClient({ timeout = 3000 })
	self.payload = {}
	self.payload["jsonrpc"]="2.0"
	self.payload["method"]=""
	self.payload["id"]=1
end

--! @brief Send POST request to XBMC server
--! @param payload a JSON string
function Xbmc:sendJsonRPC(payload)		 
	print('Xbmc:sendJsonRPC', json.encode(payload))   	
    code = to_base64(self.properties.username .. ':'.. self.properties.password)
    authenticationHeaders = {}
    authenticationHeaders['Authorization'] = 'Basic ' .. code
    local url = 'http://'.. self.properties.ip .. ':' .. tostring(self.properties.port) .. '/jsonrpc'

    print("URL: ", url)

	self.http:request(url, {
		options = {
			method = 'POST',
			headers = authenticationHeaders, 
			data = json.encode(payload),
		},
		success = function(param)
			print('Succes STATUS: ' .. param.status)
			print('Succes DATA: ' .. param.data)
		end,
		error = function (error)
			print('*******************')
			print('* ERROR: '.. error)
			print('*******************')
		end
	})
end

--! @brief create a JSON RPC command for HOME action
function Xbmc:eTgoHome()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="home"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for MUTE action
function Xbmc:mute()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="mute"}
	self:sendJsonRPC(self.payload)
	
end

--! @brief create a JSON RPC command for MENU action
function Xbmc:menu()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="osd"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for rewind action
function Xbmc:rewind()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="rewind"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for INFO action
function Xbmc:info()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="info"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for FAST_FORWARD action
function Xbmc:forward()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="fastforward"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for SKIP_PREV action
function Xbmc:previous()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="skipprevious"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for SKIP_NEXT action
function Xbmc:next()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="skipnext"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for STOP action
function Xbmc:stop()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="stop"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for PAUSE action
function Xbmc:pause()	
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="pause"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for PLAY action
function Xbmc:play()	
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="play"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for SELECT action
function Xbmc:select()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="select"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for BACK action
function Xbmc:back()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="back"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for LEFT action
function Xbmc:left()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="left"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for RIGHT action
function Xbmc:right()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="right"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for UP action
function Xbmc:up()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="up"}
	self:sendJsonRPC(self.payload)
end

--! @brief create a JSON RPC command for DOWN action
function Xbmc:down()
	self.payload["method"]="Input.ExecuteAction"
	self.payload["params"]={["action"]="down"}
	self:sendJsonRPC(self.payload)
end