
ALTER TABLE "NEW_Scene" ADD "ReadOnly" BOOLEAN NOT NULL DEFAULT '0';

CREATE TABLE "Alarm_Fibaro_Scene" (
  "Id" integer PRIMARY KEY NOT NULL,
  "PredefinedId" integer NOT NULL,
  "Name" text NOT NULL,
  "RunTime" integer NOT NULL DEFAULT "0",
  "Active" boolean NOT NULL DEFAULT "0",
  "Predefined" boolean NOT NULL,
  "Properties" text NOT NULL DEFAULT "[]"
);

INSERT INTO "Alarm_Fibaro_Scene" ("Id", "PredefinedId", "Name", "RunTime", "Active", "Predefined", "Properties", "Id") VALUES (1,	1,	'Panic',	0,	'0',	'1',	'{
    "conditions":[
        {
            "type":"com.fibaro.binarySwitch",
            "properties":[
                {"name": "isLight", "value":"1"}
            ]
        },
				{
            "type":"com.fibaro.multilevelSwitch",
            "properties":[
                {"name": "isLight", "value":"1"}
            ]
        },
				{
            "type":"com.fibaro.rollerShutter",
            "properties":[]
        },
				{
            "type":"IP_camera",
            "properties":[]
        }
    ],
    "devices":[
        0
    ],
    "notifications":[
        0
    ]
}',	1);
INSERT INTO "Alarm_Fibaro_Scene" ("Id", "PredefinedId", "Name", "RunTime", "Active", "Predefined", "Properties", "Id") VALUES (2,	2,	'Lights On',	0,	'0',	'1',	'{
    "conditions":[
        {
            "type":"com.fibaro.binarySwitch",
            "properties":[
                {"name": "isLight", "value":"1"}
            ]
        },
				{
            "type":"com.fibaro.multilevelSwitch",
            "properties":[
                {"name": "isLight", "value":"1"}
            ]
        }
    ],
    "devices":[
        0
    ]
}',	2);
INSERT INTO "Alarm_Fibaro_Scene" ("Id", "PredefinedId", "Name", "RunTime", "Active", "Predefined", "Properties", "Id") VALUES (3,	3,	'Blinds / Windows Close',	0,	'0',	'1',	'{
    "conditions":[
		{
            "type":"com.fibaro.rollerShutter",
            "properties":[]
        }
    ],
    "devices":[
        0
    ]
}',	3);
INSERT INTO "Alarm_Fibaro_Scene" ("Id", "PredefinedId", "Name", "RunTime", "Active", "Predefined", "Properties", "Id") VALUES (4,	4,	'Emergency Lights',	0,	'0',	'1',	'{
    "conditions":[
        {
            "type":"com.fibaro.binarySwitch",
            "properties":[
                {"name": "isLight", "value":"1"}
            ]
        },
				{
            "type":"com.fibaro.multilevelSwitch",
            "properties":[
                {"name": "isLight", "value":"1"}
            ]
        }
    ],
    "devices":[
        0
    ]
}',	4);
INSERT INTO "Alarm_Fibaro_Scene" ("Id", "PredefinedId", "Name", "RunTime", "Active", "Predefined", "Properties", "Id") VALUES (5,	5,	'Send Screens',	0,	'0',	'1',	'{
    "conditions":[
	{
            "type":"com.fibaro.camera",
            "properties":[]
        }
    ],
    "devices":[
        0
    ]
}',	5);
INSERT INTO "Alarm_Fibaro_Scene" ("Id", "PredefinedId", "Name", "RunTime", "Active", "Predefined", "Properties", "Id") VALUES (7,	7,	'Text Message',	0,	'0',	'1',	'{
    "notifications":[
        0
    ]
}',	7);



INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_1_NAME', 'Panika');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_1_NAME', 'Panic');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_1_DESCRIPTION', 'Włącz wybrane światła, zamknij wybrane rolety, wyślij obrazy z wybranych kamer i wybrane powiadomienia.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_1_DESCRIPTION', 'Switch on selected lights, close selected blinds, send selected cameras screens and selected notifications.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_2_NAME', 'Włącz światła');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_2_NAME', 'Lights On');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_2_DESCRIPTION', 'Włącz wybrane światła lub wszystkie światła w domu.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_2_DESCRIPTION', 'Switch on selected lights or all lights in the house.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_3_NAME', 'Zamknij rolety');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_3_NAME', 'Blinds close');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_3_DESCRIPTION', 'Zamknij wybrane rolety lub wszystkie w domu.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_3_DESCRIPTION', 'Close selected blinds or all blinds in the house.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_4_NAME', 'Światła awaryjne');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_4_NAME', 'Emergency lights');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_4_DESCRIPTION', 'Przełącz wybrane światła lub wszystkie światła w domu w tryb awaryjny.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_4_DESCRIPTION', 'Switch selected lights or all lights in the house to emergency mode.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_5_NAME', 'Wyślij obrazy');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_5_NAME', 'Send screens');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_5_DESCRIPTION', 'Wyślij obrazy z wybranych kamer lub ze wszystkich kamer w domu.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_5_DESCRIPTION', 'Send screens from selected cameras or all cameras in the house.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_7_NAME', 'Wyślij powiadomienia');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_7_NAME', 'Send notifications');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('pl', 'TXT_FIBAROALARMSCENE_7_DESCRIPTION', 'Wyślij wybrane lub wszystkie powiadomienia zdefiniowane w systemie.');
INSERT INTO `LogTranslation` (`lang`, `key`, `translation`) VALUES('en', 'TXT_FIBAROALARMSCENE_7_DESCRIPTION', 'Send selected or all notifications defined in the system.');

