ALTER TABLE HC_Data ADD COLUMN batteryLowNotification INTEGER DEFAULT '1' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN defaultTemperatureSensor INTEGER DEFAULT '0' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN defaultHumiditySensor INTEGER DEFAULT '0' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN defaultLightSensor INTEGER DEFAULT '0' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN fireAlarmTemperature REAL DEFAULT '60' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN freezeAlarmTemperature REAL DEFAULT '1' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN smsManagement INTEGER DEFAULT '-1' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN frequency TEXT DEFAULT 'EU' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN HW_version TEXT DEFAULT '1.0' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN avrSoftVersion TEXT DEFAULT '1.5' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN firstRun BOOLEAN DEFAULT '1' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN alarmEnabled BOOLEAN DEFAULT '1' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN weatherProviderId INTEGER DEFAULT '3' NOT NULL;
ALTER TABLE HC_Data ADD COLUMN name;
ALTER TABLE HC_Data ADD COLUMN firstRunAfterUpdate BOOLEAN DEFAULT 1 NOT NULL;
ALTER TABLE HC_Data ADD COLUMN Remote_Access_Support INTEGER DEFAULT 0 NOT NULL;

BEGIN TRANSACTION;

 ALTER TABLE HC_Data RENAME TO _HC_Data;

 CREATE TABLE 'HC_Data' (
   'Serial_Number' TEXT NOT NULL,
   'HW_Key' TEXT NOT NULL,
   'Version' TEXT NOT NULL,
   'ZW_Version_Chip' TEXT NOT NULL,
   'Hotel_Mode' INTEGER NOT NULL DEFAULT '0',
   'Remote_Access' INTEGER NOT NULL DEFAULT '1',
   'Remote_Access_Support' INTEGER NOT NULL DEFAULT '0',
   'Beta' INTEGER NOT NULL,
   'powerPrice' REAL,
   'powerCurrency' TEXT,
   'batteryLowNotification' INTEGER,
   'defaultTemperatureSensor' INTEGER,
   'defaultHumiditySensor' INTEGER,
   'defaultLightSensor' INTEGER,
   'fireAlarmTemperature' REAL NOT NULL DEFAULT '60',
   'freezeAlarmTemperature' REAL NOT NULL DEFAULT '1',
   'smsManagement' INTEGER NOT NULL DEFAULT '0',
   'frequency' TEXT NOT NULL DEFAULT 'EU',
   'HW_version' TEXT NOT NULL DEFAULT '1.0',
   'avrSoftVersion' TEXT NOT NULL DEFAULT '1.5',
   'firstRun' BOOLEAN NOT NULL DEFAULT '1',
   'alarmEnabled' BOOLEAN NOT NULL DEFAULT '1',
   'weatherProviderId' INTEGER NOT NULL DEFAULT '3',
   'name' TEXT,
   'firstRunAfterUpdate' BOOLEAN NOT NULL DEFAULT 1
 );

 INSERT INTO HC_Data(Serial_Number, HW_Key, Version, ZW_Version_Chip, Hotel_Mode, Remote_Access, Remote_Access_Support,
 Beta, powerPrice, powerCurrency, batteryLowNotification, defaultTemperatureSensor, defaultHumiditySensor,
 defaultLightSensor, fireAlarmTemperature, freezeAlarmTemperature, smsManagement, frequency, HW_version, avrSoftVersion,
 firstRun, alarmEnabled, weatherProviderId, name)

 SELECT Serial_Number, HW_Key, Version, ZW_Version_Chip, Hotel_Mode, Remote_Access, Remote_Access_Support, Beta,
 powerPrice, powerCurrency, batteryLowNotification, defaultTemperatureSensor, defaultHumiditySensor, defaultLightSensor,
  fireAlarmTemperature, freezeAlarmTemperature, smsManagement, frequency, HW_version, avrSoftVersion, firstRun,
  alarmEnabled, weatherProviderId, coalesce(name, serial_number)
 FROM _HC_Data;

 DROP TABLE _HC_Data;

COMMIT;
