-- Base abstract class for all derived Action classes (SendEmail, SendPush, SendPhotoToEmail etc.)
-- Do not instantiate it.


class 'Action' 

IOS_DEVICE_TYPE = 'iOS_device'
IP_CAMERA_TYPE = 'com.fibaro.ipCamera'
FIBARO_INTERCOM = 'com.fibaro.fibaroIntercom'

function Action:__init(deviceId, params)
    if params and deviceId then
        self.name = params.actionName
        self.actionParams = params.args
        self.deviceId = tonumber(deviceId)
    end

    self.settingsInfo = api.get('/settings/info')
    
    local filePath = '/tmp/hwKey' .. math.random()
    os.execute('/opt/fibaro/scripts/hw_key.sh > ' .. filePath)
    local hwKeyFile = io.open(filePath)
    self.hcKey = hwKeyFile:read()
    hwKeyFile:close()
    os.execute('rm '.. filePath)
    
    self.type = 'Action'
end

function Action:getType()
    return self.type
end

function Action:setType(type)
    self.type = type
end

function Action:getName()
    return self.name
end

function Action:setName(name)
    self.name = name
end

function Action:execute() -- virtual
end

function Action:tablelength(table)
  local count = 0
  for _ in pairs(table) do
    count = count + 1
  end

  return count
end
