require('actionHandlers.SendEmailAction')
require('actionHandlers.SendPushAction')
require('actionHandlers.SendPhotoToEmailAction')
require('actionHandlers.SendPhotoToUserAction')
require('actionHandlers.SendDefinedEmailAction')
require('actionHandlers.SendDefinedSMSAction')
require('actionHandlers.SendDefinedPushAction')
require('actionHandlers.SendGlobalPushAction')
require('actionHandlers.SendGlobalEmailAction')
require('actionHandlers.SendGlobalSMSAction')
require('actionHandlers.PressButtonAction')
require('actionHandlers.SetSliderAction')
require('actionHandlers.CameraMoveLeftAction')
require('actionHandlers.CameraMoveRightAction')
require('actionHandlers.CameraMoveUpAction')
require('actionHandlers.CameraMoveDownAction')
require('actionHandlers.CameraStopAction')
require('actionHandlers.SendVideogatePushAction')
require('actionHandlers.SendNotificationAction')


if (type(ActionFactory) ~= "table") then
    ActionFactory = {}
end


ActionFactory.actions = {
	["sendEmail"]					 =  SendEmailAction,
	["sendPush"]					 =  SendPushAction,
	["sendPhotoToEmail"]			 =  SendPhotoToEmailAction,
	["sendPhotoToUser"]				 =  SendPhotoToUserAction,
	["sendDefinedEmailNotification"] =  SendDefinedEmailAction,
	["sendDefinedSMSNotification"]	 =  SendDefinedSMSAction,
	["sendDefinedPushNotification"]	 =  SendDefinedPushAction,
	["sendGlobalPushNotifications"]  =  SendGlobalPushAction,
	["sendGlobalEmailNotifications"] =  SendGlobalEmailAction,
	["sendGlobalSMSNotifications"]	 =  SendGlobalSMSAction,
	["pressButton"]					 =  PressButtonAction,
	["setSlider"]					 =  SetSliderAction,
	["moveLeft"]					 =  CameraMoveLeftAction,
	["moveRight"]					 =  CameraMoveRightAction,
	["moveUp"]						 =  CameraMoveUpAction,
	["moveDown"]					 =  CameraMoveDownAction,
	["moveStop"]					 =  CameraStopAction,
	["sendVideogatePush"]			 =  SendVideogatePushAction,
	["sendNotification"]			 =  SendNotificationAction,
}
	         
function ActionFactory.getAction(deviceId, action)
	local ActionClass = ActionFactory.actions[action.actionName]

	if ActionClass then
		return ActionClass(deviceId, action)
	end
end

