require('common.EthSend')
require('actionHandlers.Action')


class 'PressButtonAction' (Action)


VIRTUAL_DEVICE_TYPE = 'virtual_device'

function PressButtonAction:__init(deviceId, params)
  Action.__init(self, deviceId, params)
  self.type = 'PressButtonAction'
end

function PressButtonAction:execute() 
  self:initEthSendParams()

  if self.ip and self.port and self.string then
    local ethSend = EthSend(self.ip, self.port, self.string, self.waitForResponse) 
    ethSend:execute()
  end
end

function PressButtonAction:tablelength(table)
  local count = 0
  for _ in pairs(table) do
    count = count + 1
  end

  return count
end

function PressButtonAction:initEthSendParams()
  local deviceID = self.deviceID
  local buttonID = self.actionParams[1]
  local device = api.get('/devices/' .. self.deviceId)

  if device and device.type == VIRTUAL_DEVICE_TYPE then 
    local properties = device.properties
    self.ip = device.properties.ip
    self.port = device.properties.port
    local rows = device.properties.rows
    if self:tablelength(rows) > 0 then
      for _,row in pairs(rows) do 
        if row.type == 'button' then
          local elements = row.elements
          for _,button in pairs(elements) do
              if button.id == buttonID then
                self.string = button.msg
                self.waitForResponse = button.waitForResponse or false
              end
          end
        end
      end
    end
  end 
end
