require('actionHandlers.HTTPAction')


class 'SendDefinedSMSAction' (HTTPAction)


function SendDefinedSMSAction:__init(deviceId, params)
    HTTPAction.__init(self, deviceId, params)

    self.type = 'SendDefinedSMSAction'
    self:initMessage()
    self:initPhoneNumber()
    self.hcNumber = self.settingsInfo.serialNumber
end

function SendDefinedSMSAction:initMessage(message)
    if not message then
        local notification = api.get('/panels/notifications/' .. tonumber(self.actionParams[2]))  
        if not notification then
            self.message = ''
        else 
            self.message = notification.sms
        end
    else
        self.message = message
    end
end

function SendDefinedSMSAction:initPhoneNumber(phoneNumber)
    if not phoneNumber then
        self.phoneNumber = self.actionParams[1]
    else
        self.phoneNumber = phoneNumber
    end
end

function SendDefinedSMSAction:execute()
    local postData = 'PK_AccessPoint=' .. self.hcNumber .. '&HW_Key=' .. self.hcKey .. '&Message=' .. self.message .. '&PhoneNumber=' .. self.phoneNumber
    local controlHeaders = {
        ['Content-Type'] = 'application/x-www-form-urlencoded',
    }

    local httpRequestParams = {
        url = 'https://sms2.fibaro.com/sendNotificationSMSToNumber.php',
        method = 'POST',
        headers = controlHeaders,
        callback =  function(response) self:onDataReceivedFromExecute(response) end,
        data = postData,
    }

    self:httpRequest(httpRequestParams)
end

function SendDefinedSMSAction:onDataReceivedFromExecute(response)
    print('****response***  onDataReceivedFromExecute:')
    tprint(response)
end




