require('actionHandlers.HTTPAction')


class 'SendEmailAction' (HTTPAction)


function SendEmailAction:__init(deviceId, params)
    HTTPAction.__init(self, deviceId, params)

    self.type = 'SendEmailAction'            
    self:initSubject()
    self:initMessage()        
    self:initEmail()
    self.hcNumber = self.settingsInfo.serialNumber
end

function SendEmailAction:initEmail()
    local hcUser = api.get('/users/' .. self.deviceId)  
    if not hcUser then
        return 
    end 

    self.email = hcUser.email
end

function SendEmailAction:initSubject()
    self.subject = self:addslashes(self:trim(self.actionParams[1]))
end

function SendEmailAction:initMessage()
    self.message = self:addslashes(self:trim(self.actionParams[2]))
end

function SendEmailAction:execute()    
    local postData = 'Email=' .. self.email .. '&PK_AccessPoint=' .. self.hcNumber .. '&HW_Key=' .. self.hcKey .. '&Message=' .. self.message .. '&Subject=' .. self.subject
    local controlHeaders = {
        ['Content-Type'] = 'application/x-www-form-urlencoded',
    }

    local httpRequestParams = {
        url = 'https://storage.fibaro.com/email_notification2.php',
        method = 'POST',
        headers = controlHeaders,
        callback =  function(response) self:onDataReceivedFromExecute(response) end,
        data = postData,
    }

    self:httpRequest(httpRequestParams)
end

function SendEmailAction:onDataReceivedFromExecute(response)
    print('****response***  onDataReceivedFromExecute:')
    tprint(response)
end




