require('actionHandlers.SendDefinedPushAction') 


class 'SendGlobalPushAction' (SendDefinedPushAction)


function SendGlobalPushAction:__init(deviceId, params)
    SendPushAction.__init(self, deviceId, params)

    self.type = 'SendGlobalPushAction'
    self:initTokens()
end

function SendGlobalPushAction:initTokens()
    local hcDevices = api.get('/devices?type=' .. IOS_DEVICE_TYPE)
    local targetMobileDevice = nil
    self.iosTokens = ''
    self.androidTokens = ''

    for _,dev in pairs(hcDevices) do
        if dev.type == IOS_DEVICE_TYPE and dev.properties.Push == true then 
            targetMobileDevice = dev
            local deviceToken = targetMobileDevice.properties.DeviceToken
            if string.len(deviceToken) == 64 then -- this is iOS Device <ugly>
                if self.iosTokens ~= '' then
                    self.iosTokens = self.iosTokens .. '_'
                end
                self.iosTokens = self.iosTokens .. deviceToken
            else
                if self.androidTokens ~= '' then
                    self.androidTokens = self.androidTokens .. '#sep#'
                end
                self.androidTokens = self.androidTokens .. deviceToken
            end
        end
    end
end




