require('actionHandlers.HTTPAction')


class 'SendGlobalSMSAction' (HTTPAction)


function SendGlobalSMSAction:__init(deviceId, params)
    HTTPAction.__init(self, deviceId, params)

    self.type = 'SendGlobalSMSAction'
    self:initMessage()
    self.hcNumber = self.settingsInfo.serialNumber
end

function SendGlobalSMSAction:initMessage(message)
    if not message then
        local notification = api.get('/panels/notifications/' .. tonumber(self.actionParams[1]))
        if not notification then
            self.message = ''
        else 
            self.message = notification.sms
        end
    else
        self.message = message
    end
end

function SendGlobalSMSAction:execute()
    local postData = 'PK_AccessPoint=' .. self.hcNumber .. '&HW_Key=' .. self.hcKey .. '&Message=' .. self.message
    local controlHeaders = {
        ['Content-Type'] = 'application/x-www-form-urlencoded',
    }

    local httpRequestParams = {
        url = 'https://sms2.fibaro.com/sendNotificationSMS.php',
        method = 'POST',
        headers = controlHeaders,
        callback =  function(response) self:onDataReceivedFromExecute(response) end,
        data = postData,
    }

    self:httpRequest(httpRequestParams)
end

function SendGlobalSMSAction:onDataReceivedFromExecute(response)
    print('****response***  onDataReceivedFromExecute:')
    tprint(response)
end




