require('actionHandlers.Action')
require('actionHandlers.SendGlobalPushAction')
require('actionHandlers.SendDefinedEmailAction')


class 'SendNotificationAction' (Action)


function SendNotificationAction:__init(deviceId, params)
    Action.__init(self, deviceId, params)

    self.type = 'SendNotificationAction'
end

function SendNotificationAction:tablelength(table)
      local count = 0
      for _ in pairs(table) do
          count = count + 1
      end

      return count
end

function SendNotificationAction:getDevById(devId)
    local device = api.get('/devices/' .. tostring(devId))
    return device
end

function SendNotificationAction:getRoomById(id)
    local room = api.get('/rooms/' .. tostring(id))
    return room
end

function SendNotificationAction:generateMessage()
    local eventType = tonumber(self.actionParams[1]) -- event type 
    local message = self.actionParams[1]
    local msg = ''
    local rooms = api.get('/rooms')
    local device = self:getDevById(self.actionParams[2])

    local roomName = ''
    if device.roomID == 0 then -- <ugly> hack for room unassigned
        roomName = 'unassigned'
    else
        room = self:getRoomById(device.roomID)
        roomName = room.name
    end

    if eventType == 0 then
        msg = message
    elseif eventType == 2 then
        msg = device.name
        msg = msg .. ' (' .. roomName .. '): ';
        local txt = ''
        if self.settingsInfo.defaultLanguage == 'pl' then
            txt = 'Ważne! Czujnik ' .. device.name .. ' odnotował wysoką temperaturę. Może to oznaczać zagrożenie pożarem.'
        else
            txt = 'Important! Sensor ' .. device.name .. ' detected high temperature. It may mean potential fire.'
        end
        msg = msg .. txt  
    elseif eventType == 3 then
        msg = device.name
        msg = msg .. ' (' .. roomName .. '): ';
        local txt = ''
        if self.settingsInfo.defaultLanguage == 'pl' then
            txt = 'Ważne! Czujnik ' .. device.name .. ' wykrył bardzo niską temperaturę. To może oznaczać zamrożenie.'
        else
            txt = 'Important! Sensor ' .. device.name .. ' detected low temperature. It may mean freeze.'
        end
        msg = msg .. txt
    end

    return msg
end

function SendNotificationAction:execute()
    local msg = self:generateMessage()

    if msg ~= '' then
        local pushParams = {
                    ['args'] = { msg },
                    ['actionName'] = 'Push Action...'    ,
                }

        local sendGlobalPushAction = SendGlobalPushAction(2, pushParams)
        sendGlobalPushAction:initMessage(msg)
        sendGlobalPushAction:execute()

        local endDefinedEmailAction = SendDefinedEmailAction(2, pushParams)
        endDefinedEmailAction:initMessage(msg)
        endDefinedEmailAction:execute()
    end
end

