require('common.EthSend')
require('actionHandlers.Action')


class 'SetSliderAction' (Action)


VIRTUAL_DEVICE_TYPE = 'virtual_device'

function SetSliderAction:__init(deviceId, params)
    Action.__init(self, deviceId, params)

    self.type = 'SetSliderAction'
end

function SetSliderAction:execute() 
    self:initEthSendParams()

  if self.ip and self.port and self.string then
    local ethSend = EthSend(self.ip, self.port, self.string, self.waitForResponse) 
    ethSend:execute()
  end
end

function SetSliderAction:tablelength(table)
  local count = 0
  for _ in pairs(table) do
    count = count + 1
  end

  return count
end

function SetSliderAction:initEthSendParams()
  local deviceID = self.deviceID
  local sliderID = self.actionParams[1]
  local sliderValu = self.actionParams[2]
  local device = api.get('/devices/' .. tostring(self.deviceId))

  if device and device.type == VIRTUAL_DEVICE_TYPE then 
    local properties = device.properties
    self.ip = device.properties.ip
    self.port = device.properties.port
    local rows = device.properties.rows

    if self:tablelength(rows) > 0 then
      for _,row in pairs(rows) do 
        if row.type == 'slider' then
          local elements = row.elements
          for _,slider in pairs(elements) do
              if slider.id == sliderID then
                self.string = slider.msg
                self.string = string.gsub(self.string, "_sliderValue_", sliderValu)
                self.waitForResponse = slider.waitForResponse or false
              end
          end
        end
      end
    end
  end 
end



