require('net.TCPSocket')


class 'EthSend' 


function EthSend:__init(address, port, data, waitForResponse)   
    self.waitForResponse = waitForResponse 
    self.address = address
    self.port = port
    self.data = data
    self.sock = net.TCPSocket()
end

function EthSend:fromhex(str)
    return (str:gsub('..', function(cc)
        return string.char(tonumber(cc, 16))
    end))
end

function EthSend:tohex(str)
    return (str:gsub('.', function(c)
        return string.format('%02X', string.byte(c))
    end))
end

function EthSend:parseData(str)
    while true do 
        if string.find(str, '0x') then
            i,j = string.find(str, '0x')
            str = string.sub(str, 1, i - 1) .. self:fromhex(string.sub(str, i + 2, j +2)) .. string.sub(str, j + 3)
        else
            return str
        end
    end
end

function EthSend:send(str)
    strToSend = self:parseData(str)
    self.sock:write(strToSend, {
        success = function()
            self:waitForResponseFunction()
        end,
        error = function(err)
            self:close()
        end
    })
end

function EthSend:close()
    self.sock:close()
end

function EthSend:execute()
    self.sock:connect(self.address, self.port, {
        success = function()
            self:send(self.data)
        end,
        error = function(err)
            self:close()
        end,
    })
end

function EthSend:waitForResponseFunction()
    if self.waitForResponse then
        self.sock:read({
            success = function()
                self:close()
            end,
            error = function()
                self:close()
            end
        })
    else
        self:close()
    end
end

