class 'Object'

function Object:__init()
    self.__events = {}
end

function Object:registerEvent(eventName, handler)
    if(type(handler) == 'function') then
        self.__events[eventName] = handler
    else
        error("ERROR (Object:registerEvent): handler is not a function")
    end
end

function Object:unregisterEvent(eventName)
    self.__events[eventName] = nil
end

function Object:emitEvent(eventName, ...)
    local handler = self.__events[eventName]
	
    if (handler) then
        handler(self, ...) 
    end
end
