class 'queue'

function queue:__init()
    self.queue = {}
end

--! Adds element to back of the queue
--!@param element element to be added
function queue:pushBack(element)
    table.insert(self.queue, element)
end

--! Adds element at the front of the queue (rest of elements are shifted)
--!@param element element to be added
function queue:pushFront(element)
    table.insert(self.queue, 1, element)
end

--! Gets element from queue front. Element is removed from queue.
--!@return element from front of the queue
function queue:popFront()
    if #self.queue > 0 then
        return table.remove(self.queue, 1)
    else
        return nil
    end
end

--! Gets element from queue back. Element is removed from queue.
--!@return element from back of the queue
function queue:popBack()
    if #self.queue > 0 then
        return table.remove(self.queue)
    else
        return nil
    end
end

--! Gets element from queue front. Element is not removed from queue.
--!@return element from front of the queue
function queue:peekFront()
    if #self.queue > 0 then
        return self.queue[1]
    else
        return nil
    end
end

--! Gets element from queue back. Element is not removed from queue.
--!@return element from back of the queue
function queue:peekBack()
    if #self.queue > 0 then
        return self.queue[#self.queue]
    else
        return nil
    end
end

--! Clears queue. It becomes empty.
function queue:clear()
    self.queue = {}
end
