
--! Set of functions to convert different metric units to imperial units (and imperial to metric)
unitsConverter = {}

--! converts celsius to farenheit
--!@param celsius celsius value
--!@return farenheit value
unitsConverter.celsius2farenheit = function(celsius)
	return celsius*9/5 + 32
end

--! converts farenheit to celsius
--!@param farenheit farenheit value
--!@return celsius value
unitsConverter.farenheit2celsius = function(farenheit)
	return (farenheit - 32)*5/9
end

--! converts centimeters to inches
--!@param cm centimeter value
--!@return inch value
unitsConverter.cm2inch = function(cm)
	return cm*0.393701
end

--! converts inches to centimeters
--!@param inch inch value
--!@return centimeter value
unitsConverter.inch2cm = function(inch)
	return inch*2.54
end

--! converts meters to yards
--!@param m meters value
--!@return yard value
unitsConverter.meter2yard = function(m)
	return m*1.0936
end

--! converts yards to meters
--!@param yard yard value
--!@return meter value
unitsConverter.yard2meter = function(yard)
	return yard*0.9144
end

--! converts miles to kilometers
--!@param mile mile value
--!@return kilometer value
unitsConverter.mile2km = function(mile)
	return mile*1.60934
end

--! converts kilometers to miles
--!@param km kilometer value
--!@return mile value
unitsConverter.km2mile = function(km)
	return km*0.621371
end