function onLoad() {
	setPromoSlider();

	jQuery( "#slider" ).easySlider( {
		auto: true,
		continuous: true,
		numeric: true,
		speed: 1500,
		pause: 4500
	} );

	disableSaveButton();
	generateLeftPanelsMenu();
	initializeFileUpload();
}

function generateLeftPanelsMenu() {
	var html = '',
	    tmpHtml = '',
	    typeName = getType()[0],
	    allPlugins = 0;

	html += '<div class="clearfix"><a href="' + pathPrefix + '/' + globalLang + '/plugins/plugins.html" class="pluginTab leftTabActive">' + t0( 'TXT_PLUGINS_INSTALL' ) + '</a><a href="' + pathPrefix + '/' + globalLang + '/plugins/index.html" class="pluginTab rightTab">' + t0( 'TXT_PLUGINS_MY' ) + '</a></div>';

	html += '<div class="LeftMenuElement LeftMenuElementA">' + t0( 'TXT_PLUGINS_UPLOAD' ) + '</div>';

	html += '<a href="plugins.html" onclick="openPlugin(); return false;"><div class="LeftMenuElement"><div class="fleft">' + t0( 'TXT_PLUGINS_ALL_PLUGINS' ) + '</div><div class="fright pluginCounter allPluginsCount">' + allPlugins + '</div></div></a>';

	mainData.plugins.types.each( function( type ) {
		if( type.category === 2 ) {
			tmpHtml += '<a href="plugins.html?type=' + getPluginType( type.category ) + '" onclick="openPlugin(\'' + getPluginType( type.category ) + '\'); return false;"><div class="LeftMenuElement';
			if( typeName == getPluginType( type.category ) ) {
				tmpHtml += ' LeftMenuElementA';
			}

			tmpHtml += '"><div class="fleft">' + getTypeName( type.category ) + '</div><div class="fright pluginCounter">' + type.plugins.length + '</div></div></a>';
		}
		else {
			html += '<a href="plugins.html?type=' + getPluginType( type.category ) + '" onclick="openPlugin(\'' + getPluginType( type.category ) + '\'); return false;"><div class="LeftMenuElement';
			if( typeName == getPluginType( type.category ) ) {
				html += ' LeftMenuElementA';
			}

			html += '"><div class="fleft">' + getTypeName( type.category ) + '</div><div class="fright pluginCounter">' + type.plugins.length + '</div></div></a>';
		}

		allPlugins += type.plugins.length;
	} );

	html += tmpHtml;

	jQuery( '#panelsMenu' ).html( html );
	jQuery( '.allPluginsCount' ).text( allPlugins );
	sortMenu();
}

function initializeFileUpload() {
	var $uploadButton = jQuery( '<span/>' )
		.addClass( 'Button1 fileinput-button' )
		//.prop('disabled', true)
		.text( t0( 'TXT_PLUGINS_UPLOAD_ADD' ) )
		.on( 'click', function() {
			var $this = jQuery( this ),
			    data = $this.data();
			$this
				.off( 'click' )
				.text( 'Abort' )
				.on( 'click', function() {
					$this.remove();
					data.abort();
				} );
			data.submit().always( function() {
				$this.remove();
			} );
		} );
	jQuery( '#fileupload' ).fileupload( {
		url: '/api/plugins/install',
		type: 'POST',
		dataType: 'json',
		limitConcurrentUploads: 1,
		formData: [
			{ name: 'overwrite', value: false }
		],
		autoUpload: false,
		//acceptFileTypes: /(\.|\/)(gif|jpe?g|png)$/i,
		//maxFileSize: 5 * 1000000, // 5 MB
		limitMultiFileUploads: 1,
		add: function( e, data ) {
			// when there is no other file add new to upload
			jQuery( '#filesPlaceholder' ).hide();
			if( jQuery( '#files' ).children().length != 0 ) {
				data.abort();
			}
			data.context = jQuery( '<div/>' ).appendTo( '#files' );
			jQuery.each( data.files, function( index, file ) {
				// add selected file to drop area
				var $node = jQuery( '<div/>' )
					.addClass( 'fileContainer' )
					.append( jQuery( '<span/>' ).text( file.name ) );
				if( !index ) {
					// append 'upload added file' button
					jQuery( '.SectionContentRight' ).append( $uploadButton.clone( true ).data( data ) );
				}
				$node.appendTo( data.context );
			} );
			jQuery( '#chooseFile' ).hide();
		},
		submit: function( e, data ) {
			openWindow( 'fileUploadProgress' );
			// add info that overwrite checkbox is checked to data send
			if( jQuery( '#overwrite' ).is( ':checked' ) ) {
				data.formData = { overwrite: true }
			}
		},
		// behaviour when file upload is done and file meets requirements
		done: function( e, data ) {
			var pluginDescription = '',
			    pluginName = '';

			data = data.result;

			// url to go to after uploading
			jQuery( '#pluginUrl' ).attr( "href", pathPrefix + '/' + globalLang + '/plugins/index.html?type=' + data.category + '&name=' + data.type );

			jQuery.ajax( {
				type: "GET",
				url: apiPath + apiPluginsPath + '/types'
			} ).success( function( pluginsApi ) {
				pluginsApi.types.each( function( type ) {
					if( type.category == data.categoryId ) {
						type.plugins.each( function( plugin ) {
							if( plugin.type == data.type ) {
								pluginDescription = plugin.description;
								pluginName = plugin.name;
							}
						} );
					}
				} );

				jQuery( '#pluginName' ).text( pluginName );
				jQuery( '#pluginCategory' ).text( data.category );
				jQuery( '#pluginDescription' ).html( pluginDescription );

				jQuery( '.SectionContentIcon img' ).attr( "src", '/' + pluginsPath + '/' + data.type + '/' + pluginsImagePath + '/icon.png' );
			} );
			jQuery( '.fileinput-button' ).hide();

			// display popup
			closeWindow( 'fileUploadProgress' );
			openWindow( 'fileUploadDone' );
		},
		// behaviour when file upload fails or file do not meet requirements
		fail: function( e, data ) {
			jQuery( '.SectionContentIcon img' ).attr( 'src', 'img/icon_error.png' );

			var error = JSON.decode( data.jqXHR.responseText );
			jQuery( '#fileUploadInfo, .fileUploadArea, #overwriteCheckboxContainer' ).hide();
			jQuery( '#sceneLog' ).text( error.message );
			jQuery( '#fileUploadError' ).show();

			closeWindow( 'fileUploadProgress' );
		},
		error: function() {
			// overriding default system function
			return false;
		},
		progressall: function( e, data ) {
			// progress bar updating
			var progress = parseInt( data.loaded / data.total * 100, 10 );
			jQuery( '#progress .bar' ).css(
				'width', progress + '%'
			);
		}
	} );
};
