<?php

$messages = array(
   'en' => array(
           'STATUS_SYSTEM_UPDATING' => 'Updating system',
           'STATUS_SYSTEM_UPDATING_TITLE' => 'Updating system',
           'STATUS_SYSTEM_UPDATING_STOPPING' => 'Stopping services',
           'STATUS_SYSTEM_UPDATING_DOWNLOADING' => 'Downloading patch',
           'STATUS_SYSTEM_UPDATING_EXTRACTING' => 'Extracting archive',
           'STATUS_SYSTEM_UPDATING_INSTALLING' => 'Installing patch',
           'STATUS_SYSTEM_UPDATING_BACKUPING' => 'Creating backup',
           'STATUS_SYSTEM_UPDATING_REBOOTING' => 'Rebooting system',
           'STARTING_SERVICES' => 'Starting services',
           'STARTING_SERVICES_TITLE' => 'Starting services',
           'STATUS_BACKUP_CREATE' => 'Creating backup',
           'STATUS_BACKUP_CREATE_TITLE' => 'Creating backup',
           'STATUS_BACKUP_RESTORE' => 'Restoring backup',
           'STATUS_BACKUP_RESTORE_TITLE' => 'Restoring backup',
           'REBOOTING' => 'Rebooting system',
           'REBOOTING_TITLE' => 'Rebooting system',
           'ZWAVE_LEARN_MODE_ADDING' => 'Adding device',
           'ZWAVE_LEARN_MODE_ADDING_TITLE' => 'Adding device',
           'ZWAVE_LEARN_MODE_REMOVING' => 'Removing device',
           'ZWAVE_LEARN_MODE_REMOVING_TITLE' => 'Removing device',
           'ZWAVE_DEVICE_CONFIGURATION' => 'Configuring device',
           'ZWAVE_DEVICE_CONFIGURATION_TITLE' => 'Configuring device',
           'ZWAVE_SECONDARY_CONTROLLER_LEARN_MODE' => 'Zwave learning mode',
           'ZWAVE_SECONDARY_CONTROLLER_LEARN_MODE_TITLE' => 'Zwave learning mode',
           'ZWAVE_CHANGING_CONTROLLERS' => 'Zwave changing controllers',
           'ZWAVE_CHANGING_CONTROLLERS_TITLE' => 'Zwave changing controllers',
           'FIBARO_SATEL_CONFIGURATION' => 'Configuring SATEL',
           'FIBARO_SATEL_CONFIGURATION_TITLE' => 'Configuring SATEL',
           'FIBARO_ADDING_SLAVE' => 'Adding slave',
           'FIBARO_ADDING_SLAVE_TITLE' => 'Adding slave',
           'PERFORMING_MIGRATION' => 'Performing migration',
           'PERFORMING_MIGRATION_TITLE' => 'Performing migration',
           'ERROR' => 'Error',
           'ERROR_TITLE' => 'Error',
           'MAINTENANCE' => 'Maintenance',
           'MAINTENANCE_TITLE' => 'Maintenance'
      ),
   'pl' => array(
      'STATUS_SYSTEM_UPDATING' => 'Aktualizowanie systemu',
      'STATUS_SYSTEM_UPDATING_TITLE' => 'Aktualizowanie systemu',
      'STATUS_SYSTEM_UPDATING_STOPPING' => 'Zatrzymywanie usług',
      'STATUS_SYSTEM_UPDATING_DOWNLOADING' => 'Pobieranie aktualizacji',
      'STATUS_SYSTEM_UPDATING_EXTRACTING' => 'Rozpakowywanie archiwum',
      'STATUS_SYSTEM_UPDATING_INSTALLING' => 'Instalowanie aktualizacji',
      'STATUS_SYSTEM_UPDATING_BACKUPING' => 'Tworzenie kopii zapasowej',
      'STATUS_SYSTEM_UPDATING_REBOOTING' => 'Restartowanie systemu',
      'STARTING_SERVICES' => 'Uruchamianie usług',
      'STARTING_SERVICES_TITLE' => 'Uruchamianie usług',
      'STATUS_BACKUP_CREATE' => 'Tworzenie kopii zapasowej',
      'STATUS_BACKUP_CREATE_TITLE' => 'Tworzenie kopii zapasowej',
      'STATUS_BACKUP_RESTORE' => 'Przywracanie kopii zapasowej',
      'STATUS_BACKUP_RESTORE_TITLE' => 'Przywracanie kopii zapasowej',
      'REBOOTING' => 'Restartowanie systemu',
      'REBOOTING_TITLE' => 'Restartowanie systemu',
      'ZWAVE_LEARN_MODE_ADDING' => 'Dodawanie urządzenia',
      'ZWAVE_LEARN_MODE_ADDING_TITLE' => 'Dodawanie urządzenia',
      'ZWAVE_LEARN_MODE_REMOVING' => 'Usuwanie urządzenia',
      'ZWAVE_LEARN_MODE_REMOVING_TITLE' => 'Usuwanie urządzenia',
      'ZWAVE_DEVICE_CONFIGURATION' => 'Konfigurowanie urządzenia',
      'ZWAVE_DEVICE_CONFIGURATION_TITLE' => 'Konfigurowanie urządzenia',
      'ZWAVE_SECONDARY_CONTROLLER_LEARN_MODE' => 'Tryb nauki Z-Wave',
      'ZWAVE_SECONDARY_CONTROLLER_LEARN_MODE_TITLE' => 'Tryb nauki Z-Wave',
      'ZWAVE_CHANGING_CONTROLLERS' => 'Wymiana kontrolerów Z-Wave',
      'ZWAVE_CHANGING_CONTROLLERS_TITLE' => 'Wymiana kontrolerów Z-Wave',
      'FIBARO_SATEL_CONFIGURATION' => 'Konfigurowanie centrali SATEL',
      'FIBARO_SATEL_CONFIGURATION_TITLE' => 'Konfigurowanie centrali SATEL',
      'FIBARO_ADDING_SLAVE' => 'Dodawanie centrali Slave',
      'FIBARO_ADDING_SLAVE_TITLE' => 'Dodawanie centrali Slave',
      'PERFORMING_MIGRATION' => 'Wykonywanie migracji',
      'PERFORMING_MIGRATION_TITLE' => 'Wykonywanie migracji',
      'ERROR' => 'Błąd',
      'ERROR_TITLE' => 'Błąd',
      'MAINTENANCE' => 'Konserwacja',
      'MAINTENANCE_TITLE' => 'Konserwacja'
      )
   );

function getMsg($lang, $key)
{
   if (!isset($key) || trim($key) === "")
       return "";

   global $messages;
   if (isset($messages[$lang][$key]))
   {
      return $messages[$lang][$key];
   }
   else
   {
      error_log("No translation for: LANG:$lang, KEY:$key");
      if ($lang != "en")
      {
         return getMsg("en", $key);
      }
   }
   return $key;
}
?>