<?php

require_once("../../authorize.php");
require_once("../../dbSession.php");

function authorize()
{
   if (!isAuthorized() && !isAuthorizedFibaroAuth(array(role::USER, role::INSTALLER)))
   {
      sendUnauthorized();
      exit(0);
   }
}

require("httpStatuses.php");

	function printAsJson($text)
	{
		echo(json_encode($text));
	}

	function createBackup($params)
	{
		$name = urldecode($params->name);
		if (strpos($name, '"') !== false)
		{
			$name = str_replace('"', '‘', $name);
		}

		exec("screen -dmS BACKUP sudo /usr/bin/create_backup --auto \"$name\"");
		setStatusAccepted();
	}

	function restoreBackup($params)
	{
		$backupID = $params->id;

		if ($backupID > 0) {
			$dbh = createSession();
			//get directory name from id. restore_backup script is using path as parameter
			$backup_query = $dbh->query('SELECT DirectoryPath FROM Backups WHERE Id=' . $backupID);
			if (is_object($backup_query)) {
				$backup = $backup_query->fetchArray();
				$backup_query->finalize();
				$dbh->close();
				$ret = exec('screen -dmS RESTORE sudo /usr/bin/restore_backup /home/fghc2/recovery/backups/' . $backup['DirectoryPath'], $retArray);
			}
			else {
				setStatusNotFound();
				return;
			}
		}
		else {
			setStatusNotFound();
			return;
		}

		setStatusAccepted();
	}

	function removeBackup($id)
	{
           if ($id > 0) {
              $dbh = createSession();
              //get directory name from id. restore_backup script is using path as parameter
              $backup_query = $dbh->query('SELECT DirectoryPath FROM Backups WHERE Id=' . $id);
              if (is_object($backup_query)) {
                 $backup = $backup_query->fetchArray();
                 $backup_query->finalize();

                 $ret = exec('sudo /var/www/services/system/remove_backup2.sh ' . $backup['DirectoryPath'], $rmout, $rmstat);

                 if ($rmstat) {
                    setStatusNotFound();
                    return;
                 }

                 $remove_query = $dbh->query("DELETE FROM Backups WHERE Id=" . $id);
                 if (is_object($remove_query))
                 {
                    $remove_query->finalize();
                 }


                 $dbh->close();
              }
              else {
                 setStatusNotFound();
                 return;
              }
           } else {
              setStatusNotFound();
              return;
           }
	}

	function handleGET()
	{
		//get backup list
		header('Content-Type: application/json');

		$dbh = createSession();
		$backups_query = $dbh->query('SELECT * FROM Backups ORDER BY Date DESC');
		$backups = array();
		while($row = $backups_query->fetchArray()) {
			$backup = array();
			$backup['id'] = $row['Id'];
			$backup['timestamp'] = $row['Date'];
			$backup['devices'] = $row['Devices'];
			$backup['rooms'] = $row['Rooms'];
			$backup['scenes'] = $row['Scenes'];
			$backup['description'] = $row['Description'];
			$backup['version'] = $row['Version'];
			$backup['compatible'] = $row['Compatible'];
			array_push($backups, $backup);
		}
		printAsJson($backups);
		$dbh->close();
	}

	function handlePOST($data) {
		authorize();
//		var_dump($data);

		$action = $data->action;
		$params = $data->params;

		if($action == "create") {
			createBackup($params);
		}
		elseif ($action == "restore") {
			restoreBackup($params);
		}
	}

	function handleDELETE($id) {
		authorize();
		removeBackup($id);
	}

	// Main function
	$requestBody = file_get_contents('php://input');
	$requestMethod = $_SERVER['REQUEST_METHOD'];

	//echo ($requestMethod);

	if($requestMethod == "GET")
	{
		handleGET();
	}
	elseif ($requestMethod == "POST") {
		$data = json_decode($requestBody);
		//var_dump($data);
		handlePOST($data);
	}
	elseif ($requestMethod == "DELETE") {
		//TODO add proper rewrite in .htaccess (need REST like request path maybe: service/backups/<id> -> backups.php?id=<id>)
           parse_str($_SERVER['QUERY_STRING']);
           handleDELETE($id);
	}
	else
	{
		//TODO check return code in HCServer
		setStatusNotImplemented(500);
	}
?>
