<?php
require("httpStatuses.php");
require("../../authorize.php");

if (!isAuthorized() && !isAuthorizedFibaroAuth(array(role::USER, role::INSTALLER)))
{
	sendUnauthorized();
	exit(0);
}

function printAsJson($text)
{
	echo(json_encode($text));
}

function httpGetRequest($url)
{
    $ch = curl_init();

    curl_setopt($ch,CURLOPT_URL,$url);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);

    $output=curl_exec($ch);

    curl_close($ch);
    return $output;
}

function isSizeConditionMet()
{
	$updateResponse = json_decode(httpGetRequest("127.0.0.1:11111/api/update"));

	if(is_null($updateResponse)
		|| is_null($updateResponse->conditions)
		|| is_null($updateResponse->conditions->storage))
	{
		return false;
	}
  return $updateResponse->conditions->storage;
}

function runUpdate($isBeta)
{
	if(!isSizeConditionMet())
	{
		setStatusInsufficientStorage();
		return;
	}

	$command = "sudo /usr/bin/update";
	$arg = "--auto";

	if ($isBeta) {
		$arg = "--beta";
	}

	exec($command . ' ' . $arg);
        setStatusAccepted();
}

function handlePOST($data) {
    if(is_null($data)
       || is_null($data->params)
       || is_null($data->params->beta)) {
		http_response_code(400);

	}

	runUpdate($data->params->beta);
}

// Main function
$requestBody = file_get_contents('php://input');
$requestMethod = $_SERVER['REQUEST_METHOD'];

if($requestMethod == "POST")
{
	$data = json_decode($requestBody);
	handlePOST($data);
}
else
{
	//TODO check return code in HCServer
	setStatusNotImplemented();
}
?>
