<?php
require_once("/var/www/dbSession.php");

function getSerial()
{
  $db = createSession();
  $result = $db->querySingle("SELECT Serial_Number FROM hc_data", true);
  return $result['Serial_Number'];
}

function getHwKey()
{
  $db = createSession();
  $result = $db->querySingle("SELECT HW_Key FROM hc_data", true);
  return $result['HW_Key'];
}

function getInstallerRemoteAccess()
{
  $db = createSession();
  $result = $db->querySingle("SELECT remoteAccess FROM installer", true);
  return $result['remoteAccess'];
}

function getProperty($deviceId, $propertyName)
{
  $db = createSession();
  $statement = $db->prepare("SELECT Value FROM NEW_Property WHERE Name=:name AND Device_Id = :id");
  $statement->bindValue(':id', $deviceId);
  $statement->bindValue(':name', $propertyName);
  
  $result = $statement->execute();
  $result = $result->fetchArray();
  return json_decode($result['Value']);
}

function getInstaller()
{
  $db = createSession();
  $result = $db->querySingle("SELECT * FROM installer", true);
  return $result;
}

function updateInstaller($installer)
{
  $db = createSession();
  $statement = $db->prepare("update installer set email=:email, firstName=:firstName, lastName=:lastName, remoteAccess=:remoteAccess");
  $statement->bindValue(':email', $installer['email']);
  $statement->bindValue(':firstName', $installer['firstName']);
  $statement->bindValue(':lastName', $installer['lastName']);
  $statement->bindValue(':remoteAccess', $installer['remoteAccess']);
  
  $statement->execute();
}

function getLowBatteryDevices()
{
  $db = createSession();

  $query = "SELECT D.id, D.name, R.name as RoomName, P.value as BatteryLevel, P3.value as ParametersTemplate" .
            " FROM New_Device D" .
              " join new_property P on P.device_id=D.id and P.name='batteryLevel'" .
              " join new_property P2 on P2.device_id=D.id and P2.name='dead' and P2.value='false'" .
              " join new_property P3 on P3.device_id=D.id and P3.name='parametersTemplate'" .
              " left join room R on D.room_id = R.pk_room" .
            " where P.value in(0,255) and D.parent_id=1";

  $dbResult = $db->query($query);
  $result = array();
  $row = array();

  while ($row = $dbResult->fetchArray(SQLITE3_ASSOC))
    $result[] = $row;

  return $result;
}

?>