BEGIN IMMEDIATE TRANSACTION;

DROP TABLE IF EXISTS "Device_Parameters_Template_Parameter";
CREATE TABLE 'Device_Parameters_Template_Parameter' (
'PK_Device_Parameters_Template_Parameter' INTEGER NOT NULL PRIMARY KEY,
'FK_Device_Parameters_Template' INT (11) NOT NULL,
'ParameterNumber' INT (11) NOT NULL,
'ParameterDescription' VARCHAR (250) NOT NULL,
'ParameterDescriptionPolish' VARCHAR (250) NOT NULL,
'ParameterSize' INT (11) NOT NULL DEFAULT '1',
'MinValue' INT (11) NOT NULL DEFAULT '0',
'MaxValue' INT (11) NOT NULL DEFAULT '0',
'DefaultValue' INT (11) NOT NULL DEFAULT '',
'Scale' REAL NOT NULL DEFAULT '',
'Unit' VARCHAR (16) NOT NULL DEFAULT '',
'ExtraValue' VARCHAR (8) NOT NULL DEFAULT ''
);

DROP TABLE IF EXISTS "Device_Parameters_Template_Parameters_Value";
CREATE TABLE 'Device_Parameters_Template_Parameters_Value' (
'PK_Device_Parameters_Template_Parameter_Value' INTEGER NOT NULL,
'FK_Device_Parameters_Template_Parameter' INT(11) NOT NULL,
'Value' INT(11) NOT NULL,
'ValueDescription' TEXT NOT NULL,
'ValueDescriptionPolish' TEXT NOT NULL
);

DROP TABLE IF EXISTS "Device_Parameters_Template";
CREATE TABLE `Device_Parameters_Template` (
  `PK_Device_Parameters_Template` INTEGER NOT NULL PRIMARY KEY,
  `ManufacturerID` TEXT,
  `ManufcaturerSubID` TEXT,
  `ProductTypeID` TEXT,
  `ProductTypeSubID` TEXT,
  `ProductID` TEXT,
  `ProductSubID` TEXT,
  `ApplicationVersion` TEXT,
  `ApplicationSubVersion` TEXT,
  `Description` TEXT
);


INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(1, '1', '15', '1', '0', '1', '4', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(2, '1', '15', '1', '0', '1', '3', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(3, '1', '15', '1', '0', '1', '2', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(4, '1', '15', '1', '0', '1', '1', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(5, '1', '15', '3', '0', '1', '0', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(9, '1', '15', '3', '0', '1', '4', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(6, '1', '15', '3', '0', '1', '1', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(8, '1', '15', '3', '0', '1', '3', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(7, '1', '15', '3', '0', '1', '2', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(11, '1', '15', '4', '0', '1', '3', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(10, '1', '15', '4', '0', '1', '4', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(12, '1', '15', '4', '0', '1', '2', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(14, '1', '15', '4', '0', '1', '0', '', '', 'FGS211 Switch 3kW  ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(13, '1', '15', '4', '0', '1', '1', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(15, '1', '15', '2', '0', '1', '4', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(17, '1', '15', '2', '0', '1', '2', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(16, '1', '15', '2', '0', '1', '3', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(18, '1', '15', '2', '0', '1', '1', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(19, '1', '15', '2', '0', '1', '0', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(20, '0', '96', '0', '6', '0', '1', '', '', 'ST814 Temperature / Humidity Detector');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(21, '0', '96', '0', '7', '0', '1', '', '', 'ST815 Illumination Detector');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(22, '0', '96', '0', '11', '0', '1', '', '', 'ST812 Flood Detector');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(23, '0', '96', '1', '1', '0', '1', '', '', 'SP103 PIR Detector');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(24, '0', '96', '0', '2', '0', '1', '', '', 'SM103 Door/Window Detector');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(25, '0', '96', '0', '4', '0', '2', '', '', 'AN158 ON/Off Plug');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(27, '0', '96', '0', '12', '0', '1', '', '', 'SE812 Indoor Siren');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(30, '1', '15', '1', '0', '1', '0', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(31, '1', '15', '3', '1', '3', '1', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(40, '0', '96', '0', '13', '0', '1', '', '', 'SF812-1 Smoke Sensor');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(41, '0', '134', '0', '2', '0', '4', '', '', 'Door/Window Sensor');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(42, '0', '2', '128', '5', '0', '1', '', '', 'Danfoss Living Connect Thermostat');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(43, '0', '89', '0', '1', '0', '3', '', '', 'HRT4-ZW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(44, '0', '89', '0', '3', '0', '1', '', '', 'HRT4 ASR-ZW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(45, '0', '30', '0', '2', '0', '1', '', '', '3 in 1');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(46, '0', '89', '0', '1', '0', '2', '', '', 'AS2-RF');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(47, '1', '15', '1', '0', '1', '5', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(48, '1', '15', '3', '0', '1', '5', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(49, '1', '15', '4', '0', '1', '5', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(50, '1', '15', '2', '0', '1', '5', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(51, '1', '15', '1', '0', '1', '6', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(52, '1', '15', '3', '0', '1', '6', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(53, '1', '15', '4', '0', '1', '6', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(54, '1', '15', '2', '0', '1', '6', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(55, '1', '15', '1', '0', '1', '8', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(56, '1', '15', '1', '0', '1', '7', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(57, '1', '15', '3', '0', '1', '7', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(58, '1', '15', '4', '0', '1', '7', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(59, '1', '15', '2', '0', '1', '7', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(60, '1', '15', '5', '1', '1', '2', '', '', 'FGBS321 Universal Binary Sensor');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(61, '0', '96', '0', '3', '0', '1', '', '', 'AD142 Dimmer Plug');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(62, '0', '134', '0', '2', '0', '5', '', '', 'DSB05xxx-ZWUS Z-Wave Multi Sensor');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(63, '0', '138', '0', '5', '1', '0', '', '', 'Wintop iAlarm 1184R-FR');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(64, '0', '96', '0', '9', '0', '1', '', '', 'TSE03 Door Bell');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(65, '0', '132', '0', '33', '1', '10', '', '', 'Fortrezz WWA-02');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(66, '0', '149', '49', '3', '0', '1', '', '', 'RETO Plug-in Switch Plus');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(67, '0', '149', '49', '1', '0', '1', '', '', 'RETO Shell Switch Plus');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(68, '1', '22', '0', '17', '0', '1', '', '', 'HAN01-1');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(69, '1', '22', '0', '17', '0', '2', '', '', 'HAN02-1');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(70, '0', '96', '0', '1', '0', '2', '', '', 'SP814 Motion detector');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(71, '0', '96', '0', '4', '0', '1', '', '', 'AN157-2 Screw-in on/off module');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(72, '1', '22', '0', '2', '0', '1', '', '', 'HSM02-1-1V1 Mini Door/Window Sensor');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(73, '1', '22', '0', '1', '0', '1', '', '', 'HSP02 -1-1V1 Motion Sensor Everest');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(74, '0', '122', '128', '1', '128', '4', '', '', '507502 Switch');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(75, '0', '122', '0', '3', '128', '4', '', '', 'MEG5016-0002');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(76, '0', '122', '0', '1', '0', '4', '', '', '507219');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(77, '1', '15', '1', '0', '1', '10', '', '', 'FGD211 Dimmer 60Hz');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(78, '1', '15', '5', '1', '1', '9', '', '', 'FGBS321 Universal Binary Sensor');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(79, '1', '15', '2', '0', '1', '9', '', '', 'FGS221 Switch 2x1,5kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(80, '1', '15', '4', '0', '1', '9', '', '', 'FGS211 Switch 3kW');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(81, '1', '15', '3', '0', '1', '9', '', '', 'FGR221 Roller Shutter');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(82, '1', '15', '1', '0', '1', '9', '', '', 'FGD211 Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(83, '0', '2', '0', '5', '0', '2', '', '', 'Danfoss Living Connect Thermostat');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(84, '0', '2', '0', '5', '0', '3', '', '', 'Danfoss Living Connect Thermostat');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(85, '1', '15', '5', '1', '16', '2', '', '', 'FGBS321 Universal Binary Sensor EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(86, '1', '15', '5', '1', '64', '2', '', '', 'FGBS321 Universal Binary Sensor RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(87, '1', '15', '5', '1', '48', '2', '', '', 'FGBS321 Universal Binary Sensor ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(88, '1', '15', '5', '1', '32', '2', '', '', 'FGBS321 Universal Binary Sensor US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(89, '1', '15', '1', '0', '1', '11', '', '', 'FGD211 Dimmer ANZ/BR');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(200, '0', '134', '0', '1', '0', '3', '', '', 'Minimote DSA03202W - ZWEU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(201, '1', '24', '1', '1', '1', '3', '', '', 'Plugs');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(202, '0', '134', '0', '3', '0', '19', '', '', 'Aeotec Micro Smart Energy Illuminator G2');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(203, '1', '21', '1', '0', '0', '1', '', '', 'Key Fob');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(204, '1', '15', '7', '0', '16', '0', '', '', 'FGK101 Door/Window Sensor');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(205, '0', '134', '0', '2', '0', '9', '', '', 'Home Energy Meter DSB09104-ZWEU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(229, '1', '15', '2', '0', '64', '10', '', '', 'FGS221 Switch 2x1,5kW RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(207, '1', '15', '7', '0', '64', '0', '', '', 'FGK101 Door/Window Sensor RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(208, '1', '15', '7', '0', '48', '0', '', '', 'FGK101 Door/Window Sensor ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(209, '1', '15', '7', '0', '32', '0', '', '', 'FGK101 Door/Window Sensor US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(210, '1', '15', '1', '0', '16', '8', '', '', 'FGD211 Dimmer EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(211, '1', '15', '1', '0', '32', '8', '', '', 'FGD211 Dimmer US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(212, '1', '15', '1', '0', '48', '8', '', '', 'FGD211 Dimmer ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(213, '1', '15', '1', '0', '64', '8', '', '', 'FGD211 Dimmer RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(214, '1', '15', '2', '0', '16', '10', '', '', 'FGS221 Switch 2x1,5kW EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(215, '1', '15', '2', '0', '32', '10', '', '', 'FGS221 Switch 2x1,5kW US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(216, '1', '15', '2', '0', '48', '10', '', '', 'FGS221 Switch 2x1,5kW ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(217, '1', '15', '3', '0', '16', '10', '', '', 'FGR221 Roller Shutter EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(218, '1', '15', '3', '0', '32', '10', '', '', 'FGR221 Roller Shutter US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(219, '1', '15', '3', '0', '48', '10', '', '', 'FGR221 Roller Shutter ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(220, '1', '15', '3', '0', '64', '10', '', '', 'FGR221 Roller Shutter RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(221, '1', '15', '4', '0', '16', '10', '', '', 'FGS211 Switch 3kW EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(222, '1', '15', '4', '0', '32', '10', '', '', 'FGS211 Switch 3kW US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(223, '1', '15', '4', '0', '48', '10', '', '', 'FGS211 Switch 3kW ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(224, '1', '15', '4', '0', '64', '10', '', '', 'FGS211 Switch 3kW RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(225, '1', '15', '6', '0', '16', '0', '', '', 'FGP111 Plug');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(226, '1', '10', '18', '0', '83', '0', '', '', 'Think Simple III EU ON/OFF');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(227, '1', '10', '21', '0', '105', '0', '', '', 'Think Simple IV Scene EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(228, '0', '96', '0', '4', '0', '2', '', '', 'Think Simple III EU Dimmer');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(230, '1', '10', '20', '0', '102', '0', '1', '1', 'Think Simple VI EU Virtrum');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(235, '1', '15', '1', '0', '16', '10', '2', '2', 'FGD211 Dimmer EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(236, '1', '15', '1', '0', '32', '10', '2', '2', 'FGD211 Dimmer US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(237, '1', '15', '1', '0', '48', '10', '2', '2', 'FGD211 Dimmer ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(238, '1', '15', '1', '0', '64', '10', '2', '2', 'FGD211 Dimmer RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(231, '1', '15', '9', '0', '16', '0', '2', '2', 'FGRGBW 441M EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(239, '1', '15', '7', '0', '112', '0', '2', '2', 'FGK101 Door/Window Sensor IL');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(240, '1', '15', '5', '1', '112', '2', '2', '2', 'FGBS321 Universal Binary Sensor IL');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(241, '1', '15', '2', '0', '112', '10', '2', '3', 'FGS221 Switch 2x1,5kW IL');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(242, '1', '15', '4', '0', '112', '10', '2', '3', 'FGS211 Switch 3kW IL');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(243, '1', '15', '3', '0', '112', '10', '2', '3', 'FGR221 Roller Shutter IL');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(244, '1', '15', '1', '0', '112', '10', '2', '2', 'FGD211 Dimmer IL');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(245, '1', '15', '11', '0', '16', '1', '2', '2', 'FGFS101 Flood Sensor EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(246, '1', '15', '11', '0', '32', '1', '2', '2', 'FGFS101 Flood Sensor US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(247, '1', '15', '11', '0', '48', '1', '2', '2', 'FGFS101 Flood Sensor ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(248, '1', '15', '11', '0', '64', '1', '2', '2', 'FGFS101 Flood Sensor RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(232, '1', '15', '9', '0', '16', '0', '2', '2', 'FGRGBW 441M EU Outputs ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(249, '1', '15', '3', '1', '16', '1', '', '', 'FGRM222 EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(250, '1', '15', '5', '1', '16', '2', '2', '3', 'FGK101 Door/Window Sensor EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(251, '1', '15', '5', '1', '32', '2', '2', '3', 'FGK101 Door/Window Sensor US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(252, '1', '15', '5', '1', '48', '2', '2', '3', 'FGK101 Door/Window Sensor ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(253, '1', '15', '5', '1', '64', '2', '2', '3', 'FGK101 Door/Window Sensor RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(254, '1', '15', '9', '0', '32', '0', '2', '2', 'FGRGBW 441M US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(255, '1', '15', '9', '0', '48', '0', '2', '2', 'FGRGBW 441M ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(256, '1', '15', '9', '0', '64', '0', '2', '2', 'FGRGBW 441M RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(257, '1', '15', '9', '0', '32', '0', '2', '2', 'FGRGBW 441M US Outputs ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(258, '1', '15', '9', '0', '48', '0', '2', '2', 'FGRGBW 441M ANZ Outputs ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(259, '1', '15', '9', '0', '64', '0', '2', '2', 'FGRGBW 441M RU Outputs ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(260, '1', '15', '3', '1', '32', '1', '', '', 'FGRM222 US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(261, '1', '15', '3', '1', '48', '1', '', '', 'FGRM222 ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(262, '1', '15', '3', '1', '64', '1', '', '', 'FGRM222 RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(263, '1', '15', '12', '0', '16', '0', '', '', 'FGSS001 Smoke Sensor EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(264, '1', '15', '12', '0', '32', '0', '', '', 'FGSS001 Smoke Sensor US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(265, '1', '15', '12', '0', '48', '0', '', '', 'FGSS001 Smoke Sensor ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(266, '1', '15', '12', '0', '64', '0', '', '', 'FGSS001 Smoke Sensor RU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(270, '1', '15', '8', '0', '16', '1', '', '', 'FGMS001 MultiSensor EU');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(271, '1', '15', '8', '0', '32', '1', '', '', 'FGMS001 MultiSensor US');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(272, '1', '15', '8', '0', '48', '1', '', '', 'FGMS001 MultiSensor ANZ');
INSERT INTO `Device_Parameters_Template` (`PK_Device_Parameters_Template`, `ManufacturerID`, `ManufcaturerSubID`, `ProductTypeID`, `ProductTypeSubID`, `ProductID`, `ProductSubID`, `ApplicationVersion`, `ApplicationSubVersion`, `Description`) VALUES(273, '1', '15', '8', '0', '64', '1', '', '', 'FGMS001 MultiSensor RU');




INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(38, 2, 14, 'TXT_DEVICEPARAMETERS_38', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(3, 4, 1, 'TXT_DEVICEPARAMETERS_3', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(4, 4, 7, 'TXT_DEVICEPARAMETERS_4', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(5, 4, 9, 'TXT_DEVICEPARAMETERS_5', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(6, 4, 10, 'TXT_DEVICEPARAMETERS_6', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(7, 4, 11, 'TXT_DEVICEPARAMETERS_7', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(8, 4, 12, 'TXT_DEVICEPARAMETERS_8', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(9, 4, 13, 'TXT_DEVICEPARAMETERS_9', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(10, 4, 14, 'TXT_DEVICEPARAMETERS_10', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(11, 4, 16, 'TXT_DEVICEPARAMETERS_11', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(12, 4, 17, 'TXT_DEVICEPARAMETERS_12', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(13, 4, 18, 'TXT_DEVICEPARAMETERS_13', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(14, 4, 20, 'TXT_DEVICEPARAMETERS_14', '', '1', 100, 170, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(15, 3, 1, 'TXT_DEVICEPARAMETERS_15', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(16, 3, 7, 'TXT_DEVICEPARAMETERS_16', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(17, 3, 9, 'TXT_DEVICEPARAMETERS_17', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(18, 3, 10, 'TXT_DEVICEPARAMETERS_18', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(19, 3, 11, 'TXT_DEVICEPARAMETERS_19', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(20, 3, 12, 'TXT_DEVICEPARAMETERS_20', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(21, 3, 13, 'TXT_DEVICEPARAMETERS_21', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(22, 3, 14, 'TXT_DEVICEPARAMETERS_22', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(23, 3, 16, 'TXT_DEVICEPARAMETERS_23', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(24, 3, 17, 'TXT_DEVICEPARAMETERS_24', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(25, 3, 18, 'TXT_DEVICEPARAMETERS_25', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(26, 3, 20, 'TXT_DEVICEPARAMETERS_26', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(27, 3, 30, 'TXT_DEVICEPARAMETERS_27', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(28, 3, 39, 'TXT_DEVICEPARAMETERS_28', '', '1', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(29, 2, 1, 'TXT_DEVICEPARAMETERS_29', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(31, 2, 7, 'TXT_DEVICEPARAMETERS_31', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(32, 2, 8, 'TXT_DEVICEPARAMETERS_32', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(33, 2, 9, 'TXT_DEVICEPARAMETERS_33', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(34, 2, 10, 'TXT_DEVICEPARAMETERS_34', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(35, 2, 11, 'TXT_DEVICEPARAMETERS_35', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(36, 2, 12, 'TXT_DEVICEPARAMETERS_36', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(37, 2, 13, 'TXT_DEVICEPARAMETERS_37', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(39, 2, 15, 'TXT_DEVICEPARAMETERS_39', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(41, 2, 16, 'TXT_DEVICEPARAMETERS_41', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(42, 2, 17, 'TXT_DEVICEPARAMETERS_42', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(43, 2, 18, 'TXT_DEVICEPARAMETERS_43', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(44, 2, 19, 'TXT_DEVICEPARAMETERS_44', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(45, 2, 20, 'TXT_DEVICEPARAMETERS_45', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(46, 2, 30, 'TXT_DEVICEPARAMETERS_46', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(47, 2, 39, 'TXT_DEVICEPARAMETERS_47', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(50, 1, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(51, 1, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(52, 1, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(53, 1, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(54, 1, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(55, 1, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(56, 1, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(57, 1, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(58, 1, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(59, 1, 14, 'TXT_DEVICEPARAMETERS_59', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(60, 1, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(61, 1, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(62, 1, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(63, 1, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(64, 1, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(65, 1, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(66, 1, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(67, 1, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(68, 19, 1, 'TXT_DEVICEPARAMETERS_68', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(69, 19, 7, 'TXT_DEVICEPARAMETERS_69', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(70, 19, 13, 'TXT_DEVICEPARAMETERS_70', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(71, 19, 14, 'TXT_DEVICEPARAMETERS_71', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(72, 19, 15, 'TXT_DEVICEPARAMETERS_72', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(73, 19, 16, 'TXT_DEVICEPARAMETERS_73', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(74, 18, 1, 'TXT_DEVICEPARAMETERS_74', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(75, 18, 7, 'TXT_DEVICEPARAMETERS_75', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(76, 18, 13, 'TXT_DEVICEPARAMETERS_76', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(77, 18, 14, 'TXT_DEVICEPARAMETERS_77', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(78, 18, 15, 'TXT_DEVICEPARAMETERS_78', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(79, 18, 16, 'TXT_DEVICEPARAMETERS_79', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(80, 17, 1, 'TXT_DEVICEPARAMETERS_80', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(81, 17, 7, 'TXT_DEVICEPARAMETERS_81', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(82, 17, 13, 'TXT_DEVICEPARAMETERS_82', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(83, 17, 14, 'TXT_DEVICEPARAMETERS_83', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(84, 17, 15, 'TXT_DEVICEPARAMETERS_84', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(85, 17, 16, 'TXT_DEVICEPARAMETERS_85', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(86, 17, 30, 'TXT_DEVICEPARAMETERS_86', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(87, 17, 40, 'TXT_DEVICEPARAMETERS_87', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(88, 17, 31, 'TXT_DEVICEPARAMETERS_88', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(89, 17, 41, 'TXT_DEVICEPARAMETERS_89', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(90, 17, 32, 'TXT_DEVICEPARAMETERS_90', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(91, 17, 42, 'TXT_DEVICEPARAMETERS_91', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(92, 17, 33, 'TXT_DEVICEPARAMETERS_92', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(93, 17, 43, 'TXT_DEVICEPARAMETERS_93', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(94, 17, 39, 'TXT_DEVICEPARAMETERS_94', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(95, 16, 1, 'TXT_DEVICEPARAMETERS_95', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(96, 16, 3, 'TXT_DEVICEPARAMETERS_96', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(97, 16, 4, 'TXT_DEVICEPARAMETERS_97', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(98, 16, 5, 'TXT_DEVICEPARAMETERS_98', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(99, 16, 6, 'TXT_DEVICEPARAMETERS_99', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(100, 16, 7, 'TXT_DEVICEPARAMETERS_100', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(101, 16, 13, 'TXT_DEVICEPARAMETERS_101', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(102, 16, 14, 'TXT_DEVICEPARAMETERS_102', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(103, 16, 15, 'TXT_DEVICEPARAMETERS_103', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(104, 16, 30, 'TXT_DEVICEPARAMETERS_104', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(105, 16, 40, 'TXT_DEVICEPARAMETERS_105', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(106, 16, 31, 'TXT_DEVICEPARAMETERS_106', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(107, 16, 41, 'TXT_DEVICEPARAMETERS_107', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(108, 16, 32, 'TXT_DEVICEPARAMETERS_108', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(109, 16, 42, 'TXT_DEVICEPARAMETERS_109', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(110, 16, 33, 'TXT_DEVICEPARAMETERS_110', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(111, 16, 43, 'TXT_DEVICEPARAMETERS_111', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(112, 15, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(113, 15, 3, 'TXT_DEVICEPARAMETERS_113', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(114, 15, 4, 'TXT_DEVICEPARAMETERS_114', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(115, 15, 5, 'TXT_DEVICEPARAMETERS_115', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(116, 15, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(117, 15, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(118, 15, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(119, 15, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(120, 15, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(121, 15, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(122, 15, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(123, 15, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(124, 15, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(125, 15, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(126, 15, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(127, 15, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(128, 15, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(129, 15, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(130, 15, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(134, 12, 13, 'TXT_DEVICEPARAMETERS_134', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(133, 12, 1, 'TXT_DEVICEPARAMETERS_133', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(135, 12, 14, 'TXT_DEVICEPARAMETERS_135', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(136, 12, 15, 'TXT_DEVICEPARAMETERS_136', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(137, 12, 30, 'TXT_DEVICEPARAMETERS_137', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(138, 12, 31, 'TXT_DEVICEPARAMETERS_138', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(139, 12, 32, 'TXT_DEVICEPARAMETERS_139', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(140, 12, 33, 'TXT_DEVICEPARAMETERS_140', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(141, 11, 1, 'TXT_DEVICEPARAMETERS_141', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(142, 11, 13, 'TXT_DEVICEPARAMETERS_142', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(143, 11, 14, 'TXT_DEVICEPARAMETERS_143', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(144, 11, 15, 'TXT_DEVICEPARAMETERS_144', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(145, 11, 30, 'TXT_DEVICEPARAMETERS_145', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(146, 11, 31, 'TXT_DEVICEPARAMETERS_146', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(147, 11, 32, 'TXT_DEVICEPARAMETERS_147', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(148, 11, 33, 'TXT_DEVICEPARAMETERS_148', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(149, 11, 3, 'TXT_DEVICEPARAMETERS_149', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(150, 11, 4, 'TXT_DEVICEPARAMETERS_150', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(151, 11, 6, 'TXT_DEVICEPARAMETERS_151', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(152, 10, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(153, 10, 3, 'TXT_DEVICEPARAMETERS_153', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(154, 10, 4, 'TXT_DEVICEPARAMETERS_154', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(155, 10, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(156, 10, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(157, 10, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(158, 10, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(159, 10, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(160, 10, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(161, 10, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(162, 10, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(163, 10, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(164, 10, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(166, 5, 1, 'TXT_DEVICEPARAMETERS_166', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(167, 5, 7, 'TXT_DEVICEPARAMETERS_167', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(168, 5, 10, 'TXT_DEVICEPARAMETERS_168', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(169, 5, 14, 'TXT_DEVICEPARAMETERS_169', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(170, 5, 20, 'TXT_DEVICEPARAMETERS_170', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(171, 6, 1, 'TXT_DEVICEPARAMETERS_171', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(172, 6, 7, 'TXT_DEVICEPARAMETERS_172', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(173, 6, 10, 'TXT_DEVICEPARAMETERS_173', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(174, 6, 14, 'TXT_DEVICEPARAMETERS_174', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(175, 6, 20, 'TXT_DEVICEPARAMETERS_175', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(176, 7, 1, 'TXT_DEVICEPARAMETERS_176', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(177, 7, 7, 'TXT_DEVICEPARAMETERS_177', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(178, 7, 10, 'TXT_DEVICEPARAMETERS_178', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(179, 7, 14, 'TXT_DEVICEPARAMETERS_179', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(180, 7, 20, 'TXT_DEVICEPARAMETERS_180', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(181, 7, 30, 'TXT_DEVICEPARAMETERS_181', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(182, 7, 31, 'TXT_DEVICEPARAMETERS_182', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(183, 7, 32, 'TXT_DEVICEPARAMETERS_183', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(184, 7, 33, 'TXT_DEVICEPARAMETERS_184', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(185, 8, 1, 'TXT_DEVICEPARAMETERS_185', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(186, 8, 10, 'TXT_DEVICEPARAMETERS_186', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(187, 8, 14, 'TXT_DEVICEPARAMETERS_187', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(188, 8, 20, 'TXT_DEVICEPARAMETERS_188', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(189, 8, 30, 'TXT_DEVICEPARAMETERS_189', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(190, 8, 31, 'TXT_DEVICEPARAMETERS_190', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(191, 8, 32, 'TXT_DEVICEPARAMETERS_191', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(192, 8, 33, 'TXT_DEVICEPARAMETERS_192', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(193, 9, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(194, 9, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(195, 9, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(196, 9, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(197, 9, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(198, 9, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(199, 9, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(200, 9, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(201, 20, 1, 'TXT_DEVICEPARAMETERS_201', '', '1', 0, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(202, 20, 2, 'TXT_DEVICEPARAMETERS_202', '', '1', -20, 50, 30, '1.0000000', '℃', '99');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(203, 20, 3, 'TXT_DEVICEPARAMETERS_203', '', '1', -20, 50, 20, '1.0000000', '℃', '99');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(204, 20, 4, 'TXT_DEVICEPARAMETERS_204', '', '1', 20, 90, 50, '1.0000000', '%', '99');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(205, 20, 5, 'TXT_DEVICEPARAMETERS_205', '', '1', 20, 90, 40, '1.0000000', '%', '99');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(206, 20, 6, 'TXT_DEVICEPARAMETERS_206', '', '2', 0, 1439, 0, '1.0000000', 'm', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(207, 20, 7, 'TXT_DEVICEPARAMETERS_207', '', '1', 0, 70, 1, '1.0000000', '℃', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(208, 20, 8, 'TXT_DEVICEPARAMETERS_208', '', '1', 5, 70, 10, '1.0000000', '%', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(209, 47, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(210, 47, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(211, 47, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(212, 47, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(213, 47, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(214, 47, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(215, 47, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(216, 47, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(217, 47, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(218, 47, 14, 'TXT_DEVICEPARAMETERS_59', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(219, 47, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(220, 47, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(221, 47, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(222, 47, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(223, 47, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(224, 47, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(225, 47, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(226, 47, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(227, 50, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(228, 50, 3, 'TXT_DEVICEPARAMETERS_113', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(229, 50, 4, 'TXT_DEVICEPARAMETERS_114', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(230, 50, 5, 'TXT_DEVICEPARAMETERS_115', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(231, 50, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(232, 50, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(233, 50, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(234, 50, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(235, 50, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(236, 50, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(237, 50, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(238, 50, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(239, 50, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(240, 50, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(241, 50, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(242, 50, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(243, 50, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(244, 50, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(245, 50, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(246, 49, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(247, 49, 3, 'TXT_DEVICEPARAMETERS_153', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(248, 49, 4, 'TXT_DEVICEPARAMETERS_154', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(249, 49, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(250, 49, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(251, 49, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(252, 49, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(253, 49, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(254, 49, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(255, 49, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(256, 49, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(257, 49, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(258, 49, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(259, 48, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(260, 48, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(261, 48, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(262, 48, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(263, 48, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(264, 48, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(265, 48, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(266, 48, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(267, 51, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(268, 51, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(269, 51, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(270, 51, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(271, 51, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(272, 51, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(273, 51, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(274, 51, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(275, 51, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(276, 51, 14, 'TXT_DEVICEPARAMETERS_59', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(277, 51, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(278, 51, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(279, 51, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(280, 51, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(281, 51, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(282, 51, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(283, 51, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(284, 51, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(285, 54, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(286, 54, 3, 'TXT_DEVICEPARAMETERS_113', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(287, 54, 4, 'TXT_DEVICEPARAMETERS_114', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(288, 54, 5, 'TXT_DEVICEPARAMETERS_115', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(289, 54, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(290, 54, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(291, 54, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(292, 54, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(293, 54, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(294, 54, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(295, 54, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(296, 54, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(297, 54, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(298, 54, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(299, 54, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(300, 54, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(301, 54, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(302, 54, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(303, 54, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(304, 53, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(305, 53, 3, 'TXT_DEVICEPARAMETERS_153', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(306, 53, 4, 'TXT_DEVICEPARAMETERS_154', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(307, 53, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(308, 53, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(309, 53, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(310, 53, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(311, 53, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(312, 53, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(313, 53, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(314, 53, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(315, 53, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(316, 53, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(317, 52, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(318, 52, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(319, 52, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(320, 52, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(321, 52, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(322, 52, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(323, 52, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(324, 52, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(325, 45, 1, 'TXT_DEVICEPARAMETERS_214', '', '1', 0, 255, 200, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(326, 45, 2, 'TXT_DEVICEPARAMETERS_209', '', '1', 0, 255, 20, '1.0000000', 'min', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(327, 45, 3, 'TXT_DEVICEPARAMETERS_210', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(328, 45, 4, 'TXT_DEVICEPARAMETERS_211', '', '1', 0, 100, 100, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(329, 45, 5, 'TXT_DEVICEPARAMETERS_212', '', '1', 0, 255, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(330, 45, 6, 'TXT_DEVICEPARAMETERS_213', '', '1', 0, 100, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(331, 23, 1, 'TXT_DEVICEPARAMETERS_331', '', '1', 0, 127, 127, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(332, 23, 3, 'TXT_DEVICEPARAMETERS_332', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(333, 24, 1, 'TXT_DEVICEPARAMETERS_333', '', '1', 0, 99, 99, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(334, 24, 2, 'TXT_DEVICEPARAMETERS_334', '', '1', 0, 127, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(335, 55, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(336, 55, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(337, 55, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(338, 55, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(339, 55, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(340, 55, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(341, 55, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(342, 55, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(343, 55, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(344, 55, 14, 'TXT_DEVICEPARAMETERS_59', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(345, 55, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(346, 55, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(347, 55, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(348, 55, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(349, 55, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(350, 55, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 101, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(351, 55, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(352, 55, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(353, 56, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(354, 56, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(355, 56, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(356, 56, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(357, 56, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(358, 56, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(359, 56, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(360, 56, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(361, 56, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(367, 56, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(363, 56, 14, 'TXT_DEVICEPARAMETERS_59', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(364, 56, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(365, 56, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(366, 56, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(368, 56, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(369, 56, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(370, 56, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(371, 56, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(372, 57, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(373, 57, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(374, 57, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(375, 57, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(376, 57, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(377, 57, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(378, 57, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(379, 57, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(380, 58, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(381, 58, 3, 'TXT_DEVICEPARAMETERS_153', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(382, 58, 4, 'TXT_DEVICEPARAMETERS_154', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(383, 58, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(384, 58, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(385, 58, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(386, 58, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(387, 58, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(388, 58, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(389, 58, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(390, 58, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(391, 58, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(392, 58, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(395, 59, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(396, 59, 3, 'TXT_DEVICEPARAMETERS_113', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(397, 59, 4, 'TXT_DEVICEPARAMETERS_114', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(398, 59, 5, 'TXT_DEVICEPARAMETERS_115', '', '1', 1, 255, 20, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(399, 59, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(400, 59, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(401, 59, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(402, 59, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(403, 59, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(404, 59, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(405, 59, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(406, 59, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(407, 59, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(408, 59, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(409, 59, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(410, 59, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(411, 59, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(412, 59, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(413, 59, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(414, 60, 1, 'TXT_DEVICEPARAMETERS_414', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(415, 60, 2, 'TXT_DEVICEPARAMETERS_415', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(416, 60, 3, 'TXT_DEVICEPARAMETERS_416', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(417, 60, 4, 'TXT_DEVICEPARAMETERS_417', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(418, 60, 5, 'TXT_DEVICEPARAMETERS_418', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(419, 60, 6, 'TXT_DEVICEPARAMETERS_419', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(420, 60, 7, 'TXT_DEVICEPARAMETERS_420', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(421, 60, 8, 'TXT_DEVICEPARAMETERS_421', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(422, 60, 9, 'TXT_DEVICEPARAMETERS_422', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(423, 60, 10, 'TXT_DEVICEPARAMETERS_423', '', '1', 1, 255, 20, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(424, 60, 11, 'TXT_DEVICEPARAMETERS_424', '', '1', 0, 255, 200, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(425, 60, 12, 'TXT_DEVICEPARAMETERS_425', '', '1', 0, 255, 8, '0.0630000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(426, 60, 13, 'TXT_DEVICEPARAMETERS_426', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(427, 60, 14, 'TXT_DEVICEPARAMETERS_427', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(428, 43, 1, 'TXT_DEVICEPARAMETERS_428', '', '1', 0, 255, 129, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(429, 43, 2, 'TXT_DEVICEPARAMETERS_429', '', '1', 0, 255, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(430, 43, 3, 'TXT_DEVICEPARAMETERS_430', '', '1', 1, 100, 10, '0.1000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(431, 78, 1, 'TXT_DEVICEPARAMETERS_414', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(432, 78, 2, 'TXT_DEVICEPARAMETERS_415', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(433, 78, 3, 'TXT_DEVICEPARAMETERS_416', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(434, 78, 4, 'TXT_DEVICEPARAMETERS_417', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(435, 78, 5, 'TXT_DEVICEPARAMETERS_418', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(436, 78, 6, 'TXT_DEVICEPARAMETERS_419', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(437, 78, 7, 'TXT_DEVICEPARAMETERS_420', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(438, 78, 8, 'TXT_DEVICEPARAMETERS_421', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(439, 78, 9, 'TXT_DEVICEPARAMETERS_422', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(440, 78, 10, 'TXT_DEVICEPARAMETERS_423', '', '1', 1, 255, 20, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(441, 78, 11, 'TXT_DEVICEPARAMETERS_424', '', '1', 0, 255, 200, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(442, 78, 12, 'TXT_DEVICEPARAMETERS_425', '', '1', 0, 255, 8, '0.0630000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(443, 78, 13, 'TXT_DEVICEPARAMETERS_426', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(444, 78, 14, 'TXT_DEVICEPARAMETERS_427', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(445, 77, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(446, 77, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(447, 77, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(448, 77, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(449, 77, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(450, 77, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(451, 77, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(452, 77, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(453, 77, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(454, 77, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(455, 77, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(456, 77, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(457, 77, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(458, 77, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(459, 77, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(460, 77, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 101, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(461, 77, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(462, 77, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(463, 77, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(464, 82, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(465, 82, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(466, 82, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(467, 82, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(468, 82, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(469, 82, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(470, 82, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(471, 82, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(472, 82, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(473, 82, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(474, 82, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(475, 82, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(476, 82, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(477, 82, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(478, 82, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(479, 82, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(480, 82, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(481, 82, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(482, 82, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(483, 81, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(484, 81, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(485, 81, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(486, 81, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(487, 81, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(488, 81, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(489, 81, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(490, 81, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(491, 81, 41, 'TXT_DEVICEPARAMETERS_491', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(492, 79, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(493, 79, 3, 'TXT_DEVICEPARAMETERS_493', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(494, 79, 4, 'TXT_DEVICEPARAMETERS_494', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(495, 79, 5, 'TXT_DEVICEPARAMETERS_495', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(496, 79, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(497, 79, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(498, 79, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(499, 79, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(500, 79, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(501, 79, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(502, 79, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(503, 79, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(504, 79, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(505, 79, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(506, 79, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(507, 79, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(508, 79, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(509, 79, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(510, 79, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(511, 80, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(512, 80, 3, 'TXT_DEVICEPARAMETERS_512', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(513, 80, 4, 'TXT_DEVICEPARAMETERS_513', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(514, 80, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(515, 80, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(516, 80, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(517, 80, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(518, 80, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(519, 80, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(520, 80, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(521, 80, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(522, 80, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(523, 80, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(524, 85, 1, 'TXT_DEVICEPARAMETERS_414', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(525, 85, 2, 'TXT_DEVICEPARAMETERS_415', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(526, 85, 3, 'TXT_DEVICEPARAMETERS_416', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(527, 85, 4, 'TXT_DEVICEPARAMETERS_417', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(528, 85, 5, 'TXT_DEVICEPARAMETERS_418', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(529, 85, 6, 'TXT_DEVICEPARAMETERS_419', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(530, 85, 7, 'TXT_DEVICEPARAMETERS_420', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(531, 85, 8, 'TXT_DEVICEPARAMETERS_421', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(532, 85, 9, 'TXT_DEVICEPARAMETERS_422', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(533, 85, 10, 'TXT_DEVICEPARAMETERS_423', '', '1', 1, 255, 20, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(534, 85, 11, 'TXT_DEVICEPARAMETERS_424', '', '1', 0, 255, 200, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(535, 85, 12, 'TXT_DEVICEPARAMETERS_425', '', '1', 0, 255, 8, '0.0630000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(536, 85, 13, 'TXT_DEVICEPARAMETERS_426', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(537, 85, 14, 'TXT_DEVICEPARAMETERS_427', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(538, 86, 1, 'TXT_DEVICEPARAMETERS_414', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(539, 86, 2, 'TXT_DEVICEPARAMETERS_415', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(540, 86, 3, 'TXT_DEVICEPARAMETERS_416', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(541, 86, 4, 'TXT_DEVICEPARAMETERS_417', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(542, 86, 5, 'TXT_DEVICEPARAMETERS_418', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(543, 86, 6, 'TXT_DEVICEPARAMETERS_419', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(544, 86, 7, 'TXT_DEVICEPARAMETERS_420', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(545, 86, 8, 'TXT_DEVICEPARAMETERS_421', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(546, 86, 9, 'TXT_DEVICEPARAMETERS_422', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(547, 86, 10, 'TXT_DEVICEPARAMETERS_423', '', '1', 1, 255, 20, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(548, 86, 11, 'TXT_DEVICEPARAMETERS_424', '', '1', 0, 255, 200, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(549, 86, 12, 'TXT_DEVICEPARAMETERS_425', '', '1', 0, 255, 8, '0.0630000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(550, 86, 13, 'TXT_DEVICEPARAMETERS_426', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(551, 86, 14, 'TXT_DEVICEPARAMETERS_427', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(552, 87, 1, 'TXT_DEVICEPARAMETERS_414', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(553, 87, 2, 'TXT_DEVICEPARAMETERS_415', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(554, 87, 3, 'TXT_DEVICEPARAMETERS_416', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(555, 87, 4, 'TXT_DEVICEPARAMETERS_417', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(556, 87, 5, 'TXT_DEVICEPARAMETERS_418', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(557, 87, 6, 'TXT_DEVICEPARAMETERS_419', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(558, 87, 7, 'TXT_DEVICEPARAMETERS_420', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(559, 87, 8, 'TXT_DEVICEPARAMETERS_421', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(560, 87, 9, 'TXT_DEVICEPARAMETERS_422', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(561, 87, 10, 'TXT_DEVICEPARAMETERS_423', '', '1', 1, 255, 20, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(562, 87, 11, 'TXT_DEVICEPARAMETERS_424', '', '1', 0, 255, 200, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(563, 87, 12, 'TXT_DEVICEPARAMETERS_425', '', '1', 0, 255, 8, '0.0630000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(564, 87, 13, 'TXT_DEVICEPARAMETERS_426', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(565, 87, 14, 'TXT_DEVICEPARAMETERS_427', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(566, 88, 1, 'TXT_DEVICEPARAMETERS_414', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(567, 88, 2, 'TXT_DEVICEPARAMETERS_415', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(568, 88, 3, 'TXT_DEVICEPARAMETERS_416', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(569, 88, 4, 'TXT_DEVICEPARAMETERS_417', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(570, 88, 5, 'TXT_DEVICEPARAMETERS_418', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(571, 88, 6, 'TXT_DEVICEPARAMETERS_419', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(572, 88, 7, 'TXT_DEVICEPARAMETERS_420', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(573, 88, 8, 'TXT_DEVICEPARAMETERS_421', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(574, 88, 9, 'TXT_DEVICEPARAMETERS_422', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(575, 88, 10, 'TXT_DEVICEPARAMETERS_423', '', '1', 1, 255, 20, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(576, 88, 11, 'TXT_DEVICEPARAMETERS_424', '', '1', 0, 255, 200, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(577, 88, 12, 'TXT_DEVICEPARAMETERS_425', '', '1', 0, 255, 8, '0.0630000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(578, 88, 13, 'TXT_DEVICEPARAMETERS_426', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(579, 88, 14, 'TXT_DEVICEPARAMETERS_427', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(580, 89, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(581, 89, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(582, 89, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(583, 89, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(584, 89, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(585, 89, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(586, 89, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(587, 89, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(588, 89, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(589, 89, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(590, 89, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(591, 89, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(592, 89, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(593, 89, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(594, 89, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(595, 89, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 101, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(596, 89, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(597, 89, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(598, 89, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1541, 205, 9, 'TXT_DEVICEPARAMETERS_4212', '', '1', 0, 100, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1542, 205, 10, 'TXT_DEVICEPARAMETERS_4213', '', '1', 0, 100, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1543, 205, 11, 'TXT_DEVICEPARAMETERS_4214', '', '1', 0, 100, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1544, 205, 101, 'TXT_DEVICEPARAMETERS_4215', '', '4', 0, 4294967295, 1792, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1545, 205, 102, 'TXT_DEVICEPARAMETERS_4216', '', '4', 0, 4294967295, 14336, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1546, 205, 103, 'TXT_DEVICEPARAMETERS_4217', '', '4', 0, 4294967295, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1547, 205, 111, 'TXT_DEVICEPARAMETERS_4218', '', '4', 0, 4294967295, 360, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1548, 205, 112, 'TXT_DEVICEPARAMETERS_4219', '', '4', 0, 4294967295, 3600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1549, 205, 113, 'TXT_DEVICEPARAMETERS_4220', '', '4', 0, 4294967295, 7200, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1550, 21, 1, 'TXT_DEVICEPARAMETERS_4221', '', '1', 0, 99, 0, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1551, 21, 2, 'TXT_DEVICEPARAMETERS_4222', '', '2', 30, 1000, 0, '1.0000000', 'Lux', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1552, 21, 3, 'TXT_DEVICEPARAMETERS_4223', '', '2', 30, 1000, 0, '1.0000000', 'Lux', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1553, 21, 4, 'TXT_DEVICEPARAMETERS_4224', '', '2', 1, 480, 0, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1554, 21, 5, 'TXT_DEVICEPARAMETERS_4225', '', '2', 0, 1439, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1555, 21, 6, 'TXT_DEVICEPARAMETERS_4226', '', '2', 30, 1000, 100, '1.0000000', 'Lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1532, 265, 89, 'TXT_DEVICEPARAMETERS_4197', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1533, 266, 89, 'TXT_DEVICEPARAMETERS_4201', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1534, 205, 1, 'TXT_DEVICEPARAMETERS_4205', '', '2', 230, 240, 235, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1535, 205, 3, 'TXT_DEVICEPARAMETERS_4206', '', '1', 0, 255, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(644, 210, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1538, 205, 6, 'TXT_DEVICEPARAMETERS_4209', '', '2', 0, 65535, 20, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1539, 205, 7, 'TXT_DEVICEPARAMETERS_4210', '', '2', 0, 65535, 20, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(643, 210, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1536, 205, 4, 'TXT_DEVICEPARAMETERS_4207', '', '2', 0, 65535, 20, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1537, 205, 5, 'TXT_DEVICEPARAMETERS_4208', '', '2', 0, 65535, 20, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(642, 210, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1531, 264, 89, 'TXT_DEVICEPARAMETERS_4193', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(641, 210, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1530, 263, 89, 'TXT_DEVICEPARAMETERS_4189', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(640, 210, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1529, 62, 113, 'TXT_DEVICEPARAMETERS_4184', '', '4', 1, 2678400, 4, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(639, 210, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1526, 62, 103, 'TXT_DEVICEPARAMETERS_4181', '', '4', 1, 241, 4, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1527, 62, 111, 'TXT_DEVICEPARAMETERS_4182', '', '4', 1, 2678400, 300, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1528, 62, 112, 'TXT_DEVICEPARAMETERS_4183', '', '4', 1, 2678400, 1800, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(638, 210, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1524, 62, 101, 'TXT_DEVICEPARAMETERS_4179', '', '4', 1, 241, 224, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1525, 62, 102, 'TXT_DEVICEPARAMETERS_4180', '', '4', 1, 241, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(637, 210, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1521, 62, 4, 'TXT_DEVICEPARAMETERS_4174', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1522, 62, 2, 'TXT_DEVICEPARAMETERS_4177', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1523, 62, 5, 'TXT_DEVICEPARAMETERS_4178', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(636, 210, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1540, 205, 8, 'TXT_DEVICEPARAMETERS_4211', '', '1', 0, 100, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(645, 210, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1520, 62, 3, 'TXT_DEVICEPARAMETERS_4173', '', '2', 1, 15300, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(646, 210, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1519, 266, 88, 'TXT_DEVICEPARAMETERS_4084', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(647, 210, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1516, 266, 85, 'TXT_DEVICEPARAMETERS_4078', '', '1', 1, 255, 5, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1517, 266, 86, 'TXT_DEVICEPARAMETERS_4081', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1518, 266, 87, 'TXT_DEVICEPARAMETERS_4082', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(648, 210, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1514, 266, 83, 'TXT_DEVICEPARAMETERS_4074', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1515, 266, 84, 'TXT_DEVICEPARAMETERS_4076', '', '1', 1, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(649, 210, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1512, 266, 81, 'TXT_DEVICEPARAMETERS_4072', '', '1', 2, 100, 54, '1.0000000', '°C', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1513, 266, 82, 'TXT_DEVICEPARAMETERS_4073', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(650, 210, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1510, 266, 73, 'TXT_DEVICEPARAMETERS_4070', '', '2', -1000, 1000, 0, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1511, 266, 80, 'TXT_DEVICEPARAMETERS_4071', '', '1', 0, 144, 1, '10.0000000', 'min', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(651, 210, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1509, 266, 13, 'TXT_DEVICEPARAMETERS_4065', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(652, 210, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1507, 266, 10, 'TXT_DEVICEPARAMETERS_4063', '', '2', 0, 17280, 0, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1508, 266, 12, 'TXT_DEVICEPARAMETERS_4064', '', '1', 0, 100, 20, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(653, 210, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1556, 203, 1, 'TXT_DEVICEPARAMETERS_4227', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(654, 210, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1478, 264, 83, 'TXT_DEVICEPARAMETERS_4074', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1479, 264, 84, 'TXT_DEVICEPARAMETERS_4076', '', '1', 1, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1480, 264, 85, 'TXT_DEVICEPARAMETERS_4078', '', '1', 1, 255, 5, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1481, 264, 86, 'TXT_DEVICEPARAMETERS_4081', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1482, 264, 87, 'TXT_DEVICEPARAMETERS_4082', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1483, 264, 88, 'TXT_DEVICEPARAMETERS_4084', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1484, 265, 1, 'TXT_DEVICEPARAMETERS_4050', '', '2', 0, 17280, 0, '5.0000000', 's', '65535');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1485, 265, 2, 'TXT_DEVICEPARAMETERS_4051', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1486, 265, 5, 'TXT_DEVICEPARAMETERS_4056', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1487, 265, 7, 'TXT_DEVICEPARAMETERS_4059', '', '1', 1, 99, 255, '1.0000000', '%', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1557, 203, 2, 'TXT_DEVICEPARAMETERS_4231', '', '1', 0, 0, 1, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1489, 265, 10, 'TXT_DEVICEPARAMETERS_4063', '', '2', 0, 17280, 0, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1490, 265, 12, 'TXT_DEVICEPARAMETERS_4064', '', '1', 0, 100, 20, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1491, 265, 13, 'TXT_DEVICEPARAMETERS_4065', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1492, 265, 73, 'TXT_DEVICEPARAMETERS_4070', '', '2', -1000, 1000, 0, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1493, 265, 80, 'TXT_DEVICEPARAMETERS_4071', '', '1', 0, 144, 1, '10.0000000', 'min', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1494, 265, 81, 'TXT_DEVICEPARAMETERS_4072', '', '1', 2, 100, 54, '1.0000000', '°C', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1495, 265, 82, 'TXT_DEVICEPARAMETERS_4073', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1496, 265, 83, 'TXT_DEVICEPARAMETERS_4074', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1497, 265, 84, 'TXT_DEVICEPARAMETERS_4076', '', '1', 1, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1498, 265, 85, 'TXT_DEVICEPARAMETERS_4078', '', '1', 1, 255, 5, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1499, 265, 86, 'TXT_DEVICEPARAMETERS_4081', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1500, 265, 87, 'TXT_DEVICEPARAMETERS_4082', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1501, 265, 88, 'TXT_DEVICEPARAMETERS_4084', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1502, 266, 1, 'TXT_DEVICEPARAMETERS_4050', '', '2', 0, 17280, 0, '5.0000000', 's', '65535');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1503, 266, 2, 'TXT_DEVICEPARAMETERS_4051', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1504, 266, 5, 'TXT_DEVICEPARAMETERS_4056', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1505, 266, 7, 'TXT_DEVICEPARAMETERS_4059', '', '1', 1, 99, 255, '1.0000000', '%', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(655, 211, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1476, 264, 81, 'TXT_DEVICEPARAMETERS_4072', '', '1', 2, 100, 54, '1.0000000', '°C', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1477, 264, 82, 'TXT_DEVICEPARAMETERS_4073', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(656, 211, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1474, 264, 73, 'TXT_DEVICEPARAMETERS_4070', '', '2', -1000, 1000, 0, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1475, 264, 80, 'TXT_DEVICEPARAMETERS_4071', '', '1', 0, 144, 1, '10.0000000', 'min', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(657, 211, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1472, 264, 12, 'TXT_DEVICEPARAMETERS_4064', '', '1', 0, 100, 20, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1473, 264, 13, 'TXT_DEVICEPARAMETERS_4065', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(658, 211, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(659, 211, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1558, 203, 11, 'TXT_DEVICEPARAMETERS_4235', '', '1', 0, 0, 4, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1471, 264, 10, 'TXT_DEVICEPARAMETERS_4063', '', '2', 0, 17280, 0, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(660, 211, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1466, 264, 1, 'TXT_DEVICEPARAMETERS_4050', '', '2', 0, 17280, 0, '5.0000000', 's', '65535');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1467, 264, 2, 'TXT_DEVICEPARAMETERS_4051', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1468, 264, 5, 'TXT_DEVICEPARAMETERS_4056', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1469, 264, 7, 'TXT_DEVICEPARAMETERS_4059', '', '1', 1, 99, 255, '1.0000000', '%', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(661, 211, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1465, 263, 88, 'TXT_DEVICEPARAMETERS_4084', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(662, 211, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1464, 263, 87, 'TXT_DEVICEPARAMETERS_4082', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(663, 211, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1463, 263, 86, 'TXT_DEVICEPARAMETERS_4081', '', '2', 1, 17280, 360, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(664, 211, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1461, 263, 84, 'TXT_DEVICEPARAMETERS_4076', '', '1', 1, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1462, 263, 85, 'TXT_DEVICEPARAMETERS_4078', '', '1', 1, 255, 5, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(665, 211, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1460, 263, 83, 'TXT_DEVICEPARAMETERS_4074', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(666, 211, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1458, 263, 81, 'TXT_DEVICEPARAMETERS_4072', '', '1', 2, 100, 54, '1.0000000', '°C', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1459, 263, 82, 'TXT_DEVICEPARAMETERS_4073', '', '1', 1, 3, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(667, 211, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1455, 263, 13, 'TXT_DEVICEPARAMETERS_4065', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1456, 263, 73, 'TXT_DEVICEPARAMETERS_4070', '', '2', -1000, 1000, 0, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1457, 263, 80, 'TXT_DEVICEPARAMETERS_4071', '', '1', 0, 144, 1, '10.0000000', 'min', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(668, 211, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1453, 263, 10, 'TXT_DEVICEPARAMETERS_4063', '', '2', 0, 17280, 0, '5.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1454, 263, 12, 'TXT_DEVICEPARAMETERS_4064', '', '1', 0, 100, 20, '0.1000000', '°C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(669, 211, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1451, 263, 7, 'TXT_DEVICEPARAMETERS_4059', '', '1', 1, 99, 255, '1.0000000', '%', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1559, 203, 12, 'TXT_DEVICEPARAMETERS_4241', '', '1', 0, 0, 4, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(670, 211, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 101, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1450, 263, 5, 'TXT_DEVICEPARAMETERS_4056', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(671, 211, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1407, 260, 43, 'TXT_DEVICEPARAMETERS_3909', '', '1', 0, 254, 10, '0.0100000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1404, 260, 35, 'TXT_DEVICEPARAMETERS_3904', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(672, 211, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1368, 248, 77, 'TXT_DEVICEPARAMETERS_3770', '', '1', 0, 0, 0, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(673, 211, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1339, 247, 12, 'TXT_DEVICEPARAMETERS_3709', '', '2', 1, 1000, 50, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1340, 247, 13, 'TXT_DEVICEPARAMETERS_3710', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1341, 247, 50, 'TXT_DEVICEPARAMETERS_3715', '', '2', -10000, 10000, 1500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1342, 247, 51, 'TXT_DEVICEPARAMETERS_3716', '', '2', -10000, 10000, 3500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1343, 247, 61, 'TXT_DEVICEPARAMETERS_3717', '', '4', 0, 16777215, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1344, 247, 62, 'TXT_DEVICEPARAMETERS_3718', '', '4', 0, 16777215, 16711680, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1345, 247, 63, 'TXT_DEVICEPARAMETERS_3719', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1346, 247, 73, 'TXT_DEVICEPARAMETERS_3723', '', '2', -10000, 10000, 0, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1347, 247, 74, 'TXT_DEVICEPARAMETERS_3724', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1348, 247, 75, 'TXT_DEVICEPARAMETERS_3729', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1349, 247, 76, 'TXT_DEVICEPARAMETERS_3730', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1350, 247, 77, 'TXT_DEVICEPARAMETERS_3731', '', '1', 0, 0, 0, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1351, 248, 1, 'TXT_DEVICEPARAMETERS_3734', '', '2', 0, 3600, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1352, 248, 2, 'TXT_DEVICEPARAMETERS_3735', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1353, 248, 5, 'TXT_DEVICEPARAMETERS_3740', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1354, 248, 7, 'TXT_DEVICEPARAMETERS_3743', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1355, 248, 9, 'TXT_DEVICEPARAMETERS_3744', '', '1', 0, 0, 1, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1356, 248, 10, 'TXT_DEVICEPARAMETERS_3747', '', '2', 1, 65535, 300, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1357, 248, 12, 'TXT_DEVICEPARAMETERS_3748', '', '2', 1, 1000, 50, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1358, 248, 13, 'TXT_DEVICEPARAMETERS_3749', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1359, 248, 50, 'TXT_DEVICEPARAMETERS_3754', '', '2', -10000, 10000, 1500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1360, 248, 51, 'TXT_DEVICEPARAMETERS_3755', '', '2', -10000, 10000, 3500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1361, 248, 61, 'TXT_DEVICEPARAMETERS_3756', '', '4', 0, 16777215, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1362, 248, 62, 'TXT_DEVICEPARAMETERS_3757', '', '4', 0, 16777215, 16711680, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1363, 248, 63, 'TXT_DEVICEPARAMETERS_3758', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1364, 248, 73, 'TXT_DEVICEPARAMETERS_3762', '', '2', -10000, 10000, 0, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1365, 248, 74, 'TXT_DEVICEPARAMETERS_3763', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1366, 248, 75, 'TXT_DEVICEPARAMETERS_3768', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1367, 248, 76, 'TXT_DEVICEPARAMETERS_3769', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(674, 212, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1337, 247, 9, 'TXT_DEVICEPARAMETERS_3705', '', '1', 0, 0, 1, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1338, 247, 10, 'TXT_DEVICEPARAMETERS_3708', '', '2', 1, 65535, 300, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(675, 212, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1335, 247, 5, 'TXT_DEVICEPARAMETERS_3701', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1336, 247, 7, 'TXT_DEVICEPARAMETERS_3704', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(676, 212, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1333, 247, 1, 'TXT_DEVICEPARAMETERS_3695', '', '2', 0, 3600, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1334, 247, 2, 'TXT_DEVICEPARAMETERS_3696', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(677, 212, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(678, 212, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1331, 246, 76, 'TXT_DEVICEPARAMETERS_3691', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1332, 246, 77, 'TXT_DEVICEPARAMETERS_3692', '', '1', 0, 0, 0, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(679, 212, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1327, 246, 63, 'TXT_DEVICEPARAMETERS_3680', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1328, 246, 73, 'TXT_DEVICEPARAMETERS_3684', '', '2', -10000, 10000, 0, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1329, 246, 74, 'TXT_DEVICEPARAMETERS_3685', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1330, 246, 75, 'TXT_DEVICEPARAMETERS_3690', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(680, 212, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1326, 246, 62, 'TXT_DEVICEPARAMETERS_3679', '', '4', 0, 16777215, 16711680, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(681, 212, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1325, 246, 61, 'TXT_DEVICEPARAMETERS_3678', '', '4', 0, 16777215, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(682, 212, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1324, 246, 51, 'TXT_DEVICEPARAMETERS_3677', '', '2', -10000, 10000, 3500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(683, 212, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1322, 246, 13, 'TXT_DEVICEPARAMETERS_3671', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1323, 246, 50, 'TXT_DEVICEPARAMETERS_3676', '', '2', -10000, 10000, 1500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(684, 212, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1321, 246, 12, 'TXT_DEVICEPARAMETERS_3670', '', '2', 1, 1000, 50, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(685, 212, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1429, 262, 3, 'TXT_DEVICEPARAMETERS_3968', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1319, 246, 9, 'TXT_DEVICEPARAMETERS_3666', '', '1', 0, 0, 1, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1320, 246, 10, 'TXT_DEVICEPARAMETERS_3669', '', '2', 1, 65535, 300, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(686, 212, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1432, 262, 13, 'TXT_DEVICEPARAMETERS_3978', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1431, 262, 12, 'TXT_DEVICEPARAMETERS_3977', '', '2', 0, 65535, 150, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1430, 262, 10, 'TXT_DEVICEPARAMETERS_3971', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(687, 212, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1434, 262, 17, 'TXT_DEVICEPARAMETERS_3986', '', '1', 0, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1433, 262, 14, 'TXT_DEVICEPARAMETERS_3982', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(688, 212, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1436, 262, 22, 'TXT_DEVICEPARAMETERS_3988', '', '2', 0, 65535, 240, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1435, 262, 18, 'TXT_DEVICEPARAMETERS_3987', '', '1', 0, 255, 10, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(689, 212, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 101, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1437, 262, 29, 'TXT_DEVICEPARAMETERS_3989', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(690, 212, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1439, 262, 31, 'TXT_DEVICEPARAMETERS_3996', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1438, 262, 30, 'TXT_DEVICEPARAMETERS_3992', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(691, 212, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1440, 262, 32, 'TXT_DEVICEPARAMETERS_4000', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(692, 212, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1393, 260, 12, 'TXT_DEVICEPARAMETERS_3873', '', '2', 0, 65535, 150, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1392, 260, 10, 'TXT_DEVICEPARAMETERS_3867', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1391, 260, 3, 'TXT_DEVICEPARAMETERS_3864', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1317, 246, 5, 'TXT_DEVICEPARAMETERS_3662', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1428, 261, 50, 'TXT_DEVICEPARAMETERS_3965', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1447, 262, 50, 'TXT_DEVICEPARAMETERS_4017', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1446, 262, 44, 'TXT_DEVICEPARAMETERS_4014', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1425, 261, 42, 'TXT_DEVICEPARAMETERS_3960', '', '2', 0, 65534, 3600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1424, 261, 40, 'TXT_DEVICEPARAMETERS_3959', '', '1', 0, 100, 10, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1445, 262, 43, 'TXT_DEVICEPARAMETERS_4013', '', '1', 0, 254, 10, '0.0100000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1422, 261, 33, 'TXT_DEVICEPARAMETERS_3952', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1421, 261, 32, 'TXT_DEVICEPARAMETERS_3948', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1420, 261, 31, 'TXT_DEVICEPARAMETERS_3944', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1419, 261, 30, 'TXT_DEVICEPARAMETERS_3940', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1418, 261, 29, 'TXT_DEVICEPARAMETERS_3937', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1417, 261, 22, 'TXT_DEVICEPARAMETERS_3936', '', '2', 0, 65535, 240, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1416, 261, 18, 'TXT_DEVICEPARAMETERS_3935', '', '1', 0, 255, 10, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1415, 261, 17, 'TXT_DEVICEPARAMETERS_3934', '', '1', 0, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1414, 261, 14, 'TXT_DEVICEPARAMETERS_3930', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1413, 261, 13, 'TXT_DEVICEPARAMETERS_3926', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1412, 261, 12, 'TXT_DEVICEPARAMETERS_3925', '', '2', 0, 65535, 150, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1411, 261, 10, 'TXT_DEVICEPARAMETERS_3919', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1410, 261, 3, 'TXT_DEVICEPARAMETERS_3916', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1316, 246, 2, 'TXT_DEVICEPARAMETERS_3657', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1448, 263, 1, 'TXT_DEVICEPARAMETERS_4050', '', '2', 0, 17280, 0, '5.0000000', 's', '65535');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1441, 262, 33, 'TXT_DEVICEPARAMETERS_4004', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1442, 262, 35, 'TXT_DEVICEPARAMETERS_4008', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1443, 262, 40, 'TXT_DEVICEPARAMETERS_4011', '', '1', 0, 100, 10, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1444, 262, 42, 'TXT_DEVICEPARAMETERS_4012', '', '2', 0, 65534, 3600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1369, 249, 17, 'TXT_DEVICEPARAMETERS_3775', '', '1', 0, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1408, 260, 44, 'TXT_DEVICEPARAMETERS_3910', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(693, 213, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1394, 260, 13, 'TXT_DEVICEPARAMETERS_3874', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(694, 213, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1396, 260, 17, 'TXT_DEVICEPARAMETERS_3882', '', '1', 0, 255, 10, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1395, 260, 14, 'TXT_DEVICEPARAMETERS_3878', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(695, 213, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1398, 260, 22, 'TXT_DEVICEPARAMETERS_3884', '', '2', 0, 65535, 240, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1397, 260, 18, 'TXT_DEVICEPARAMETERS_3883', '', '1', 0, 255, 10, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(696, 213, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1399, 260, 29, 'TXT_DEVICEPARAMETERS_3885', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(697, 213, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1400, 260, 30, 'TXT_DEVICEPARAMETERS_3888', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(698, 213, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1426, 261, 43, 'TXT_DEVICEPARAMETERS_3961', '', '1', 0, 254, 10, '0.0100000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1423, 261, 35, 'TXT_DEVICEPARAMETERS_3956', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1402, 260, 32, 'TXT_DEVICEPARAMETERS_3896', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1401, 260, 31, 'TXT_DEVICEPARAMETERS_3892', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(699, 213, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1405, 260, 40, 'TXT_DEVICEPARAMETERS_3907', '', '1', 0, 100, 10, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(700, 213, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1406, 260, 42, 'TXT_DEVICEPARAMETERS_3908', '', '2', 0, 65534, 3600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(701, 213, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1427, 261, 44, 'TXT_DEVICEPARAMETERS_3962', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(702, 213, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1409, 260, 50, 'TXT_DEVICEPARAMETERS_3913', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1403, 260, 33, 'TXT_DEVICEPARAMETERS_3900', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(703, 213, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1318, 246, 7, 'TXT_DEVICEPARAMETERS_3665', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(704, 213, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1250, 259, 44, 'TXT_DEVICEPARAMETERS_3455', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1251, 259, 45, 'TXT_DEVICEPARAMETERS_3457', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(705, 213, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1247, 259, 16, 'TXT_DEVICEPARAMETERS_3446', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1248, 259, 30, 'TXT_DEVICEPARAMETERS_3449', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1249, 259, 43, 'TXT_DEVICEPARAMETERS_3454', '', '1', 1, 100, 5, '0.1000000', 'V', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(706, 213, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1245, 259, 13, 'TXT_DEVICEPARAMETERS_3442', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1246, 259, 15, 'TXT_DEVICEPARAMETERS_3443', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(707, 213, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1243, 259, 11, 'TXT_DEVICEPARAMETERS_3440', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1244, 259, 12, 'TXT_DEVICEPARAMETERS_3441', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(708, 213, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1242, 259, 10, 'TXT_DEVICEPARAMETERS_3438', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(709, 213, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1240, 259, 8, 'TXT_DEVICEPARAMETERS_3434', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1241, 259, 9, 'TXT_DEVICEPARAMETERS_3437', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(710, 213, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1239, 259, 1, 'TXT_DEVICEPARAMETERS_3429', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(711, 213, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1211, 256, 71, 'TXT_DEVICEPARAMETERS_3363', '', '1', 0, 0, 1, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1212, 256, 73, 'TXT_DEVICEPARAMETERS_3366', '', '1', 0, 0, 0, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1213, 257, 1, 'TXT_DEVICEPARAMETERS_3369', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1214, 257, 8, 'TXT_DEVICEPARAMETERS_3374', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1215, 257, 9, 'TXT_DEVICEPARAMETERS_3377', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1216, 257, 10, 'TXT_DEVICEPARAMETERS_3378', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1217, 257, 11, 'TXT_DEVICEPARAMETERS_3380', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1218, 257, 12, 'TXT_DEVICEPARAMETERS_3381', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1219, 257, 13, 'TXT_DEVICEPARAMETERS_3382', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1220, 257, 15, 'TXT_DEVICEPARAMETERS_3383', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1221, 257, 16, 'TXT_DEVICEPARAMETERS_3386', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1222, 257, 30, 'TXT_DEVICEPARAMETERS_3389', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1223, 257, 43, 'TXT_DEVICEPARAMETERS_3394', '', '1', 1, 100, 5, '0.1000000', 'V', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1224, 257, 44, 'TXT_DEVICEPARAMETERS_3395', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1225, 257, 45, 'TXT_DEVICEPARAMETERS_3397', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1226, 258, 1, 'TXT_DEVICEPARAMETERS_3399', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1227, 258, 8, 'TXT_DEVICEPARAMETERS_3404', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1228, 258, 9, 'TXT_DEVICEPARAMETERS_3407', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1229, 258, 10, 'TXT_DEVICEPARAMETERS_3408', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1230, 258, 11, 'TXT_DEVICEPARAMETERS_3410', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1231, 258, 12, 'TXT_DEVICEPARAMETERS_3411', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1232, 258, 13, 'TXT_DEVICEPARAMETERS_3412', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1233, 258, 15, 'TXT_DEVICEPARAMETERS_3413', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1234, 258, 16, 'TXT_DEVICEPARAMETERS_3416', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1235, 258, 30, 'TXT_DEVICEPARAMETERS_3419', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1236, 258, 43, 'TXT_DEVICEPARAMETERS_3424', '', '1', 1, 100, 5, '0.1000000', 'V', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1237, 258, 44, 'TXT_DEVICEPARAMETERS_3425', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1238, 258, 45, 'TXT_DEVICEPARAMETERS_3427', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(712, 214, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1209, 256, 44, 'TXT_DEVICEPARAMETERS_3359', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1210, 256, 45, 'TXT_DEVICEPARAMETERS_3361', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(713, 214, 3, 'TXT_DEVICEPARAMETERS_493', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1207, 256, 38, 'TXT_DEVICEPARAMETERS_3357', '', '1', 1, 10, 10, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1208, 256, 39, 'TXT_DEVICEPARAMETERS_3358', '', '2', 1, 65534, 600, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(714, 214, 4, 'TXT_DEVICEPARAMETERS_494', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1206, 256, 30, 'TXT_DEVICEPARAMETERS_3352', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(715, 214, 5, 'TXT_DEVICEPARAMETERS_495', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1204, 256, 15, 'TXT_DEVICEPARAMETERS_3346', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1205, 256, 16, 'TXT_DEVICEPARAMETERS_3349', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(716, 214, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1203, 256, 13, 'TXT_DEVICEPARAMETERS_3345', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(717, 214, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1201, 256, 11, 'TXT_DEVICEPARAMETERS_3343', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1202, 256, 12, 'TXT_DEVICEPARAMETERS_3344', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(718, 214, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1199, 256, 9, 'TXT_DEVICEPARAMETERS_3340', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1200, 256, 10, 'TXT_DEVICEPARAMETERS_3341', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(719, 214, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1198, 256, 8, 'TXT_DEVICEPARAMETERS_3337', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(720, 214, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1194, 255, 45, 'TXT_DEVICEPARAMETERS_3324', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1195, 255, 71, 'TXT_DEVICEPARAMETERS_3326', '', '1', 0, 0, 1, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1196, 255, 73, 'TXT_DEVICEPARAMETERS_3329', '', '1', 0, 0, 0, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1197, 256, 1, 'TXT_DEVICEPARAMETERS_3332', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(721, 214, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1191, 255, 38, 'TXT_DEVICEPARAMETERS_3320', '', '1', 1, 10, 10, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1192, 255, 39, 'TXT_DEVICEPARAMETERS_3321', '', '2', 1, 65534, 600, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1193, 255, 44, 'TXT_DEVICEPARAMETERS_3322', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(722, 214, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1189, 255, 16, 'TXT_DEVICEPARAMETERS_3312', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1190, 255, 30, 'TXT_DEVICEPARAMETERS_3315', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(723, 214, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1188, 255, 15, 'TXT_DEVICEPARAMETERS_3309', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(724, 214, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1186, 255, 12, 'TXT_DEVICEPARAMETERS_3307', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1187, 255, 13, 'TXT_DEVICEPARAMETERS_3308', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(725, 214, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1185, 255, 11, 'TXT_DEVICEPARAMETERS_3306', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(726, 214, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1184, 255, 10, 'TXT_DEVICEPARAMETERS_3304', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(727, 214, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1181, 255, 1, 'TXT_DEVICEPARAMETERS_3295', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1182, 255, 8, 'TXT_DEVICEPARAMETERS_3300', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(728, 214, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1183, 255, 9, 'TXT_DEVICEPARAMETERS_3303', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(729, 214, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1180, 254, 73, 'TXT_DEVICEPARAMETERS_3292', '', '1', 0, 0, 0, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1179, 254, 71, 'TXT_DEVICEPARAMETERS_3289', '', '1', 0, 0, 1, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(730, 214, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1178, 254, 45, 'TXT_DEVICEPARAMETERS_3287', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(731, 215, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1177, 254, 44, 'TXT_DEVICEPARAMETERS_3285', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(732, 215, 3, 'TXT_DEVICEPARAMETERS_493', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1173, 254, 16, 'TXT_DEVICEPARAMETERS_3275', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1174, 254, 30, 'TXT_DEVICEPARAMETERS_3278', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(733, 215, 4, 'TXT_DEVICEPARAMETERS_494', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1176, 254, 39, 'TXT_DEVICEPARAMETERS_3284', '', '2', 1, 65534, 600, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1175, 254, 38, 'TXT_DEVICEPARAMETERS_3283', '', '1', 1, 10, 10, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(734, 215, 5, 'TXT_DEVICEPARAMETERS_495', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1170, 254, 12, 'TXT_DEVICEPARAMETERS_3270', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1171, 254, 13, 'TXT_DEVICEPARAMETERS_3271', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(735, 215, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1172, 254, 15, 'TXT_DEVICEPARAMETERS_3272', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(736, 215, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1169, 254, 11, 'TXT_DEVICEPARAMETERS_3269', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(737, 215, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1165, 254, 1, 'TXT_DEVICEPARAMETERS_3258', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1166, 254, 8, 'TXT_DEVICEPARAMETERS_3263', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(738, 215, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1168, 254, 10, 'TXT_DEVICEPARAMETERS_3267', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1167, 254, 9, 'TXT_DEVICEPARAMETERS_3266', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(739, 215, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1142, 251, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1143, 251, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1144, 251, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1145, 251, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(740, 215, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1139, 251, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1140, 251, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1141, 251, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(741, 215, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1138, 251, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(742, 215, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1136, 252, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1137, 251, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(743, 215, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1135, 252, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(744, 215, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1133, 252, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1134, 252, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(745, 215, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1132, 252, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(746, 215, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1131, 252, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(747, 215, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1129, 252, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1130, 252, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(748, 215, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1127, 253, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1128, 252, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(749, 215, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1126, 253, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(750, 216, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1124, 253, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1125, 253, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(751, 216, 3, 'TXT_DEVICEPARAMETERS_493', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1122, 253, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1123, 253, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(752, 216, 4, 'TXT_DEVICEPARAMETERS_494', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1120, 253, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1121, 253, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(753, 216, 5, 'TXT_DEVICEPARAMETERS_495', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1118, 250, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1119, 253, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(754, 216, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1116, 250, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1117, 250, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(755, 216, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1115, 250, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(756, 216, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1113, 250, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1114, 250, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(757, 216, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1111, 250, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1112, 250, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(758, 216, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1107, 249, 44, 'TXT_DEVICEPARAMETERS_3199', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1315, 246, 1, 'TXT_DEVICEPARAMETERS_3656', '', '2', 0, 3600, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1109, 249, 50, 'TXT_DEVICEPARAMETERS_3205', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1110, 250, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(759, 216, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1104, 249, 40, 'TXT_DEVICEPARAMETERS_3196', '', '1', 0, 100, 10, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1105, 249, 42, 'TXT_DEVICEPARAMETERS_3197', '', '2', 0, 65534, 3600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1106, 249, 43, 'TXT_DEVICEPARAMETERS_3198', '', '1', 0, 254, 10, '0.0100000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(760, 216, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1103, 249, 35, 'TXT_DEVICEPARAMETERS_3193', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(761, 216, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1101, 249, 32, 'TXT_DEVICEPARAMETERS_3185', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1102, 249, 33, 'TXT_DEVICEPARAMETERS_3189', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(762, 216, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1100, 249, 31, 'TXT_DEVICEPARAMETERS_3181', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(763, 216, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1098, 249, 29, 'TXT_DEVICEPARAMETERS_3174', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1099, 249, 30, 'TXT_DEVICEPARAMETERS_3177', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(764, 216, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1097, 249, 22, 'TXT_DEVICEPARAMETERS_3173', '', '2', 0, 65535, 240, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(765, 216, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1096, 249, 18, 'TXT_DEVICEPARAMETERS_3172', '', '1', 0, 255, 10, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(766, 216, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1094, 249, 14, 'TXT_DEVICEPARAMETERS_3168', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1449, 263, 2, 'TXT_DEVICEPARAMETERS_4051', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(767, 216, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1093, 249, 13, 'TXT_DEVICEPARAMETERS_3164', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(768, 216, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1091, 249, 10, 'TXT_DEVICEPARAMETERS_3159', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1092, 249, 12, 'TXT_DEVICEPARAMETERS_3163', '', '2', 0, 65535, 150, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(769, 217, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1090, 249, 3, 'TXT_DEVICEPARAMETERS_3156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(770, 217, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1089, 245, 77, 'TXT_DEVICEPARAMETERS_3153', '', '1', 0, 0, 0, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(771, 217, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1088, 245, 76, 'TXT_DEVICEPARAMETERS_3152', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(772, 217, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1087, 245, 75, 'TXT_DEVICEPARAMETERS_3151', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(773, 217, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1086, 245, 74, 'TXT_DEVICEPARAMETERS_3146', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(774, 217, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1085, 245, 73, 'TXT_DEVICEPARAMETERS_3145', '', '2', -10000, 10000, 0, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(775, 217, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1084, 245, 63, 'TXT_DEVICEPARAMETERS_3141', '', '1', 0, 0, 2, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(776, 217, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1083, 245, 62, 'TXT_DEVICEPARAMETERS_3140', '', '4', 0, 16777215, 16711680, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(777, 217, 41, 'TXT_DEVICEPARAMETERS_491', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1059, 231, 10, 'TXT_DEVICEPARAMETERS_3055', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1060, 231, 11, 'TXT_DEVICEPARAMETERS_3057', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1061, 231, 12, 'TXT_DEVICEPARAMETERS_3058', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1062, 231, 13, 'TXT_DEVICEPARAMETERS_3059', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1063, 231, 15, 'TXT_DEVICEPARAMETERS_3060', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1064, 231, 16, 'TXT_DEVICEPARAMETERS_3063', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1065, 232, 30, 'TXT_DEVICEPARAMETERS_3066', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1082, 245, 61, 'TXT_DEVICEPARAMETERS_3139', '', '4', 0, 16777215, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1071, 245, 1, 'TXT_DEVICEPARAMETERS_3114', '', '2', 0, 3600, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1072, 245, 2, 'TXT_DEVICEPARAMETERS_3115', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1074, 245, 5, 'TXT_DEVICEPARAMETERS_3123', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1075, 245, 7, 'TXT_DEVICEPARAMETERS_3126', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1076, 245, 9, 'TXT_DEVICEPARAMETERS_3127', '', '1', 0, 0, 1, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1077, 245, 10, 'TXT_DEVICEPARAMETERS_3130', '', '2', 1, 65535, 300, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1078, 245, 12, 'TXT_DEVICEPARAMETERS_3131', '', '2', 1, 1000, 50, '0.0100000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1079, 245, 13, 'TXT_DEVICEPARAMETERS_3132', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1080, 245, 50, 'TXT_DEVICEPARAMETERS_3137', '', '2', -10000, 10000, 1500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1081, 245, 51, 'TXT_DEVICEPARAMETERS_3138', '', '2', -10000, 10000, 3500, '0.0100000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(778, 218, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1055, 232, 43, 'TXT_DEVICEPARAMETERS_3048', '', '1', 1, 100, 5, '0.1000000', 'V', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1056, 232, 45, 'TXT_DEVICEPARAMETERS_3049', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(779, 218, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(780, 218, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1054, 232, 44, 'TXT_DEVICEPARAMETERS_3046', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(781, 218, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1052, 231, 73, 'TXT_DEVICEPARAMETERS_3035', '', '1', 0, 0, 0, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(782, 218, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1051, 231, 71, 'TXT_DEVICEPARAMETERS_3032', '', '1', 0, 0, 1, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(783, 218, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1050, 231, 45, 'TXT_DEVICEPARAMETERS_3030', '', '1', 1, 254, 10, '0.0100000', 'kWh', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(784, 218, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1049, 231, 44, 'TXT_DEVICEPARAMETERS_3028', '', '2', 1, 65534, 30, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(785, 218, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1057, 231, 8, 'TXT_DEVICEPARAMETERS_3051', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(786, 218, 41, 'TXT_DEVICEPARAMETERS_491', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1029, 238, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1030, 238, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1031, 238, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1032, 238, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1033, 238, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1034, 231, 1, 'TXT_DEVICEPARAMETERS_2990', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1053, 232, 1, 'TXT_DEVICEPARAMETERS_3041', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1036, 232, 8, 'TXT_DEVICEPARAMETERS_3001', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1037, 232, 9, 'TXT_DEVICEPARAMETERS_3004', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1038, 232, 10, 'TXT_DEVICEPARAMETERS_3005', '', '2', 1, 60000, 10, '1.0000000', 'ms', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1039, 232, 11, 'TXT_DEVICEPARAMETERS_3007', '', '1', 0, 255, 67, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1040, 232, 12, 'TXT_DEVICEPARAMETERS_3008', '', '1', 3, 255, 255, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1041, 232, 13, 'TXT_DEVICEPARAMETERS_3009', '', '1', 2, 254, 2, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1042, 232, 15, 'TXT_DEVICEPARAMETERS_3010', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1043, 232, 16, 'TXT_DEVICEPARAMETERS_3013', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1044, 231, 30, 'TXT_DEVICEPARAMETERS_3016', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1045, 231, 38, 'TXT_DEVICEPARAMETERS_3021', '', '1', 1, 10, 10, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1046, 231, 39, 'TXT_DEVICEPARAMETERS_3022', '', '2', 1, 65534, 600, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1058, 231, 9, 'TXT_DEVICEPARAMETERS_3054', '', '1', 1, 255, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(787, 219, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1028, 238, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(788, 219, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1027, 238, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(789, 219, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1026, 238, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(790, 219, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1025, 238, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(791, 219, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1024, 238, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(792, 219, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1023, 238, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(793, 219, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1022, 238, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(794, 219, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1021, 238, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(795, 219, 41, 'TXT_DEVICEPARAMETERS_491', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1001, 237, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1002, 237, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1003, 237, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1004, 237, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1005, 237, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1006, 237, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1007, 237, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1008, 237, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1009, 237, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1010, 237, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1011, 237, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 101, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1012, 237, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1013, 237, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1014, 237, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1015, 238, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1016, 238, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1017, 238, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1018, 238, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1019, 238, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1020, 238, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(796, 220, 1, 'TXT_DEVICEPARAMETERS_193', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1000, 237, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(797, 220, 10, 'TXT_DEVICEPARAMETERS_194', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(999, 237, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(798, 220, 14, 'TXT_DEVICEPARAMETERS_195', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(998, 237, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(799, 220, 20, 'TXT_DEVICEPARAMETERS_196', '', '1', 1, 98, 16, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(997, 237, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(800, 220, 30, 'TXT_DEVICEPARAMETERS_197', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(996, 237, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(801, 220, 31, 'TXT_DEVICEPARAMETERS_198', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(995, 236, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(802, 220, 32, 'TXT_DEVICEPARAMETERS_199', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(994, 236, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(803, 220, 33, 'TXT_DEVICEPARAMETERS_200', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(993, 236, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(804, 220, 41, 'TXT_DEVICEPARAMETERS_491', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(973, 235, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 110, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(974, 235, 30, 'TXT_DEVICEPARAMETERS_66', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(975, 235, 39, 'TXT_DEVICEPARAMETERS_67', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(976, 235, 41, 'TXT_DEVICEPARAMETERS_463', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(977, 236, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(978, 236, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(979, 236, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(980, 236, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(981, 236, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(982, 236, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(983, 236, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(984, 236, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(985, 236, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(986, 236, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(987, 236, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(988, 236, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(989, 236, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(990, 236, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(991, 236, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(992, 236, 20, 'TXT_DEVICEPARAMETERS_65', '', '1', 100, 170, 101, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(805, 221, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(971, 235, 18, 'TXT_DEVICEPARAMETERS_63', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(972, 235, 19, 'TXT_DEVICEPARAMETERS_64', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(806, 221, 3, 'TXT_DEVICEPARAMETERS_512', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(969, 235, 16, 'TXT_DEVICEPARAMETERS_61', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(970, 235, 17, 'TXT_DEVICEPARAMETERS_62', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(807, 221, 4, 'TXT_DEVICEPARAMETERS_513', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(967, 235, 14, 'TXT_DEVICEPARAMETERS_454', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(968, 235, 15, 'TXT_DEVICEPARAMETERS_60', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(808, 221, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(965, 235, 12, 'TXT_DEVICEPARAMETERS_57', '', '1', 2, 99, 99, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(966, 235, 13, 'TXT_DEVICEPARAMETERS_58', '', '1', 1, 98, 2, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(809, 221, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(964, 235, 11, 'TXT_DEVICEPARAMETERS_56', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(810, 221, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(962, 235, 9, 'TXT_DEVICEPARAMETERS_54', '', '1', 1, 255, 5, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(963, 235, 10, 'TXT_DEVICEPARAMETERS_55', '', '1', 0, 254, 1, '0.0100000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(811, 221, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(957, 225, 70, 'TXT_DEVICEPARAMETERS_2772', '', '2', 10, 65535, 65535, '0.1000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(959, 235, 6, 'TXT_DEVICEPARAMETERS_51', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(960, 235, 7, 'TXT_DEVICEPARAMETERS_52', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(961, 235, 8, 'TXT_DEVICEPARAMETERS_53', '', '1', 1, 99, 1, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(812, 221, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(938, 209, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(958, 235, 1, 'TXT_DEVICEPARAMETERS_50', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(956, 225, 63, 'TXT_DEVICEPARAMETERS_2761', '', '1', 0, 0, 1, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(813, 221, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(937, 209, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(814, 221, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(935, 209, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(936, 209, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(815, 221, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(934, 209, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(816, 221, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(932, 209, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(933, 209, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(817, 221, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(931, 209, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(818, 222, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(607, 73, 3, 'TXT_DEVICEPARAMETERS_2480', '', '1', 1, 10, 6, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(930, 209, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(819, 222, 3, 'TXT_DEVICEPARAMETERS_512', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(604, 73, 1, 'TXT_DEVICEPARAMETERS_2469', '', '1', 1, 99, 99, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(605, 73, 2, 'TXT_DEVICEPARAMETERS_2470', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(820, 222, 4, 'TXT_DEVICEPARAMETERS_513', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(942, 225, 35, 'TXT_DEVICEPARAMETERS_2713', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(821, 222, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(603, 70, 3, 'TXT_DEVICEPARAMETERS_2468', '', '1', 1, 10, 6, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(944, 225, 40, 'TXT_DEVICEPARAMETERS_2719', '', '1', 1, 100, 80, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(822, 222, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(601, 70, 2, 'TXT_DEVICEPARAMETERS_2464', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(943, 225, 39, 'TXT_DEVICEPARAMETERS_2718', '', '2', 1, 65536, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(823, 222, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(599, 70, 1, 'TXT_DEVICEPARAMETERS_2460', '', '1', 1, 99, 99, '1.0000000', '%', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(824, 222, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(916, 208, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(917, 208, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(918, 208, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(919, 208, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(920, 208, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(825, 222, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(913, 208, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(914, 208, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(915, 208, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(826, 222, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(947, 225, 45, 'TXT_DEVICEPARAMETERS_2722', '', '1', 1, 254, 10, '0.0100000', 'kWh', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(912, 208, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(827, 222, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(612, 73, 6, 'TXT_DEVICEPARAMETERS_2485', '', '2', 5, 3600, 15, '1.0000000', 's', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(828, 222, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(946, 225, 43, 'TXT_DEVICEPARAMETERS_2721', '', '1', 1, 254, 30, '1.0000000', 's', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(945, 225, 42, 'TXT_DEVICEPARAMETERS_2720', '', '1', 1, 100, 15, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(829, 222, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(611, 73, 5, 'TXT_DEVICEPARAMETERS_2484', '', '1', 1, 100, 10, '1.0000000', '%', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(830, 222, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(939, 225, 1, 'TXT_DEVICEPARAMETERS_2706', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(831, 223, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(941, 225, 34, 'TXT_DEVICEPARAMETERS_2712', '', '1', 0, 63, 63, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(832, 223, 3, 'TXT_DEVICEPARAMETERS_512', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(940, 225, 16, 'TXT_DEVICEPARAMETERS_2709', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(610, 73, 4, 'TXT_DEVICEPARAMETERS_2483', '', '1', 5, 3600, 180, '1.0000000', '', '0');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(833, 223, 4, 'TXT_DEVICEPARAMETERS_513', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(901, 207, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(902, 207, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(834, 223, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(900, 207, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(835, 223, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(898, 207, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(899, 207, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(836, 223, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(896, 207, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(897, 207, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(837, 223, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(951, 225, 51, 'TXT_DEVICEPARAMETERS_2730', '', '2', 0, 25000, 500, '0.1000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(952, 225, 52, 'TXT_DEVICEPARAMETERS_2731', '', '1', 0, 0, 6, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(953, 225, 60, 'TXT_DEVICEPARAMETERS_2739', '', '2', 1000, 32000, 25000, '0.1000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(894, 207, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(895, 207, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(838, 223, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(955, 225, 62, 'TXT_DEVICEPARAMETERS_2751', '', '1', 0, 0, 8, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(954, 225, 61, 'TXT_DEVICEPARAMETERS_2740', '', '1', 0, 0, 1, '1.0000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(839, 223, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(949, 225, 49, 'TXT_DEVICEPARAMETERS_2726', '', '1', 0, 0, 0, '1.0000000', 'kWh', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(840, 223, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(950, 225, 50, 'TXT_DEVICEPARAMETERS_2729', '', '2', 0, 25000, 300, '0.1000000', 'W', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(841, 223, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(948, 225, 47, 'TXT_DEVICEPARAMETERS_2724', '', '2', 1, 65534, 3600, '1.0000000', 's', '65535');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(842, 223, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(883, 204, 13, 'TXT_DEVICEPARAMETERS_2553', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(884, 204, 14, 'TXT_DEVICEPARAMETERS_2563', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(843, 223, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(882, 204, 12, 'TXT_DEVICEPARAMETERS_2552', '', '1', 0, 255, 8, '0.0625000', '&#8451;', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(844, 224, 1, 'TXT_DEVICEPARAMETERS_152', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(881, 204, 9, 'TXT_DEVICEPARAMETERS_2548', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(845, 224, 3, 'TXT_DEVICEPARAMETERS_512', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(879, 204, 5, 'TXT_DEVICEPARAMETERS_2538', '', '1', 0, 0, 255, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(880, 204, 7, 'TXT_DEVICEPARAMETERS_2546', '', '1', 1, 99, 255, '1.0000000', '', '255');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(846, 224, 4, 'TXT_DEVICEPARAMETERS_513', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(877, 204, 2, 'TXT_DEVICEPARAMETERS_2531', '', '1', 0, 0, 1, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(878, 204, 3, 'TXT_DEVICEPARAMETERS_2533', '', '1', 0, 0, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(847, 224, 6, 'TXT_DEVICEPARAMETERS_155', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(875, 229, 43, 'TXT_DEVICEPARAMETERS_128', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(876, 204, 1, 'TXT_DEVICEPARAMETERS_2526', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(848, 224, 13, 'TXT_DEVICEPARAMETERS_156', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(873, 229, 41, 'TXT_DEVICEPARAMETERS_126', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(874, 229, 42, 'TXT_DEVICEPARAMETERS_127', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(849, 224, 14, 'TXT_DEVICEPARAMETERS_157', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(872, 229, 40, 'TXT_DEVICEPARAMETERS_125', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(850, 224, 15, 'TXT_DEVICEPARAMETERS_158', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(867, 229, 30, 'TXT_DEVICEPARAMETERS_121', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(868, 229, 31, 'TXT_DEVICEPARAMETERS_122', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(869, 229, 32, 'TXT_DEVICEPARAMETERS_123', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(870, 229, 33, 'TXT_DEVICEPARAMETERS_124', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(871, 229, 39, 'TXT_DEVICEPARAMETERS_130', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(851, 224, 16, 'TXT_DEVICEPARAMETERS_163', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(864, 229, 14, 'TXT_DEVICEPARAMETERS_119', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(865, 229, 15, 'TXT_DEVICEPARAMETERS_120', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(866, 229, 16, 'TXT_DEVICEPARAMETERS_129', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(852, 224, 30, 'TXT_DEVICEPARAMETERS_159', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(863, 229, 13, 'TXT_DEVICEPARAMETERS_118', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(853, 224, 31, 'TXT_DEVICEPARAMETERS_160', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(861, 229, 6, 'TXT_DEVICEPARAMETERS_116', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(862, 229, 7, 'TXT_DEVICEPARAMETERS_117', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(854, 224, 32, 'TXT_DEVICEPARAMETERS_161', '', '1', 0, 0, 3, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(860, 229, 5, 'TXT_DEVICEPARAMETERS_495', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(855, 224, 33, 'TXT_DEVICEPARAMETERS_162', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(858, 229, 3, 'TXT_DEVICEPARAMETERS_493', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(859, 229, 4, 'TXT_DEVICEPARAMETERS_494', '', '2', 0, 65535, 0, '0.1000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(856, 224, 39, 'TXT_DEVICEPARAMETERS_164', '', '2', 1, 65500, 600, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(857, 229, 1, 'TXT_DEVICEPARAMETERS_112', '', '1', 0, 0, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1560, 203, 13, 'TXT_DEVICEPARAMETERS_4247', '', '1', 0, 0, 4, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1561, 203, 14, 'TXT_DEVICEPARAMETERS_4253', '', '1', 0, 0, 4, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1562, 203, 20, 'TXT_DEVICEPARAMETERS_4259', '', '1', 1, 100, 50, '10.0000000', 'ms', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1563, 203, 21, 'TXT_DEVICEPARAMETERS_4260', '', '1', 0, 0, 1, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1564, 203, 22, 'TXT_DEVICEPARAMETERS_4264', '', '1', 0, 0, 0, '0.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1565, 203, 30, 'TXT_DEVICEPARAMETERS_4267', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1566, 270, 1, 'TXT_DEVICEPARAMETERS_4276', '', '1', 8, 255, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1567, 270, 2, 'TXT_DEVICEPARAMETERS_4277', '', '1', 0, 15, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1568, 270, 3, 'TXT_DEVICEPARAMETERS_4278', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1569, 270, 4, 'TXT_DEVICEPARAMETERS_4279', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1570, 270, 6, 'TXT_DEVICEPARAMETERS_4280', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1571, 270, 8, 'TXT_DEVICEPARAMETERS_4281', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1572, 270, 9, 'TXT_DEVICEPARAMETERS_4285', '', '2', 1, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1573, 270, 12, 'TXT_DEVICEPARAMETERS_4286', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1574, 270, 14, 'TXT_DEVICEPARAMETERS_4290', '', '1', 0, 255, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1575, 270, 16, 'TXT_DEVICEPARAMETERS_4291', '', '1', 0, 255, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1576, 270, 20, 'TXT_DEVICEPARAMETERS_4292', '', '1', 0, 121, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1577, 270, 22, 'TXT_DEVICEPARAMETERS_4293', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1578, 270, 24, 'TXT_DEVICEPARAMETERS_4294', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1579, 270, 26, 'TXT_DEVICEPARAMETERS_4299', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1580, 270, 40, 'TXT_DEVICEPARAMETERS_4302', '', '2', 0, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1581, 270, 42, 'TXT_DEVICEPARAMETERS_4303', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1582, 270, 60, 'TXT_DEVICEPARAMETERS_4304', '', '1', 0, 255, 10, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1583, 270, 62, 'TXT_DEVICEPARAMETERS_4305', '', '2', 0, 65535, 900, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1584, 270, 64, 'TXT_DEVICEPARAMETERS_4306', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1585, 270, 66, 'TXT_DEVICEPARAMETERS_4307', '', '2', -1000, 1000, 0, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1586, 270, 80, 'TXT_DEVICEPARAMETERS_4309', '', '1', 0, 0, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1587, 270, 81, 'TXT_DEVICEPARAMETERS_4337', '', '1', 0, 100, 50, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1588, 270, 82, 'TXT_DEVICEPARAMETERS_4338', '', '2', 0, 32766, 100, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1589, 270, 83, 'TXT_DEVICEPARAMETERS_4339', '', '2', 1, 32767, 1000, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1590, 270, 86, 'TXT_DEVICEPARAMETERS_4340', '', '1', 0, 255, 18, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1591, 270, 87, 'TXT_DEVICEPARAMETERS_4341', '', '1', 0, 255, 28, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1592, 270, 89, 'TXT_DEVICEPARAMETERS_4342', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1593, 271, 1, 'TXT_DEVICEPARAMETERS_4276', '', '1', 8, 255, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1594, 271, 2, 'TXT_DEVICEPARAMETERS_4277', '', '1', 0, 15, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1595, 271, 3, 'TXT_DEVICEPARAMETERS_4278', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1596, 271, 4, 'TXT_DEVICEPARAMETERS_4279', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1597, 271, 6, 'TXT_DEVICEPARAMETERS_4280', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1598, 271, 8, 'TXT_DEVICEPARAMETERS_4281', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1599, 271, 9, 'TXT_DEVICEPARAMETERS_4285', '', '2', 1, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1600, 271, 12, 'TXT_DEVICEPARAMETERS_4286', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1601, 271, 14, 'TXT_DEVICEPARAMETERS_4290', '', '1', 0, 255, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1602, 271, 16, 'TXT_DEVICEPARAMETERS_4291', '', '1', 0, 255, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1603, 271, 20, 'TXT_DEVICEPARAMETERS_4292', '', '1', 0, 121, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1604, 271, 22, 'TXT_DEVICEPARAMETERS_4293', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1605, 271, 24, 'TXT_DEVICEPARAMETERS_4294', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1606, 271, 26, 'TXT_DEVICEPARAMETERS_4299', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1607, 271, 40, 'TXT_DEVICEPARAMETERS_4302', '', '2', 0, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1608, 271, 42, 'TXT_DEVICEPARAMETERS_4303', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1609, 271, 60, 'TXT_DEVICEPARAMETERS_4304', '', '1', 0, 255, 10, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1610, 271, 62, 'TXT_DEVICEPARAMETERS_4305', '', '2', 0, 65535, 900, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1611, 271, 64, 'TXT_DEVICEPARAMETERS_4306', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1612, 271, 66, 'TXT_DEVICEPARAMETERS_4307', '', '2', -1000, 1000, 0, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1613, 271, 80, 'TXT_DEVICEPARAMETERS_4309', '', '1', 0, 0, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1614, 271, 81, 'TXT_DEVICEPARAMETERS_4337', '', '1', 0, 100, 50, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1615, 271, 82, 'TXT_DEVICEPARAMETERS_4338', '', '2', 0, 32766, 100, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1616, 271, 83, 'TXT_DEVICEPARAMETERS_4339', '', '2', 1, 32767, 1000, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1617, 271, 86, 'TXT_DEVICEPARAMETERS_4340', '', '1', 0, 255, 18, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1618, 271, 87, 'TXT_DEVICEPARAMETERS_4341', '', '1', 0, 255, 28, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1619, 271, 89, 'TXT_DEVICEPARAMETERS_4342', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1620, 272, 1, 'TXT_DEVICEPARAMETERS_4276', '', '1', 8, 255, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1621, 272, 2, 'TXT_DEVICEPARAMETERS_4277', '', '1', 0, 15, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1622, 272, 3, 'TXT_DEVICEPARAMETERS_4278', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1623, 272, 4, 'TXT_DEVICEPARAMETERS_4279', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1624, 272, 6, 'TXT_DEVICEPARAMETERS_4280', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1625, 272, 8, 'TXT_DEVICEPARAMETERS_4281', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1626, 272, 9, 'TXT_DEVICEPARAMETERS_4285', '', '2', 1, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1627, 272, 12, 'TXT_DEVICEPARAMETERS_4286', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1628, 272, 14, 'TXT_DEVICEPARAMETERS_4290', '', '1', 0, 255, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1629, 272, 16, 'TXT_DEVICEPARAMETERS_4291', '', '1', 0, 255, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1630, 272, 20, 'TXT_DEVICEPARAMETERS_4292', '', '1', 0, 121, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1631, 272, 22, 'TXT_DEVICEPARAMETERS_4293', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1632, 272, 24, 'TXT_DEVICEPARAMETERS_4294', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1633, 272, 26, 'TXT_DEVICEPARAMETERS_4299', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1634, 272, 40, 'TXT_DEVICEPARAMETERS_4302', '', '2', 0, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1635, 272, 42, 'TXT_DEVICEPARAMETERS_4303', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1636, 272, 60, 'TXT_DEVICEPARAMETERS_4304', '', '1', 0, 255, 10, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1637, 272, 62, 'TXT_DEVICEPARAMETERS_4305', '', '2', 0, 65535, 900, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1638, 272, 64, 'TXT_DEVICEPARAMETERS_4306', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1639, 272, 66, 'TXT_DEVICEPARAMETERS_4307', '', '2', -1000, 1000, 0, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1640, 272, 80, 'TXT_DEVICEPARAMETERS_4309', '', '1', 0, 0, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1641, 272, 81, 'TXT_DEVICEPARAMETERS_4337', '', '1', 0, 100, 50, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1642, 272, 82, 'TXT_DEVICEPARAMETERS_4338', '', '2', 0, 32766, 100, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1643, 272, 83, 'TXT_DEVICEPARAMETERS_4339', '', '2', 1, 32767, 1000, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1644, 272, 86, 'TXT_DEVICEPARAMETERS_4340', '', '1', 0, 255, 18, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1645, 272, 87, 'TXT_DEVICEPARAMETERS_4341', '', '1', 0, 255, 28, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1646, 272, 89, 'TXT_DEVICEPARAMETERS_4342', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1647, 273, 1, 'TXT_DEVICEPARAMETERS_4276', '', '1', 8, 255, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1648, 273, 2, 'TXT_DEVICEPARAMETERS_4277', '', '1', 0, 15, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1649, 273, 3, 'TXT_DEVICEPARAMETERS_4278', '', '1', 0, 0, 1, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1650, 273, 4, 'TXT_DEVICEPARAMETERS_4279', '', '1', 0, 0, 2, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1651, 273, 6, 'TXT_DEVICEPARAMETERS_4280', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1652, 273, 8, 'TXT_DEVICEPARAMETERS_4281', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1653, 273, 9, 'TXT_DEVICEPARAMETERS_4285', '', '2', 1, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1654, 273, 12, 'TXT_DEVICEPARAMETERS_4286', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1655, 273, 14, 'TXT_DEVICEPARAMETERS_4290', '', '1', 0, 255, 255, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1656, 273, 16, 'TXT_DEVICEPARAMETERS_4291', '', '1', 0, 255, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1657, 273, 20, 'TXT_DEVICEPARAMETERS_4292', '', '1', 0, 121, 15, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1658, 273, 22, 'TXT_DEVICEPARAMETERS_4293', '', '2', 1, 65535, 30, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1659, 273, 24, 'TXT_DEVICEPARAMETERS_4294', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1660, 273, 26, 'TXT_DEVICEPARAMETERS_4299', '', '1', 0, 0, 0, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1661, 273, 40, 'TXT_DEVICEPARAMETERS_4302', '', '2', 0, 65535, 200, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1662, 273, 42, 'TXT_DEVICEPARAMETERS_4303', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1663, 273, 60, 'TXT_DEVICEPARAMETERS_4304', '', '1', 0, 255, 10, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1664, 273, 62, 'TXT_DEVICEPARAMETERS_4305', '', '2', 0, 65535, 900, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1665, 273, 64, 'TXT_DEVICEPARAMETERS_4306', '', '2', 0, 65535, 0, '1.0000000', 's', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1666, 273, 66, 'TXT_DEVICEPARAMETERS_4307', '', '2', -1000, 1000, 0, '0.1000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1667, 273, 80, 'TXT_DEVICEPARAMETERS_4309', '', '1', 0, 0, 10, '1.0000000', '', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1668, 273, 81, 'TXT_DEVICEPARAMETERS_4337', '', '1', 0, 100, 50, '1.0000000', '%', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1669, 273, 82, 'TXT_DEVICEPARAMETERS_4338', '', '2', 0, 32766, 100, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1670, 273, 83, 'TXT_DEVICEPARAMETERS_4339', '', '2', 1, 32767, 1000, '1.0000000', 'lux', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1671, 273, 86, 'TXT_DEVICEPARAMETERS_4340', '', '1', 0, 255, 18, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1672, 273, 87, 'TXT_DEVICEPARAMETERS_4341', '', '1', 0, 255, 28, '1.0000000', 'C', '');
INSERT INTO `Device_Parameters_Template_Parameter` (`PK_Device_Parameters_Template_Parameter`, `FK_Device_Parameters_Template`, `ParameterNumber`, `ParameterDescription`, `ParameterDescriptionPolish`, `ParameterSize`, `MinValue`, `MaxValue`, `DefaultValue`, `Scale`, `Unit`, `ExtraValue`) VALUES(1673, 273, 89, 'TXT_DEVICEPARAMETERS_4342', '', '1', 0, 0, 1, '1.0000000', '', '');



INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1, 1, 1, 'jakaś wartość - 1', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2, 1, 3, 'jakaś wartość - 3', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3, 1, 5, 'jakaś wartość - 5', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(4, 1, 8, 'jakaś wartość - 8', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(5, 3, 255, 'TXT_DEVICEPARAMETERSVALUES_5', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(6, 3, 0, 'TXT_DEVICEPARAMETERSVALUES_6', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(7, 3, 1, 'TXT_DEVICEPARAMETERSVALUES_7', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(8, 3, 2, 'TXT_DEVICEPARAMETERSVALUES_8', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(9, 4, 0, 'TXT_DEVICEPARAMETERSVALUES_9', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(10, 4, 1, 'TXT_DEVICEPARAMETERSVALUES_10', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(11, 10, 0, 'TXT_DEVICEPARAMETERSVALUES_11', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(12, 10, 1, 'TXT_DEVICEPARAMETERSVALUES_12', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(13, 11, 0, 'TXT_DEVICEPARAMETERSVALUES_13', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(14, 11, 1, 'TXT_DEVICEPARAMETERSVALUES_14', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(15, 12, 0, 'TXT_DEVICEPARAMETERSVALUES_15', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(16, 12, 1, 'TXT_DEVICEPARAMETERSVALUES_16', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(17, 13, 0, 'TXT_DEVICEPARAMETERSVALUES_17', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(18, 13, 1, 'TXT_DEVICEPARAMETERSVALUES_18', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(19, 15, 255, 'TXT_DEVICEPARAMETERSVALUES_19', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(20, 15, 0, 'TXT_DEVICEPARAMETERSVALUES_20', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(21, 15, 1, 'TXT_DEVICEPARAMETERSVALUES_21', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(22, 15, 2, 'TXT_DEVICEPARAMETERSVALUES_22', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(23, 16, 0, 'TXT_DEVICEPARAMETERSVALUES_23', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(24, 16, 1, 'TXT_DEVICEPARAMETERSVALUES_24', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(25, 22, 0, 'TXT_DEVICEPARAMETERSVALUES_25', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(26, 22, 1, 'TXT_DEVICEPARAMETERSVALUES_26', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(27, 23, 0, 'TXT_DEVICEPARAMETERSVALUES_27', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(28, 23, 1, 'TXT_DEVICEPARAMETERSVALUES_28', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2891, 1531, 2, 'TXT_DEVICEPARAMETERSVALUES_4196', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(29, 24, 0, 'TXT_DEVICEPARAMETERSVALUES_29', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(30, 24, 1, 'TXT_DEVICEPARAMETERSVALUES_30', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(31, 25, 0, 'TXT_DEVICEPARAMETERSVALUES_31', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(32, 25, 1, 'TXT_DEVICEPARAMETERSVALUES_32', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(33, 27, 0, 'TXT_DEVICEPARAMETERSVALUES_33', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(34, 27, 2, 'TXT_DEVICEPARAMETERSVALUES_34', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(35, 27, 1, 'TXT_DEVICEPARAMETERSVALUES_35', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2890, 1531, 1, 'TXT_DEVICEPARAMETERSVALUES_4195', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(36, 27, 3, 'TXT_DEVICEPARAMETERSVALUES_36', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2889, 1531, 0, 'TXT_DEVICEPARAMETERSVALUES_4194', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(37, 29, 255, 'TXT_DEVICEPARAMETERSVALUES_37', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(38, 29, 0, 'TXT_DEVICEPARAMETERSVALUES_38', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(39, 29, 1, 'TXT_DEVICEPARAMETERSVALUES_39', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(40, 29, 2, 'TXT_DEVICEPARAMETERSVALUES_40', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(41, 30, 0, 'TXT_DEVICEPARAMETERSVALUES_41', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2888, 1530, 2, 'TXT_DEVICEPARAMETERSVALUES_4192', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(42, 30, 1, 'TXT_DEVICEPARAMETERSVALUES_42', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2884, 1523, 1, 'TXT_DEVICEPARAMETERSVALUES_4187', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2885, 1523, 2, 'TXT_DEVICEPARAMETERSVALUES_4188', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2886, 1530, 0, 'TXT_DEVICEPARAMETERSVALUES_4190', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2887, 1530, 1, 'TXT_DEVICEPARAMETERSVALUES_4191', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(43, 30, 2, 'TXT_DEVICEPARAMETERSVALUES_43', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2880, 1521, 0, 'TXT_DEVICEPARAMETERSVALUES_4175', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2881, 1521, 1, 'TXT_DEVICEPARAMETERSVALUES_4176', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2882, 1522, 0, 'TXT_DEVICEPARAMETERSVALUES_4185', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2883, 1522, 1, 'TXT_DEVICEPARAMETERSVALUES_4186', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(44, 31, 0, 'TXT_DEVICEPARAMETERSVALUES_44', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2879, 1519, 0, 'TXT_DEVICEPARAMETERSVALUES_4085', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(45, 31, 1, 'TXT_DEVICEPARAMETERSVALUES_45', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2878, 1519, 1, 'TXT_DEVICEPARAMETERSVALUES_4086', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(46, 38, 0, 'TXT_DEVICEPARAMETERSVALUES_46', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(47, 38, 1, 'TXT_DEVICEPARAMETERSVALUES_47', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(48, 39, 0, 'TXT_DEVICEPARAMETERSVALUES_48', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(49, 39, 1, 'TXT_DEVICEPARAMETERSVALUES_49', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(50, 41, 0, 'TXT_DEVICEPARAMETERSVALUES_50', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(51, 41, 1, 'TXT_DEVICEPARAMETERSVALUES_51', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(52, 42, 0, 'TXT_DEVICEPARAMETERSVALUES_52', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(53, 42, 1, 'TXT_DEVICEPARAMETERSVALUES_53', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(54, 43, 0, 'TXT_DEVICEPARAMETERSVALUES_54', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(55, 43, 1, 'TXT_DEVICEPARAMETERSVALUES_55', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(56, 44, 0, 'TXT_DEVICEPARAMETERSVALUES_56', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2877, 1509, 0, 'TXT_DEVICEPARAMETERSVALUES_4066', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(57, 44, 1, 'TXT_DEVICEPARAMETERSVALUES_57', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2876, 1509, 3, 'TXT_DEVICEPARAMETERSVALUES_4069', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(58, 46, 0, 'TXT_DEVICEPARAMETERSVALUES_58', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(59, 46, 2, 'TXT_DEVICEPARAMETERSVALUES_59', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(60, 46, 1, 'TXT_DEVICEPARAMETERSVALUES_60', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2875, 1509, 2, 'TXT_DEVICEPARAMETERSVALUES_4068', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(61, 46, 3, 'TXT_DEVICEPARAMETERSVALUES_61', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(62, 50, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(63, 50, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(64, 50, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(65, 50, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(66, 51, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2874, 1509, 1, 'TXT_DEVICEPARAMETERSVALUES_4067', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(67, 51, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2869, 1503, 3, 'TXT_DEVICEPARAMETERSVALUES_4055', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2870, 1504, 255, 'TXT_DEVICEPARAMETERSVALUES_4058', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2871, 1504, 0, 'TXT_DEVICEPARAMETERSVALUES_4057', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2872, 1506, 0, 'TXT_DEVICEPARAMETERSVALUES_4061', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2873, 1506, 1, 'TXT_DEVICEPARAMETERSVALUES_4062', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(68, 51, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2865, 1501, 0, 'TXT_DEVICEPARAMETERSVALUES_4085', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2866, 1503, 0, 'TXT_DEVICEPARAMETERSVALUES_4052', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2867, 1503, 1, 'TXT_DEVICEPARAMETERSVALUES_4053', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2868, 1503, 2, 'TXT_DEVICEPARAMETERSVALUES_4054', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(69, 52, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(70, 52, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2864, 1501, 1, 'TXT_DEVICEPARAMETERSVALUES_4086', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(71, 59, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(72, 59, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(73, 60, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(74, 60, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(75, 61, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(76, 61, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2863, 1491, 0, 'TXT_DEVICEPARAMETERSVALUES_4066', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(77, 62, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(78, 62, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(79, 63, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(80, 63, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(81, 64, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(82, 64, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2862, 1491, 3, 'TXT_DEVICEPARAMETERSVALUES_4069', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(83, 66, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(84, 66, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2861, 1491, 2, 'TXT_DEVICEPARAMETERSVALUES_4068', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(85, 66, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(86, 66, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2860, 1491, 1, 'TXT_DEVICEPARAMETERSVALUES_4067', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(87, 68, 255, 'TXT_DEVICEPARAMETERSVALUES_87', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(88, 68, 0, 'TXT_DEVICEPARAMETERSVALUES_88', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(89, 68, 1, 'TXT_DEVICEPARAMETERSVALUES_89', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(90, 68, 2, 'TXT_DEVICEPARAMETERSVALUES_90', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(91, 69, 0, 'TXT_DEVICEPARAMETERSVALUES_91', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(92, 69, 1, 'TXT_DEVICEPARAMETERSVALUES_92', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(93, 70, 0, 'TXT_DEVICEPARAMETERSVALUES_93', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(94, 70, 1, 'TXT_DEVICEPARAMETERSVALUES_94', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(95, 71, 0, 'TXT_DEVICEPARAMETERSVALUES_95', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(96, 71, 1, 'TXT_DEVICEPARAMETERSVALUES_96', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(97, 72, 0, 'TXT_DEVICEPARAMETERSVALUES_97', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(98, 72, 1, 'TXT_DEVICEPARAMETERSVALUES_98', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(99, 73, 0, 'TXT_DEVICEPARAMETERSVALUES_99', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2859, 1488, 1, 'TXT_DEVICEPARAMETERSVALUES_4062', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(100, 73, 1, 'TXT_DEVICEPARAMETERSVALUES_100', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(101, 74, 255, 'TXT_DEVICEPARAMETERSVALUES_101', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(102, 74, 0, 'TXT_DEVICEPARAMETERSVALUES_102', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(103, 74, 1, 'TXT_DEVICEPARAMETERSVALUES_103', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(104, 74, 2, 'TXT_DEVICEPARAMETERSVALUES_104', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(105, 75, 0, 'TXT_DEVICEPARAMETERSVALUES_105', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(106, 75, 1, 'TXT_DEVICEPARAMETERSVALUES_106', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(107, 76, 0, 'TXT_DEVICEPARAMETERSVALUES_107', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(108, 76, 1, 'TXT_DEVICEPARAMETERSVALUES_108', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(109, 77, 0, 'TXT_DEVICEPARAMETERSVALUES_109', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(110, 77, 1, 'TXT_DEVICEPARAMETERSVALUES_110', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(111, 78, 0, 'TXT_DEVICEPARAMETERSVALUES_111', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2858, 1488, 0, 'TXT_DEVICEPARAMETERSVALUES_4061', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(112, 78, 1, 'TXT_DEVICEPARAMETERSVALUES_112', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(113, 79, 0, 'TXT_DEVICEPARAMETERSVALUES_113', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2857, 1486, 0, 'TXT_DEVICEPARAMETERSVALUES_4057', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(114, 79, 1, 'TXT_DEVICEPARAMETERSVALUES_114', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(115, 80, 255, 'TXT_DEVICEPARAMETERSVALUES_115', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(116, 80, 0, 'TXT_DEVICEPARAMETERSVALUES_116', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(117, 80, 1, 'TXT_DEVICEPARAMETERSVALUES_117', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(118, 80, 2, 'TXT_DEVICEPARAMETERSVALUES_118', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(119, 81, 0, 'TXT_DEVICEPARAMETERSVALUES_119', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(120, 81, 1, 'TXT_DEVICEPARAMETERSVALUES_120', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(121, 82, 0, 'TXT_DEVICEPARAMETERSVALUES_121', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(122, 82, 1, 'TXT_DEVICEPARAMETERSVALUES_122', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(123, 83, 0, 'TXT_DEVICEPARAMETERSVALUES_123', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(124, 83, 1, 'TXT_DEVICEPARAMETERSVALUES_124', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(125, 84, 0, 'TXT_DEVICEPARAMETERSVALUES_125', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2856, 1486, 255, 'TXT_DEVICEPARAMETERSVALUES_4058', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(126, 84, 1, 'TXT_DEVICEPARAMETERSVALUES_126', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(127, 85, 0, 'TXT_DEVICEPARAMETERSVALUES_127', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2855, 1485, 3, 'TXT_DEVICEPARAMETERSVALUES_4055', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(128, 85, 1, 'TXT_DEVICEPARAMETERSVALUES_128', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(129, 86, 0, 'TXT_DEVICEPARAMETERSVALUES_129', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(130, 86, 1, 'TXT_DEVICEPARAMETERSVALUES_130', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2854, 1485, 2, 'TXT_DEVICEPARAMETERSVALUES_4054', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(131, 86, 2, 'TXT_DEVICEPARAMETERSVALUES_131', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(132, 86, 3, 'TXT_DEVICEPARAMETERSVALUES_132', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2853, 1485, 1, 'TXT_DEVICEPARAMETERSVALUES_4053', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(133, 87, 0, 'TXT_DEVICEPARAMETERSVALUES_133', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(134, 87, 1, 'TXT_DEVICEPARAMETERSVALUES_134', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(135, 87, 2, 'TXT_DEVICEPARAMETERSVALUES_135', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2852, 1485, 0, 'TXT_DEVICEPARAMETERSVALUES_4052', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(136, 87, 3, 'TXT_DEVICEPARAMETERSVALUES_136', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2851, 1483, 0, 'TXT_DEVICEPARAMETERSVALUES_4085', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(137, 88, 0, 'TXT_DEVICEPARAMETERSVALUES_137', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(138, 88, 1, 'TXT_DEVICEPARAMETERSVALUES_138', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(139, 88, 2, 'TXT_DEVICEPARAMETERSVALUES_139', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2850, 1483, 1, 'TXT_DEVICEPARAMETERSVALUES_4086', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(140, 88, 3, 'TXT_DEVICEPARAMETERSVALUES_140', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2849, 1473, 0, 'TXT_DEVICEPARAMETERSVALUES_4066', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(141, 89, 0, 'TXT_DEVICEPARAMETERSVALUES_141', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(142, 89, 1, 'TXT_DEVICEPARAMETERSVALUES_142', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(143, 89, 2, 'TXT_DEVICEPARAMETERSVALUES_143', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2848, 1473, 3, 'TXT_DEVICEPARAMETERSVALUES_4069', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(144, 89, 3, 'TXT_DEVICEPARAMETERSVALUES_144', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(145, 90, 0, 'TXT_DEVICEPARAMETERSVALUES_145', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(146, 90, 1, 'TXT_DEVICEPARAMETERSVALUES_146', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2847, 1473, 2, 'TXT_DEVICEPARAMETERSVALUES_4068', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(147, 90, 2, 'TXT_DEVICEPARAMETERSVALUES_147', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(148, 90, 3, 'TXT_DEVICEPARAMETERSVALUES_148', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2846, 1473, 1, 'TXT_DEVICEPARAMETERSVALUES_4067', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(149, 91, 0, 'TXT_DEVICEPARAMETERSVALUES_149', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(150, 91, 1, 'TXT_DEVICEPARAMETERSVALUES_150', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(151, 91, 2, 'TXT_DEVICEPARAMETERSVALUES_151', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2845, 1470, 1, 'TXT_DEVICEPARAMETERSVALUES_4062', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(152, 91, 3, 'TXT_DEVICEPARAMETERSVALUES_152', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2844, 1470, 0, 'TXT_DEVICEPARAMETERSVALUES_4061', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(153, 92, 0, 'TXT_DEVICEPARAMETERSVALUES_153', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(154, 92, 1, 'TXT_DEVICEPARAMETERSVALUES_154', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(155, 92, 2, 'TXT_DEVICEPARAMETERSVALUES_155', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2843, 1468, 0, 'TXT_DEVICEPARAMETERSVALUES_4057', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(156, 92, 3, 'TXT_DEVICEPARAMETERSVALUES_156', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(157, 93, 0, 'TXT_DEVICEPARAMETERSVALUES_157', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(158, 93, 1, 'TXT_DEVICEPARAMETERSVALUES_158', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2842, 1468, 255, 'TXT_DEVICEPARAMETERSVALUES_4058', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(159, 93, 2, 'TXT_DEVICEPARAMETERSVALUES_159', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(160, 93, 3, 'TXT_DEVICEPARAMETERSVALUES_160', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2841, 1467, 3, 'TXT_DEVICEPARAMETERSVALUES_4055', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(161, 95, 255, 'TXT_DEVICEPARAMETERSVALUES_161', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(162, 95, 0, 'TXT_DEVICEPARAMETERSVALUES_162', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(163, 95, 1, 'TXT_DEVICEPARAMETERSVALUES_163', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(164, 95, 2, 'TXT_DEVICEPARAMETERSVALUES_164', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(165, 96, 0, 'TXT_DEVICEPARAMETERSVALUES_165', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(166, 96, 1, 'TXT_DEVICEPARAMETERSVALUES_166', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2840, 1467, 2, 'TXT_DEVICEPARAMETERSVALUES_4054', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(167, 96, 2, 'TXT_DEVICEPARAMETERSVALUES_167', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2839, 1467, 1, 'TXT_DEVICEPARAMETERSVALUES_4053', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(168, 96, 3, 'TXT_DEVICEPARAMETERSVALUES_168', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2838, 1467, 0, 'TXT_DEVICEPARAMETERSVALUES_4052', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(169, 99, 0, 'TXT_DEVICEPARAMETERSVALUES_169', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2837, 1465, 1, 'TXT_DEVICEPARAMETERSVALUES_4086', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(170, 99, 1, 'TXT_DEVICEPARAMETERSVALUES_170', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2833, 1455, 1, 'TXT_DEVICEPARAMETERSVALUES_4067', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2834, 1455, 2, 'TXT_DEVICEPARAMETERSVALUES_4068', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2835, 1455, 3, 'TXT_DEVICEPARAMETERSVALUES_4069', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2836, 1465, 0, 'TXT_DEVICEPARAMETERSVALUES_4085', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(171, 99, 2, 'TXT_DEVICEPARAMETERSVALUES_171', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2829, 1450, 255, 'TXT_DEVICEPARAMETERSVALUES_4058', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2830, 1452, 0, 'TXT_DEVICEPARAMETERSVALUES_4061', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2831, 1452, 1, 'TXT_DEVICEPARAMETERSVALUES_4062', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2832, 1455, 0, 'TXT_DEVICEPARAMETERSVALUES_4066', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(172, 100, 0, 'TXT_DEVICEPARAMETERSVALUES_172', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2828, 1450, 0, 'TXT_DEVICEPARAMETERSVALUES_4057', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(173, 100, 1, 'TXT_DEVICEPARAMETERSVALUES_173', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2824, 1449, 0, 'TXT_DEVICEPARAMETERSVALUES_4052', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2825, 1449, 1, 'TXT_DEVICEPARAMETERSVALUES_4053', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2826, 1449, 2, 'TXT_DEVICEPARAMETERSVALUES_4054', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2827, 1449, 3, 'TXT_DEVICEPARAMETERSVALUES_4055', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(174, 100, 2, 'TXT_DEVICEPARAMETERSVALUES_174', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2747, 1402, 1, 'TXT_DEVICEPARAMETERSVALUES_3898', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2780, 1421, 1, 'TXT_DEVICEPARAMETERSVALUES_3950', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2812, 1440, 2, 'TXT_DEVICEPARAMETERSVALUES_4001', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2813, 1440, 1, 'TXT_DEVICEPARAMETERSVALUES_4002', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2814, 1440, 0, 'TXT_DEVICEPARAMETERSVALUES_4003', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(175, 101, 0, 'TXT_DEVICEPARAMETERSVALUES_175', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(176, 101, 1, 'TXT_DEVICEPARAMETERSVALUES_176', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2721, 1094, 2, 'TXT_DEVICEPARAMETERSVALUES_3832', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(177, 102, 0, 'TXT_DEVICEPARAMETERSVALUES_177', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(178, 102, 1, 'TXT_DEVICEPARAMETERSVALUES_178', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(179, 103, 0, 'TXT_DEVICEPARAMETERSVALUES_179', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(180, 103, 1, 'TXT_DEVICEPARAMETERSVALUES_180', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2755, 1408, 0, 'TXT_DEVICEPARAMETERSVALUES_3912', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(181, 104, 0, 'TXT_DEVICEPARAMETERSVALUES_181', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(182, 104, 1, 'TXT_DEVICEPARAMETERSVALUES_182', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(183, 104, 2, 'TXT_DEVICEPARAMETERSVALUES_183', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2754, 1408, 1, 'TXT_DEVICEPARAMETERSVALUES_3911', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(184, 104, 3, 'TXT_DEVICEPARAMETERSVALUES_184', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2753, 1404, 0, 'TXT_DEVICEPARAMETERSVALUES_3906', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(185, 105, 0, 'TXT_DEVICEPARAMETERSVALUES_185', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(186, 105, 1, 'TXT_DEVICEPARAMETERSVALUES_186', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(187, 105, 2, 'TXT_DEVICEPARAMETERSVALUES_187', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2752, 1404, 1, 'TXT_DEVICEPARAMETERSVALUES_3905', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(188, 105, 3, 'TXT_DEVICEPARAMETERSVALUES_188', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(189, 106, 0, 'TXT_DEVICEPARAMETERSVALUES_189', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(190, 106, 1, 'TXT_DEVICEPARAMETERSVALUES_190', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2751, 1403, 0, 'TXT_DEVICEPARAMETERSVALUES_3903', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(191, 106, 2, 'TXT_DEVICEPARAMETERSVALUES_191', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(192, 106, 3, 'TXT_DEVICEPARAMETERSVALUES_192', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(193, 107, 0, 'TXT_DEVICEPARAMETERSVALUES_193', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(194, 107, 1, 'TXT_DEVICEPARAMETERSVALUES_194', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2821, 1446, 0, 'TXT_DEVICEPARAMETERSVALUES_4016', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(195, 107, 2, 'TXT_DEVICEPARAMETERSVALUES_195', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(196, 107, 3, 'TXT_DEVICEPARAMETERSVALUES_196', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2690, 1091, 4, 'TXT_DEVICEPARAMETERSVALUES_3774', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(197, 108, 0, 'TXT_DEVICEPARAMETERSVALUES_197', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(198, 108, 1, 'TXT_DEVICEPARAMETERSVALUES_198', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(199, 108, 2, 'TXT_DEVICEPARAMETERSVALUES_199', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2689, 1091, 3, 'TXT_DEVICEPARAMETERSVALUES_3773', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(200, 108, 3, 'TXT_DEVICEPARAMETERSVALUES_200', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2688, 1368, 0, 'TXT_DEVICEPARAMETERSVALUES_3772', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(201, 109, 0, 'TXT_DEVICEPARAMETERSVALUES_201', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(202, 109, 1, 'TXT_DEVICEPARAMETERSVALUES_202', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(203, 109, 2, 'TXT_DEVICEPARAMETERSVALUES_203', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2687, 1368, 1, 'TXT_DEVICEPARAMETERSVALUES_3771', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(204, 109, 3, 'TXT_DEVICEPARAMETERSVALUES_204', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2686, 1365, 0, 'TXT_DEVICEPARAMETERSVALUES_3767', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(205, 110, 0, 'TXT_DEVICEPARAMETERSVALUES_205', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(206, 110, 1, 'TXT_DEVICEPARAMETERSVALUES_206', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(207, 110, 2, 'TXT_DEVICEPARAMETERSVALUES_207', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2685, 1365, 3, 'TXT_DEVICEPARAMETERSVALUES_3766', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(208, 110, 3, 'TXT_DEVICEPARAMETERSVALUES_208', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(209, 111, 0, 'TXT_DEVICEPARAMETERSVALUES_209', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(210, 111, 1, 'TXT_DEVICEPARAMETERSVALUES_210', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2684, 1365, 2, 'TXT_DEVICEPARAMETERSVALUES_3765', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(211, 111, 2, 'TXT_DEVICEPARAMETERSVALUES_211', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(212, 111, 3, 'TXT_DEVICEPARAMETERSVALUES_212', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2683, 1365, 1, 'TXT_DEVICEPARAMETERSVALUES_3764', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(213, 112, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(214, 112, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(215, 112, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(216, 112, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(217, 113, 0, 'TXT_DEVICEPARAMETERSVALUES_217', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(218, 113, 1, 'TXT_DEVICEPARAMETERSVALUES_218', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2682, 1363, 2, 'TXT_DEVICEPARAMETERSVALUES_3761', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(219, 113, 2, 'TXT_DEVICEPARAMETERSVALUES_219', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2681, 1363, 1, 'TXT_DEVICEPARAMETERSVALUES_3760', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(220, 113, 3, 'TXT_DEVICEPARAMETERSVALUES_220', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2680, 1363, 0, 'TXT_DEVICEPARAMETERSVALUES_3759', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(221, 116, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2679, 1358, 0, 'TXT_DEVICEPARAMETERSVALUES_3753', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(222, 116, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2675, 1355, 0, 'TXT_DEVICEPARAMETERSVALUES_3746', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2676, 1358, 3, 'TXT_DEVICEPARAMETERSVALUES_3750', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2677, 1358, 2, 'TXT_DEVICEPARAMETERSVALUES_3751', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2678, 1358, 1, 'TXT_DEVICEPARAMETERSVALUES_3752', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(223, 116, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2671, 1352, 3, 'TXT_DEVICEPARAMETERSVALUES_3739', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2672, 1353, 255, 'TXT_DEVICEPARAMETERSVALUES_3741', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2673, 1353, 0, 'TXT_DEVICEPARAMETERSVALUES_3742', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2674, 1355, 1, 'TXT_DEVICEPARAMETERSVALUES_3745', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(224, 117, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2670, 1352, 2, 'TXT_DEVICEPARAMETERSVALUES_3738', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(225, 117, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2666, 1350, 1, 'TXT_DEVICEPARAMETERSVALUES_3732', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2667, 1350, 0, 'TXT_DEVICEPARAMETERSVALUES_3733', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2668, 1352, 1, 'TXT_DEVICEPARAMETERSVALUES_3736', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2669, 1352, 0, 'TXT_DEVICEPARAMETERSVALUES_3737', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(226, 117, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2662, 1347, 1, 'TXT_DEVICEPARAMETERSVALUES_3725', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2663, 1347, 2, 'TXT_DEVICEPARAMETERSVALUES_3726', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2664, 1347, 3, 'TXT_DEVICEPARAMETERSVALUES_3727', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2665, 1347, 0, 'TXT_DEVICEPARAMETERSVALUES_3728', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(227, 118, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2661, 1345, 2, 'TXT_DEVICEPARAMETERSVALUES_3722', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(228, 118, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2660, 1345, 1, 'TXT_DEVICEPARAMETERSVALUES_3721', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(229, 119, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(230, 119, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(231, 120, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(232, 120, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2659, 1345, 0, 'TXT_DEVICEPARAMETERSVALUES_3720', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(233, 121, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(234, 121, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(235, 121, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2658, 1340, 0, 'TXT_DEVICEPARAMETERSVALUES_3714', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(236, 121, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(237, 122, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(238, 122, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2657, 1340, 1, 'TXT_DEVICEPARAMETERSVALUES_3713', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(239, 122, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(240, 122, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2656, 1340, 2, 'TXT_DEVICEPARAMETERSVALUES_3712', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(241, 123, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(242, 123, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(243, 123, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2655, 1340, 3, 'TXT_DEVICEPARAMETERSVALUES_3711', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(244, 123, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(245, 124, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(246, 124, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2654, 1337, 0, 'TXT_DEVICEPARAMETERSVALUES_3707', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(247, 124, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(248, 124, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2653, 1337, 1, 'TXT_DEVICEPARAMETERSVALUES_3706', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(249, 125, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(250, 125, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(251, 125, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2652, 1335, 0, 'TXT_DEVICEPARAMETERSVALUES_3703', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(252, 125, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(253, 126, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(254, 126, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2651, 1335, 255, 'TXT_DEVICEPARAMETERSVALUES_3702', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(255, 126, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(256, 126, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2650, 1334, 3, 'TXT_DEVICEPARAMETERSVALUES_3700', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(257, 127, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(258, 127, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(259, 127, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2649, 1334, 2, 'TXT_DEVICEPARAMETERSVALUES_3699', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(260, 127, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2648, 1334, 0, 'TXT_DEVICEPARAMETERSVALUES_3698', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(261, 128, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(262, 128, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(263, 128, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2647, 1334, 1, 'TXT_DEVICEPARAMETERSVALUES_3697', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(264, 128, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2646, 1332, 0, 'TXT_DEVICEPARAMETERSVALUES_3694', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(265, 129, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2645, 1332, 1, 'TXT_DEVICEPARAMETERSVALUES_3693', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(266, 129, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(267, 133, 255, 'TXT_DEVICEPARAMETERSVALUES_267', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(268, 133, 0, 'TXT_DEVICEPARAMETERSVALUES_268', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(269, 133, 1, 'TXT_DEVICEPARAMETERSVALUES_269', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(270, 133, 2, 'TXT_DEVICEPARAMETERSVALUES_270', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(271, 134, 0, 'TXT_DEVICEPARAMETERSVALUES_271', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2644, 1329, 0, 'TXT_DEVICEPARAMETERSVALUES_3689', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(272, 134, 1, 'TXT_DEVICEPARAMETERSVALUES_272', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2643, 1329, 3, 'TXT_DEVICEPARAMETERSVALUES_3688', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(273, 135, 0, 'TXT_DEVICEPARAMETERSVALUES_273', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(274, 135, 1, 'TXT_DEVICEPARAMETERSVALUES_274', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(275, 136, 0, 'TXT_DEVICEPARAMETERSVALUES_275', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(276, 136, 1, 'TXT_DEVICEPARAMETERSVALUES_276', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2642, 1329, 2, 'TXT_DEVICEPARAMETERSVALUES_3687', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(277, 137, 0, 'TXT_DEVICEPARAMETERSVALUES_277', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(278, 137, 1, 'TXT_DEVICEPARAMETERSVALUES_278', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(279, 137, 2, 'TXT_DEVICEPARAMETERSVALUES_279', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2641, 1329, 1, 'TXT_DEVICEPARAMETERSVALUES_3686', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(280, 137, 3, 'TXT_DEVICEPARAMETERSVALUES_280', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(281, 138, 0, 'TXT_DEVICEPARAMETERSVALUES_281', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(282, 138, 1, 'TXT_DEVICEPARAMETERSVALUES_282', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2640, 1327, 2, 'TXT_DEVICEPARAMETERSVALUES_3683', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(283, 138, 2, 'TXT_DEVICEPARAMETERSVALUES_283', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(284, 138, 3, 'TXT_DEVICEPARAMETERSVALUES_284', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2639, 1327, 1, 'TXT_DEVICEPARAMETERSVALUES_3682', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(285, 139, 0, 'TXT_DEVICEPARAMETERSVALUES_285', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(286, 139, 1, 'TXT_DEVICEPARAMETERSVALUES_286', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(287, 139, 2, 'TXT_DEVICEPARAMETERSVALUES_287', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2638, 1327, 0, 'TXT_DEVICEPARAMETERSVALUES_3681', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(288, 139, 3, 'TXT_DEVICEPARAMETERSVALUES_288', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(289, 140, 0, 'TXT_DEVICEPARAMETERSVALUES_289', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(290, 140, 1, 'TXT_DEVICEPARAMETERSVALUES_290', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2637, 1322, 0, 'TXT_DEVICEPARAMETERSVALUES_3675', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(291, 140, 2, 'TXT_DEVICEPARAMETERSVALUES_291', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(292, 140, 3, 'TXT_DEVICEPARAMETERSVALUES_292', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2636, 1322, 1, 'TXT_DEVICEPARAMETERSVALUES_3674', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(293, 141, 255, 'TXT_DEVICEPARAMETERSVALUES_293', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(294, 141, 0, 'TXT_DEVICEPARAMETERSVALUES_294', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(295, 141, 1, 'TXT_DEVICEPARAMETERSVALUES_295', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(296, 141, 2, 'TXT_DEVICEPARAMETERSVALUES_296', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(297, 142, 0, 'TXT_DEVICEPARAMETERSVALUES_297', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(298, 142, 1, 'TXT_DEVICEPARAMETERSVALUES_298', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2635, 1322, 2, 'TXT_DEVICEPARAMETERSVALUES_3673', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(299, 143, 0, 'TXT_DEVICEPARAMETERSVALUES_299', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(300, 143, 1, 'TXT_DEVICEPARAMETERSVALUES_300', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(301, 144, 0, 'TXT_DEVICEPARAMETERSVALUES_301', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2792, 1429, 0, 'TXT_DEVICEPARAMETERSVALUES_3970', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(302, 144, 1, 'TXT_DEVICEPARAMETERSVALUES_302', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(303, 145, 0, 'TXT_DEVICEPARAMETERSVALUES_303', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(304, 145, 1, 'TXT_DEVICEPARAMETERSVALUES_304', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2791, 1429, 1, 'TXT_DEVICEPARAMETERSVALUES_3969', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(305, 145, 2, 'TXT_DEVICEPARAMETERSVALUES_305', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(306, 145, 3, 'TXT_DEVICEPARAMETERSVALUES_306', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2794, 1430, 3, 'TXT_DEVICEPARAMETERSVALUES_3973', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(307, 146, 0, 'TXT_DEVICEPARAMETERSVALUES_307', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(308, 146, 1, 'TXT_DEVICEPARAMETERSVALUES_308', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2793, 1430, 4, 'TXT_DEVICEPARAMETERSVALUES_3972', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(309, 146, 2, 'TXT_DEVICEPARAMETERSVALUES_309', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(310, 146, 3, 'TXT_DEVICEPARAMETERSVALUES_310', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(311, 147, 0, 'TXT_DEVICEPARAMETERSVALUES_311', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(312, 147, 1, 'TXT_DEVICEPARAMETERSVALUES_312', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2796, 1430, 1, 'TXT_DEVICEPARAMETERSVALUES_3975', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(313, 147, 2, 'TXT_DEVICEPARAMETERSVALUES_313', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(314, 147, 3, 'TXT_DEVICEPARAMETERSVALUES_314', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2795, 1430, 2, 'TXT_DEVICEPARAMETERSVALUES_3974', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(315, 148, 0, 'TXT_DEVICEPARAMETERSVALUES_315', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(316, 148, 1, 'TXT_DEVICEPARAMETERSVALUES_316', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(317, 148, 2, 'TXT_DEVICEPARAMETERSVALUES_317', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2799, 1432, 2, 'TXT_DEVICEPARAMETERSVALUES_3980', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(318, 148, 3, 'TXT_DEVICEPARAMETERSVALUES_318', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2798, 1432, 1, 'TXT_DEVICEPARAMETERSVALUES_3979', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(319, 149, 0, 'TXT_DEVICEPARAMETERSVALUES_319', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(320, 149, 1, 'TXT_DEVICEPARAMETERSVALUES_320', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(321, 151, 0, 'TXT_DEVICEPARAMETERSVALUES_321', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2797, 1430, 0, 'TXT_DEVICEPARAMETERSVALUES_3976', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(322, 151, 1, 'TXT_DEVICEPARAMETERSVALUES_322', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2804, 1437, 0, 'TXT_DEVICEPARAMETERSVALUES_3990', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2801, 1433, 2, 'TXT_DEVICEPARAMETERSVALUES_3983', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2800, 1432, 0, 'TXT_DEVICEPARAMETERSVALUES_3981', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(323, 151, 2, 'TXT_DEVICEPARAMETERSVALUES_323', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2807, 1438, 1, 'TXT_DEVICEPARAMETERSVALUES_3994', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2806, 1438, 0, 'TXT_DEVICEPARAMETERSVALUES_3993', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2803, 1433, 1, 'TXT_DEVICEPARAMETERSVALUES_3985', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2802, 1433, 0, 'TXT_DEVICEPARAMETERSVALUES_3984', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(324, 152, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(325, 152, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(326, 152, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(327, 152, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(328, 153, 0, 'TXT_DEVICEPARAMETERSVALUES_328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(329, 153, 1, 'TXT_DEVICEPARAMETERSVALUES_329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(330, 155, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2805, 1437, 1, 'TXT_DEVICEPARAMETERSVALUES_3991', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(331, 155, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2811, 1439, 0, 'TXT_DEVICEPARAMETERSVALUES_3999', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2810, 1439, 1, 'TXT_DEVICEPARAMETERSVALUES_3998', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2809, 1439, 2, 'TXT_DEVICEPARAMETERSVALUES_3997', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2808, 1438, 2, 'TXT_DEVICEPARAMETERSVALUES_3995', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(332, 155, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2820, 1446, 1, 'TXT_DEVICEPARAMETERSVALUES_4015', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2819, 1442, 0, 'TXT_DEVICEPARAMETERSVALUES_4010', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2816, 1441, 2, 'TXT_DEVICEPARAMETERSVALUES_4006', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2815, 1441, 1, 'TXT_DEVICEPARAMETERSVALUES_4005', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(333, 156, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(334, 156, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2818, 1442, 1, 'TXT_DEVICEPARAMETERSVALUES_4009', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(335, 157, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(336, 157, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(337, 158, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2823, 1447, 0, 'TXT_DEVICEPARAMETERSVALUES_4019', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(338, 158, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(339, 159, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(340, 159, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2822, 1447, 1, 'TXT_DEVICEPARAMETERSVALUES_4018', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(341, 159, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(342, 159, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(343, 160, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(344, 160, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(345, 160, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2629, 1316, 3, 'TXT_DEVICEPARAMETERSVALUES_3661', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(346, 160, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2759, 1410, 0, 'TXT_DEVICEPARAMETERSVALUES_3918', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(347, 161, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(348, 161, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2758, 1410, 1, 'TXT_DEVICEPARAMETERSVALUES_3917', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(349, 161, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(350, 161, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2761, 1411, 3, 'TXT_DEVICEPARAMETERSVALUES_3921', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(351, 162, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(352, 162, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(353, 162, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2760, 1411, 4, 'TXT_DEVICEPARAMETERSVALUES_3920', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(354, 162, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(355, 163, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2763, 1411, 1, 'TXT_DEVICEPARAMETERSVALUES_3923', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(356, 163, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2762, 1411, 2, 'TXT_DEVICEPARAMETERSVALUES_3922', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(357, 166, 255, 'TXT_DEVICEPARAMETERSVALUES_357', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(358, 166, 0, 'TXT_DEVICEPARAMETERSVALUES_358', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(359, 166, 1, 'TXT_DEVICEPARAMETERSVALUES_359', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(360, 166, 2, 'TXT_DEVICEPARAMETERSVALUES_360', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(361, 167, 0, 'TXT_DEVICEPARAMETERSVALUES_361', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(362, 167, 1, 'TXT_DEVICEPARAMETERSVALUES_362', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(363, 168, 0, 'TXT_DEVICEPARAMETERSVALUES_363', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(364, 168, 1, 'TXT_DEVICEPARAMETERSVALUES_364', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(365, 169, 0, 'TXT_DEVICEPARAMETERSVALUES_365', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(366, 169, 1, 'TXT_DEVICEPARAMETERSVALUES_366', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(367, 169, 2, 'TXT_DEVICEPARAMETERSVALUES_367', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(368, 171, 255, 'TXT_DEVICEPARAMETERSVALUES_368', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(369, 171, 0, 'TXT_DEVICEPARAMETERSVALUES_369', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(370, 171, 1, 'TXT_DEVICEPARAMETERSVALUES_370', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(371, 171, 2, 'TXT_DEVICEPARAMETERSVALUES_371', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(372, 172, 0, 'TXT_DEVICEPARAMETERSVALUES_372', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(373, 172, 1, 'TXT_DEVICEPARAMETERSVALUES_373', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(374, 173, 0, 'TXT_DEVICEPARAMETERSVALUES_374', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(375, 173, 1, 'TXT_DEVICEPARAMETERSVALUES_375', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(376, 174, 0, 'TXT_DEVICEPARAMETERSVALUES_376', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(377, 174, 1, 'TXT_DEVICEPARAMETERSVALUES_377', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(378, 174, 2, 'TXT_DEVICEPARAMETERSVALUES_378', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(379, 176, 255, 'TXT_DEVICEPARAMETERSVALUES_379', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(380, 176, 0, 'TXT_DEVICEPARAMETERSVALUES_380', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(381, 176, 1, 'TXT_DEVICEPARAMETERSVALUES_381', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(382, 176, 2, 'TXT_DEVICEPARAMETERSVALUES_382', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(383, 177, 0, 'TXT_DEVICEPARAMETERSVALUES_383', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(384, 177, 1, 'TXT_DEVICEPARAMETERSVALUES_384', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(385, 178, 0, 'TXT_DEVICEPARAMETERSVALUES_385', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(386, 178, 1, 'TXT_DEVICEPARAMETERSVALUES_386', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(387, 179, 0, 'TXT_DEVICEPARAMETERSVALUES_387', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(388, 179, 1, 'TXT_DEVICEPARAMETERSVALUES_388', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(389, 179, 2, 'TXT_DEVICEPARAMETERSVALUES_389', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(390, 181, 0, 'TXT_DEVICEPARAMETERSVALUES_390', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(391, 181, 1, 'TXT_DEVICEPARAMETERSVALUES_391', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(392, 181, 2, 'TXT_DEVICEPARAMETERSVALUES_392', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2766, 1413, 2, 'TXT_DEVICEPARAMETERSVALUES_3928', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(393, 182, 0, 'TXT_DEVICEPARAMETERSVALUES_393', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(394, 182, 1, 'TXT_DEVICEPARAMETERSVALUES_394', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(395, 182, 2, 'TXT_DEVICEPARAMETERSVALUES_395', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2765, 1413, 1, 'TXT_DEVICEPARAMETERSVALUES_3927', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(396, 183, 0, 'TXT_DEVICEPARAMETERSVALUES_396', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(397, 183, 1, 'TXT_DEVICEPARAMETERSVALUES_397', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(398, 183, 2, 'TXT_DEVICEPARAMETERSVALUES_398', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2764, 1411, 0, 'TXT_DEVICEPARAMETERSVALUES_3924', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(399, 184, 0, 'TXT_DEVICEPARAMETERSVALUES_399', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(400, 184, 1, 'TXT_DEVICEPARAMETERSVALUES_400', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(401, 184, 2, 'TXT_DEVICEPARAMETERSVALUES_401', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2769, 1414, 0, 'TXT_DEVICEPARAMETERSVALUES_3932', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(402, 185, 255, 'TXT_DEVICEPARAMETERSVALUES_402', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(403, 185, 0, 'TXT_DEVICEPARAMETERSVALUES_403', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(404, 185, 1, 'TXT_DEVICEPARAMETERSVALUES_404', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(405, 185, 2, 'TXT_DEVICEPARAMETERSVALUES_405', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(406, 186, 0, 'TXT_DEVICEPARAMETERSVALUES_406', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(407, 186, 1, 'TXT_DEVICEPARAMETERSVALUES_407', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(408, 187, 0, 'TXT_DEVICEPARAMETERSVALUES_408', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(409, 187, 1, 'TXT_DEVICEPARAMETERSVALUES_409', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(410, 187, 2, 'TXT_DEVICEPARAMETERSVALUES_410', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(411, 189, 0, 'TXT_DEVICEPARAMETERSVALUES_411', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(412, 189, 1, 'TXT_DEVICEPARAMETERSVALUES_412', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(413, 189, 2, 'TXT_DEVICEPARAMETERSVALUES_413', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2768, 1414, 2, 'TXT_DEVICEPARAMETERSVALUES_3931', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(414, 190, 0, 'TXT_DEVICEPARAMETERSVALUES_414', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(415, 190, 1, 'TXT_DEVICEPARAMETERSVALUES_415', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(416, 190, 2, 'TXT_DEVICEPARAMETERSVALUES_416', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2767, 1413, 0, 'TXT_DEVICEPARAMETERSVALUES_3929', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(417, 191, 0, 'TXT_DEVICEPARAMETERSVALUES_417', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(418, 191, 1, 'TXT_DEVICEPARAMETERSVALUES_418', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(419, 191, 2, 'TXT_DEVICEPARAMETERSVALUES_419', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2772, 1418, 1, 'TXT_DEVICEPARAMETERSVALUES_3939', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(420, 192, 0, 'TXT_DEVICEPARAMETERSVALUES_420', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(421, 192, 1, 'TXT_DEVICEPARAMETERSVALUES_421', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(422, 192, 2, 'TXT_DEVICEPARAMETERSVALUES_422', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2771, 1418, 0, 'TXT_DEVICEPARAMETERSVALUES_3938', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(423, 193, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(424, 193, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(425, 193, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(426, 193, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(427, 194, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(428, 194, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(429, 195, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(430, 195, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(431, 195, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(432, 197, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(433, 197, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(434, 197, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2770, 1414, 1, 'TXT_DEVICEPARAMETERSVALUES_3933', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(435, 198, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(436, 198, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(437, 198, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2775, 1419, 2, 'TXT_DEVICEPARAMETERSVALUES_3943', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(438, 199, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(439, 199, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(440, 199, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2774, 1419, 1, 'TXT_DEVICEPARAMETERSVALUES_3942', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(441, 200, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(442, 200, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(443, 200, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2773, 1419, 0, 'TXT_DEVICEPARAMETERSVALUES_3941', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(444, 209, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(445, 209, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(446, 209, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(447, 209, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(448, 210, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2776, 1420, 2, 'TXT_DEVICEPARAMETERSVALUES_3945', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(449, 210, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2783, 1422, 2, 'TXT_DEVICEPARAMETERSVALUES_3954', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2779, 1421, 2, 'TXT_DEVICEPARAMETERSVALUES_3949', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2778, 1420, 0, 'TXT_DEVICEPARAMETERSVALUES_3947', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2777, 1420, 1, 'TXT_DEVICEPARAMETERSVALUES_3946', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(450, 210, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2788, 1427, 0, 'TXT_DEVICEPARAMETERSVALUES_3964', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2787, 1427, 1, 'TXT_DEVICEPARAMETERSVALUES_3963', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2782, 1422, 1, 'TXT_DEVICEPARAMETERSVALUES_3953', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2781, 1421, 0, 'TXT_DEVICEPARAMETERSVALUES_3951', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(451, 211, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2817, 1441, 0, 'TXT_DEVICEPARAMETERSVALUES_4007', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(452, 211, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2790, 1428, 0, 'TXT_DEVICEPARAMETERSVALUES_3967', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(453, 218, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(454, 218, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(455, 219, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(456, 219, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(457, 220, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(458, 220, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2789, 1428, 1, 'TXT_DEVICEPARAMETERSVALUES_3966', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(459, 221, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(460, 221, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(461, 222, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(462, 222, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(463, 223, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(464, 223, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2631, 1317, 0, 'TXT_DEVICEPARAMETERSVALUES_3664', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(465, 225, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(466, 225, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2630, 1317, 255, 'TXT_DEVICEPARAMETERSVALUES_3663', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(467, 225, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(468, 225, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2726, 1391, 0, 'TXT_DEVICEPARAMETERSVALUES_3866', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(469, 227, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(470, 227, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(471, 227, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(472, 227, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(473, 228, 0, 'TXT_DEVICEPARAMETERSVALUES_217', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(474, 228, 1, 'TXT_DEVICEPARAMETERSVALUES_218', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2725, 1391, 1, 'TXT_DEVICEPARAMETERSVALUES_3865', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(475, 228, 2, 'TXT_DEVICEPARAMETERSVALUES_219', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2728, 1392, 3, 'TXT_DEVICEPARAMETERSVALUES_3869', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(476, 228, 3, 'TXT_DEVICEPARAMETERSVALUES_220', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2727, 1392, 4, 'TXT_DEVICEPARAMETERSVALUES_3868', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(477, 231, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2730, 1392, 1, 'TXT_DEVICEPARAMETERSVALUES_3871', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(478, 231, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2733, 1394, 2, 'TXT_DEVICEPARAMETERSVALUES_3876', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2732, 1394, 1, 'TXT_DEVICEPARAMETERSVALUES_3875', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2731, 1392, 0, 'TXT_DEVICEPARAMETERSVALUES_3872', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2729, 1392, 2, 'TXT_DEVICEPARAMETERSVALUES_3870', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(479, 231, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2739, 1399, 1, 'TXT_DEVICEPARAMETERSVALUES_3887', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2736, 1395, 0, 'TXT_DEVICEPARAMETERSVALUES_3880', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2735, 1395, 2, 'TXT_DEVICEPARAMETERSVALUES_3879', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2734, 1394, 0, 'TXT_DEVICEPARAMETERSVALUES_3877', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(480, 232, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2738, 1399, 0, 'TXT_DEVICEPARAMETERSVALUES_3886', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(481, 232, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2743, 1401, 2, 'TXT_DEVICEPARAMETERSVALUES_3893', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2742, 1400, 2, 'TXT_DEVICEPARAMETERSVALUES_3891', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2741, 1400, 1, 'TXT_DEVICEPARAMETERSVALUES_3890', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2740, 1400, 0, 'TXT_DEVICEPARAMETERSVALUES_3889', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2737, 1395, 1, 'TXT_DEVICEPARAMETERSVALUES_3881', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(482, 232, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2746, 1402, 2, 'TXT_DEVICEPARAMETERSVALUES_3897', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2745, 1401, 0, 'TXT_DEVICEPARAMETERSVALUES_3895', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2744, 1401, 1, 'TXT_DEVICEPARAMETERSVALUES_3894', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(483, 233, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2750, 1403, 2, 'TXT_DEVICEPARAMETERSVALUES_3902', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(484, 233, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2748, 1402, 0, 'TXT_DEVICEPARAMETERSVALUES_3899', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(485, 234, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(486, 234, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(487, 235, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2749, 1403, 1, 'TXT_DEVICEPARAMETERSVALUES_3901', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(488, 235, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2786, 1423, 0, 'TXT_DEVICEPARAMETERSVALUES_3958', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(489, 236, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(490, 236, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(491, 236, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2785, 1423, 1, 'TXT_DEVICEPARAMETERSVALUES_3957', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(492, 236, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(493, 237, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(494, 237, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2784, 1422, 0, 'TXT_DEVICEPARAMETERSVALUES_3955', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(495, 237, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(496, 237, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2757, 1409, 0, 'TXT_DEVICEPARAMETERSVALUES_3915', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(497, 238, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(498, 238, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2756, 1409, 1, 'TXT_DEVICEPARAMETERSVALUES_3914', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(499, 238, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(500, 238, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2633, 1319, 0, 'TXT_DEVICEPARAMETERSVALUES_3668', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(501, 239, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(502, 239, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2634, 1322, 3, 'TXT_DEVICEPARAMETERSVALUES_3672', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(503, 239, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2632, 1319, 1, 'TXT_DEVICEPARAMETERSVALUES_3667', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(504, 239, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(505, 240, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(506, 240, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(507, 240, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2524, 1251, 0, 'TXT_DEVICEPARAMETERSVALUES_3458', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(508, 240, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2523, 1250, 0, 'TXT_DEVICEPARAMETERSVALUES_3456', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(509, 241, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(510, 241, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(511, 241, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2522, 1248, 0, 'TXT_DEVICEPARAMETERSVALUES_3453', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(512, 241, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(513, 242, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(514, 242, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2521, 1248, 3, 'TXT_DEVICEPARAMETERSVALUES_3452', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(515, 242, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(516, 242, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2520, 1248, 2, 'TXT_DEVICEPARAMETERSVALUES_3451', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(517, 243, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(518, 243, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(519, 243, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2519, 1248, 1, 'TXT_DEVICEPARAMETERSVALUES_3450', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(520, 243, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2518, 1247, 0, 'TXT_DEVICEPARAMETERSVALUES_3448', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(521, 244, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(522, 244, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2517, 1247, 1, 'TXT_DEVICEPARAMETERSVALUES_3447', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(523, 246, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(524, 246, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(525, 246, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(526, 246, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(527, 247, 0, 'TXT_DEVICEPARAMETERSVALUES_328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(528, 247, 1, 'TXT_DEVICEPARAMETERSVALUES_329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(529, 249, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2516, 1246, 0, 'TXT_DEVICEPARAMETERSVALUES_3445', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(530, 249, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2512, 1240, 1, 'TXT_DEVICEPARAMETERSVALUES_3435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2513, 1240, 0, 'TXT_DEVICEPARAMETERSVALUES_3436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2514, 1242, 0, 'TXT_DEVICEPARAMETERSVALUES_3439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2515, 1246, 1, 'TXT_DEVICEPARAMETERSVALUES_3444', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(531, 249, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2508, 1239, 255, 'TXT_DEVICEPARAMETERSVALUES_3430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2509, 1239, 0, 'TXT_DEVICEPARAMETERSVALUES_3431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2510, 1239, 1, 'TXT_DEVICEPARAMETERSVALUES_3432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2511, 1239, 2, 'TXT_DEVICEPARAMETERSVALUES_3433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(532, 250, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2507, 1238, 0, 'TXT_DEVICEPARAMETERSVALUES_3428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(533, 250, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2506, 1237, 0, 'TXT_DEVICEPARAMETERSVALUES_3426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(534, 251, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(535, 251, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(536, 252, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2505, 1235, 0, 'TXT_DEVICEPARAMETERSVALUES_3423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(537, 252, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(538, 253, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(539, 253, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2504, 1235, 3, 'TXT_DEVICEPARAMETERSVALUES_3422', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(540, 253, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(541, 253, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2503, 1235, 2, 'TXT_DEVICEPARAMETERSVALUES_3421', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(542, 254, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(543, 254, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(544, 254, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2502, 1235, 1, 'TXT_DEVICEPARAMETERSVALUES_3420', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(545, 254, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2501, 1234, 0, 'TXT_DEVICEPARAMETERSVALUES_3418', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(546, 255, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(547, 255, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(548, 255, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2500, 1234, 1, 'TXT_DEVICEPARAMETERSVALUES_3417', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(549, 255, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2499, 1233, 0, 'TXT_DEVICEPARAMETERSVALUES_3415', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(550, 256, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(551, 256, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(552, 256, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2498, 1233, 1, 'TXT_DEVICEPARAMETERSVALUES_3414', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(553, 256, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2497, 1229, 0, 'TXT_DEVICEPARAMETERSVALUES_3409', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(554, 257, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2496, 1227, 0, 'TXT_DEVICEPARAMETERSVALUES_3406', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(555, 257, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(556, 259, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(557, 259, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(558, 259, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(559, 259, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(560, 260, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(561, 260, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(562, 261, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(563, 261, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(564, 261, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(565, 263, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(566, 263, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2495, 1227, 1, 'TXT_DEVICEPARAMETERSVALUES_3405', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(567, 263, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(568, 264, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(569, 264, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2494, 1226, 2, 'TXT_DEVICEPARAMETERSVALUES_3403', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(570, 264, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(571, 265, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(572, 265, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2493, 1226, 1, 'TXT_DEVICEPARAMETERSVALUES_3402', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(573, 265, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(574, 266, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(575, 266, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2492, 1226, 0, 'TXT_DEVICEPARAMETERSVALUES_3401', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(576, 266, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(577, 267, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(578, 267, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(579, 267, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(580, 267, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(581, 268, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2491, 1226, 255, 'TXT_DEVICEPARAMETERSVALUES_3400', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(582, 268, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2486, 1222, 2, 'TXT_DEVICEPARAMETERSVALUES_3391', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2487, 1222, 3, 'TXT_DEVICEPARAMETERSVALUES_3392', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2488, 1222, 0, 'TXT_DEVICEPARAMETERSVALUES_3393', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2489, 1224, 0, 'TXT_DEVICEPARAMETERSVALUES_3396', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2490, 1225, 0, 'TXT_DEVICEPARAMETERSVALUES_3398', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(583, 268, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2482, 1220, 0, 'TXT_DEVICEPARAMETERSVALUES_3385', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2483, 1221, 1, 'TXT_DEVICEPARAMETERSVALUES_3387', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2484, 1221, 0, 'TXT_DEVICEPARAMETERSVALUES_3388', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2485, 1222, 1, 'TXT_DEVICEPARAMETERSVALUES_3390', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(584, 269, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(585, 269, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2481, 1220, 1, 'TXT_DEVICEPARAMETERSVALUES_3384', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(586, 276, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(587, 276, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(588, 277, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(589, 277, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(590, 278, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(591, 278, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2480, 1216, 0, 'TXT_DEVICEPARAMETERSVALUES_3379', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(592, 279, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(593, 279, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(594, 280, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(595, 280, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(596, 281, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(597, 281, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2479, 1214, 0, 'TXT_DEVICEPARAMETERSVALUES_3376', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(598, 283, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(599, 283, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2478, 1214, 1, 'TXT_DEVICEPARAMETERSVALUES_3375', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(600, 283, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(601, 283, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2477, 1213, 2, 'TXT_DEVICEPARAMETERSVALUES_3373', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(602, 285, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(603, 285, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(604, 285, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(605, 285, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(606, 286, 0, 'TXT_DEVICEPARAMETERSVALUES_217', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(607, 286, 1, 'TXT_DEVICEPARAMETERSVALUES_218', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2476, 1213, 1, 'TXT_DEVICEPARAMETERSVALUES_3372', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(608, 286, 2, 'TXT_DEVICEPARAMETERSVALUES_219', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2475, 1213, 0, 'TXT_DEVICEPARAMETERSVALUES_3371', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(609, 286, 3, 'TXT_DEVICEPARAMETERSVALUES_220', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(610, 289, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2474, 1213, 255, 'TXT_DEVICEPARAMETERSVALUES_3370', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(611, 289, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2469, 1210, 0, 'TXT_DEVICEPARAMETERSVALUES_3362', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2470, 1211, 0, 'TXT_DEVICEPARAMETERSVALUES_3364', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2471, 1211, 1, 'TXT_DEVICEPARAMETERSVALUES_3365', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2472, 1212, 1, 'TXT_DEVICEPARAMETERSVALUES_3367', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2473, 1212, 0, 'TXT_DEVICEPARAMETERSVALUES_3368', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(612, 289, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2465, 1206, 2, 'TXT_DEVICEPARAMETERSVALUES_3354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2466, 1206, 1, 'TXT_DEVICEPARAMETERSVALUES_3355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2467, 1206, 0, 'TXT_DEVICEPARAMETERSVALUES_3356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2468, 1209, 0, 'TXT_DEVICEPARAMETERSVALUES_3360', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(613, 290, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2464, 1206, 3, 'TXT_DEVICEPARAMETERSVALUES_3353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(614, 290, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2460, 1204, 0, 'TXT_DEVICEPARAMETERSVALUES_3347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2461, 1204, 1, 'TXT_DEVICEPARAMETERSVALUES_3348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2462, 1205, 0, 'TXT_DEVICEPARAMETERSVALUES_3350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2463, 1205, 1, 'TXT_DEVICEPARAMETERSVALUES_3351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(615, 290, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2456, 1197, 0, 'TXT_DEVICEPARAMETERSVALUES_3336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2457, 1198, 0, 'TXT_DEVICEPARAMETERSVALUES_3338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2458, 1198, 1, 'TXT_DEVICEPARAMETERSVALUES_3339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2459, 1200, 0, 'TXT_DEVICEPARAMETERSVALUES_3342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(616, 291, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2455, 1197, 255, 'TXT_DEVICEPARAMETERSVALUES_3335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(617, 291, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2454, 1197, 2, 'TXT_DEVICEPARAMETERSVALUES_3334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(618, 292, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(619, 292, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(620, 293, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(621, 293, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2453, 1197, 1, 'TXT_DEVICEPARAMETERSVALUES_3333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(622, 294, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(623, 294, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(624, 294, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2452, 1196, 0, 'TXT_DEVICEPARAMETERSVALUES_3331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(625, 294, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(626, 295, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(627, 295, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2451, 1196, 1, 'TXT_DEVICEPARAMETERSVALUES_3330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(628, 295, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(629, 295, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2450, 1195, 1, 'TXT_DEVICEPARAMETERSVALUES_3328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(630, 296, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(631, 296, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(632, 296, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2449, 1195, 0, 'TXT_DEVICEPARAMETERSVALUES_3327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(633, 296, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2448, 1194, 0, 'TXT_DEVICEPARAMETERSVALUES_3325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(634, 297, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(635, 297, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(636, 297, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2447, 1193, 0, 'TXT_DEVICEPARAMETERSVALUES_3323', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(637, 297, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2446, 1190, 0, 'TXT_DEVICEPARAMETERSVALUES_3319', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(638, 298, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(639, 298, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(640, 298, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2445, 1190, 1, 'TXT_DEVICEPARAMETERSVALUES_3318', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(641, 298, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(642, 299, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(643, 299, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2444, 1190, 2, 'TXT_DEVICEPARAMETERSVALUES_3317', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(644, 299, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(645, 299, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2443, 1190, 3, 'TXT_DEVICEPARAMETERSVALUES_3316', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(646, 300, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(647, 300, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(648, 300, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2442, 1189, 1, 'TXT_DEVICEPARAMETERSVALUES_3314', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(649, 300, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2441, 1189, 0, 'TXT_DEVICEPARAMETERSVALUES_3313', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(650, 301, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(651, 301, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(652, 301, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2440, 1188, 1, 'TXT_DEVICEPARAMETERSVALUES_3311', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(653, 301, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2439, 1188, 0, 'TXT_DEVICEPARAMETERSVALUES_3310', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(654, 302, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(655, 302, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2438, 1184, 0, 'TXT_DEVICEPARAMETERSVALUES_3305', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(656, 304, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(657, 304, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(658, 304, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(659, 304, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(660, 305, 0, 'TXT_DEVICEPARAMETERSVALUES_328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(661, 305, 1, 'TXT_DEVICEPARAMETERSVALUES_329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(662, 307, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2437, 1182, 1, 'TXT_DEVICEPARAMETERSVALUES_3302', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(663, 307, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2433, 1181, 2, 'TXT_DEVICEPARAMETERSVALUES_3297', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2434, 1181, 255, 'TXT_DEVICEPARAMETERSVALUES_3298', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2435, 1181, 0, 'TXT_DEVICEPARAMETERSVALUES_3299', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2436, 1182, 0, 'TXT_DEVICEPARAMETERSVALUES_3301', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(664, 307, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2428, 1179, 0, 'TXT_DEVICEPARAMETERSVALUES_3290', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2429, 1179, 1, 'TXT_DEVICEPARAMETERSVALUES_3291', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2430, 1180, 1, 'TXT_DEVICEPARAMETERSVALUES_3293', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2431, 1180, 0, 'TXT_DEVICEPARAMETERSVALUES_3294', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(665, 308, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2432, 1181, 1, 'TXT_DEVICEPARAMETERSVALUES_3296', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(666, 308, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2426, 1177, 0, 'TXT_DEVICEPARAMETERSVALUES_3286', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(667, 309, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(668, 309, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(669, 310, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2427, 1178, 0, 'TXT_DEVICEPARAMETERSVALUES_3288', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(670, 310, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2425, 1174, 0, 'TXT_DEVICEPARAMETERSVALUES_3282', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(671, 311, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(672, 311, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(673, 311, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2424, 1174, 1, 'TXT_DEVICEPARAMETERSVALUES_3281', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(674, 311, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(675, 312, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(676, 312, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2423, 1174, 2, 'TXT_DEVICEPARAMETERSVALUES_3280', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(677, 312, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(678, 312, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(679, 313, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(680, 313, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(681, 313, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2422, 1174, 3, 'TXT_DEVICEPARAMETERSVALUES_3279', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(682, 313, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2420, 1173, 0, 'TXT_DEVICEPARAMETERSVALUES_3276', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(683, 314, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(684, 314, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2421, 1173, 1, 'TXT_DEVICEPARAMETERSVALUES_3277', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(685, 314, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2419, 1172, 1, 'TXT_DEVICEPARAMETERSVALUES_3274', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(686, 314, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(687, 315, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2418, 1172, 0, 'TXT_DEVICEPARAMETERSVALUES_3273', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(688, 315, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2417, 1168, 0, 'TXT_DEVICEPARAMETERSVALUES_3268', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(689, 317, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(690, 317, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(691, 317, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(692, 317, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(693, 318, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(694, 318, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(695, 319, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(696, 319, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(697, 319, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(698, 321, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(699, 321, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(700, 321, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2416, 1166, 1, 'TXT_DEVICEPARAMETERSVALUES_3265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(701, 322, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(702, 322, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(703, 322, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2415, 1166, 0, 'TXT_DEVICEPARAMETERSVALUES_3264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(704, 323, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(705, 323, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(706, 323, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(707, 324, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(708, 324, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2387, 1145, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(709, 324, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(710, 327, 0, 'TXT_DEVICEPARAMETERSVALUES_444', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(711, 327, 255, 'TXT_DEVICEPARAMETERSVALUES_445', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(712, 332, 0, 'TXT_DEVICEPARAMETERSVALUES_712', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(713, 332, 1, 'TXT_DEVICEPARAMETERSVALUES_713', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(714, 335, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(715, 335, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(716, 335, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(717, 335, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(718, 336, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2386, 1145, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(719, 336, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2381, 1142, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2382, 1144, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2383, 1144, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2384, 1144, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2385, 1144, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(720, 336, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2377, 1140, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2378, 1140, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2379, 1141, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2380, 1142, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(721, 337, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2376, 1140, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(722, 337, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2375, 1140, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(723, 344, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(724, 344, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(725, 345, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(726, 345, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(727, 346, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(728, 346, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(729, 347, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(730, 347, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(731, 348, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(732, 348, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(733, 349, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2374, 1140, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(734, 349, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2373, 1140, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(735, 351, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(736, 351, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(737, 351, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2414, 1165, 0, 'TXT_DEVICEPARAMETERSVALUES_3262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(738, 351, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(739, 353, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(740, 353, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(741, 353, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(742, 353, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(743, 354, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2371, 1139, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(744, 354, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2366, 1138, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2367, 1138, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2368, 1139, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2369, 1139, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2370, 1139, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(745, 354, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2362, 1135, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2363, 1135, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2364, 1136, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2365, 1136, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(746, 355, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(747, 355, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2361, 1135, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(748, 367, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(749, 367, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(750, 363, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(751, 363, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(752, 364, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(753, 364, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(754, 365, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(755, 365, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2360, 1135, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(756, 366, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(757, 366, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(758, 368, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(759, 368, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2359, 1133, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(760, 370, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(761, 370, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2358, 1133, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(762, 370, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(763, 370, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2357, 1132, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(764, 372, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(765, 372, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(766, 372, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(767, 372, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(768, 373, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(769, 373, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(770, 374, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(771, 374, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(772, 374, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(773, 376, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(774, 376, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(775, 376, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2356, 1131, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(776, 377, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(777, 377, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(778, 377, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2355, 1131, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(779, 378, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(780, 378, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(781, 378, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2354, 1131, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(782, 379, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(783, 379, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(784, 379, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2353, 1131, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(785, 380, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(786, 380, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(787, 380, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(788, 380, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(789, 381, 0, 'TXT_DEVICEPARAMETERSVALUES_328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(790, 381, 1, 'TXT_DEVICEPARAMETERSVALUES_329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(791, 383, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2352, 1131, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(792, 383, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2348, 1130, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2349, 1130, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2413, 1165, 255, 'TXT_DEVICEPARAMETERSVALUES_3261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2351, 1131, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(793, 383, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2344, 1129, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2345, 1129, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2346, 1130, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2347, 1130, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(794, 384, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2343, 1127, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(795, 384, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2342, 1127, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(796, 385, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(797, 385, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(798, 386, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(799, 386, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2341, 1126, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(800, 387, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(801, 387, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(802, 387, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2340, 1126, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(803, 387, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2339, 1126, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(804, 388, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(805, 388, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(806, 388, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2338, 1126, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(807, 388, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2337, 1124, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(808, 389, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(809, 389, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(810, 389, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2336, 1124, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(811, 389, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(812, 390, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(813, 390, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2335, 1123, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(814, 390, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(815, 390, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2334, 1122, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(816, 391, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(817, 391, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2333, 1122, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(818, 395, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(819, 395, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(820, 395, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(821, 395, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(822, 396, 0, 'TXT_DEVICEPARAMETERSVALUES_217', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(823, 396, 1, 'TXT_DEVICEPARAMETERSVALUES_218', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2332, 1122, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(824, 396, 2, 'TXT_DEVICEPARAMETERSVALUES_219', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2331, 1122, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(825, 396, 3, 'TXT_DEVICEPARAMETERSVALUES_220', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2330, 1122, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(826, 399, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2329, 1122, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(827, 399, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2325, 1121, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2326, 1121, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2327, 1121, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2412, 1165, 2, 'TXT_DEVICEPARAMETERSVALUES_3260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(828, 399, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2321, 1118, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2322, 1120, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2323, 1120, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2324, 1121, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(829, 400, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2320, 1118, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(830, 400, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2316, 1117, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2317, 1117, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2318, 1117, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2319, 1117, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(831, 400, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2411, 1165, 1, 'TXT_DEVICEPARAMETERSVALUES_3259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2313, 1114, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2314, 1115, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2315, 1115, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(832, 401, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2311, 1113, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(833, 401, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2310, 1113, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(834, 402, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(835, 402, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(836, 403, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2309, 1113, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(837, 403, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(838, 404, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(839, 404, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2308, 1113, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(840, 404, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(841, 404, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2307, 1113, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(842, 405, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(843, 405, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(844, 405, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2306, 1113, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(845, 405, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2305, 1112, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(846, 406, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(847, 406, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(848, 406, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2304, 1112, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(849, 406, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(850, 407, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(851, 407, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2303, 1112, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(852, 407, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(853, 407, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2302, 1112, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(854, 408, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(855, 408, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(856, 408, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2301, 1111, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(857, 408, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2300, 1111, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(858, 409, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(859, 409, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(860, 409, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2299, 1109, 1, 'TXT_DEVICEPARAMETERSVALUES_3207', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(861, 409, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2298, 1109, 0, 'TXT_DEVICEPARAMETERSVALUES_3206', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(862, 410, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(863, 410, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(864, 410, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2628, 1316, 2, 'TXT_DEVICEPARAMETERSVALUES_3660', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(865, 410, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2627, 1316, 0, 'TXT_DEVICEPARAMETERSVALUES_3659', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(866, 411, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(867, 411, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2626, 1316, 1, 'TXT_DEVICEPARAMETERSVALUES_3658', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(868, 411, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(869, 411, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2295, 1107, 1, 'TXT_DEVICEPARAMETERSVALUES_3201', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(870, 412, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2294, 1107, 0, 'TXT_DEVICEPARAMETERSVALUES_3200', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(871, 412, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(872, 416, 0, 'TXT_DEVICEPARAMETERSVALUES_872', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(873, 416, 1, 'TXT_DEVICEPARAMETERSVALUES_873', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(874, 416, 2, 'TXT_DEVICEPARAMETERSVALUES_874', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(875, 416, 3, 'TXT_DEVICEPARAMETERSVALUES_875', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(876, 417, 0, 'TXT_DEVICEPARAMETERSVALUES_876', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(877, 417, 1, 'TXT_DEVICEPARAMETERSVALUES_877', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(878, 417, 2, 'TXT_DEVICEPARAMETERSVALUES_878', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(879, 417, 3, 'TXT_DEVICEPARAMETERSVALUES_879', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(880, 418, 0, 'TXT_DEVICEPARAMETERSVALUES_880', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(881, 418, 1, 'TXT_DEVICEPARAMETERSVALUES_881', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(882, 418, 2, 'TXT_DEVICEPARAMETERSVALUES_882', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(883, 418, 3, 'TXT_DEVICEPARAMETERSVALUES_883', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(884, 418, 4, 'TXT_DEVICEPARAMETERSVALUES_884', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(885, 418, 5, 'TXT_DEVICEPARAMETERSVALUES_885', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(886, 418, 255, 'TXT_DEVICEPARAMETERSVALUES_886', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(887, 419, 0, 'TXT_DEVICEPARAMETERSVALUES_887', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(888, 419, 1, 'TXT_DEVICEPARAMETERSVALUES_888', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(889, 419, 2, 'TXT_DEVICEPARAMETERSVALUES_889', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(890, 419, 3, 'TXT_DEVICEPARAMETERSVALUES_890', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(891, 419, 4, 'TXT_DEVICEPARAMETERSVALUES_891', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(892, 419, 5, 'TXT_DEVICEPARAMETERSVALUES_892', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(893, 419, 255, 'TXT_DEVICEPARAMETERSVALUES_893', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(894, 422, 0, 'TXT_DEVICEPARAMETERSVALUES_894', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2293, 1103, 1, 'TXT_DEVICEPARAMETERSVALUES_3195', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(895, 422, 1, 'TXT_DEVICEPARAMETERSVALUES_895', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2292, 1103, 0, 'TXT_DEVICEPARAMETERSVALUES_3194', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(896, 422, 2, 'TXT_DEVICEPARAMETERSVALUES_896', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2290, 1102, 1, 'TXT_DEVICEPARAMETERSVALUES_3191', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2291, 1102, 2, 'TXT_DEVICEPARAMETERSVALUES_3192', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(898, 426, 0, 'TXT_DEVICEPARAMETERSVALUES_898', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(899, 426, 1, 'TXT_DEVICEPARAMETERSVALUES_899', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2289, 1102, 0, 'TXT_DEVICEPARAMETERSVALUES_3190', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(900, 426, 2, 'TXT_DEVICEPARAMETERSVALUES_900', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(901, 426, 3, 'TXT_DEVICEPARAMETERSVALUES_901', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(902, 427, 0, 'TXT_DEVICEPARAMETERSVALUES_902', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(903, 427, 1, 'TXT_DEVICEPARAMETERSVALUES_903', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(904, 433, 0, 'TXT_DEVICEPARAMETERSVALUES_872', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(905, 433, 1, 'TXT_DEVICEPARAMETERSVALUES_873', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(906, 433, 2, 'TXT_DEVICEPARAMETERSVALUES_874', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(907, 433, 3, 'TXT_DEVICEPARAMETERSVALUES_875', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(908, 434, 0, 'TXT_DEVICEPARAMETERSVALUES_876', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(909, 434, 1, 'TXT_DEVICEPARAMETERSVALUES_877', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(910, 434, 2, 'TXT_DEVICEPARAMETERSVALUES_878', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(911, 434, 3, 'TXT_DEVICEPARAMETERSVALUES_879', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(912, 435, 0, 'TXT_DEVICEPARAMETERSVALUES_880', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(913, 435, 1, 'TXT_DEVICEPARAMETERSVALUES_881', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(914, 435, 2, 'TXT_DEVICEPARAMETERSVALUES_882', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(915, 435, 3, 'TXT_DEVICEPARAMETERSVALUES_883', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(916, 435, 4, 'TXT_DEVICEPARAMETERSVALUES_884', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(917, 435, 5, 'TXT_DEVICEPARAMETERSVALUES_885', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(918, 435, 255, 'TXT_DEVICEPARAMETERSVALUES_886', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(919, 436, 0, 'TXT_DEVICEPARAMETERSVALUES_887', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(920, 436, 1, 'TXT_DEVICEPARAMETERSVALUES_888', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(921, 436, 2, 'TXT_DEVICEPARAMETERSVALUES_889', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(922, 436, 3, 'TXT_DEVICEPARAMETERSVALUES_890', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(923, 436, 4, 'TXT_DEVICEPARAMETERSVALUES_891', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(924, 436, 5, 'TXT_DEVICEPARAMETERSVALUES_892', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(925, 436, 255, 'TXT_DEVICEPARAMETERSVALUES_893', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(926, 439, 0, 'TXT_DEVICEPARAMETERSVALUES_894', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2288, 1101, 2, 'TXT_DEVICEPARAMETERSVALUES_3188', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(927, 439, 1, 'TXT_DEVICEPARAMETERSVALUES_895', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2287, 1101, 1, 'TXT_DEVICEPARAMETERSVALUES_3187', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(928, 439, 2, 'TXT_DEVICEPARAMETERSVALUES_896', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2285, 1100, 2, 'TXT_DEVICEPARAMETERSVALUES_3184', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2286, 1101, 0, 'TXT_DEVICEPARAMETERSVALUES_3186', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(929, 443, 0, 'TXT_DEVICEPARAMETERSVALUES_898', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(930, 443, 1, 'TXT_DEVICEPARAMETERSVALUES_899', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2284, 1100, 1, 'TXT_DEVICEPARAMETERSVALUES_3183', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(931, 443, 2, 'TXT_DEVICEPARAMETERSVALUES_900', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(932, 443, 3, 'TXT_DEVICEPARAMETERSVALUES_901', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(933, 444, 0, 'TXT_DEVICEPARAMETERSVALUES_902', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(934, 444, 1, 'TXT_DEVICEPARAMETERSVALUES_903', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(935, 445, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(936, 445, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(937, 445, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(938, 445, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(939, 446, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2283, 1100, 0, 'TXT_DEVICEPARAMETERSVALUES_3182', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(940, 446, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2278, 1098, 0, 'TXT_DEVICEPARAMETERSVALUES_3175', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2279, 1098, 1, 'TXT_DEVICEPARAMETERSVALUES_3176', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2280, 1099, 0, 'TXT_DEVICEPARAMETERSVALUES_3178', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2281, 1099, 1, 'TXT_DEVICEPARAMETERSVALUES_3179', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2282, 1099, 2, 'TXT_DEVICEPARAMETERSVALUES_3180', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(941, 446, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2274, 1093, 1, 'TXT_DEVICEPARAMETERSVALUES_3166', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2275, 1093, 2, 'TXT_DEVICEPARAMETERSVALUES_3167', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2276, 1094, 0, 'TXT_DEVICEPARAMETERSVALUES_3169', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2277, 1094, 1, 'TXT_DEVICEPARAMETERSVALUES_3170', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(942, 447, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(943, 447, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2273, 1093, 0, 'TXT_DEVICEPARAMETERSVALUES_3165', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(944, 454, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(945, 454, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(946, 455, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(947, 455, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(948, 456, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(949, 456, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2272, 1091, 2, 'TXT_DEVICEPARAMETERSVALUES_3162', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(950, 457, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(951, 457, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(952, 458, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(953, 458, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(954, 459, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(955, 459, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2271, 1091, 1, 'TXT_DEVICEPARAMETERSVALUES_3161', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(956, 461, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(957, 461, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2270, 1091, 0, 'TXT_DEVICEPARAMETERSVALUES_3160', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(958, 461, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(959, 461, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2269, 1090, 1, 'TXT_DEVICEPARAMETERSVALUES_3158', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(960, 454, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2268, 1090, 0, 'TXT_DEVICEPARAMETERSVALUES_3157', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(961, 463, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(962, 463, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(963, 464, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(964, 464, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(965, 464, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(966, 464, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(967, 465, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2267, 1089, 1, 'TXT_DEVICEPARAMETERSVALUES_3155', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(968, 465, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2263, 1086, 1, 'TXT_DEVICEPARAMETERSVALUES_3148', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2264, 1086, 2, 'TXT_DEVICEPARAMETERSVALUES_3149', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2265, 1086, 3, 'TXT_DEVICEPARAMETERSVALUES_3150', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2266, 1089, 0, 'TXT_DEVICEPARAMETERSVALUES_3154', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(969, 465, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2259, 1084, 0, 'TXT_DEVICEPARAMETERSVALUES_3142', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2260, 1084, 1, 'TXT_DEVICEPARAMETERSVALUES_3143', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2261, 1084, 2, 'TXT_DEVICEPARAMETERSVALUES_3144', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2262, 1086, 0, 'TXT_DEVICEPARAMETERSVALUES_3147', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(970, 466, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2258, 1079, 3, 'TXT_DEVICEPARAMETERSVALUES_3136', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(971, 466, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2257, 1079, 2, 'TXT_DEVICEPARAMETERSVALUES_3135', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(972, 473, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(973, 473, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(974, 473, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2256, 1079, 1, 'TXT_DEVICEPARAMETERSVALUES_3134', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(975, 474, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(976, 474, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(977, 475, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(978, 475, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(979, 476, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(980, 476, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(981, 477, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(982, 477, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(983, 478, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2255, 1079, 0, 'TXT_DEVICEPARAMETERSVALUES_3133', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(984, 478, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2254, 1076, 1, 'TXT_DEVICEPARAMETERSVALUES_3129', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(985, 480, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(986, 480, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(987, 480, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2253, 1076, 0, 'TXT_DEVICEPARAMETERSVALUES_3128', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(988, 480, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(989, 482, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(990, 482, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(991, 483, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(992, 483, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(993, 483, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(994, 483, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(995, 484, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(996, 484, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(997, 485, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(998, 485, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(999, 485, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1000, 487, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1001, 487, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2252, 1074, 255, 'TXT_DEVICEPARAMETERSVALUES_3125', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1002, 487, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1003, 488, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1004, 488, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2251, 1074, 0, 'TXT_DEVICEPARAMETERSVALUES_3124', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1005, 488, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1006, 489, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1007, 489, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2246, 1072, 1, 'TXT_DEVICEPARAMETERSVALUES_3117', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1008, 489, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2245, 1072, 0, 'TXT_DEVICEPARAMETERSVALUES_3116', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1009, 490, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1010, 490, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1011, 490, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2247, 1072, 2, 'TXT_DEVICEPARAMETERSVALUES_3118', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1012, 491, 0, 'TXT_DEVICEPARAMETERSVALUES_1012', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1013, 491, 1, 'TXT_DEVICEPARAMETERSVALUES_1013', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1014, 492, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1015, 492, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1016, 492, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1017, 492, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1018, 493, 0, 'TXT_DEVICEPARAMETERSVALUES_1018', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2248, 1072, 3, 'TXT_DEVICEPARAMETERSVALUES_3119', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1019, 493, 1, 'TXT_DEVICEPARAMETERSVALUES_1019', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2229, 1065, 1, 'TXT_DEVICEPARAMETERSVALUES_3068', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2230, 1065, 2, 'TXT_DEVICEPARAMETERSVALUES_3069', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2231, 1065, 3, 'TXT_DEVICEPARAMETERSVALUES_3070', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1022, 496, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2228, 1065, 0, 'TXT_DEVICEPARAMETERSVALUES_3067', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1023, 496, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2223, 1059, 0, 'TXT_DEVICEPARAMETERSVALUES_3056', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2224, 1063, 0, 'TXT_DEVICEPARAMETERSVALUES_3061', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2225, 1063, 1, 'TXT_DEVICEPARAMETERSVALUES_3062', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2226, 1064, 0, 'TXT_DEVICEPARAMETERSVALUES_3064', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2227, 1064, 1, 'TXT_DEVICEPARAMETERSVALUES_3065', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1024, 496, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2219, 1054, 0, 'TXT_DEVICEPARAMETERSVALUES_3047', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2220, 1056, 0, 'TXT_DEVICEPARAMETERSVALUES_3050', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2221, 1057, 0, 'TXT_DEVICEPARAMETERSVALUES_3052', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2222, 1057, 1, 'TXT_DEVICEPARAMETERSVALUES_3053', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1025, 497, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2218, 1053, 255, 'TXT_DEVICEPARAMETERSVALUES_3045', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1026, 497, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2214, 1052, 1, 'TXT_DEVICEPARAMETERSVALUES_3037', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2215, 1053, 0, 'TXT_DEVICEPARAMETERSVALUES_3042', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2216, 1053, 1, 'TXT_DEVICEPARAMETERSVALUES_3043', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2217, 1053, 2, 'TXT_DEVICEPARAMETERSVALUES_3044', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1027, 497, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2210, 1050, 0, 'TXT_DEVICEPARAMETERSVALUES_3031', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2211, 1051, 0, 'TXT_DEVICEPARAMETERSVALUES_3033', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2212, 1051, 1, 'TXT_DEVICEPARAMETERSVALUES_3034', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2213, 1052, 0, 'TXT_DEVICEPARAMETERSVALUES_3036', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1028, 498, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2209, 1049, 0, 'TXT_DEVICEPARAMETERSVALUES_3029', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1029, 498, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2208, 1047, 2, 'TXT_DEVICEPARAMETERSVALUES_3026', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1030, 499, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1031, 499, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1032, 500, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1033, 500, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2207, 1047, 1, 'TXT_DEVICEPARAMETERSVALUES_3025', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1034, 501, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2206, 1047, 0, 'TXT_DEVICEPARAMETERSVALUES_3024', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1035, 501, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1036, 502, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1037, 502, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2205, 1044, 3, 'TXT_DEVICEPARAMETERSVALUES_3020', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1038, 502, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1039, 502, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2204, 1044, 2, 'TXT_DEVICEPARAMETERSVALUES_3019', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1040, 503, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1041, 503, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1042, 503, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2203, 1044, 1, 'TXT_DEVICEPARAMETERSVALUES_3018', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1043, 503, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2202, 1044, 0, 'TXT_DEVICEPARAMETERSVALUES_3017', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1044, 504, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1045, 504, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1046, 504, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2201, 1043, 1, 'TXT_DEVICEPARAMETERSVALUES_3015', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1047, 504, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1048, 505, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1049, 505, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2200, 1043, 0, 'TXT_DEVICEPARAMETERSVALUES_3014', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1050, 505, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1051, 505, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2199, 1042, 1, 'TXT_DEVICEPARAMETERSVALUES_3012', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1052, 507, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1053, 507, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1054, 507, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2198, 1042, 0, 'TXT_DEVICEPARAMETERSVALUES_3011', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1055, 507, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2197, 1038, 0, 'TXT_DEVICEPARAMETERSVALUES_3006', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1056, 508, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1057, 508, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1058, 508, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2196, 1036, 1, 'TXT_DEVICEPARAMETERSVALUES_3003', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1059, 508, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2195, 1036, 0, 'TXT_DEVICEPARAMETERSVALUES_3002', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1060, 509, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1061, 509, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1062, 509, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2194, 1035, 4, 'TXT_DEVICEPARAMETERSVALUES_3000', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1063, 509, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1064, 510, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1065, 510, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2193, 1035, 3, 'TXT_DEVICEPARAMETERSVALUES_2999', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1066, 510, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1067, 510, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2192, 1035, 2, 'TXT_DEVICEPARAMETERSVALUES_2998', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1068, 511, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1069, 511, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1070, 511, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1071, 511, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1072, 512, 0, 'TXT_DEVICEPARAMETERSVALUES_1072', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2190, 1035, 0, 'TXT_DEVICEPARAMETERSVALUES_2996', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2191, 1035, 1, 'TXT_DEVICEPARAMETERSVALUES_2997', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1073, 512, 1, 'TXT_DEVICEPARAMETERSVALUES_1073', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2187, 1034, 1, 'TXT_DEVICEPARAMETERSVALUES_2992', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2188, 1034, 2, 'TXT_DEVICEPARAMETERSVALUES_2993', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2189, 1034, 255, 'TXT_DEVICEPARAMETERSVALUES_2994', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1074, 514, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2186, 1034, 0, 'TXT_DEVICEPARAMETERSVALUES_2991', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1075, 514, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2182, 1031, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2183, 1031, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2184, 1033, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2185, 1033, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1076, 514, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2178, 1029, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2179, 1029, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2180, 1031, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2181, 1031, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1077, 515, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2177, 1028, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1078, 515, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2176, 1028, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1079, 516, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1080, 516, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1081, 517, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1082, 517, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2175, 1027, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1083, 518, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1084, 518, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2174, 1027, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1085, 519, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1086, 519, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1087, 519, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2173, 1026, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1088, 519, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2172, 1026, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1089, 520, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1090, 520, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1091, 520, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2171, 1025, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1092, 520, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2170, 1025, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1093, 521, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1094, 521, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1095, 521, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2169, 1024, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1096, 521, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2168, 1024, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1097, 522, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1098, 522, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1099, 522, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2167, 1024, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1100, 522, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2166, 1017, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1101, 526, 0, 'TXT_DEVICEPARAMETERSVALUES_872', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1102, 526, 1, 'TXT_DEVICEPARAMETERSVALUES_873', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1103, 526, 2, 'TXT_DEVICEPARAMETERSVALUES_874', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1104, 526, 3, 'TXT_DEVICEPARAMETERSVALUES_875', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1105, 527, 0, 'TXT_DEVICEPARAMETERSVALUES_876', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1106, 527, 1, 'TXT_DEVICEPARAMETERSVALUES_877', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1107, 527, 2, 'TXT_DEVICEPARAMETERSVALUES_878', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1108, 527, 3, 'TXT_DEVICEPARAMETERSVALUES_879', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1109, 528, 0, 'TXT_DEVICEPARAMETERSVALUES_880', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1110, 528, 1, 'TXT_DEVICEPARAMETERSVALUES_881', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1111, 528, 2, 'TXT_DEVICEPARAMETERSVALUES_882', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1112, 528, 3, 'TXT_DEVICEPARAMETERSVALUES_883', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1113, 528, 4, 'TXT_DEVICEPARAMETERSVALUES_884', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1114, 528, 5, 'TXT_DEVICEPARAMETERSVALUES_885', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1115, 528, 255, 'TXT_DEVICEPARAMETERSVALUES_886', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1116, 529, 0, 'TXT_DEVICEPARAMETERSVALUES_887', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1117, 529, 1, 'TXT_DEVICEPARAMETERSVALUES_888', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1118, 529, 2, 'TXT_DEVICEPARAMETERSVALUES_889', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1119, 529, 3, 'TXT_DEVICEPARAMETERSVALUES_890', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1120, 529, 4, 'TXT_DEVICEPARAMETERSVALUES_891', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1121, 529, 5, 'TXT_DEVICEPARAMETERSVALUES_892', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1122, 529, 255, 'TXT_DEVICEPARAMETERSVALUES_893', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1123, 532, 0, 'TXT_DEVICEPARAMETERSVALUES_894', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2165, 1017, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1124, 532, 1, 'TXT_DEVICEPARAMETERSVALUES_895', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2164, 1016, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1125, 532, 2, 'TXT_DEVICEPARAMETERSVALUES_896', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2162, 1016, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2163, 1016, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1126, 536, 0, 'TXT_DEVICEPARAMETERSVALUES_898', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1127, 536, 1, 'TXT_DEVICEPARAMETERSVALUES_899', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2161, 1015, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1128, 536, 2, 'TXT_DEVICEPARAMETERSVALUES_900', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2160, 1015, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1129, 536, 3, 'TXT_DEVICEPARAMETERSVALUES_901', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1130, 537, 0, 'TXT_DEVICEPARAMETERSVALUES_902', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1131, 537, 1, 'TXT_DEVICEPARAMETERSVALUES_903', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1132, 540, 0, 'TXT_DEVICEPARAMETERSVALUES_872', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1133, 540, 1, 'TXT_DEVICEPARAMETERSVALUES_873', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1134, 540, 2, 'TXT_DEVICEPARAMETERSVALUES_874', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1135, 540, 3, 'TXT_DEVICEPARAMETERSVALUES_875', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1136, 541, 0, 'TXT_DEVICEPARAMETERSVALUES_876', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1137, 541, 1, 'TXT_DEVICEPARAMETERSVALUES_877', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1138, 541, 2, 'TXT_DEVICEPARAMETERSVALUES_878', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1139, 541, 3, 'TXT_DEVICEPARAMETERSVALUES_879', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1140, 542, 0, 'TXT_DEVICEPARAMETERSVALUES_880', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1141, 542, 1, 'TXT_DEVICEPARAMETERSVALUES_881', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1142, 542, 2, 'TXT_DEVICEPARAMETERSVALUES_882', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1143, 542, 3, 'TXT_DEVICEPARAMETERSVALUES_883', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1144, 542, 4, 'TXT_DEVICEPARAMETERSVALUES_884', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1145, 542, 5, 'TXT_DEVICEPARAMETERSVALUES_885', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1146, 542, 255, 'TXT_DEVICEPARAMETERSVALUES_886', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1147, 543, 0, 'TXT_DEVICEPARAMETERSVALUES_887', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1148, 543, 1, 'TXT_DEVICEPARAMETERSVALUES_888', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1149, 543, 2, 'TXT_DEVICEPARAMETERSVALUES_889', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1150, 543, 3, 'TXT_DEVICEPARAMETERSVALUES_890', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1151, 543, 4, 'TXT_DEVICEPARAMETERSVALUES_891', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1152, 543, 5, 'TXT_DEVICEPARAMETERSVALUES_892', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1153, 543, 255, 'TXT_DEVICEPARAMETERSVALUES_893', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1154, 546, 0, 'TXT_DEVICEPARAMETERSVALUES_894', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2159, 1015, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1155, 546, 1, 'TXT_DEVICEPARAMETERSVALUES_895', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2158, 1015, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1156, 546, 2, 'TXT_DEVICEPARAMETERSVALUES_896', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2156, 1014, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2157, 1014, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1157, 550, 0, 'TXT_DEVICEPARAMETERSVALUES_898', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1158, 550, 1, 'TXT_DEVICEPARAMETERSVALUES_899', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2155, 1012, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1159, 550, 2, 'TXT_DEVICEPARAMETERSVALUES_900', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1160, 550, 3, 'TXT_DEVICEPARAMETERSVALUES_901', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1161, 551, 0, 'TXT_DEVICEPARAMETERSVALUES_902', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1162, 551, 1, 'TXT_DEVICEPARAMETERSVALUES_903', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1163, 554, 0, 'TXT_DEVICEPARAMETERSVALUES_872', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1164, 554, 1, 'TXT_DEVICEPARAMETERSVALUES_873', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1165, 554, 2, 'TXT_DEVICEPARAMETERSVALUES_874', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1166, 554, 3, 'TXT_DEVICEPARAMETERSVALUES_875', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1167, 555, 0, 'TXT_DEVICEPARAMETERSVALUES_876', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1168, 555, 1, 'TXT_DEVICEPARAMETERSVALUES_877', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1169, 555, 2, 'TXT_DEVICEPARAMETERSVALUES_878', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1170, 555, 3, 'TXT_DEVICEPARAMETERSVALUES_879', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1171, 556, 0, 'TXT_DEVICEPARAMETERSVALUES_880', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1172, 556, 1, 'TXT_DEVICEPARAMETERSVALUES_881', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1173, 556, 2, 'TXT_DEVICEPARAMETERSVALUES_882', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1174, 556, 3, 'TXT_DEVICEPARAMETERSVALUES_883', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1175, 556, 4, 'TXT_DEVICEPARAMETERSVALUES_884', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1176, 556, 5, 'TXT_DEVICEPARAMETERSVALUES_885', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1177, 556, 255, 'TXT_DEVICEPARAMETERSVALUES_886', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1178, 557, 0, 'TXT_DEVICEPARAMETERSVALUES_887', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1179, 557, 1, 'TXT_DEVICEPARAMETERSVALUES_888', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1180, 557, 2, 'TXT_DEVICEPARAMETERSVALUES_889', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1181, 557, 3, 'TXT_DEVICEPARAMETERSVALUES_890', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1182, 557, 4, 'TXT_DEVICEPARAMETERSVALUES_891', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1183, 557, 5, 'TXT_DEVICEPARAMETERSVALUES_892', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1184, 557, 255, 'TXT_DEVICEPARAMETERSVALUES_893', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1185, 560, 0, 'TXT_DEVICEPARAMETERSVALUES_894', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2154, 1012, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1186, 560, 1, 'TXT_DEVICEPARAMETERSVALUES_895', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2153, 1012, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1187, 560, 2, 'TXT_DEVICEPARAMETERSVALUES_896', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2151, 1010, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2152, 1012, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1188, 564, 0, 'TXT_DEVICEPARAMETERSVALUES_898', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1189, 564, 1, 'TXT_DEVICEPARAMETERSVALUES_899', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2150, 1010, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1190, 564, 2, 'TXT_DEVICEPARAMETERSVALUES_900', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1191, 564, 3, 'TXT_DEVICEPARAMETERSVALUES_901', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1192, 565, 0, 'TXT_DEVICEPARAMETERSVALUES_902', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1193, 565, 1, 'TXT_DEVICEPARAMETERSVALUES_903', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1194, 568, 0, 'TXT_DEVICEPARAMETERSVALUES_872', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1195, 568, 1, 'TXT_DEVICEPARAMETERSVALUES_873', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1196, 568, 2, 'TXT_DEVICEPARAMETERSVALUES_874', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1197, 568, 3, 'TXT_DEVICEPARAMETERSVALUES_875', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1198, 569, 0, 'TXT_DEVICEPARAMETERSVALUES_876', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1199, 569, 1, 'TXT_DEVICEPARAMETERSVALUES_877', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1200, 569, 2, 'TXT_DEVICEPARAMETERSVALUES_878', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1201, 569, 3, 'TXT_DEVICEPARAMETERSVALUES_879', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1202, 570, 0, 'TXT_DEVICEPARAMETERSVALUES_880', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1203, 570, 1, 'TXT_DEVICEPARAMETERSVALUES_881', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1204, 570, 2, 'TXT_DEVICEPARAMETERSVALUES_882', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1205, 570, 3, 'TXT_DEVICEPARAMETERSVALUES_883', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1206, 570, 4, 'TXT_DEVICEPARAMETERSVALUES_884', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1207, 570, 5, 'TXT_DEVICEPARAMETERSVALUES_885', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1208, 570, 255, 'TXT_DEVICEPARAMETERSVALUES_886', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1209, 571, 0, 'TXT_DEVICEPARAMETERSVALUES_887', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1210, 571, 1, 'TXT_DEVICEPARAMETERSVALUES_888', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1211, 571, 2, 'TXT_DEVICEPARAMETERSVALUES_889', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1212, 571, 3, 'TXT_DEVICEPARAMETERSVALUES_890', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1213, 571, 4, 'TXT_DEVICEPARAMETERSVALUES_891', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1214, 571, 5, 'TXT_DEVICEPARAMETERSVALUES_892', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1215, 571, 255, 'TXT_DEVICEPARAMETERSVALUES_893', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1216, 574, 0, 'TXT_DEVICEPARAMETERSVALUES_894', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2149, 1009, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1217, 574, 1, 'TXT_DEVICEPARAMETERSVALUES_895', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2148, 1009, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1218, 574, 2, 'TXT_DEVICEPARAMETERSVALUES_896', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2146, 1008, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2147, 1008, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1219, 578, 0, 'TXT_DEVICEPARAMETERSVALUES_898', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1220, 578, 1, 'TXT_DEVICEPARAMETERSVALUES_899', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2145, 1007, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1221, 578, 2, 'TXT_DEVICEPARAMETERSVALUES_900', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2144, 1007, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1222, 578, 3, 'TXT_DEVICEPARAMETERSVALUES_901', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1223, 579, 0, 'TXT_DEVICEPARAMETERSVALUES_902', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1224, 579, 1, 'TXT_DEVICEPARAMETERSVALUES_903', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1225, 422, 3, 'TXT_DEVICEPARAMETERSVALUES_1225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2143, 1006, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1226, 439, 3, 'TXT_DEVICEPARAMETERSVALUES_1225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2142, 1006, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1227, 532, 3, 'TXT_DEVICEPARAMETERSVALUES_1225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2141, 1005, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1228, 546, 3, 'TXT_DEVICEPARAMETERSVALUES_1225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2140, 1005, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1229, 560, 3, 'TXT_DEVICEPARAMETERSVALUES_1225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2139, 1005, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1230, 574, 3, 'TXT_DEVICEPARAMETERSVALUES_1225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2138, 998, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1231, 580, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1232, 580, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1233, 580, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1234, 580, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1235, 581, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2137, 998, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1236, 581, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2133, 996, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2134, 997, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2135, 997, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2136, 997, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1237, 581, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2129, 995, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2130, 996, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2131, 996, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2132, 996, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1238, 582, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2128, 995, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1239, 582, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2127, 993, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1240, 589, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1241, 589, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1242, 589, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2126, 993, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1243, 590, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1244, 590, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1245, 591, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1246, 591, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1247, 592, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1248, 592, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1249, 593, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1250, 593, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1251, 594, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2125, 993, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1252, 594, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2124, 993, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1253, 596, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1254, 596, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1255, 596, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2123, 991, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1256, 596, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1257, 598, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1258, 598, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1259, 600, 0, 'TXT_DEVICEPARAMETERSVALUES_2462', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1260, 600, 1, 'TXT_DEVICEPARAMETERSVALUES_2463', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1261, 601, 0, 'TXT_DEVICEPARAMETERSVALUES_2465', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1262, 601, 1, 'TXT_DEVICEPARAMETERSVALUES_2466', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1263, 605, 0, 'TXT_DEVICEPARAMETERSVALUES_2471', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1264, 605, 1, 'TXT_DEVICEPARAMETERSVALUES_2472', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1265, 605, 2, 'TXT_DEVICEPARAMETERSVALUES_2473', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1266, 605, 3, 'TXT_DEVICEPARAMETERSVALUES_2474', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1267, 606, 0, 'TXT_DEVICEPARAMETERSVALUES_2476', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1268, 606, 1, 'TXT_DEVICEPARAMETERSVALUES_2477', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1269, 606, 2, 'TXT_DEVICEPARAMETERSVALUES_2478', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1270, 606, 3, 'TXT_DEVICEPARAMETERSVALUES_2479', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1271, 613, 0, 'TXT_DEVICEPARAMETERSVALUES_2487', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1272, 613, 1, 'TXT_DEVICEPARAMETERSVALUES_2488', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1273, 613, 2, 'TXT_DEVICEPARAMETERSVALUES_2489', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1274, 614, 0, 'TXT_DEVICEPARAMETERSVALUES_2491', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1275, 614, 1, 'TXT_DEVICEPARAMETERSVALUES_2492', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1276, 614, 2, 'TXT_DEVICEPARAMETERSVALUES_2493', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1277, 615, 0, 'TXT_DEVICEPARAMETERSVALUES_2495', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1278, 615, 1, 'TXT_DEVICEPARAMETERSVALUES_2496', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1279, 615, 2, 'TXT_DEVICEPARAMETERSVALUES_2497', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1280, 615, 3, 'TXT_DEVICEPARAMETERSVALUES_2498', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1281, 615, 4, 'TXT_DEVICEPARAMETERSVALUES_2499', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1282, 616, 0, 'TXT_DEVICEPARAMETERSVALUES_2501', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1283, 616, 1, 'TXT_DEVICEPARAMETERSVALUES_2502', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1284, 616, 2, 'TXT_DEVICEPARAMETERSVALUES_2503', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1285, 616, 3, 'TXT_DEVICEPARAMETERSVALUES_2504', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1286, 616, 4, 'TXT_DEVICEPARAMETERSVALUES_2505', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1287, 617, 0, 'TXT_DEVICEPARAMETERSVALUES_2507', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1288, 617, 1, 'TXT_DEVICEPARAMETERSVALUES_2508', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1289, 617, 2, 'TXT_DEVICEPARAMETERSVALUES_2509', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1290, 617, 3, 'TXT_DEVICEPARAMETERSVALUES_2510', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1291, 617, 4, 'TXT_DEVICEPARAMETERSVALUES_2511', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1292, 618, 0, 'TXT_DEVICEPARAMETERSVALUES_2513', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1293, 618, 1, 'TXT_DEVICEPARAMETERSVALUES_2514', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1294, 618, 2, 'TXT_DEVICEPARAMETERSVALUES_2515', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1295, 618, 3, 'TXT_DEVICEPARAMETERSVALUES_2516', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1296, 618, 4, 'TXT_DEVICEPARAMETERSVALUES_2517', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1297, 620, 1, 'TXT_DEVICEPARAMETERSVALUES_2520', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1298, 620, 2, 'TXT_DEVICEPARAMETERSVALUES_2521', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1299, 620, 255, 'TXT_DEVICEPARAMETERSVALUES_2522', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1300, 621, 0, 'TXT_DEVICEPARAMETERSVALUES_2524', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1301, 621, 1, 'TXT_DEVICEPARAMETERSVALUES_2525', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1302, 623, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1303, 623, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1304, 627, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1305, 627, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1306, 627, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1307, 627, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1308, 628, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1309, 628, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1310, 628, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1311, 628, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1312, 628, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1313, 628, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1314, 628, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1315, 629, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1316, 630, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1317, 630, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1318, 633, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1319, 633, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1320, 633, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1321, 633, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1322, 634, 0, 'TXT_DEVICEPARAMETERSVALUES_2559', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1323, 634, 1, 'TXT_DEVICEPARAMETERSVALUES_2560', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1324, 634, 2, 'TXT_DEVICEPARAMETERSVALUES_2561', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1325, 634, 3, 'TXT_DEVICEPARAMETERSVALUES_2562', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1326, 635, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1327, 635, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1328, 636, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1329, 636, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1330, 636, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1331, 636, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1332, 637, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2122, 991, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1333, 637, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2117, 988, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2118, 989, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2119, 989, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2120, 990, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2121, 990, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1334, 637, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2113, 986, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2114, 987, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2115, 987, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2116, 988, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1335, 638, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2112, 986, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1336, 638, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2111, 986, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1337, 645, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1338, 645, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1339, 645, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2110, 979, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1340, 646, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1341, 646, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1342, 647, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1343, 647, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1344, 648, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1345, 648, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1346, 649, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1347, 649, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1348, 650, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2109, 979, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1349, 650, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2108, 978, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1350, 652, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1351, 652, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1352, 652, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2107, 978, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1353, 652, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2106, 978, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1354, 654, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1355, 654, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1356, 655, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1357, 655, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1358, 655, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1359, 655, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1360, 656, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2105, 977, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1361, 656, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2101, 976, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2102, 977, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2103, 977, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2104, 977, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1362, 656, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2097, 974, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2098, 974, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2099, 974, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2100, 976, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1363, 657, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2096, 974, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1364, 657, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2095, 972, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1365, 664, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1366, 664, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1367, 664, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2094, 972, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1368, 665, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1369, 665, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1370, 666, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1371, 666, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1372, 667, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1373, 667, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1374, 668, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1375, 668, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1376, 669, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2093, 971, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1377, 669, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2092, 971, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1378, 671, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1379, 671, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1380, 671, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2091, 970, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1381, 671, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1382, 673, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1383, 673, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1384, 674, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1385, 674, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1386, 674, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1387, 674, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1388, 675, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2090, 970, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1389, 675, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2085, 967, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2086, 968, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2087, 968, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2088, 969, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2089, 969, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1390, 675, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2081, 960, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2082, 960, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2083, 967, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2084, 967, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1391, 676, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2080, 959, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1392, 676, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2079, 959, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1393, 683, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1394, 683, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1395, 683, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2078, 959, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1396, 684, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1397, 684, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1398, 685, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1399, 685, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1400, 686, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1401, 686, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1402, 687, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1403, 687, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1404, 688, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2077, 958, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1405, 688, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2076, 958, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1406, 690, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1407, 690, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1408, 690, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2075, 958, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1409, 690, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2074, 958, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1410, 692, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1411, 692, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1412, 693, 255, 'TXT_DEVICEPARAMETERSVALUES_62', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1413, 693, 0, 'TXT_DEVICEPARAMETERSVALUES_63', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1414, 693, 1, 'TXT_DEVICEPARAMETERSVALUES_64', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1415, 693, 2, 'TXT_DEVICEPARAMETERSVALUES_65', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1416, 694, 0, 'TXT_DEVICEPARAMETERSVALUES_66', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2073, 956, 9, 'TXT_DEVICEPARAMETERSVALUES_2771', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1417, 694, 1, 'TXT_DEVICEPARAMETERSVALUES_67', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2069, 956, 5, 'TXT_DEVICEPARAMETERSVALUES_2767', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2070, 956, 6, 'TXT_DEVICEPARAMETERSVALUES_2768', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2071, 956, 7, 'TXT_DEVICEPARAMETERSVALUES_2769', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2072, 956, 8, 'TXT_DEVICEPARAMETERSVALUES_2770', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1418, 694, 2, 'TXT_DEVICEPARAMETERSVALUES_68', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2065, 956, 1, 'TXT_DEVICEPARAMETERSVALUES_2763', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2066, 956, 2, 'TXT_DEVICEPARAMETERSVALUES_2764', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2067, 956, 3, 'TXT_DEVICEPARAMETERSVALUES_2765', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2068, 956, 4, 'TXT_DEVICEPARAMETERSVALUES_2766', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1419, 695, 0, 'TXT_DEVICEPARAMETERSVALUES_69', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2064, 956, 0, 'TXT_DEVICEPARAMETERSVALUES_2762', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1420, 695, 1, 'TXT_DEVICEPARAMETERSVALUES_70', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2063, 955, 8, 'TXT_DEVICEPARAMETERSVALUES_2760', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1421, 702, 0, 'TXT_DEVICEPARAMETERSVALUES_71', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1422, 702, 1, 'TXT_DEVICEPARAMETERSVALUES_72', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1423, 702, 2, 'TXT_DEVICEPARAMETERSVALUES_960', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1424, 703, 0, 'TXT_DEVICEPARAMETERSVALUES_73', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1425, 703, 1, 'TXT_DEVICEPARAMETERSVALUES_74', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1426, 704, 0, 'TXT_DEVICEPARAMETERSVALUES_75', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1427, 704, 1, 'TXT_DEVICEPARAMETERSVALUES_76', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2062, 955, 7, 'TXT_DEVICEPARAMETERSVALUES_2759', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1428, 705, 0, 'TXT_DEVICEPARAMETERSVALUES_77', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1429, 705, 1, 'TXT_DEVICEPARAMETERSVALUES_78', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1430, 706, 0, 'TXT_DEVICEPARAMETERSVALUES_79', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1431, 706, 1, 'TXT_DEVICEPARAMETERSVALUES_80', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1432, 707, 0, 'TXT_DEVICEPARAMETERSVALUES_81', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1433, 707, 1, 'TXT_DEVICEPARAMETERSVALUES_82', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2061, 955, 6, 'TXT_DEVICEPARAMETERSVALUES_2758', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1434, 709, 0, 'TXT_DEVICEPARAMETERSVALUES_83', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1435, 709, 2, 'TXT_DEVICEPARAMETERSVALUES_84', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2060, 955, 5, 'TXT_DEVICEPARAMETERSVALUES_2757', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1436, 709, 1, 'TXT_DEVICEPARAMETERSVALUES_85', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1437, 709, 3, 'TXT_DEVICEPARAMETERSVALUES_86', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2059, 955, 4, 'TXT_DEVICEPARAMETERSVALUES_2756', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1438, 711, 0, 'TXT_DEVICEPARAMETERSVALUES_961', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1439, 711, 1, 'TXT_DEVICEPARAMETERSVALUES_962', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1440, 712, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1441, 712, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1442, 712, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1443, 712, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1444, 713, 0, 'TXT_DEVICEPARAMETERSVALUES_1018', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2057, 955, 2, 'TXT_DEVICEPARAMETERSVALUES_2754', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2058, 955, 3, 'TXT_DEVICEPARAMETERSVALUES_2755', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1445, 713, 1, 'TXT_DEVICEPARAMETERSVALUES_1019', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2054, 954, 9, 'TXT_DEVICEPARAMETERSVALUES_2750', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2055, 955, 0, 'TXT_DEVICEPARAMETERSVALUES_2752', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2056, 955, 1, 'TXT_DEVICEPARAMETERSVALUES_2753', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1446, 716, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2053, 954, 8, 'TXT_DEVICEPARAMETERSVALUES_2749', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1447, 716, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2049, 954, 4, 'TXT_DEVICEPARAMETERSVALUES_2745', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2050, 954, 5, 'TXT_DEVICEPARAMETERSVALUES_2746', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2051, 954, 6, 'TXT_DEVICEPARAMETERSVALUES_2747', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2052, 954, 7, 'TXT_DEVICEPARAMETERSVALUES_2748', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1448, 716, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2045, 954, 0, 'TXT_DEVICEPARAMETERSVALUES_2741', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2046, 954, 1, 'TXT_DEVICEPARAMETERSVALUES_2742', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2047, 954, 2, 'TXT_DEVICEPARAMETERSVALUES_2743', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2048, 954, 3, 'TXT_DEVICEPARAMETERSVALUES_2744', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1449, 717, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2044, 952, 6, 'TXT_DEVICEPARAMETERSVALUES_2738', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1450, 717, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2040, 952, 2, 'TXT_DEVICEPARAMETERSVALUES_2734', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2041, 952, 3, 'TXT_DEVICEPARAMETERSVALUES_2735', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2042, 952, 4, 'TXT_DEVICEPARAMETERSVALUES_2736', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2043, 952, 5, 'TXT_DEVICEPARAMETERSVALUES_2737', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1451, 717, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2036, 949, 0, 'TXT_DEVICEPARAMETERSVALUES_2727', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2037, 949, 1, 'TXT_DEVICEPARAMETERSVALUES_2728', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2038, 952, 0, 'TXT_DEVICEPARAMETERSVALUES_2732', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2039, 952, 1, 'TXT_DEVICEPARAMETERSVALUES_2733', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1452, 718, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2035, 948, 65535, 'TXT_DEVICEPARAMETERSVALUES_2725', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1453, 718, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2034, 947, 255, 'TXT_DEVICEPARAMETERSVALUES_2723', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1454, 719, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1455, 719, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1456, 720, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1457, 720, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2033, 942, 3, 'TXT_DEVICEPARAMETERSVALUES_2717', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1458, 721, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1459, 721, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2032, 942, 2, 'TXT_DEVICEPARAMETERSVALUES_2716', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1460, 722, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1461, 722, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1462, 722, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2031, 942, 1, 'TXT_DEVICEPARAMETERSVALUES_2715', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1463, 722, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2030, 942, 0, 'TXT_DEVICEPARAMETERSVALUES_2714', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1464, 723, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1465, 723, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1466, 723, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2029, 940, 1, 'TXT_DEVICEPARAMETERSVALUES_2711', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1467, 723, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2028, 940, 0, 'TXT_DEVICEPARAMETERSVALUES_2710', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1468, 724, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1469, 724, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1470, 724, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2027, 939, 1, 'TXT_DEVICEPARAMETERSVALUES_2708', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1471, 724, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2026, 939, 0, 'TXT_DEVICEPARAMETERSVALUES_2707', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1472, 725, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1473, 725, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1474, 725, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2025, 938, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1475, 725, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1476, 727, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1477, 727, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2024, 938, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1478, 727, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1479, 727, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2023, 937, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1480, 728, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1481, 728, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1482, 728, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2022, 937, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1483, 728, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1484, 729, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1485, 729, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2021, 937, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1486, 729, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1487, 729, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2020, 937, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1488, 730, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1489, 730, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1490, 730, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2019, 935, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1491, 730, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2018, 935, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1492, 731, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1493, 731, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1494, 731, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1495, 731, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1496, 732, 0, 'TXT_DEVICEPARAMETERSVALUES_1018', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2016, 933, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2017, 934, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1497, 732, 1, 'TXT_DEVICEPARAMETERSVALUES_1019', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2013, 933, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2014, 933, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2015, 933, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1498, 735, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2012, 933, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1499, 735, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2008, 932, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2009, 932, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2010, 933, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2011, 933, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1500, 735, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2004, 931, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2005, 931, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2006, 932, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2007, 932, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1501, 736, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2003, 929, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1502, 736, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1999, 928, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2000, 928, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2001, 928, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2002, 929, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1503, 736, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1995, 925, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1996, 926, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1997, 926, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1998, 928, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1504, 737, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1994, 924, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1505, 737, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1993, 924, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1506, 738, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1507, 738, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1508, 739, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1509, 739, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1992, 924, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1510, 740, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1991, 924, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1511, 740, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1512, 741, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1513, 741, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1990, 924, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1514, 741, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1515, 741, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1989, 924, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1516, 742, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1517, 742, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1518, 742, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1988, 924, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1519, 742, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1987, 923, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1520, 743, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1521, 743, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1522, 743, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1986, 923, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1523, 743, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1524, 744, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1525, 744, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1985, 923, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1526, 744, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1527, 744, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1984, 923, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1528, 746, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1529, 746, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1530, 746, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1983, 922, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1531, 746, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1982, 922, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1532, 747, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1533, 747, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1534, 747, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1981, 920, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1535, 747, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1980, 920, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1536, 748, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1537, 748, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1538, 748, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1979, 919, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1539, 748, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1540, 749, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1541, 749, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1978, 919, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1542, 749, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1543, 749, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1977, 919, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1544, 750, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1545, 750, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1546, 750, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1547, 750, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1548, 751, 0, 'TXT_DEVICEPARAMETERSVALUES_1018', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1975, 917, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1976, 919, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1549, 751, 1, 'TXT_DEVICEPARAMETERSVALUES_1019', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1972, 915, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1973, 916, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1974, 917, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1550, 754, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1971, 915, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1551, 754, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1967, 915, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1968, 915, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1969, 915, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1970, 915, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1552, 754, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1963, 914, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1964, 914, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1965, 914, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1966, 915, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1553, 755, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1962, 914, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1554, 755, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1958, 911, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1959, 911, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1960, 913, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1961, 913, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1555, 755, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1954, 910, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1955, 910, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1956, 910, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1957, 910, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1556, 756, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1953, 908, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1557, 756, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1952, 908, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1558, 757, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1559, 757, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1560, 758, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1561, 758, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1951, 907, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1562, 759, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1950, 906, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1563, 759, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1564, 760, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1565, 760, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1949, 906, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1566, 760, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1567, 760, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1948, 906, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1568, 761, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1569, 761, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1570, 761, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1947, 906, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1571, 761, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1572, 762, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1573, 762, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1946, 906, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1574, 762, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1575, 762, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1945, 906, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1576, 763, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1577, 763, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1578, 763, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1944, 906, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1579, 763, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1943, 905, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1580, 765, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1581, 765, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1582, 765, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1942, 905, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1583, 765, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1584, 766, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1585, 766, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1941, 905, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1586, 766, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1587, 766, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1940, 905, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1588, 767, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1589, 767, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1590, 767, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1939, 904, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1591, 767, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1592, 768, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1593, 768, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1938, 904, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1594, 768, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1595, 768, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1937, 902, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1596, 769, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1597, 769, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1598, 769, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1599, 769, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1600, 770, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1601, 770, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1602, 771, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1603, 771, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1604, 771, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1605, 773, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1606, 773, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1607, 773, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1936, 902, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1608, 774, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1609, 774, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1610, 774, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1935, 901, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1611, 775, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1612, 775, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1613, 775, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1934, 901, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1614, 776, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1615, 776, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1616, 776, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1933, 901, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1617, 777, 0, 'TXT_DEVICEPARAMETERSVALUES_1012', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1618, 777, 1, 'TXT_DEVICEPARAMETERSVALUES_1013', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1619, 778, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1620, 778, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1621, 778, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1622, 778, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1623, 779, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1624, 779, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1625, 780, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1626, 780, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1627, 780, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1628, 782, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1629, 782, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1630, 782, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1932, 901, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1631, 783, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1632, 783, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1633, 783, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1931, 899, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1634, 784, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1635, 784, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1636, 784, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1930, 899, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1637, 785, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1638, 785, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1639, 785, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1929, 898, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1640, 786, 0, 'TXT_DEVICEPARAMETERSVALUES_1012', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1641, 786, 1, 'TXT_DEVICEPARAMETERSVALUES_1013', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1642, 787, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1643, 787, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1644, 787, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1645, 787, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1646, 788, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1647, 788, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1648, 789, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1649, 789, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1650, 789, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1651, 791, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1652, 791, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1653, 791, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1928, 897, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1654, 792, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1655, 792, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1656, 792, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1927, 897, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1657, 793, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1658, 793, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1659, 793, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1926, 897, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1660, 794, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1661, 794, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1662, 794, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1925, 897, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1663, 795, 0, 'TXT_DEVICEPARAMETERSVALUES_1012', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1664, 795, 1, 'TXT_DEVICEPARAMETERSVALUES_1013', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1665, 796, 255, 'TXT_DEVICEPARAMETERSVALUES_423', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1666, 796, 0, 'TXT_DEVICEPARAMETERSVALUES_424', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1667, 796, 1, 'TXT_DEVICEPARAMETERSVALUES_425', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1668, 796, 2, 'TXT_DEVICEPARAMETERSVALUES_426', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1669, 797, 0, 'TXT_DEVICEPARAMETERSVALUES_427', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1670, 797, 1, 'TXT_DEVICEPARAMETERSVALUES_428', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1671, 798, 0, 'TXT_DEVICEPARAMETERSVALUES_429', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1672, 798, 1, 'TXT_DEVICEPARAMETERSVALUES_430', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1673, 798, 2, 'TXT_DEVICEPARAMETERSVALUES_431', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1674, 800, 0, 'TXT_DEVICEPARAMETERSVALUES_432', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1675, 800, 1, 'TXT_DEVICEPARAMETERSVALUES_433', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1676, 800, 2, 'TXT_DEVICEPARAMETERSVALUES_434', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1924, 897, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1677, 801, 0, 'TXT_DEVICEPARAMETERSVALUES_435', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1678, 801, 1, 'TXT_DEVICEPARAMETERSVALUES_436', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1679, 801, 2, 'TXT_DEVICEPARAMETERSVALUES_437', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1923, 897, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1680, 802, 0, 'TXT_DEVICEPARAMETERSVALUES_438', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1681, 802, 1, 'TXT_DEVICEPARAMETERSVALUES_439', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1682, 802, 2, 'TXT_DEVICEPARAMETERSVALUES_440', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1922, 897, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1683, 803, 0, 'TXT_DEVICEPARAMETERSVALUES_441', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1684, 803, 1, 'TXT_DEVICEPARAMETERSVALUES_442', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1685, 803, 2, 'TXT_DEVICEPARAMETERSVALUES_443', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1921, 896, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1686, 804, 0, 'TXT_DEVICEPARAMETERSVALUES_1012', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1687, 804, 1, 'TXT_DEVICEPARAMETERSVALUES_1013', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1688, 805, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1689, 805, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1690, 805, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1691, 805, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1692, 806, 0, 'TXT_DEVICEPARAMETERSVALUES_1072', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1919, 896, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1920, 896, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1693, 806, 1, 'TXT_DEVICEPARAMETERSVALUES_1073', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1916, 895, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1917, 895, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1918, 896, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1694, 808, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1915, 893, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1695, 808, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1911, 892, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1912, 892, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1913, 892, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1914, 893, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1696, 808, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1907, 889, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1908, 890, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1909, 890, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1910, 892, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1697, 809, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1906, 888, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1698, 809, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1905, 888, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1699, 810, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1700, 810, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1701, 811, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1702, 811, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1904, 888, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1703, 812, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1903, 888, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1704, 812, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1705, 813, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1706, 813, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1902, 888, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1707, 813, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1708, 813, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1901, 888, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1709, 814, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1710, 814, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1711, 814, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1900, 888, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1712, 814, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1899, 887, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1713, 815, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1714, 815, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1715, 815, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1898, 887, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1716, 815, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1717, 816, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1718, 816, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1897, 887, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1719, 816, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1720, 816, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1896, 887, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1721, 818, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1722, 818, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1723, 818, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1724, 818, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1725, 819, 0, 'TXT_DEVICEPARAMETERSVALUES_1072', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1894, 886, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1895, 886, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1726, 819, 1, 'TXT_DEVICEPARAMETERSVALUES_1073', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1891, 883, 3, 'TXT_DEVICEPARAMETERSVALUES_2557', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1892, 884, 0, 'TXT_DEVICEPARAMETERSVALUES_2564', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1893, 884, 1, 'TXT_DEVICEPARAMETERSVALUES_2565', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1727, 821, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1890, 883, 2, 'TXT_DEVICEPARAMETERSVALUES_2556', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1728, 821, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1886, 881, 0, 'TXT_DEVICEPARAMETERSVALUES_2549', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1887, 881, 1, 'TXT_DEVICEPARAMETERSVALUES_2550', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1888, 883, 0, 'TXT_DEVICEPARAMETERSVALUES_2554', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1889, 883, 1, 'TXT_DEVICEPARAMETERSVALUES_2555', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1729, 821, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1882, 879, 4, 'TXT_DEVICEPARAMETERSVALUES_2543', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1883, 879, 5, 'TXT_DEVICEPARAMETERSVALUES_2544', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1884, 879, 255, 'TXT_DEVICEPARAMETERSVALUES_2545', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1885, 880, 255, 'TXT_DEVICEPARAMETERSVALUES_2547', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1730, 822, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1881, 879, 3, 'TXT_DEVICEPARAMETERSVALUES_2542', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1731, 822, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1880, 879, 2, 'TXT_DEVICEPARAMETERSVALUES_2541', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1732, 823, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1733, 823, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1734, 824, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1735, 824, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1879, 879, 1, 'TXT_DEVICEPARAMETERSVALUES_2540', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1736, 825, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1737, 825, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1878, 879, 0, 'TXT_DEVICEPARAMETERSVALUES_2539', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1738, 826, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1739, 826, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1740, 826, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1877, 878, 3, 'TXT_DEVICEPARAMETERSVALUES_2537', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1741, 826, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1742, 827, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1743, 827, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1876, 878, 2, 'TXT_DEVICEPARAMETERSVALUES_2536', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1744, 827, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1745, 827, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1875, 878, 1, 'TXT_DEVICEPARAMETERSVALUES_2535', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1746, 828, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1747, 828, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1748, 828, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1874, 878, 0, 'TXT_DEVICEPARAMETERSVALUES_2534', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1749, 828, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1750, 829, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1751, 829, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1873, 877, 0, 'TXT_DEVICEPARAMETERSVALUES_2528', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1752, 829, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1753, 829, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1872, 877, 1, 'TXT_DEVICEPARAMETERSVALUES_2529', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1754, 831, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1755, 831, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1756, 831, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1757, 831, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1758, 832, 0, 'TXT_DEVICEPARAMETERSVALUES_1072', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1870, 875, 2, 'TXT_DEVICEPARAMETERSVALUES_263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1871, 875, 3, 'TXT_DEVICEPARAMETERSVALUES_264', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1759, 832, 1, 'TXT_DEVICEPARAMETERSVALUES_1073', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1867, 874, 3, 'TXT_DEVICEPARAMETERSVALUES_260', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1868, 875, 0, 'TXT_DEVICEPARAMETERSVALUES_261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1869, 875, 1, 'TXT_DEVICEPARAMETERSVALUES_262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1760, 834, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1866, 874, 2, 'TXT_DEVICEPARAMETERSVALUES_259', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1761, 834, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1862, 873, 2, 'TXT_DEVICEPARAMETERSVALUES_255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1863, 873, 3, 'TXT_DEVICEPARAMETERSVALUES_256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1864, 874, 0, 'TXT_DEVICEPARAMETERSVALUES_257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1865, 874, 1, 'TXT_DEVICEPARAMETERSVALUES_258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1762, 834, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1858, 872, 2, 'TXT_DEVICEPARAMETERSVALUES_251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1859, 872, 3, 'TXT_DEVICEPARAMETERSVALUES_252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1860, 873, 0, 'TXT_DEVICEPARAMETERSVALUES_253', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1861, 873, 1, 'TXT_DEVICEPARAMETERSVALUES_254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1763, 835, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1857, 872, 1, 'TXT_DEVICEPARAMETERSVALUES_250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1764, 835, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1856, 872, 0, 'TXT_DEVICEPARAMETERSVALUES_249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1765, 836, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1766, 836, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1767, 837, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1768, 837, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1855, 870, 3, 'TXT_DEVICEPARAMETERSVALUES_248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1769, 838, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1770, 838, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1854, 870, 2, 'TXT_DEVICEPARAMETERSVALUES_247', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1771, 839, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1772, 839, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1773, 839, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1853, 870, 1, 'TXT_DEVICEPARAMETERSVALUES_246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1774, 839, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1852, 870, 0, 'TXT_DEVICEPARAMETERSVALUES_245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1775, 840, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1776, 840, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1777, 840, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1851, 869, 3, 'TXT_DEVICEPARAMETERSVALUES_244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1778, 840, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1850, 869, 2, 'TXT_DEVICEPARAMETERSVALUES_243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1779, 841, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1780, 841, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1781, 841, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1849, 869, 1, 'TXT_DEVICEPARAMETERSVALUES_242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1782, 841, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1848, 869, 0, 'TXT_DEVICEPARAMETERSVALUES_241', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1783, 842, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1784, 842, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1785, 842, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1847, 868, 3, 'TXT_DEVICEPARAMETERSVALUES_240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1786, 842, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1846, 868, 2, 'TXT_DEVICEPARAMETERSVALUES_239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1787, 844, 255, 'TXT_DEVICEPARAMETERSVALUES_324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1788, 844, 0, 'TXT_DEVICEPARAMETERSVALUES_325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1789, 844, 1, 'TXT_DEVICEPARAMETERSVALUES_326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1790, 844, 2, 'TXT_DEVICEPARAMETERSVALUES_327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1791, 845, 0, 'TXT_DEVICEPARAMETERSVALUES_1072', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1844, 868, 0, 'TXT_DEVICEPARAMETERSVALUES_237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1845, 868, 1, 'TXT_DEVICEPARAMETERSVALUES_238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1792, 845, 1, 'TXT_DEVICEPARAMETERSVALUES_1073', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1841, 867, 1, 'TXT_DEVICEPARAMETERSVALUES_234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1842, 867, 2, 'TXT_DEVICEPARAMETERSVALUES_235', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1843, 867, 3, 'TXT_DEVICEPARAMETERSVALUES_236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1793, 847, 0, 'TXT_DEVICEPARAMETERSVALUES_330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1840, 867, 0, 'TXT_DEVICEPARAMETERSVALUES_233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1794, 847, 1, 'TXT_DEVICEPARAMETERSVALUES_331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1836, 865, 0, 'TXT_DEVICEPARAMETERSVALUES_231', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1837, 865, 1, 'TXT_DEVICEPARAMETERSVALUES_232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1838, 866, 0, 'TXT_DEVICEPARAMETERSVALUES_265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1839, 866, 1, 'TXT_DEVICEPARAMETERSVALUES_266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1795, 847, 2, 'TXT_DEVICEPARAMETERSVALUES_332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1832, 863, 0, 'TXT_DEVICEPARAMETERSVALUES_227', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1833, 863, 1, 'TXT_DEVICEPARAMETERSVALUES_228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1834, 864, 0, 'TXT_DEVICEPARAMETERSVALUES_229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1835, 864, 1, 'TXT_DEVICEPARAMETERSVALUES_230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1796, 848, 0, 'TXT_DEVICEPARAMETERSVALUES_333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1831, 862, 2, 'TXT_DEVICEPARAMETERSVALUES_226', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1797, 848, 1, 'TXT_DEVICEPARAMETERSVALUES_334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1830, 862, 1, 'TXT_DEVICEPARAMETERSVALUES_225', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1798, 849, 0, 'TXT_DEVICEPARAMETERSVALUES_335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1799, 849, 1, 'TXT_DEVICEPARAMETERSVALUES_336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1800, 850, 0, 'TXT_DEVICEPARAMETERSVALUES_337', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1801, 850, 1, 'TXT_DEVICEPARAMETERSVALUES_338', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1829, 862, 0, 'TXT_DEVICEPARAMETERSVALUES_224', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1802, 851, 0, 'TXT_DEVICEPARAMETERSVALUES_355', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1803, 851, 1, 'TXT_DEVICEPARAMETERSVALUES_356', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1828, 861, 2, 'TXT_DEVICEPARAMETERSVALUES_223', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1804, 852, 0, 'TXT_DEVICEPARAMETERSVALUES_339', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1805, 852, 1, 'TXT_DEVICEPARAMETERSVALUES_340', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1806, 852, 2, 'TXT_DEVICEPARAMETERSVALUES_341', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1827, 861, 1, 'TXT_DEVICEPARAMETERSVALUES_222', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1807, 852, 3, 'TXT_DEVICEPARAMETERSVALUES_342', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1826, 861, 0, 'TXT_DEVICEPARAMETERSVALUES_221', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1808, 853, 0, 'TXT_DEVICEPARAMETERSVALUES_343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1809, 853, 1, 'TXT_DEVICEPARAMETERSVALUES_344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1810, 853, 2, 'TXT_DEVICEPARAMETERSVALUES_345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1825, 858, 1, 'TXT_DEVICEPARAMETERSVALUES_1019', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1811, 853, 3, 'TXT_DEVICEPARAMETERSVALUES_346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1824, 858, 0, 'TXT_DEVICEPARAMETERSVALUES_1018', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1812, 854, 0, 'TXT_DEVICEPARAMETERSVALUES_347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1813, 854, 1, 'TXT_DEVICEPARAMETERSVALUES_348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1814, 854, 2, 'TXT_DEVICEPARAMETERSVALUES_349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1823, 857, 2, 'TXT_DEVICEPARAMETERSVALUES_216', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1815, 854, 3, 'TXT_DEVICEPARAMETERSVALUES_350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1822, 857, 1, 'TXT_DEVICEPARAMETERSVALUES_215', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1816, 855, 0, 'TXT_DEVICEPARAMETERSVALUES_351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1817, 855, 1, 'TXT_DEVICEPARAMETERSVALUES_352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1818, 855, 2, 'TXT_DEVICEPARAMETERSVALUES_353', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1821, 857, 0, 'TXT_DEVICEPARAMETERSVALUES_214', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1819, 855, 3, 'TXT_DEVICEPARAMETERSVALUES_354', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(1820, 857, 255, 'TXT_DEVICEPARAMETERSVALUES_213', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2892, 1532, 0, 'TXT_DEVICEPARAMETERSVALUES_4198', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2893, 1532, 1, 'TXT_DEVICEPARAMETERSVALUES_4199', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2894, 1532, 2, 'TXT_DEVICEPARAMETERSVALUES_4200', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2895, 1533, 0, 'TXT_DEVICEPARAMETERSVALUES_4202', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2896, 1533, 1, 'TXT_DEVICEPARAMETERSVALUES_4203', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2897, 1533, 2, 'TXT_DEVICEPARAMETERSVALUES_4204', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2898, 1556, 0, 'TXT_DEVICEPARAMETERSVALUES_4228', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2899, 1556, 1, 'TXT_DEVICEPARAMETERSVALUES_4229', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2900, 1556, 2, 'TXT_DEVICEPARAMETERSVALUES_4230', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2901, 1557, 0, 'TXT_DEVICEPARAMETERSVALUES_4232', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2902, 1557, 1, 'TXT_DEVICEPARAMETERSVALUES_4233', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2903, 1557, 2, 'TXT_DEVICEPARAMETERSVALUES_4234', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2904, 1558, 0, 'TXT_DEVICEPARAMETERSVALUES_4236', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2905, 1558, 1, 'TXT_DEVICEPARAMETERSVALUES_4237', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2906, 1558, 2, 'TXT_DEVICEPARAMETERSVALUES_4238', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2907, 1558, 3, 'TXT_DEVICEPARAMETERSVALUES_4239', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2908, 1558, 4, 'TXT_DEVICEPARAMETERSVALUES_4240', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2909, 1559, 0, 'TXT_DEVICEPARAMETERSVALUES_4242', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2910, 1559, 1, 'TXT_DEVICEPARAMETERSVALUES_4243', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2911, 1559, 2, 'TXT_DEVICEPARAMETERSVALUES_4244', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2912, 1559, 3, 'TXT_DEVICEPARAMETERSVALUES_4245', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2913, 1559, 4, 'TXT_DEVICEPARAMETERSVALUES_4246', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2914, 1560, 0, 'TXT_DEVICEPARAMETERSVALUES_4248', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2915, 1560, 1, 'TXT_DEVICEPARAMETERSVALUES_4249', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2916, 1560, 2, 'TXT_DEVICEPARAMETERSVALUES_4250', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2917, 1560, 3, 'TXT_DEVICEPARAMETERSVALUES_4251', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2918, 1560, 4, 'TXT_DEVICEPARAMETERSVALUES_4252', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2919, 1561, 0, 'TXT_DEVICEPARAMETERSVALUES_4254', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2920, 1561, 1, 'TXT_DEVICEPARAMETERSVALUES_4255', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2921, 1561, 2, 'TXT_DEVICEPARAMETERSVALUES_4256', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2922, 1561, 3, 'TXT_DEVICEPARAMETERSVALUES_4257', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2923, 1561, 4, 'TXT_DEVICEPARAMETERSVALUES_4258', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2924, 1563, 1, 'TXT_DEVICEPARAMETERSVALUES_4261', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2925, 1563, 2, 'TXT_DEVICEPARAMETERSVALUES_4262', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2926, 1563, 255, 'TXT_DEVICEPARAMETERSVALUES_4263', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2927, 1564, 0, 'TXT_DEVICEPARAMETERSVALUES_4265', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2928, 1564, 1, 'TXT_DEVICEPARAMETERSVALUES_4266', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2929, 1565, 0, 'TXT_DEVICEPARAMETERSVALUES_4268', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2930, 1565, 1, 'TXT_DEVICEPARAMETERSVALUES_4269', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2931, 1565, 2, 'TXT_DEVICEPARAMETERSVALUES_4270', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2932, 1571, 0, 'TXT_DEVICEPARAMETERSVALUES_4282', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2933, 1571, 1, 'TXT_DEVICEPARAMETERSVALUES_4283', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2934, 1571, 2, 'TXT_DEVICEPARAMETERSVALUES_4284', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2935, 1573, 0, 'TXT_DEVICEPARAMETERSVALUES_4287', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2936, 1573, 1, 'TXT_DEVICEPARAMETERSVALUES_4288', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2937, 1573, 2, 'TXT_DEVICEPARAMETERSVALUES_4289', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2938, 1578, 0, 'TXT_DEVICEPARAMETERSVALUES_4295', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2939, 1578, 1, 'TXT_DEVICEPARAMETERSVALUES_4296', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2940, 1578, 2, 'TXT_DEVICEPARAMETERSVALUES_4297', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2941, 1578, 3, 'TXT_DEVICEPARAMETERSVALUES_4298', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2942, 1579, 0, 'TXT_DEVICEPARAMETERSVALUES_4300', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2943, 1579, 1, 'TXT_DEVICEPARAMETERSVALUES_4301', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2944, 1578, 4, 'TXT_DEVICEPARAMETERSVALUES_4308', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2945, 1586, 0, 'TXT_DEVICEPARAMETERSVALUES_4310', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2946, 1586, 1, 'TXT_DEVICEPARAMETERSVALUES_4311', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2947, 1586, 2, 'TXT_DEVICEPARAMETERSVALUES_4312', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2948, 1586, 3, 'TXT_DEVICEPARAMETERSVALUES_4313', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2949, 1586, 4, 'TXT_DEVICEPARAMETERSVALUES_4314', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2950, 1586, 5, 'TXT_DEVICEPARAMETERSVALUES_4315', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2951, 1586, 6, 'TXT_DEVICEPARAMETERSVALUES_4316', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2952, 1586, 7, 'TXT_DEVICEPARAMETERSVALUES_4317', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2953, 1586, 8, 'TXT_DEVICEPARAMETERSVALUES_4318', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2954, 1586, 9, 'TXT_DEVICEPARAMETERSVALUES_4319', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2955, 1586, 10, 'TXT_DEVICEPARAMETERSVALUES_4320', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2956, 1586, 11, 'TXT_DEVICEPARAMETERSVALUES_4321', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2957, 1586, 12, 'TXT_DEVICEPARAMETERSVALUES_4322', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2958, 1586, 13, 'TXT_DEVICEPARAMETERSVALUES_4323', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2959, 1586, 14, 'TXT_DEVICEPARAMETERSVALUES_4324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2960, 1586, 15, 'TXT_DEVICEPARAMETERSVALUES_4325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2961, 1586, 16, 'TXT_DEVICEPARAMETERSVALUES_4326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2962, 1586, 17, 'TXT_DEVICEPARAMETERSVALUES_4327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2963, 1586, 18, 'TXT_DEVICEPARAMETERSVALUES_4328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2964, 1586, 19, 'TXT_DEVICEPARAMETERSVALUES_4329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2965, 1586, 20, 'TXT_DEVICEPARAMETERSVALUES_4330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2966, 1586, 21, 'TXT_DEVICEPARAMETERSVALUES_4331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2967, 1586, 22, 'TXT_DEVICEPARAMETERSVALUES_4332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2968, 1586, 23, 'TXT_DEVICEPARAMETERSVALUES_4333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2969, 1586, 24, 'TXT_DEVICEPARAMETERSVALUES_4334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2970, 1586, 25, 'TXT_DEVICEPARAMETERSVALUES_4335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2971, 1586, 26, 'TXT_DEVICEPARAMETERSVALUES_4336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2972, 1592, 0, 'TXT_DEVICEPARAMETERSVALUES_4343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2973, 1592, 1, 'TXT_DEVICEPARAMETERSVALUES_4344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2974, 1568, 0, 'TXT_DEVICEPARAMETERSVALUES_4345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2975, 1568, 1, 'TXT_DEVICEPARAMETERSVALUES_4346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2976, 1568, 2, 'TXT_DEVICEPARAMETERSVALUES_4347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2977, 1568, 3, 'TXT_DEVICEPARAMETERSVALUES_4348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2978, 1569, 0, 'TXT_DEVICEPARAMETERSVALUES_4349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2979, 1569, 1, 'TXT_DEVICEPARAMETERSVALUES_4350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2980, 1569, 2, 'TXT_DEVICEPARAMETERSVALUES_4351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2981, 1569, 3, 'TXT_DEVICEPARAMETERSVALUES_4352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2982, 1595, 0, 'TXT_DEVICEPARAMETERSVALUES_4345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2983, 1595, 1, 'TXT_DEVICEPARAMETERSVALUES_4346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2984, 1595, 2, 'TXT_DEVICEPARAMETERSVALUES_4347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2985, 1595, 3, 'TXT_DEVICEPARAMETERSVALUES_4348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2986, 1596, 0, 'TXT_DEVICEPARAMETERSVALUES_4349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2987, 1596, 1, 'TXT_DEVICEPARAMETERSVALUES_4350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2988, 1596, 2, 'TXT_DEVICEPARAMETERSVALUES_4351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2989, 1596, 3, 'TXT_DEVICEPARAMETERSVALUES_4352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2990, 1598, 0, 'TXT_DEVICEPARAMETERSVALUES_4282', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2991, 1598, 1, 'TXT_DEVICEPARAMETERSVALUES_4283', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2992, 1598, 2, 'TXT_DEVICEPARAMETERSVALUES_4284', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2993, 1600, 0, 'TXT_DEVICEPARAMETERSVALUES_4287', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2994, 1600, 1, 'TXT_DEVICEPARAMETERSVALUES_4288', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2995, 1600, 2, 'TXT_DEVICEPARAMETERSVALUES_4289', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2996, 1605, 0, 'TXT_DEVICEPARAMETERSVALUES_4295', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2997, 1605, 1, 'TXT_DEVICEPARAMETERSVALUES_4296', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2998, 1605, 2, 'TXT_DEVICEPARAMETERSVALUES_4297', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(2999, 1605, 3, 'TXT_DEVICEPARAMETERSVALUES_4298', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3000, 1605, 4, 'TXT_DEVICEPARAMETERSVALUES_4308', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3001, 1606, 0, 'TXT_DEVICEPARAMETERSVALUES_4300', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3002, 1606, 1, 'TXT_DEVICEPARAMETERSVALUES_4301', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3003, 1613, 0, 'TXT_DEVICEPARAMETERSVALUES_4310', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3004, 1613, 1, 'TXT_DEVICEPARAMETERSVALUES_4311', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3005, 1613, 2, 'TXT_DEVICEPARAMETERSVALUES_4312', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3006, 1613, 3, 'TXT_DEVICEPARAMETERSVALUES_4313', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3007, 1613, 4, 'TXT_DEVICEPARAMETERSVALUES_4314', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3008, 1613, 5, 'TXT_DEVICEPARAMETERSVALUES_4315', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3009, 1613, 6, 'TXT_DEVICEPARAMETERSVALUES_4316', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3010, 1613, 7, 'TXT_DEVICEPARAMETERSVALUES_4317', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3011, 1613, 8, 'TXT_DEVICEPARAMETERSVALUES_4318', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3012, 1613, 9, 'TXT_DEVICEPARAMETERSVALUES_4319', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3013, 1613, 10, 'TXT_DEVICEPARAMETERSVALUES_4320', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3014, 1613, 11, 'TXT_DEVICEPARAMETERSVALUES_4321', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3015, 1613, 12, 'TXT_DEVICEPARAMETERSVALUES_4322', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3016, 1613, 13, 'TXT_DEVICEPARAMETERSVALUES_4323', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3017, 1613, 14, 'TXT_DEVICEPARAMETERSVALUES_4324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3018, 1613, 15, 'TXT_DEVICEPARAMETERSVALUES_4325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3019, 1613, 16, 'TXT_DEVICEPARAMETERSVALUES_4326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3020, 1613, 17, 'TXT_DEVICEPARAMETERSVALUES_4327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3021, 1613, 18, 'TXT_DEVICEPARAMETERSVALUES_4328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3022, 1613, 19, 'TXT_DEVICEPARAMETERSVALUES_4329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3023, 1613, 20, 'TXT_DEVICEPARAMETERSVALUES_4330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3024, 1613, 21, 'TXT_DEVICEPARAMETERSVALUES_4331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3025, 1613, 22, 'TXT_DEVICEPARAMETERSVALUES_4332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3026, 1613, 23, 'TXT_DEVICEPARAMETERSVALUES_4333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3027, 1613, 24, 'TXT_DEVICEPARAMETERSVALUES_4334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3028, 1613, 25, 'TXT_DEVICEPARAMETERSVALUES_4335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3029, 1613, 26, 'TXT_DEVICEPARAMETERSVALUES_4336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3030, 1619, 0, 'TXT_DEVICEPARAMETERSVALUES_4343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3031, 1619, 1, 'TXT_DEVICEPARAMETERSVALUES_4344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3032, 1622, 0, 'TXT_DEVICEPARAMETERSVALUES_4345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3033, 1622, 1, 'TXT_DEVICEPARAMETERSVALUES_4346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3034, 1622, 2, 'TXT_DEVICEPARAMETERSVALUES_4347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3035, 1622, 3, 'TXT_DEVICEPARAMETERSVALUES_4348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3036, 1623, 0, 'TXT_DEVICEPARAMETERSVALUES_4349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3037, 1623, 1, 'TXT_DEVICEPARAMETERSVALUES_4350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3038, 1623, 2, 'TXT_DEVICEPARAMETERSVALUES_4351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3039, 1623, 3, 'TXT_DEVICEPARAMETERSVALUES_4352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3040, 1625, 0, 'TXT_DEVICEPARAMETERSVALUES_4282', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3041, 1625, 1, 'TXT_DEVICEPARAMETERSVALUES_4283', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3042, 1625, 2, 'TXT_DEVICEPARAMETERSVALUES_4284', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3043, 1627, 0, 'TXT_DEVICEPARAMETERSVALUES_4287', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3044, 1627, 1, 'TXT_DEVICEPARAMETERSVALUES_4288', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3045, 1627, 2, 'TXT_DEVICEPARAMETERSVALUES_4289', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3046, 1632, 0, 'TXT_DEVICEPARAMETERSVALUES_4295', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3047, 1632, 1, 'TXT_DEVICEPARAMETERSVALUES_4296', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3048, 1632, 2, 'TXT_DEVICEPARAMETERSVALUES_4297', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3049, 1632, 3, 'TXT_DEVICEPARAMETERSVALUES_4298', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3050, 1632, 4, 'TXT_DEVICEPARAMETERSVALUES_4308', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3051, 1633, 0, 'TXT_DEVICEPARAMETERSVALUES_4300', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3052, 1633, 1, 'TXT_DEVICEPARAMETERSVALUES_4301', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3053, 1640, 0, 'TXT_DEVICEPARAMETERSVALUES_4310', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3054, 1640, 1, 'TXT_DEVICEPARAMETERSVALUES_4311', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3055, 1640, 2, 'TXT_DEVICEPARAMETERSVALUES_4312', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3056, 1640, 3, 'TXT_DEVICEPARAMETERSVALUES_4313', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3057, 1640, 4, 'TXT_DEVICEPARAMETERSVALUES_4314', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3058, 1640, 5, 'TXT_DEVICEPARAMETERSVALUES_4315', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3059, 1640, 6, 'TXT_DEVICEPARAMETERSVALUES_4316', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3060, 1640, 7, 'TXT_DEVICEPARAMETERSVALUES_4317', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3061, 1640, 8, 'TXT_DEVICEPARAMETERSVALUES_4318', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3062, 1640, 9, 'TXT_DEVICEPARAMETERSVALUES_4319', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3063, 1640, 10, 'TXT_DEVICEPARAMETERSVALUES_4320', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3064, 1640, 11, 'TXT_DEVICEPARAMETERSVALUES_4321', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3065, 1640, 12, 'TXT_DEVICEPARAMETERSVALUES_4322', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3066, 1640, 13, 'TXT_DEVICEPARAMETERSVALUES_4323', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3067, 1640, 14, 'TXT_DEVICEPARAMETERSVALUES_4324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3068, 1640, 15, 'TXT_DEVICEPARAMETERSVALUES_4325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3069, 1640, 16, 'TXT_DEVICEPARAMETERSVALUES_4326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3070, 1640, 17, 'TXT_DEVICEPARAMETERSVALUES_4327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3071, 1640, 18, 'TXT_DEVICEPARAMETERSVALUES_4328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3072, 1640, 19, 'TXT_DEVICEPARAMETERSVALUES_4329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3073, 1640, 20, 'TXT_DEVICEPARAMETERSVALUES_4330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3074, 1640, 21, 'TXT_DEVICEPARAMETERSVALUES_4331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3075, 1640, 22, 'TXT_DEVICEPARAMETERSVALUES_4332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3076, 1640, 23, 'TXT_DEVICEPARAMETERSVALUES_4333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3077, 1640, 24, 'TXT_DEVICEPARAMETERSVALUES_4334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3078, 1640, 25, 'TXT_DEVICEPARAMETERSVALUES_4335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3079, 1640, 26, 'TXT_DEVICEPARAMETERSVALUES_4336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3080, 1646, 0, 'TXT_DEVICEPARAMETERSVALUES_4343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3081, 1646, 1, 'TXT_DEVICEPARAMETERSVALUES_4344', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3082, 1649, 0, 'TXT_DEVICEPARAMETERSVALUES_4345', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3083, 1649, 1, 'TXT_DEVICEPARAMETERSVALUES_4346', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3084, 1649, 2, 'TXT_DEVICEPARAMETERSVALUES_4347', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3085, 1649, 3, 'TXT_DEVICEPARAMETERSVALUES_4348', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3086, 1650, 0, 'TXT_DEVICEPARAMETERSVALUES_4349', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3087, 1650, 1, 'TXT_DEVICEPARAMETERSVALUES_4350', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3088, 1650, 2, 'TXT_DEVICEPARAMETERSVALUES_4351', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3089, 1650, 3, 'TXT_DEVICEPARAMETERSVALUES_4352', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3090, 1652, 0, 'TXT_DEVICEPARAMETERSVALUES_4282', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3091, 1652, 1, 'TXT_DEVICEPARAMETERSVALUES_4283', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3092, 1652, 2, 'TXT_DEVICEPARAMETERSVALUES_4284', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3093, 1654, 0, 'TXT_DEVICEPARAMETERSVALUES_4287', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3094, 1654, 1, 'TXT_DEVICEPARAMETERSVALUES_4288', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3095, 1654, 2, 'TXT_DEVICEPARAMETERSVALUES_4289', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3096, 1659, 0, 'TXT_DEVICEPARAMETERSVALUES_4295', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3097, 1659, 1, 'TXT_DEVICEPARAMETERSVALUES_4296', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3098, 1659, 2, 'TXT_DEVICEPARAMETERSVALUES_4297', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3099, 1659, 3, 'TXT_DEVICEPARAMETERSVALUES_4298', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3100, 1659, 4, 'TXT_DEVICEPARAMETERSVALUES_4308', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3101, 1660, 0, 'TXT_DEVICEPARAMETERSVALUES_4300', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3102, 1660, 1, 'TXT_DEVICEPARAMETERSVALUES_4301', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3103, 1667, 0, 'TXT_DEVICEPARAMETERSVALUES_4310', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3104, 1667, 1, 'TXT_DEVICEPARAMETERSVALUES_4311', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3105, 1667, 2, 'TXT_DEVICEPARAMETERSVALUES_4312', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3106, 1667, 3, 'TXT_DEVICEPARAMETERSVALUES_4313', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3107, 1667, 4, 'TXT_DEVICEPARAMETERSVALUES_4314', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3108, 1667, 5, 'TXT_DEVICEPARAMETERSVALUES_4315', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3109, 1667, 6, 'TXT_DEVICEPARAMETERSVALUES_4316', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3110, 1667, 7, 'TXT_DEVICEPARAMETERSVALUES_4317', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3111, 1667, 8, 'TXT_DEVICEPARAMETERSVALUES_4318', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3112, 1667, 9, 'TXT_DEVICEPARAMETERSVALUES_4319', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3113, 1667, 10, 'TXT_DEVICEPARAMETERSVALUES_4320', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3114, 1667, 11, 'TXT_DEVICEPARAMETERSVALUES_4321', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3115, 1667, 12, 'TXT_DEVICEPARAMETERSVALUES_4322', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3116, 1667, 13, 'TXT_DEVICEPARAMETERSVALUES_4323', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3117, 1667, 14, 'TXT_DEVICEPARAMETERSVALUES_4324', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3118, 1667, 15, 'TXT_DEVICEPARAMETERSVALUES_4325', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3119, 1667, 16, 'TXT_DEVICEPARAMETERSVALUES_4326', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3120, 1667, 17, 'TXT_DEVICEPARAMETERSVALUES_4327', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3121, 1667, 18, 'TXT_DEVICEPARAMETERSVALUES_4328', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3122, 1667, 19, 'TXT_DEVICEPARAMETERSVALUES_4329', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3123, 1667, 20, 'TXT_DEVICEPARAMETERSVALUES_4330', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3124, 1667, 21, 'TXT_DEVICEPARAMETERSVALUES_4331', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3125, 1667, 22, 'TXT_DEVICEPARAMETERSVALUES_4332', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3126, 1667, 23, 'TXT_DEVICEPARAMETERSVALUES_4333', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3127, 1667, 24, 'TXT_DEVICEPARAMETERSVALUES_4334', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3128, 1667, 25, 'TXT_DEVICEPARAMETERSVALUES_4335', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3129, 1667, 26, 'TXT_DEVICEPARAMETERSVALUES_4336', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3130, 1673, 0, 'TXT_DEVICEPARAMETERSVALUES_4343', '');
INSERT INTO `Device_Parameters_Template_Parameters_Value` (`PK_Device_Parameters_Template_Parameter_Value`, `FK_Device_Parameters_Template_Parameter`, `Value`, `ValueDescription`, `ValueDescriptionPolish`) VALUES(3131, 1673, 1, 'TXT_DEVICEPARAMETERSVALUES_4344', '');


COMMIT;
